# Program : compress_script.sh
# 	created  by DIEUMEGARD, F.  12/Nov/2009
#   modifed  by DIEUMEGARD, F.  27/Jul/2011 (Add parameter 3)
# Files conpression in TAR Z
# call compress executable

# $1 RINEX/Gfile files path (if parameter 3 not present) else Ack/Nack file path (if parameter 3):  
# Be careful $1 should be terminated by / character
# used when rinex file name is not indicated (WILCARD)
# $2 if equal to 1 => remove original file
# $3 file names to compress: used to compress a set of files described by a filter. Ex 8000166a.11 (? will be added at the end)

ACKFile=CompressOk.log
NAKFile=CompressNotOk.log
LIST_FILES=/mnt/config/list_files_$$
FILTER="?"
cpt=0

if [ $# -gt 0 ];
then
	if [ -f $1${ACKFile} ];
	then
		# Ack file is present so remove it
		rm $1${ACKFile}
	fi

	if [ -f $1${NAKFile} ];
	then
		# NAK file is present so remove it
		rm $1${NAKFile}
	fi

	# Temporary file
	if [ $3 ];
	then
		#echo $3
		ls $3${FILTER} > ${LIST_FILES}
	else
		ls $1 > ${LIST_FILES} 
	fi

	if [ ! $? -eq 0 ];
	then
		echo "Error, Wrong Rinex path $1${file}."
		rm ${LIST_FILES}
 		exit 2
	fi

	for file in $(cat ${LIST_FILES}); 
	do 
		if [ $3 ];
		then
			echo ${file}
			# Compress file
			/mnt/config/compress -f ${file}
			result=$?
			
			cpt=1

			if [ ${result} != 0 ];
			then
				echo "${result}" > $1${NAKFile}
				rm ${LIST_FILES}
				exit 3
			fi

			# remove original files if $2 == 1
			if [ $2 -eq 1 ];
			then
				rm ${file}
			fi
		else
			echo $1${file}
			# Compress file
			/mnt/config/compress -f $1${file}
			result=$?
			
			cpt=1

			if [ ${result} != 0 ];
			then
				echo "${result}" > $1${NAKFile}
				rm ${LIST_FILES}
				exit 3
			fi

			# remove original files if $2 == 1
			if [ $2 -eq 1 ];
			then
				rm $1${file}
			fi
		fi	
	done

	if [ ${cpt} == 0 ];
	then
		# Error, No file in $1.
		echo "0" > $1${NAKFile}
	else
		echo "$(cat ${LIST_FILES})" > $1${ACKFile}
	fi

	rm ${LIST_FILES}
	
else

	echo "Error, RINEX file path is missing"
	exit 1
fi

exit 0
