# Program : mail.sh
# 	created  by DIEUMEGARD, F.  17/Fev/2010
# Send email

# $1 Sender
# $2 Server SMTP
# $3 Port
# $4 username. if no username then 0
# $5 password. if no password then 0
# email.txt content of the mail (recipient, subject and data)

ACKFile=/mnt/config/EmailOk.log
NAKFile=/mnt/config/EmailNotOk.log
cpt=0
result=1

if [ $# -gt 0 ];
then
	if [ -f ${ACKFile} ];
	then
		# Ack file is present so remove it
		rm ${ACKFile}
	fi

	if [ -f ${NAKFile} ];
	then
		# NAK file is present so remove it
		rm ${NAKFile}
	fi

	while [ $result != 0 ]
	do
		if [ $4 == 0 ];
		then
#			echo "Without username and password"
			sendmail -f $1 -S $2:$3 < /mnt/config/email.txt
		else
			if [ $5 == 0 ];
			then
				echo "Error no password"
				echo "98" > ${NAKFile}
				exit 3
			else
#				echo "With username and password"
				sendmail -f $1  -S $2:$3 -au$4 -ap$5 < /mnt/config/email.txt
			fi
		fi

		result=$?
		echo "Try ${cpt} result ${result}"

		cpt=$(($cpt + 1))
		
		if [ ${cpt} -eq 3 ];
		then
			echo "E-mail failed."
			echo "${result}" > ${NAKFile}
			exit 2
		fi
	done
else
	echo "99" > ${NAKFile}
	echo "Error, no sender"
	exit 1
fi

echo "0" > ${ACKFile}
exit 0