# Program : rnx2crx_script.sh
# 	created  by DIEUMEGARD, F.  12/Nov/2009
#   modifed  by DIEUMEGARD, F.  27/Jul/2011 (Add parameter 2)
# Hatanaka compression: Rinex to Compact Rinex
# Convert *.*O to *.*D

# $1 RINEX file path (if parameter 2 not present) else Ack/Nack file path (if parameter 2): 
# Be careful $1 should be terminated by / character
# used when rinex file name is not indicated (WILCARD)
# $2 RINEX file name: used to convert a simple Rinex file. 

ACKFile=Rnx2crxOk.log
NAKFile=Rnx2crxNotOk.log
WILCARD=*.*o
WILCARDd=*.*d

if [ $# -gt 0 ];
then
	if [ -f $1${ACKFile} ];
	then
		# Ack file is present so remove it
		rm $1${ACKFile}
	fi

	if [ -f $1${NAKFile} ];
	then
		# NAK file is present so remove it
		rm $1${NAKFile}
	fi
	
	if [ $2 ];
	then
		/mnt/config/rnx2crx $2 -f
		result=$?
	else
		ls $1
		
		if [ ! $? -eq 0 ];
		then
			echo "Error, Wrong Rinex path $1."
			exit 3
		fi
	
		/mnt/config/rnx2crx $1${WILCARD} -f
		result=$?
	fi
	
	if [ $2 ];
	then
		if [ ${result} != 0 ];
		then
			echo "${result}" > $1${NAKFile}
			exit 2
		else
			echo "${result}" > $1${ACKFile}
			rm  $2
		fi
	else
		if [ ${result} != 0 ];
		then
			# remove *.*d file
			rm  $1${WILCARDd}
			echo "${result}" > $1${NAKFile}
			exit 2
		else
			echo "$1${WILCARD}" > $1${ACKFile}
			rm  $1${WILCARD}
		fi
	fi
else
	echo "Error, RINEX file path is missing."
	exit 1
fi

exit 0
