function initAdministrator()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initAdministrator()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigAdministrator;
			setFieldValue('Admin-Field-Login', config.Login );
			setFieldValue('Admin-Field-Password', config.Password );
			
			setFieldPasswordVisible( 'Admin-Field-Password', isFieldChecked( 'Admin-Field-Password-Show' ) );
			//setFieldChecked('Admin-Field-Password-Show', isFieldPasswordVisible('Admin-Field-Password'));
			setFieldValue('Admin-Field-Name', config.Name );
			setFieldValue('Admin-Field-E-mail', config.Email );
			setFieldValue('Admin-Field-Phone', config.Phone );
			setFieldValue('Admin-Field-Company', config.Company );
			
			// Show form
			showConfigForm();
		},

		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initAdministrator()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigAdministrator, callbacks);
	
	// Show Characters
	YAHOO.util.Event.addListener('Admin-Field-Password-Show', 'click', onAdminPasswordShowClick);
	
	makeFieldValidator('Admin-Field-E-mail', 'validating_Email');
	makeFieldValidator('Admin-Field-Phone', 'validating_Phone');
}

function onAdminPasswordShowClick(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	setFieldPasswordVisible('Admin-Field-Password', isFieldChecked(field));
}