function initCommandScript()
{
	var callbacks = 
	{
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initCommandScript()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigCommandScript;
			setItemVisible( 'CommandScript-UsbNotConnected', false );
			//0 - not connected
			//1 - connected
			if ( config.UsbState == 0 )
			{
				setItemVisible( 'CommandScript-UsbNotConnected', true );
				setItemVisible( 'CommandScript-Usb-Execute', false );
			}
			else
			{
				//If we haven't any command files here, put message about that
				var fileView = new FileTableView(config.Files);

			}
			// Show form
			showForm('usb_key');
		},
		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("initCommandScript()", 5000);
		},

		timeout : 10000,
		cache : false
    };

	YAHOO.util.Connect.asyncRequest('GET', getConfigCommandScriptURL, callbacks);
}

function FileTableView(source)
{
	var myColumnDefs =
	[
		{label:getResource('CommandScript-Resource-CmdFiles'), key:"Filename", resizeable:true, sortable:true}
	];
	
	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema =
	{
		fields: [ "Filename" ]
	};
	
	// Table configs
	var myConfigs =
	{
		width:"auto",
		height:"auto"
	};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('CommandScript-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('CommandScript-Resource-Loading');
	
	var table = new YAHOO.widget.DataTable("CommandFilesView", myColumnDefs, myDataSource, myConfigs);
	
	var rowClick = function selectRow( event )
	{
		var target = event.target;
		var record = table.getRecord( target );
		table.unselectAllCells();
		table.unselectAllRows();
		table.selectRow( table.getTrEl( record.getCount() ) );
		
		setFieldValue( 'CommandScript-Field-UsbKey-File', record.getData( "Filename" ) );
	};
	
	table.subscribe( "rowClickEvent", rowClick );
}