function initDataStreamingSetup()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initDataStreamingSetup()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigFullSetup;
			if (config == null) return;

			// Check Mode
			if (config.Mode != null)
			{	
				if (config.Mode == 1)
				{
					//TODO: warning, you are in rover mode!
				}
			}
			
			processBaseSetup( config );
			processDataStreamingParameters( config );

			// Show form
			showConfigForm();
		},
		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initDataStreamingSetup()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigFullSetupURL, callbacks);
	
	setBaseSetupValidators();
	setDataStreamingValidators();
}