function initDifferentialMessages()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// -- Help link
			if (ProFlex.isDuo()) {
                setItemDisplayed('Index-Help', false);
				setItemDisplayed('Index-Help-HDS', true);
			} else {
				setItemDisplayed('Index-Help-HDS', false);
				setItemDisplayed('Index-Help', true);
			}

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initDifferentialMessages()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigDifferentialMessage;
			if (config == null) return;

            // -- Refresh Rates --
            var type = new Array("ATOM","RTCM","RTCM","CMR", "DBEN");
			for (i in config.Differential)
			{
			    for (j in config.Differential[i].Messages) 
			    {
			        var name = "DiffMsg-Field-" + type[i] + "-" + config.Differential[i].Messages[j].Message;
			        // Special case
			        //if (name == 'DiffMsg-Field-ATOM-1')
					//{
			        //    setFieldValue('DiffMsg-Field-ATOM-DiffMsg-Field-ATOM-RNXScenario', config.Differential[i].Messages[j].Frequency ); 
			           //setFieldValue('DiffMsg-Field-ATOM-Rate', config.Differential[i].Messages[j].Frequency);
			        //} else if (name == 'DiffMsg-Field-ATOM-2')
					//{ 
			        //    setFieldValue('DiffMsg-Field-ATOM-Type', 2); // Compact
			        //    setFieldValue('DiffMsg-Field-ATOM-Rate', config.Differential[i].Messages[j].Frequency);
			        //} /*else if (name == 'DiffMsg-Field-ATOM-3') { 
   			        //    setFieldValue('DiffMsg-Field-ATOM-Type', 3); // Super Compact (not yet supported)
			        //    setFieldValue('DiffMsg-Field-ATOM-Rate', config.Differential[i].Messages[j].Frequency);
			        //}*/
                    setFieldValue(name, config.Differential[i].Messages[j].Frequency);
                }
			}

			setAtomPosition();
			// Show form
			showConfigForm();
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("initDifferentialMessages()", 5000);
		},

		timeout : 10000,
		cache : false
    };

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigDifferentialMessage, callbacks);

	YAHOO.util.Event.addListener('DiffMsg-Field-ATOM-RNXScenario', 'change', onRNXScenarioChanged );
	YAHOO.util.Event.addListener('DiffMsg-Field-ATOM-Rate', 'change', onRNXScenarioChanged );
	
	YAHOO.util.Event.addListener('DiffMsg-Field-CMR-0-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-CMR-1-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-CMR-2-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-CMR-3-Tooltip', 'mouseover', onTooltipOver);
	
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-3-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-9-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-16-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-18-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-20-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-22-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-23-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-24-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-31-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-32-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-34-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-36-Tooltip', 'mouseover', onTooltipOver);
	
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1001-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1002-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1003-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1004-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1005-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1006-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1007-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1008-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1009-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1010-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1011-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1012-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1013-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1019-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1020-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1029-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1033-Tooltip', 'mouseover', onTooltipOver);

    // RTCM 3.2
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1071-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1072-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1073-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1074-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1075-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1076-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1077-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('DiffMsg-Field-RTCM-1230-Tooltip', 'mouseover', onTooltipOver);
    	
	// Field validation
	
	setFieldValidator('DiffMsg-Field-ATOM-Rate');
	setFieldValidator('DiffMsg-Field-ATOM-10');
	setFieldValidator('DiffMsg-Field-ATOM-11');
	
	setFieldValidator('DiffMsg-Field-CMR-0');
	setFieldValidator('DiffMsg-Field-CMR-1');
	setFieldValidator('DiffMsg-Field-CMR-2');
	setFieldValidator('DiffMsg-Field-CMR-3');
	
	setFieldValidator('DiffMsg-Field-RTCM-1');
	setFieldValidator('DiffMsg-Field-RTCM-3');
	setFieldValidator('DiffMsg-Field-RTCM-9');
	setFieldValidator('DiffMsg-Field-RTCM-16');
	setFieldValidator('DiffMsg-Field-RTCM-18');
	setFieldValidator('DiffMsg-Field-RTCM-20');
	setFieldValidator('DiffMsg-Field-RTCM-22');
	setFieldValidator('DiffMsg-Field-RTCM-23');
	setFieldValidator('DiffMsg-Field-RTCM-24');
	setFieldValidator('DiffMsg-Field-RTCM-31');
	setFieldValidator('DiffMsg-Field-RTCM-32');
	setFieldValidator('DiffMsg-Field-RTCM-34');
	setFieldValidator('DiffMsg-Field-RTCM-36');
	
	setFieldValidator('DiffMsg-Field-RTCM-1001');
	setFieldValidator('DiffMsg-Field-RTCM-1002');
	setFieldValidator('DiffMsg-Field-RTCM-1003');
	setFieldValidator('DiffMsg-Field-RTCM-1004');
	setFieldValidator('DiffMsg-Field-RTCM-1005');
	setFieldValidator('DiffMsg-Field-RTCM-1006');
	setFieldValidator('DiffMsg-Field-RTCM-1007');
	setFieldValidator('DiffMsg-Field-RTCM-1008');
	setFieldValidator('DiffMsg-Field-RTCM-1009');
	setFieldValidator('DiffMsg-Field-RTCM-1010');
    setFieldValidator('DiffMsg-Field-RTCM-1011');
	setFieldValidator('DiffMsg-Field-RTCM-1012');
	setFieldValidator('DiffMsg-Field-RTCM-1013');
	setFieldValidator('DiffMsg-Field-RTCM-1019');
	setFieldValidator('DiffMsg-Field-RTCM-1020');
	setFieldValidator('DiffMsg-Field-RTCM-1029');
	setFieldValidator('DiffMsg-Field-RTCM-1033');
	
	// RTCM 3.2
	setFieldValidator('DiffMsg-Field-RTCM-1071');
	setFieldValidator('DiffMsg-Field-RTCM-1072');
	setFieldValidator('DiffMsg-Field-RTCM-1073');
	setFieldValidator('DiffMsg-Field-RTCM-1074');
	setFieldValidator('DiffMsg-Field-RTCM-1075');
	setFieldValidator('DiffMsg-Field-RTCM-1076');
	setFieldValidator('DiffMsg-Field-RTCM-1077');
	setFieldValidator('DiffMsg-Field-RTCM-1230');

	setFieldValidator('DiffMsg-Field-DBEN-RPC');
	setFieldValidator('DiffMsg-Field-DBEN-BPS');
	
	initFieldValidator();
}

function getPrefixName()
{
	return "DiffMsg";
}

function checkRefreshRate(ev, provider)
{
	var field = YAHOO.util.Event.getTarget(ev);
	notifyErrorProvider(provider, isNaN(field.value));
}

function validating_DiffMsg_Field_ATOM_Rate(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_ATOM_10(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_ATOM_11(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_CMR_0(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_CMR_1(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_CMR_2(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_CMR_3(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_3(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_9(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_16(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_18(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_19(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_20(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_21(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_22(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_23(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_24(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_31(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_32(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_34(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_36(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1001(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1002(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1003(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1004(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1005(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1006(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1007(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1008(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1009(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1010(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1011(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1012(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1013(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1019(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1020(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1029(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1033(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1071(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1072(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1073(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1074(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1075(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1076(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1077(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_RTCM_1230(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_DBEN_RPC(e, p) {checkRefreshRate(e, p);}
function validating_DiffMsg_Field_DBEN_BPS(e, p) {checkRefreshRate(e, p);}

function onRNXScenarioChanged( ev, target )
{
	setAtomPosition();
}
function setAtomPosition()
{
	var field = YAHOO.util.Dom.get('DiffMsg-Field-ATOM-RNXScenario');
	var value = 12;
	if ( field.value == 204 || field.value == 300 )
	{
		value = YAHOO.util.Dom.get('DiffMsg-Field-ATOM-Rate').value;
	}
	setFieldValue('DiffMsg-Field-ATOM-10', value );
}