function initEmailNotifications()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initEmailNotifications()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigEmailNotifications;
			
			setFieldValue('EmailNotify-Field-SmtpServer', config.SmtpServer);
			setFieldValue('EmailNotify-Field-SmtpPort', config.SmtpPort);
			
			setFieldValue('EmailNotify-Field-Username', config.Username);
			setFieldValue('EmailNotify-Field-Password', config.Password);
			
			setFieldValue('EmailNotify-Field-SenderEmail', config.SenderEmail);
			setFieldValue('EmailNotify-Field-NotifyEmail', config.NotifyEmail);
			
			//This field is postponed.
			//setFieldValue('EmailNotify-Field-Communication', config.Communication);
			
			setFieldValue('EmailNotify-Field-VerboseLevel', config.VerboseLevel);
			
			showConfigForm();
		},

		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initEmailNotifications()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	YAHOO.util.Connect.asyncRequest('GET', getConfigEmailNotifications, callbacks);
	
	makeFieldValidator('EmailNotify-Field-SmtpPort', 'validating_Port');
	
	makeFieldValidator('EmailNotify-Field-SenderEmail', 'validating_Email');
	makeFieldValidator('EmailNotify-Field-NotifyEmail', 'validating_Email');
}