function initEmbeddedCasterMountPoints()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initEmbeddedCasterMountPoints()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigEmbeddedCasterMountPoints;
			
			//Options
			optionsGlobal = config.Options;
			
			setItemDisplayed('OptionC-OFF',(optionsGlobal.indexOf("C") == -1));
			setItemDisplayed('OptionC-ON',(optionsGlobal.indexOf("C") != -1));
			
			disableField('Delete');
			
			setDefaultFields();
			
			var table = new fillMountPointListTable( config.MountPointList );
			
			// Show form
			showConfigForm();
		},

		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initEmbeddedCasterMountPoints()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigEmbeddedCasterMountPoints, callbacks);

	// Space in MountPoint Name
	makeFieldValidator('EmbeddedCasterMountPoints-Field-Name', 'validating_MountPointName' );
	
	makeFieldValidator('EmbeddedCasterMountPoints-Field-Country', 'validating_Country' );
	
	makeFieldValidator('EmbeddedCasterMountPoints-Field-Latitude', 'validating_Latitude' );
	makeFieldValidator('EmbeddedCasterMountPoints-Field-Longitude', 'validating_Longitude' );

	makeFieldValidator('EmbeddedCasterMountPoints-Field-Name', 'validating_NameCommaSemiColon');
	makeFieldValidator('EmbeddedCasterMountPoints-Field-Identifier', 'validating_SemiColon');
	makeFieldValidator('EmbeddedCasterMountPoints-Field-Format', 'validating_SemiColon');
	makeFieldValidator('EmbeddedCasterMountPoints-Field-FormatDetails', 'validating_SemiColon');
}

function validating_NameCommaSemiColon(ev, provider)
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = ((field.value.indexOf(";") == -1) && (field.value.indexOf(",") == -1)) ? true : false;
	
	notifyErrorProvider(provider, !valid);
}

function setDefaultFields() {
	setFieldValue('EmbeddedCasterMountPoints-Field-Name', '' );
	setFieldValue('EmbeddedCasterMountPoints-Field-Identifier', '' );
	setFieldValue('EmbeddedCasterMountPoints-Field-Format', '' );
	setFieldValue('EmbeddedCasterMountPoints-Field-FormatDetails', '' );
	setFieldValue('EmbeddedCasterMountPoints-Field-Country', 'FRA' );
	setFieldValue('EmbeddedCasterMountPoints-Field-Latitude', '0.00' );
	setFieldValue('EmbeddedCasterMountPoints-Field-Longitude', '0.00' );
	setFieldChecked('EmbeddedCasterMountPoints-Field-Fee', 0);
	setFieldChecked('EmbeddedCasterMountPoints-Field-Nmea', 1);
	
	mountPoints_Action('Modify');
}

function fillMountPointListTable( source )
{
	// Columns definition
	var myColumnDefs = 
	[
		{label:getResource('EmbeddedCasterMountPoints-Resource-Name'), key:"Name", formatter:fillMountPointListTable.formatText, resizeable:true, sortable:false},
		{label:getResource('EmbeddedCasterMountPoints-Resource-Identifier'), key:"Identifier", formatter:fillMountPointListTable.formatText, resizeable:true, sortable:false},
		{label:getResource('EmbeddedCasterMountPoints-Resource-Format'), key:"Format", formatter:fillMountPointListTable.formatText, resizeable:true, sortable:false},
		{label:getResource('EmbeddedCasterMountPoints-Resource-FormatDetails'), key:"FormatDetails", formatter:fillMountPointListTable.formatText, resizeable:true, sortable:false},
		{label:getResource('EmbeddedCasterMountPoints-Resource-Country'), key:"Country", formatter:fillMountPointListTable.formatText, resizeable:true, sortable:false},
		{label:getResource('EmbeddedCasterMountPoints-Resource-Latitude'), key:"Latitude", formatter:fillMountPointListTable.formatText, resizeable:true, sortable:false},
		{label:getResource('EmbeddedCasterMountPoints-Resource-Longitude'), key:"Longitude", formatter:fillMountPointListTable.formatText, resizeable:true, sortable:false},
		{label:getResource('EmbeddedCasterMountPoints-Resource-Fee'), key:"Fee", formatter:fillMountPointListTable.formatReadOnlyCheckBox, resizeable:true, sortable:false},
        {label:getResource('EmbeddedCasterMountPoints-Resource-Nmea'), key: "Nmea", formatter: fillMountPointListTable.formatReadOnlyCheckBox, resizeable: true, sortable: false }
    ];
	
		// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = { fields: ["Name","Identifier","Format","FormatDetails","Country","Latitude","Longitude","Fee","Nmea" ] };
	
		// Table configs
	var myConfigs =
	{
		width:"auto",
		height:"auto"
	};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('EmbeddedCasterMountPoints-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('EmbeddedCasterMountPoints-Resource-Loading');

	// Create table	
	var table = new YAHOO.widget.ScrollingDataTable("EmbeddedCasterMountPoints-Div-MountPointList", myColumnDefs, myDataSource, myConfigs);
	
	var rowClick = function selectRow( event )
	{
		enableField('Delete', true);
		var target = event.target;
		var record = table.getRecord( target );
		table.unselectAllCells();
		table.unselectAllRows();
		table.selectRow( table.getTrEl( record.getCount() ) );

		setFieldValue('EmbeddedCasterMountPoints-Field-Name', record.getData( "Name" ) );
		setFieldValue('EmbeddedCasterMountPoints-Field-Identifier', record.getData( "Identifier" ) );
		setFieldValue('EmbeddedCasterMountPoints-Field-Format', record.getData( "Format" ) );
		setFieldValue('EmbeddedCasterMountPoints-Field-FormatDetails', record.getData( "FormatDetails" ) );
		setFieldValue('EmbeddedCasterMountPoints-Field-Country', record.getData( "Country" ) );
		setFieldValue('EmbeddedCasterMountPoints-Field-Latitude', record.getData( "Latitude" ) );
		setFieldValue('EmbeddedCasterMountPoints-Field-Longitude', record.getData( "Longitude" ) );
		setFieldChecked('EmbeddedCasterMountPoints-Field-Fee', record.getData("Fee"));
		setFieldChecked('EmbeddedCasterMountPoints-Field-Nmea', record.getData("Nmea"));
		
		setFieldValue( 'EmbeddedCasterMountPoints_Delete_MountPointNameId', record.getData( "Name" ) );
	};
	
	table.subscribe( "rowClickEvent", rowClick );
}

fillMountPointListTable.formatText = function(el , oRecord , oColumn , oData)
{
	el.innerHTML = oData;
};

fillMountPointListTable.formatReadOnlyCheckBox = function(el, oRecord, oColumn, oData)
{
    var checked = oData ? " checked=\"checked\"" : "";
    el.innerHTML = "<input type=\"checkbox\"" + checked + " disabled='disabled'" + " class=\"" + "yui-dt-checkbox"  + "\" />";
};

function mountPoints_Action(status)
{
	setFieldValue( 'EmbeddedCasterMountPoints_Type', status );
}

function validating_Port(ev, provider)
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = !isNaN(field.value) && isValidInteger(field.value) && field.value >= 0 && field.value <= 65535;
	
	notifyErrorProvider(provider, !valid);
}

function validating_Latitude(ev, provider)
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = !isNaN(field.value) && field.value >= -90 && field.value <= 90
		&& (field.value.indexOf('.') == -1 || (field.value.length - field.value.indexOf('.') - 1 <= 2));
	
	notifyErrorProvider(provider, !valid);
}

function validating_Longitude(ev, provider)
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = !isNaN(field.value) && field.value >= -180 && field.value <= 180
		&& (field.value.indexOf('.') == -1 || (field.value.length - field.value.indexOf('.') - 1 <= 2));
	
	notifyErrorProvider(provider, !valid);
}

function validating_Country( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	var regexp = new RegExp("^[A-Z]{3}$");
	var valid = regexp.test( field.value );
	
	notifyErrorProvider(provider, !valid);
}

function validating_MountPointName( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	notifyErrorProvider(provider, !(field.value.indexOf(' ') == -1));
}