function initEmbeddedCasterMountPoints()
{
	var table1;
	
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initEmbeddedCasterMountPoints()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigEmbeddedCasterUsers;
			
			//Options
			optionsGlobal = config.Options;
			
			setItemDisplayed('OptionC-OFF',(optionsGlobal.indexOf("C") == -1));
			setItemDisplayed('OptionC-ON',(optionsGlobal.indexOf("C") != -1));
			
			setFieldPasswordVisible( 'EmbeddedCasterUsers-Field-Password', isFieldChecked( 'EmbeddedCasterUsers-Field-Password-Show' ) );
			
			setFieldValue('MountPointSize',config.MountPointList.length);
			
			var tablea = new fillMountPointListTable( config.MountPointList );
			var tableb = new fillUserListTable( config.UserList );
			
			setDefaultFields();
			
			// Show form
			showConfigForm();
		},

		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initEmbeddedCasterMountPoints()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigEmbeddedCasterUsers, callbacks);
	
	// Show Characters
	YAHOO.util.Event.addListener('EmbeddedCasterUsers-Field-Password-Show', 'click', onUsersPasswordShowClick);
}

function setDefaultFields() {
	setFieldValue('EmbeddedCasterUsers-Field-Username', '' );
	setFieldValue('EmbeddedCasterUsers-Field-Password', '' );
	
	var nodes = YAHOO.util.Selector.query('input[name^=MountPointAllowed]');
	
	for (j in nodes) {
		nodes[j].checked = false;
	}
	
	users_Action('Modify');
}

function fillMountPointListTable( source )
{
	// Columns definition
	var myColumnDefs = 
	[
		{label:getResource('EmbeddedCasterUsers-Resource-Allow'), key:"Allow", formatter:fillMountPointListTable.formatCheckBox, resizeable:true, sortable:false},
		{label:getResource('EmbeddedCasterUsers-Resource-Name'), key:"Name", formatter:fillMountPointListTable.formatText, resizeable:true, sortable:false},
		{label:getResource('EmbeddedCasterUsers-Resource-Identifier'), key:"Identifier", formatter:fillMountPointListTable.formatText, resizeable:true, sortable:false}
	];
	
		// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = { fields: ["Allow","Name","Identifier" ] };
	
		// Table configs
	var myConfigs =
	{
		width:"auto",
		height:"auto"
	};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('EmbeddedCasterUsers-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('EmbeddedCasterUsers-Resource-Loading');

	// Create table	
	table1 = new YAHOO.widget.DataTable("EmbeddedCasterUsers-Div-MountPointList", myColumnDefs, myDataSource, myConfigs);
}

fillMountPointListTable.formatText = function(el , oRecord , oColumn , oData)
{
	el.innerHTML = oData;
};

fillMountPointListTable.formatCheckBox = function(el, oRecord, oColumn, oData)
{
	//CHECKBOX VALUE
    var checked = " checked=\"checked\"";
    el.innerHTML = "<input type=\"checkbox\"" + checked + " name=\"MountPointAllowed" + oRecord.getCount() + "\" value=\"" + oRecord.getData("Name") + "\" class=\"" + "yui-dt-checkbox"  + "\" />";
};

function fillUserListTable( source )
{
	// Columns definition
	var myColumnDefs = 
	[
		{label:getResource('EmbeddedCasterUsers-Resource-Username'), key:"Username", formatter:fillUserListTable.formatText, resizeable:true, sortable:false},
		{label:getResource('EmbeddedCasterUsers-Resource-Password'), key:"Password", formatter:fillUserListTable.formatText, resizeable:true, sortable:false},
		{label:getResource('EmbeddedCasterUsers-Resource-MountPoints'), key:"MountPoints", formatter:fillUserListTable.formatText, resizeable:true, sortable:false}
	];
	
		// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = { fields: ["Username","Password","MountPoints" ] };
	
		// Table configs
	var myConfigs =
	{
		width:"auto",
		height:"auto"
	};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('EmbeddedCasterUsers-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('EmbeddedCasterUsers-Resource-Loading');

	// Create table	
	var table = new YAHOO.widget.ScrollingDataTable("EmbeddedCasterUsers-Div-UserList", myColumnDefs, myDataSource, myConfigs);
	
	var rowClick = function selectRow( event )
	{
		var rs = table1.getRecordSet();
		var target = event.target;
		var record = table.getRecord( target );
		table.unselectAllCells();
		table.unselectAllRows();
		table.selectRow( table.getTrEl( record.getCount() - table1.getRecordSet().getLength() ) );

		setFieldValue('EmbeddedCasterUsers-Field-Username', record.getData( "Username" ) );
		setFieldValue('EmbeddedCasterUsers-Field-Password', record.getData( "Password" ) );
		//Fill Checkboxes mount point list
		
		var targetTable = document.getElementById("EmbeddedCasterUsers-Div-MountPointList");
		var targetTBody = targetTable.getElementsByTagName("tbody")[1];
		
		var targetTRs = targetTBody.getElementsByTagName("tr");
		
		for (var i = 0; i < targetTRs.length; i++)
		{
			var targetTR = targetTRs[i];
			var targetName = targetTR.getElementsByTagName("td")[1].getElementsByTagName("div")[0].innerHTML;
			
			var targetInput = targetTR.getElementsByTagName("td")[0].getElementsByTagName("div")[0].getElementsByTagName("input")[0];
			
			
			targetInput.checked = (record.getData("MountPoints").indexOf(targetName) != -1) ? true : false;			
		}
		
		setFieldValue( 'EmbeddedCasterUsers_Delete_UsernameId', record.getData( "Username" ) );
	};
	
	table.subscribe( "rowClickEvent", rowClick );
	table.hideColumn('Password');
}

fillUserListTable.formatText = function(el , oRecord , oColumn , oData)
{
	el.innerHTML = oData;
};

function users_Action(status)
{
	setFieldValue( 'EmbeddedCasterUsers_Type', status );
}

function onUsersPasswordShowClick( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	setFieldPasswordVisible('EmbeddedCasterUsers-Field-Password', isFieldChecked(field));
}