function initEmbeddedFtp()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initEmbeddedFtp()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigEmbeddedFtp;
			
			setFieldChecked('EmbeddedFtp-Field-Activation', config.Activation);
			
			setFieldValue('EmbeddedFtp-Field-Port', config.Port);
			
			setFieldValue('EmbeddedFtp-Field-Location', config.Location);
			
			setFieldValue('EmbeddedFtp-Field-Path', config.Path);
			
			setFieldValue('EmbeddedFtp-Field-AdminUsername', config.AdminUsername);
			setFieldValue('EmbeddedFtp-Field-AdminPassword', config.AdminPassword);
			setFieldPasswordVisible( 'EmbeddedFtp-Field-AdminPassword', isFieldChecked( 'EmbeddedFtp-Field-AdminPassword-Show' ) );
			//setFieldChecked( 'EmbeddedFtp-Field-AdminPassword-Show', isFieldPasswordVisible( 'EmbeddedFtp-Field-AdminPassword' ) );
			
			setFieldValue( 'EmbeddedFtp-Field-Username', '' );
			setFieldValue( 'EmbeddedFtp-Field-Password', '' );
			
			setFieldPasswordVisible( 'EmbeddedFtp-Field-Password', isFieldChecked( 'EmbeddedFtp-Field-Password-Show' ) );
			//setFieldChecked( 'EmbeddedFtp-Field-Password-Show', isFieldPasswordVisible( 'EmbeddedFtp-Field-Password' ) );
			
			var table = new fillEmbeddedFtpUsersTable( config.Users );
			
			// Show form
			showConfigForm();
			showForm('users_form');
		},

		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initEmbeddedFtp()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigEmbeddedFtp, callbacks);
	
	// Show Characters
	YAHOO.util.Event.addListener('EmbeddedFtp-Field-AdminPassword-Show', 'click', onEmbeddedFtpAdminPasswordShowClick);
	YAHOO.util.Event.addListener('EmbeddedFtp-Field-Password-Show', 'click', onEmbeddedFtpPasswordShowClick);
	
	makeFieldValidator('EmbeddedFtp-Field-Port', 'validating_Port' );
}

function fillEmbeddedFtpUsersTable( source )
{
	// Columns definition
	var myColumnDefs = 
	[
		{label:getResource('EmbeddedFtp-Resource-Username'), key:"Username", formatter:fillEmbeddedFtpUsersTable.formatText, resizeable:true, sortable:false},
		{label:getResource('EmbeddedFtp-Resource-Password'), key:"Password", formatter:fillEmbeddedFtpUsersTable.formatText, resizeable:true, sortable:false}
	];
	
	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = { fields: ["Username", "Password" ] };
	
		// Table configs
	var myConfigs =
	{
		width:"auto",
		height:"auto"
	};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('EmbeddedFtp-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('EmbeddedFtp-Resource-Loading');

	// Create table	
	var table = new YAHOO.widget.DataTable("EmbeddedFtpView", myColumnDefs, myDataSource, myConfigs);
	
	var rowClick = function selectRow( event )
	{
		var target = event.target;
		var record = table.getRecord( target );
		table.unselectAllCells();
		table.unselectAllRows();
		table.selectRow( table.getTrEl( record.getCount() ) );
		
		setFieldValue( 'EmbeddedFtp-Field-Username', record.getData( "Username" ) );
		setFieldValue( 'EmbeddedFtp-Field-Password', record.getData( "Password" ) );
	};
	
	table.subscribe( "rowClickEvent", rowClick );
	table.hideColumn('Password');
}

fillEmbeddedFtpUsersTable.formatText = function(el , oRecord , oColumn , oData)
{
	el.innerHTML = oData;
};

function EmbeddedFtp_Modify()
{
	setFieldValue('EmbeddedFtp-Field-Type', 'Modify');
}

function EmbeddedFtp_Delete()
{
	setFieldValue('EmbeddedFtp-Field-Type', 'Delete');
	disableField('EmbeddedFtp-Field-Password');
}

function onEmbeddedFtpAdminPasswordShowClick(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	setFieldPasswordVisible('EmbeddedFtp-Field-AdminPassword', isFieldChecked(field));
}

function onEmbeddedFtpPasswordShowClick(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	setFieldPasswordVisible('EmbeddedFtp-Field-Password', isFieldChecked(field));
}
