var ddnGlobal;

function initEthernet()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initEthernet()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigEthernet;
			if (config == null) return;

			// Get Ethernet config
			var ethernet = config.Ethernet;
			if (ethernet == null) return;

			// -- MAC Address --
			setFieldValue('Ethernet-Field-MacAddress', ethernet.MacAddress);

			// -- DHCP --
			setFieldChecked('Ethernet-Field-DHCP', ethernet.Dhcp);
			enableIPConfig(ethernet.Dhcp);

			// -- IP Address --
			setFieldValue('Ethernet-Field-IpAddress', ethernet.IpAddress);

			// -- Subnetwork Mask --
			setFieldValue('Ethernet-Field-SubNetworkMask', ethernet.SubNetworkMask);

			// -- Gateway --
			setFieldValue('Ethernet-Field-GatewayIpAddress', ethernet.GatewayIpAddress);

			// -- DNS1 --
			setFieldValue('Ethernet-Field-Dns1IpAddress', ethernet.Dns1IpAddress);

			// -- DNS2 --
			setFieldValue('Ethernet-Field-Dns2IpAddress', ethernet.Dns2IpAddress);


			// Get TCP config
			var tcp = config.Tcp;
			if (tcp == null) return;

			// -- Mode --
			setFieldValue('Ethernet-Field-TCP-Mode', tcp.Mode);

			// -- Port --
			setFieldValue('Ethernet-Field-TCP-Port', tcp.Port);
			
			// -- Login --
			setFieldValue('Ethernet-Field-TCP-Login', tcp.Login);
			
			// -- Password --
			setFieldValue('Ethernet-Field-TCP-Password', tcp.Password);
			setFieldPasswordVisible( 'Ethernet-Field-TCP-Password', isFieldChecked( 'Ethernet-Field-TCP-Password-Show' ) );
			//setFieldChecked('Ethernet-Field-TCP-Password-Show', isFieldPasswordVisible('Ethernet-Field-TCP-Password'));

			
			// Get DynDNS config
			var dyndns = config.DynDNS;
			if (dyndns == null) return;
			
			ddnGlobal = dyndns;

			// -- Mode --
			setFieldChecked('Ethernet-Field-DDN-Activation', dyndns.Activation);
			setFieldValue('Ethernet-Field-DDN-System', dyndns.System);
			setFieldValue('Ethernet-Field-DDN-Username', dyndns.Username);
			setFieldValue('Ethernet-Field-DDN-Password', dyndns.Password);
			setFieldValue('Ethernet-Field-DDN-Hostname', dyndns.Hostname);
			setFieldValue('Ethernet-Field-DDN-Period',dyndns.Period);
			setFieldValue('Ethernet-Field-DDN-Hidden',0);
			
			if (dyndns.Activation != 1)
				document.getElementById('DDN-Force-Update').disabled = true;

			// -- Port --
			setFieldValue('Ethernet-Field-TCP-Port', tcp.Port);
			
			// -- Login --
			setFieldValue('Ethernet-Field-TCP-Login', tcp.Login);
			
			// -- Password --
			setFieldValue('Ethernet-Field-TCP-Password', tcp.Password);
			setFieldPasswordVisible( 'Ethernet-Field-TCP-Password', isFieldChecked( 'Ethernet-Field-TCP-Password-Show' ) );
			//setFieldChecked('Ethernet-Field-TCP-Password-Show', isFieldPasswordVisible('Ethernet-Field-TCP-Password'));

			
			document.getElementById('DDN-Force-Update').disabled = !isFieldChecked( 'Ethernet-Field-DDN-Activation' );
			
			// Show form
			showConfigForm();	
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("initEthernet()", 5000);
		},

		timeout : 10000,
		cache : false
    };

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigEthernetURL, callbacks);

	// DHCP clicked
	YAHOO.util.Event.addListener('Ethernet-Field-DHCP', 'click', onDHCPClick);
	
	// Show Characters
	YAHOO.util.Event.addListener('Ethernet-Field-TCP-Password-Show', 'click', onTCPPasswordShowClick);
	
	//Update Now button
	YAHOO.util.Event.addListener('DDN-Force-Update', 'click', onUpdateNowClick);
	YAHOO.util.Event.addListener('Ethernet-Field-DDN-Activation', 'click', onActivationClick);
	YAHOO.util.Event.addListener('Ethernet-Field-DDN-System', 'keyup', onActivationClick);
	YAHOO.util.Event.addListener('Ethernet-Field-DDN-System', 'blur', onActivationClick);
	YAHOO.util.Event.addListener('Ethernet-Field-DDN-Username', 'keyup', onActivationClick);
	YAHOO.util.Event.addListener('Ethernet-Field-DDN-Username', 'blur', onActivationClick);
	YAHOO.util.Event.addListener('Ethernet-Field-DDN-Password', 'keyup', onActivationClick);
	YAHOO.util.Event.addListener('Ethernet-Field-DDN-Password', 'blur', onActivationClick);
	YAHOO.util.Event.addListener('Ethernet-Field-DDN-Hostname', 'keyup', onActivationClick);
	YAHOO.util.Event.addListener('Ethernet-Field-DDN-Hostname', 'blur', onActivationClick);
	YAHOO.util.Event.addListener('Ethernet-Field-DDN-Period', 'keyup', onActivationClick);
	YAHOO.util.Event.addListener('Ethernet-Field-DDN-Period', 'blur', onActivationClick);
	
	// Field validation
	setFieldValidator('Ethernet-Field-IpAddress');
	setFieldValidator('Ethernet-Field-SubNetworkMask');
	setFieldValidator('Ethernet-Field-GatewayIpAddress');
	setFieldValidator('Ethernet-Field-Dns1IpAddress');
	setFieldValidator('Ethernet-Field-Dns2IpAddress');
	initFieldValidator();
	
	makeFieldValidator('Ethernet-Field-TCP-Port', 'validating_Port');
}

function onDHCPClick(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);

	enableIPConfig(isFieldChecked(field));
}

function onUpdateNowClick(ev)
{
	setFieldValue('Ethernet-Field-DDN-Hidden', 1);
}

function onActivationClick(ev)
{
	var status = !isFieldChecked( 'Ethernet-Field-DDN-Activation' );
	
	if (ddnGlobal.Activation != 1 || 
		getFieldValue('Ethernet-Field-DDN-System') != ddnGlobal.System || 
		getFieldValue('Ethernet-Field-DDN-Username') != ddnGlobal.Username || 
		getFieldValue('Ethernet-Field-DDN-Password') != ddnGlobal.Password || 
		getFieldValue('Ethernet-Field-DDN-Hostname') != ddnGlobal.Hostname || 
		getFieldValue('Ethernet-Field-DDN-Period') != ddnGlobal.Period)
		status = true;
	
	document.getElementById('DDN-Force-Update').disabled = status;
}

function onTCPPasswordShowClick(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	setFieldPasswordVisible('Ethernet-Field-TCP-Password', isFieldChecked(field));
}

function enableIPConfig(dhcp)
{
	setItemDisplayed('Ethernet-Group-IP', !dhcp);
	setFieldVisible( 'Ethernet-Field-Dns1IpAddress', !dhcp );
	setFieldVisible( 'Ethernet-Field-Dns2IpAddress', !dhcp );
}

function checkIP(ev, provider)
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = isValidAddressIP(field.value);
	
	notifyErrorProvider(provider, !valid);
}

function validating_Ethernet_Field_IpAddress(e, p) 			{checkIP(e, p);}
function validating_Ethernet_Field_SubNetworkMask(e, p) 	{checkIP(e, p);}
function validating_Ethernet_Field_GatewayIpAddress(e, p) 	{checkIP(e, p);}
function validating_Ethernet_Field_Dns1IpAddress(e, p) 		{checkIP(e, p);}
function validating_Ethernet_Field_Dns2IpAddress(e, p) 		{checkIP(e, p);}
