//After changing storage we move current folder to /
//If we change storage or current location, we need to remove all selections and set total size of selected files to 0.
var filesSeparator = ';';
var storageCookie = 'FileManagerStorage';
var storageRadioItems = new Array( 'FileManager-Button-InternalMemory', 'FileManager-Button-UsbKey' );

var initTableView = false;

var paper;
var batteryHeight = 20;
var batteryWidth = 200;
var backgroundRect;
var currentFilenameText;
var currentFilenameRect;

function initFileManager()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{

		revive : function (k,v)
		{

			if (k == "DateTime")
			{
				try
				{
					return YAHOO.lang.JSON.stringToDate(v);
				}
				catch (x) {
					YAHOO.log("ERROR: JSON revive failed!");
				}
			}
	
			return v;
		},

		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText, callbacks.revive);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initFileManager()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigFileManager;
			if (config == null) return;
			
			// Show loading before first requestFile...
			setItemText('FileTableView-Loading', getResource('FileManager-Resource-Loading'));
			
			//Options
			optionsGlobal = config.Options;
			
			// FTP Status Raphael js
			paper = Raphael(document.getElementById("paper"), batteryWidth, batteryHeight);
			backgroundRect = paper.rect(0,0,batteryWidth,batteryHeight).attr({ "stroke": "#cccccc", "stroke-width": 2 });
			currentFilenameText = paper.text(batteryWidth / 2,12, "").attr({"font-size": 12, "font-weight": "bold","fill": "#000000"});
			currentFilenameRect = paper.rect(0,0,0,batteryHeight).attr({ "fill": "#007dc3", "stroke": "none" });
			
			setItemText('FileManager-Status-FTP-Field', document.getElementById('TransferfilestoFTPserver').innerHTML);
			setItemText('FileManager-Status-USB-Field', document.getElementById('FileManager-Button-CopyToUSB').innerHTML);
			setItemText('FileManager-Status-RINEX-Field', document.getElementById('FileManager-Files-ConvertIntoRinex').innerHTML);			
			
			var showWorkInProgress = false;
			if (config.USBTransfer.State != 1)
			{
				enableField('FileManager-Button-CopyToUSB', true);
				setItemText('FileManager-Status-USB-Value', '');
			} else {
				disableField('FileManager-Button-CopyToUSB');
				showWorkInProgress = true;
				setItemText('FileManager-Status-USB-Value', getResource('FileManager-Resource-InProgress'));
			}
			
			if (config.FTPTransfer.State != 1)
			{
				enableField('TransferfilestoFTPserver', true);
				setItemText('FileManager-Status-FTP-Value', '');
				setItemDisplayed('FileManager-Status-FTP-Drawing', false);
				currentFilenameText.attr("text",'');
				currentFilenameRect.attr("width",0);
				currentFilenameRect.toBack();
			} else {
				disableField('TransferfilestoFTPserver');
				setItemDisplayed('FileManager-Status-FTP-Drawing', true);
				showWorkInProgress = true;
				setItemText('FileManager-Status-FTP-Value', getResource('FileManager-Resource-InProgress'));
				currentFilenameText.attr("text",config.FTPTransfer.FileName);
				currentFilenameRect.attr("width",Math.round((config.FTPTransfer.Progress / 100) * batteryWidth));
				currentFilenameRect.toBack();
			}
			
			if (config.RINEXConversion.State != 1)
			{
				enableField('FileManager-Files-ConvertIntoRinex', true);
				setItemText('FileManager-Status-RINEX-Value', '');
			} else {
				disableField('FileManager-Files-ConvertIntoRinex');
				showWorkInProgress = true;
				setItemText('FileManager-Status-RINEX-Value', getResource('FileManager-Resource-InProgress'));
			}
			
			setItemDisplayed('FileManager-FieldSet-ProcessStatus', showWorkInProgress);
			
			
			setFieldVisible('FileManager-Field-Rinex-DisableGALILEO',(optionsGlobal.indexOf("O") != -1));
			setItemDisplayed('FileManager-Field-Rinex-GalileoNavComment-Fieldset', (optionsGlobal.indexOf("O") != -1));
			
			// -- Internal Memory --
			setItemText('FileManager-Item-IntMem-PercentFree', config.InternalMemory.PercentFree);
			setItemText('FileManager-Item-IntMem-SizeUsed', formatTextAsMemorySize(config.InternalMemory.SizeUsed));
			setItemText('FileManager-Item-IntMem-SizeFree', formatTextAsMemorySize(config.InternalMemory.SizeFree));
			//setItemText('FileManager-Item-IntMem-FileCount', config.InternalMemory.FileCount);
			if (config.InternalMemory.FileCount >= 500) setItemText('FileManager-Item-IntMem-FileCount', '500++');
            else setItemText('FileManager-Item-IntMem-FileCount', config.InternalMemory.FileCount);
            
			// -- USB key --
			setItemText('FileManager-Item-UsbKey-PercentFree', config.UsbKey.PercentFree);
			setItemText('FileManager-Item-UsbKey-SizeUsed', formatTextAsMemorySize(config.UsbKey.SizeUsed));
			setItemText('FileManager-Item-UsbKey-SizeFree', formatTextAsMemorySize(config.UsbKey.SizeFree));
			//setItemText('FileManager-Item-UsbKey-FileCount', config.UsbKey.FileCount);
			if (config.UsbKey.FileCount >= 500) setItemText('FileManager-Item-UsbKey-FileCount', '500++');
            else setItemText('FileManager-Item-UsbKey-FileCount', config.UsbKey.FileCount);

			// -- Storage Location for Recording --
			setItemText('FileManager-Item-RecordingStorageLocation', getStorageLocation( config.RecordingStorageLocation ) );
			
			// -- Storage Location for Session --
			var text = getStorageLocation( config.SessionStorageLocation );
			if (config.SessionFileMove != null)
			{
				text += " {0} {1} ".format(getResource('FileManager-Resource-AndMovedTo'), getStorageLocation(config.SessionFileMove));
				if (config.SessionFileMoveDirectory != null && config.SessionFileMoveDirectory.length > 0)
				{
					text += " ({0})".format(config.SessionFileMoveDirectory);
				}
			}
			setItemText('FileManager-Item-SessionStorageLocation',  text);
			
			//Rinex Settings
			setFieldChecked( 'FileManager-Button-Rinex-V211', (config.Rinex.Version == 0 || config.Rinex.Version == 1) );
			setFieldChecked( 'FileManager-Button-Rinex-V301', (config.Rinex.Version == 2 || config.Rinex.Version == 3) );
			
			setFieldChecked( 'FileManager-Field-HatanakaCompression', config.Rinex.HatanakaCompression == 1);
			setFieldChecked( 'FileManager-Field-TarzCompression', config.Rinex.TarzCompression == 1);
			
			setFieldChecked( 'FileManager-Field-Rinex-ModifyRate', config.Rinex.ModifyRate == 1 );
			setFieldValue( 'FileManager-Field-Rinex-Rate', config.Rinex.Rate );
			setFieldVisible( 'FileManager-Field-Rinex-Rate', config.Rinex.ModifyRate == 1 );
			setFieldChecked( 'FileManager-Field-Rinex-DisableGLONASS', config.Rinex.DisableGLONASS == 1 );
			setFieldChecked( 'FileManager-Field-Rinex-DisableSBAS', config.Rinex.DisableSBAS == 1 );
			setFieldChecked( 'FileManager-Field-Rinex-DisableGALILEO', config.Rinex.DisableGALILEO == 1 );
			
			setFieldValue( 'FileManager-Field-Rinex-Agency', config.Rinex.Agency );
			setFieldValue( 'FileManager-Field-Rinex-Observer', config.Rinex.Observer );
			setFieldValue( 'FileManager-Field-Rinex-MarkerName', config.Rinex.MarkerName );
			setFieldValue( 'FileManager-Field-Rinex-MarkerNumber', config.Rinex.MarkerNumber );
			setFieldValue( 'FileManager-Field-Rinex-ObservationComment', config.Rinex.ObservationComment );
			setFieldValue( 'FileManager-Field-Rinex-GpsNavComment', config.Rinex.GpsNavComment );
			setFieldValue( 'FileManager-Field-Rinex-GlonassNavComment', config.Rinex.GlonassNavComment );
			setFieldValue( 'FileManager-Field-Rinex-SbasNavComment', config.Rinex.SbasNavComment );
			setFieldValue( 'FileManager-Field-Rinex-GalileoNavComment', config.Rinex.GalileoNavComment );
			setFieldValue( 'FileManager-Field-Rinex-MeteoComment', config.Rinex.MeteoComment );
			setFieldValue( 'FileManager-Field-Rinex-MeteoManufacturer', config.Rinex.MeteoSensorManufacturer );
			setFieldValue( 'FileManager-Field-Rinex-MeteoSensorType', config.Rinex.MeteoSensorType );
			setFieldValue( 'FileManager-Field-Rinex-TemperatureAccuracy', parseFloat( config.Rinex.TemperatureAccuracy ).toFixed( 1 ) );
			setFieldValue( 'FileManager-Field-Rinex-PressureAccuracy', parseFloat( config.Rinex.PressureAccuracy ).toFixed( 1 ) );
			setFieldValue( 'FileManager-Field-Rinex-HumidityAccuracy', parseFloat( config.Rinex.HumidityAccuracy ).toFixed( 1 ) );
				
			//External ftp
			setFieldValue( 'FileManager-Field-Ftp-Server', config.Ftp.Server );
			setFieldValue( 'FileManager-Field-Ftp-Port', config.Ftp.Port );
			setFieldValue( 'FileManager-Field-Ftp-Username', config.Ftp.Username );
			setFieldValue( 'FileManager-Field-Ftp-Password', config.Ftp.Password );
			setFieldValue( 'FileManager-Field-Ftp-Path', config.Ftp.Path );
			//Uncomment when Push Modem works (Gilles)
			/*
			if (config.Ftp.IPP == "")
			{
				config.Ftp.IPP = "P";
			}
			setFieldValue( 'FileManager-Field-Ftp-IPP', config.Ftp.IPP );
			*/
				
			var storage = YAHOO.util.Cookie.get( storageCookie );
			if ( storage != null )
			{
				checkRadioButton( storageRadioItems, storage );				
				setItemVisible('FileManager-Button-CopyToUSB', storage != 2);
			}
			
			setFieldValue( 'FileManager-SelectedFiles', '' );
			
			requestFileList();
			// Show form
			showConfigForm();
			
			setTimeout("updateFileManager()", 5000);
		},

		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("initFileManager()", 5000);
		},

		timeout : 10000,
		cache : false
    };

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigFileManagerURL, callbacks);

	YAHOO.util.Event.addListener( 'FileManager-Button-InternalMemory', 'click', onStorageChanged );
	YAHOO.util.Event.addListener( 'FileManager-Button-UsbKey', 'click', onStorageChanged );
	YAHOO.util.Event.addListener( 'FileManager-Field-Rinex-ModifyRate', 'click', onModifyRateChanged );
	
	makeFieldValidator( 'FileManager-Field-Ftp-Server', 'validating_Host' );
	makeFieldValidator('FileManager-Field-Ftp-Port', 'validating_Port' );
	
	makeFieldValidator( 'FileManager-Field-Rinex-Rate', 'validating_Rate' );
	
	makeFieldValidator( 'FileManager-Field-Rinex-ObservationComment', 'validating_Comment' );
	makeFieldValidator( 'FileManager-Field-Rinex-GpsNavComment', 'validating_Comment' );
	makeFieldValidator( 'FileManager-Field-Rinex-GlonassNavComment', 'validating_Comment' );
	makeFieldValidator( 'FileManager-Field-Rinex-SbasNavComment', 'validating_Comment' );
	makeFieldValidator( 'FileManager-Field-Rinex-GalileoNavComment', 'validating_Comment' );
	makeFieldValidator( 'FileManager-Field-Rinex-MeteoComment', 'validating_Comment' );
	makeFieldValidator( 'FileManager-Field-Rinex-TemperatureAccuracy', 'validating_Accuracy' );
	makeFieldValidator( 'FileManager-Field-Rinex-PressureAccuracy', 'validating_Accuracy' );
	makeFieldValidator( 'FileManager-Field-Rinex-HumidityAccuracy', 'validating_Accuracy' );
}

var currentFileList = [];

function getCurrentFileList()
{
	return currentFileList;
}

function updateFileManager()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateFileManager()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get config
			var config = data.ConfigFileManager;
			if (config == null) return;
			
			//Options
			optionsGlobal = config.Options;
			
			var showWorkInProgress = false;
			if (config.USBTransfer.State != 1)
			{
				enableField('FileManager-Button-CopyToUSB', true);
				setItemText('FileManager-Status-USB-Value', '');
			} else {
				disableField('FileManager-Button-CopyToUSB');
				showWorkInProgress = true;
				setItemText('FileManager-Status-USB-Value', getResource('FileManager-Resource-InProgress'));
			}
			
			if (config.FTPTransfer.State != 1)
			{
				enableField('TransferfilestoFTPserver', true);
				setItemText('FileManager-Status-FTP-Value', '');
				setItemDisplayed('FileManager-Status-FTP-Drawing', false);
				currentFilenameText.attr("text",'');
				currentFilenameRect.attr("width",0);
				currentFilenameRect.toBack();
			} else {
				disableField('TransferfilestoFTPserver');
				setItemDisplayed('FileManager-Status-FTP-Drawing', true);
				showWorkInProgress = true;
				setItemText('FileManager-Status-FTP-Value', getResource('FileManager-Resource-InProgress'));
				currentFilenameText.attr("text",config.FTPTransfer.FileName);
				currentFilenameRect.attr("width",Math.round((config.FTPTransfer.Progress / 100) * batteryWidth));
				currentFilenameRect.toBack();
			}
			
			if (config.RINEXConversion.State != 1)
			{
				enableField('FileManager-Files-ConvertIntoRinex', true);
				setItemText('FileManager-Status-RINEX-Value', '');
			} else {
				disableField('FileManager-Files-ConvertIntoRinex');
				showWorkInProgress = true;
				setItemText('FileManager-Status-RINEX-Value', getResource('FileManager-Resource-InProgress'));
			}
			
			setItemDisplayed('FileManager-FieldSet-ProcessStatus', showWorkInProgress);
			
						
			setFieldVisible('FileManager-Field-Rinex-DisableGALILEO',(optionsGlobal.indexOf("O") != -1));
			setItemDisplayed('FileManager-Field-Rinex-GalileoNavComment-Fieldset', (optionsGlobal.indexOf("O") != -1));
			
			// -- Internal Memory --
			setItemText('FileManager-Item-IntMem-PercentFree', config.InternalMemory.PercentFree);
			setItemText('FileManager-Item-IntMem-SizeUsed', formatTextAsMemorySize(config.InternalMemory.SizeUsed));
			setItemText('FileManager-Item-IntMem-SizeFree', formatTextAsMemorySize(config.InternalMemory.SizeFree));
//			setItemText('FileManager-Item-IntMem-FileCount', config.InternalMemory.FileCount);
			if (config.InternalMemory.FileCount >= 500) setItemText('FileManager-Item-IntMem-FileCount', '500++');
            else setItemText('FileManager-Item-IntMem-FileCount', config.InternalMemory.FileCount);


			// -- USB key --
			setItemText('FileManager-Item-UsbKey-PercentFree', config.UsbKey.PercentFree);
			setItemText('FileManager-Item-UsbKey-SizeUsed', formatTextAsMemorySize(config.UsbKey.SizeUsed));
			setItemText('FileManager-Item-UsbKey-SizeFree', formatTextAsMemorySize(config.UsbKey.SizeFree));
//			setItemText('FileManager-Item-UsbKey-FileCount', config.UsbKey.FileCount);
			if (config.UsbKey.FileCount >= 500) setItemText('FileManager-Item-UsbKey-FileCount', '500++');
            else setItemText('FileManager-Item-UsbKey-FileCount', config.UsbKey.FileCount);

			// -- Update current File List Source --
			requestFileList();
			
			setTimeout("updateFileManager()", 5000);
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateFileManager()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getConfigFileManagerURL, callbacks);
}

function requestFileList()
{
	var callbacks =
	{
		success : function (o)
		{
			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("requestFileList()", 5000);
				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigFileList;
			if (config == null) return;
			
			// Get path
			var path = (config.Path != null  ? config.Path : '/');
			if (path.length == 0 || path[path.length - 1] != '/') path += '/';
			
			// Set current path (for next POST)
			setFieldValue('FileManager-CurrentPath', path );
			
			// Show current folder
			setItemText('FileManager-CurrentFolder', path);
			
			setFieldChecked( 'FileManager-Button-InternalMemory', config.Storage == 0 );
			setFieldChecked( 'FileManager-Button-UsbKey', config.Storage == 2 );
			
			updateSelectedFilesField( config.Files );
			
			//var fileView = new FileTableView(config.Files);
			currentFileList = config.Files;
			if (initTableView == false)
			{
				initTableView = true;
				var fileView = new FileTableView(getCurrentFileList);
			}
			
			updateTable();
			
			setItemText('FileTableView-Loading', '');
			
		},
		failure : function(o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
					YAHOO.log("ERROR: Async call failed!");
			}
				
			// Retry
			setTimeout("requestFileList()", 5000);
		},

		timeout : 10000,
		cache : false
	};
	
	//Show user that we are processing his request	
	setItemText('FileTableView-Loading', getResource('FileManager-Resource-Loading'));
	
	var path = getFieldValue('FileManager-CurrentPath');
	var url = getFileListURL + '&Storage=' + getStorageFieldValue() + '&Path=' + path;
	
	YAHOO.util.Connect.asyncRequest('GET', url, callbacks);
}

var myDataTable;
function FileTableView(source)
{
	// Columns definition
	var headerCheckbox = '<input type=\"checkbox\" id="FileManager-TableHeader-NameCheckbox"' + ' class=\"' + 'yui-dt-checkbox'  + '\" />';
	var nameLabel = getResource( 'FileManager-Resource-Name' );

	//Try to duplicate exist field
	//I'm not sure that it is a best way to do this, but haven't found better way
	for( var i in source )
	{
		source[ i ].dummy = 'dummy';
	}
	
	var myColumnDefs =
	[
		{label:headerCheckbox, key:'dummy', formatter:FileTableView.checkboxFormatter, resizeable:false, sortable:false },
		{label:nameLabel, key:"Name", width:345, formatter:FileTableView.formatFilename, resizeable:true, sortable:true },
		{label:getResource('FileManager-Resource-Size'), key:"Size", formatter:FileTableView.formatSize, resizeable:true, sortable:true},
		//{label:getResource('FileManager-Resource-Type'), key:"Type", hidden:true, formatter:FileTableView.formatType, resizeable:true, sortable:true},
		//{label:getResource('FileManager-Resource-CreationDate'), key:"CreationDate", hidden:true, formatter:FileTableView.formatDateTime, resizeable:true, sortable:true},
		{label:getResource('FileManager-Resource-ModificationDate'), key:"ModificationDate", formatter:FileTableView.formatDateTime, resizeable:true, sortable:true},
		{label:'', key:'InUse', hidden:true}
	];

	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema =
	{
		fields: [ "dummy", "Name","Size","Type","CreationDate","ModificationDate","InUse"]
	};
	
	myDataSource.doBeforeCallback = function( req, raw, res, cb )
	{
		//We don't need to do anything if G-Files isn't checked.
		if ( !isFieldChecked( 'FileManager-Files-GFile' ) )
			return res;
		
		var filtered = [];
		for( var i in res.results )
		{
			//This is just file, so do not use it
			if ( res.results[ i ].Type != 2 )
			{
				filtered.push( res.results[ i ] );
			}
		}		
		res.results = filtered;
		return res;
	};

	// Table configs
	var myConfigs = {
		width:"auto",
		height:"auto"
	};

	// Localized messages
	myConfigs.MSG_EMPTY = getResource('FileManager-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('FileManager-Resource-Loading');
	myConfigs.MSG_SORTASC = getResource('FileManager-Resource-SortAsc');
	myConfigs.MSG_SORTDESC = getResource('FileManager-Resource-SortDesc');

	// Create table
	myDataTable = new YAHOO.widget.DataTable("FileTableView", myColumnDefs, myDataSource, myConfigs);

	var rowClick = function toFolder( event )
	{
		var target = event.target;
		var record = myDataTable.getRecord( target );
		var path = getFieldValue('FileManager-CurrentPath');
		
		if( record.getData('Type') != 0 )
			return;

		var requestPath = record.getData( 'Name' ) + '/';
		if ( requestPath == '../' )
		{
			requestPath = '';
			
			if ( path.length < 2 )
				return;
				
			path = path.substr( 0, path.lastIndexOf( '/', path.length - 2 ) ); 
		}
			
		if( path[ path.length - 1 ] != '/' )
			path += '/';
			
		path += requestPath;

		setFieldValue( 'FileManager-CurrentPath', path );
		changeLocation();
	};
	
	var checkboxClick = function onCheckboxClick( event )
	{
		var target = event.target;
		var record = myDataTable.getRecord( target );
		var name = record.getData( 'Name' );
		
		var isSelected = isFieldChecked( name );
		
		if ( isFieldChecked( name ) )
			selectFile( name, record, myDataTable );
		else
			unSelectFile( name, record, myDataTable );
	};
	
	//myDataTable.subscribe( "rowClickEvent", rowClick );
	myDataTable.subscribe( "checkboxClickEvent", checkboxClick );
	myDataTable.subscribe( "linkClickEvent", rowClick );
	
    YAHOO.util.Event.on('FileManager-Files-GFile','click',function (e) {
    	updateTable();
    });
	
	YAHOO.util.Event.on( 'FileManager-TableHeader-NameCheckbox', 'click', function(e){ onHeaderCheckboxClick( myDataTable ); } );
	
	initSelectedFilesSize( myDataTable );
	if ( isAllFilesSelected( myDataTable ) )
		setFieldChecked( 'FileManager-TableHeader-NameCheckbox', true );
	
	YAHOO.util.Event.addListener('timezone', 'change', updateTable );
	
	//setInterval(updateTable,5000);	
}

function updateTable()
{
	sortState = myDataTable.getState().sortedBy;
	var sort = sortState ? sortState.key : "id";
	var dir = sortState ? sortState.dir : "yui-dt-desc";
	if (initTableView == false)
	{
		myDataTable.showTableMessage(getResource('FileManager-Resource-Loading'));
	}
	myDataTable.getDataSource().sendRequest('request', { success: myDataTable.onDataReturnInitializeTable, scope: myDataTable });
	myDataTable.sortColumn(myDataTable.getColumn(sort),dir);
}


function formatTextAsFileSize(size)
{
	return formatTextAsMemorySize( size );
}

FileTableView.checkboxFormatter = function( elem, record, column, data )
{
	var id = record.getData('Name');
	var checked = isFileSelected( id ) ? 'checked="checked"' : '';
	var checkbox = '<input type="checkbox" id="' + id + '" ' + checked + ' class="yui-dt-checkbox" />';
	if( id == '..' || record.getData( 'InUse' ) )
		return;
	elem.innerHTML = checkbox;
};
FileTableView.formatText = function( elem , record , oColumn , data)
{	
	elem.innerHTML = data;
	markInUse( record, elem );
};

FileTableView.formatFilename = function( elem, record, column, data )
{
	//0 - folder
	//1 - G-File
	//2 - File
	//3 - Ring File
	var link = 'javascript:void(0);';
	var prefix = getStorageFieldValue() == 0 ? '/nand' : '/usb';
	var path = getFieldValue('FileManager-CurrentPath');
	var d = new Date();
	
	switch( record.getData( 'Type' )  )
	{
		case 0:
			if ( data == '..' )
			{
				YAHOO.util.Dom.addClass( elem, 'filemngr-parent-folder' );
			}
			else
			{
				YAHOO.util.Dom.addClass( elem, 'filemngr-folder' );
			}
			break;
		case 1:
			link = '{0}{1}{2}'.format( prefix, path, data );
			YAHOO.util.Dom.addClass( elem, 'filemngr-gfile' );
			break;
		case 2:
			link = '{0}{1}{2}?{3}'.format( prefix, path, data, d.getTime() );
			YAHOO.util.Dom.addClass( elem, 'filemngr-file' );
			break;
		case 3:
			link = null; // Cannot click on Ring File
			YAHOO.util.Dom.addClass( elem, 'filemngr-ringfile' );
			break;
	}
	
	var prefix = getStorageFieldValue() == 0 ? '/nand' : '/usb';
	var path = getFieldValue('FileManager-CurrentPath');
	var str = link != null ? '<a href="{0}">{1}</a>'.format( link, data ) : '<span>{0}</span>'.format(data);

	elem.innerHTML = str;
	markInUse( record, elem );
};

FileTableView.formatSize = function(elem, record, oColumn, data)
{
	if (record.getData('Type' ) != 0)
	{
		elem.innerHTML = formatTextAsFileSize( data);
	}
	else
	{
		elem.innerHTML = "";
	}
	markInUse( record, elem );
};

FileTableView.formatType = function( elem, record, column, data )
{
	var text = "";
	switch(data)
	{
		case 0: text = getResource('FileManager-Resource-Dir'); break;
		case 1: text = getResource('FileManager-Resource-GFile');break;
		case 2: text = getResource('FileManager-Resource-File');break;
		case 3: text = "Ring File"; break;
	}
	elem.innerHTML = text;
	markInUse( record, elem );
};
FileTableView.formatDateTime = function(elem, record, oColumn, data)
{
	try
	{
		if (data != 'null' )
		{
			var text = datetimeToCurrentTimezone( data ).full;
			elem.innerHTML = text;
			markInUse( record, elem );
		}
	}
	catch (x) {
		YAHOO.log("FileTableView.formatDateTime: '" + data + "' bad format");
	}
};

function markInUse( record, elem )
{
	if ( record.getData( 'InUse' ) )
	{
		YAHOO.util.Dom.addClass( elem, 'filemngr-in-use' );
	}
}
function getStorageLocation( value )
{
	var text = value;
	switch (value)
	{
		case 0: text = getResource('FileManager-Resource-IntMem'); break;
		case 2: text = getResource('FileManager-Resource-UsbKey'); break;
	}
	return text;
}

function getStorageFieldValue()
{
	return getRadioButtonCheckedValue( storageRadioItems );
	//return 0;
}

function onStorageChanged( event )
{
	setFieldValue( 'FileManager-CurrentPath', '/' );
	setItemVisible('FileManager-Button-CopyToUSB', getStorageFieldValue() != 2);
	
	YAHOO.util.Cookie.set( storageCookie, getStorageFieldValue(), { path: "/", expires: new Date("December 31, 2033") });
	
	changeLocation();
}

function onModifyRateChanged( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	setFieldVisible("FileManager-Field-Rinex-Rate", isFieldChecked( field ) );
}

// POST

function onCommand(element, text)
{	
	setFieldValue( 'FileManager-FileOperationType', text );
	
	if (text!= "DeleteAll")
	{
		// Set file count
		var filelist = getFileList();
		
		if ( filelist.length == 1 && filelist[ 0 ] == '' )
		{
			setFieldValue( 'FileManager-FileCount', 0 );			
			return;
		}

		// "DeleteAll" is shorter when all are selected, but do not delete folders!
		//if ( isAllFilesSelected(myDataTable) )
		//{
		//	onCommand(element, "DeleteAll");
		//	return;
		//}
		
		setFieldValue('FileManager-FileCount', filelist.length);
		
		try
		{
			// Insert file names after
			var field = YAHOO.util.Dom.get('FileManager-FileCount');	
			for(i in filelist)
			{
				var num = new Number(i) + 1;
				var id = 'FileManager-File-' + num;
				
				if (!YAHOO.util.Dom.inDocument(id))
				{
					var input = document.createElement('input');
					input.id = id;
					input.type = 'hidden';
					input.name = 'File' + num;
					YAHOO.util.Dom.insertAfter(input, field);
				}
				setFieldValue(id, filelist[ i ]);
			}
		}
		catch (x)
		{
		}
	}
	
	//State
	disableField(element.id);
	/*
	switch (text)
	{
	case "DeleteSelected":
	case "DeleteAll":
		break;
	case "TransferToFtp":
		setItemText('FileManager-Status-FTP-Value', getResource('FileManager-Resource-InProgress'));
		setItemDisplayed('FileManager-FieldSet-ProcessStatus',true);
		break;
	case "CopyToUsb":
		setItemText('FileManager-Status-USB-Value', getResource('FileManager-Resource-InProgress'));
		setItemDisplayed('FileManager-FieldSet-ProcessStatus',true);
		break;
	case "ConvertIntoRinex":
		setItemText('FileManager-Status-RINEX-Value', getResource('FileManager-Resource-InProgress'));
		setItemDisplayed('FileManager-FieldSet-ProcessStatus',true);
		break;
	}
	*/
	//SetItemDisplayed(...); is commented because it makes the section blink
	//(the following JSON doesn't contain the new status)
	
	setFieldChecked( 'FileManager-TableHeader-NameCheckbox' , false);
	unSelectAllFiles( myDataTable.getRecordSet().getRecords() );
	
	// Process async POST request according to buttons
	// /!\ Buttons management differs /!\
	// [Delete File] and [Delete All Files] => Post & Result => OK
	// [Copy To USB] and [Transfer to FTP] and [Convert into RINEX] => Post & Result & Get JSON State => OK
	
	var url = "/cgi-bin/WebService.cgic";
	
	// Define the callbacks for the asyncRequest POST
	var callbacks = {
		
		success : function (o) {
			YAHOO.util.Connect.asyncRequest('GET', exeConfigURL, null);
			
			updateResult();
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
		},

		timeout : 10000,
		cache : false
    };
	
	//Common fields.
	var params = "Page=2900";
	params += "&FileOperationType=" + text;
	
	//Storage fields.
	params += "&StorageLocation=" + getStorageFieldValue();
	params += "&CurrentPath=" + getFieldValue('FileManager-CurrentPath');
	
	// FileCount %u32
	if (text!= "DeleteAll")
	{	
		//FileCount field.
		params += "&FileCount=" + getFieldValue('FileManager-FileCount');
		
		//FileX field(s).
		for(i in filelist)
		{
			var num = new Number(i) + 1;
			var id = 'FileManager-File-' + num;
			
			params += "&File" + num + "=" + getFieldValue(id);
		}
	}
	
	switch (text)
	{
	case "DeleteSelected":
		//No additional field.
		//disableField('Deleteallfiles');
	break;
	case "DeleteAll":
		//No additional field.
		disableField('Deletefiles');
		break;
	case "TransferToFtp":
		//FTP fields.
		params += "&Ftp_Server=" + getFieldValue('FileManager-Field-Ftp-Server');
		params += "&Ftp_Port=" + getFieldValue('FileManager-Field-Ftp-Port');
		params += "&Ftp_Username=" + getFieldValue('FileManager-Field-Ftp-Username');
		params += "&Ftp_Password=" + getFieldValue('FileManager-Field-Ftp-Password');
		params += "&Ftp_Path=" + getFieldValue('FileManager-Field-Ftp-Path');
		//Uncomment when Push Modem works (Gilles)
		//params += "&Ftp_IPP=" + getFieldValue('FileManager-Field-Ftp-IPP');
		break;
	case "CopyToUsb":
		//No additional field.
		break;
	case "ConvertIntoRinex":
		//RINEX fields.
		if(isFieldChecked('FileManager-Button-Rinex-V211'))
		{
			params += "&Version=0";
		} else {
			params += "&Version=2";
		}
		
		if(isFieldChecked('FileManager-Field-HatanakaCompression'))
		{
			params += "&HatanakaCompression=1";
		}
		
		if(isFieldChecked('FileManager-Field-TarzCompression'))
		{
			params += "&TarzCompression=1";
		}
		
		if(isFieldChecked('FileManager-Field-Rinex-ModifyRate'))
		{
			params += "&ModifyRate=1";
		}
		
		params += "&Rate=" + getFieldValue('FileManager-Field-Rinex-Rate');
		
		if(isFieldChecked('FileManager-Field-Rinex-DisableGLONASS'))
		{
			params += "&DisableGLONASS=1";
		}
		
		if(isFieldChecked('FileManager-Field-Rinex-DisableSBAS'))
		{
			params += "&DisableSBAS=1";
		}
		
		if(isFieldChecked('FileManager-Field-Rinex-DisableGALILEO'))
		{
			params += "&DisableGALILEO=1";
		}
		
		params += "&Agency=" + getFieldValue('FileManager-Field-Rinex-Agency');
		params += "&Observer=" + getFieldValue('FileManager-Field-Rinex-Observer');
		params += "&MarkerName=" + getFieldValue('FileManager-Field-Rinex-MarkerName');
		params += "&MarkerNumber=" + getFieldValue('FileManager-Field-Rinex-MarkerNumber');
		params += "&ObservationComment=" + getFieldValue('FileManager-Field-Rinex-ObservationComment');
		params += "&GpsNavComment=" + getFieldValue('FileManager-Field-Rinex-GpsNavComment');
		params += "&GlonassNavComment=" + getFieldValue('FileManager-Field-Rinex-GlonassNavComment');
		params += "&SbasNavComment=" + getFieldValue('FileManager-Field-Rinex-SbasNavComment');
		params += "&GalileoNavComment=" + getFieldValue('FileManager-Field-Rinex-GalileoNavComment');
		params += "&MeteoComment=" + getFieldValue('FileManager-Field-Rinex-MeteoComment');
		params += "&MeteoManufacturer=" + getFieldValue('FileManager-Field-Rinex-MeteoManufacturer');
		params += "&MeteoSensorType=" + getFieldValue('FileManager-Field-Rinex-MeteoSensorType');
		params += "&PressureAccuracy=" + getFieldValue('FileManager-Field-Rinex-TemperatureAccuracy');
		params += "&TemperatureAccuracy=" + getFieldValue('FileManager-Field-Rinex-PressureAccuracy');
		params += "&HumidityAccuracy=" + getFieldValue('FileManager-Field-Rinex-HumidityAccuracy');
		
		break;
	}
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('POST', url, callbacks, params);
}

// RESULT

function updateResult()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateResult()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get result
			var result = data.ResultData;
			if (result == null) return;
			
			// -- Overall status --
			if (result.OverallStatus != null)
			{
				switch (result.OverallStatus)
				{
					case 0:
						// Case 0 equals ACK.
						// It does not mean that the process has been performed correctly.
						// Therefore, do not use it as a success for FTP, USB and RINEX.

						// Reset Delete buttons, they should be quick to perform
						enableField('Deletefiles', true);
						//enableField('Deleteallfiles', true);

						// Refresh File List
						requestFileList();
						break;
					case 1:
						break;
					case 2: 
						setTimeout("updateResult()", 1000);
						break;
				}
			} else {
				setTimeout("updateResult()", 1000);
			}
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateResult()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getResultURL, callbacks);
}

//TODO: optimize this function. We cna simplify isFileSelected cheks and update size only once
function onHeaderCheckboxClick( table )
{
	var records = table.getRecordSet().getRecords();
	if ( isFieldChecked( 'FileManager-TableHeader-NameCheckbox' ) )
	{
		selectAllFiles( records );
		return;
	}
	else
	{	
		unSelectAllFiles( records );
	}
}

function isFileSelected( name )
{
	var filelist = getFileList();
	return isFileSelectedImpl( name, filelist ); 
}

function isFileSelectedImpl( name, filelist )
{
	for( i in filelist )
	{
		if ( filelist[ i ] == name )
			return true;
	}
	
	return false;
}

function isAllFilesSelected( table )
{
	var set = table.getRecordSet();
	var records = set.getRecords();
	var filelist = getFileList();
	
	for ( var i in records )
	{
		var name = records[ i ].getData( 'Name' );
		// parent folder cannot be selected!
		if( name != '..' && !isFileSelectedImpl( name, filelist ) )
			return false;
	}
	
	return true;
}

function selectFile( name, record, table )
{
	if ( isFileSelected( name ) )
		return;
		
	var result = getFieldValue( 'FileManager-SelectedFiles');
	
	if ( result.length != 0 )
		result += filesSeparator;
	result += name;
	
	updateSelectedSize( record.getData( 'Size' ), true );
	
	setFieldValue( 'FileManager-SelectedFiles', result );
	
	if ( isAllFilesSelected( table ) )
		setFieldChecked( 'FileManager-TableHeader-NameCheckbox', true );
}

//Do not select file without checkbox
function selectAllFiles( records )
{
	var filelist = getFileList();
	var size = 0;
	var itemSize = 0;
	var result = '';
	var field = null;
	var name = null;
	for ( var i in records )
	{
		name = records[ i ].getData( 'Name' );
		field = YAHOO.util.Dom.get( name );
		if ( field != null )
		{
			result += name + filesSeparator;
			itemSize = parseFloat( records[ i ].getData( 'Size' ) );
			if( !isNaN( itemSize ) )
				size += itemSize;
			setFieldChecked( name, true );
		}
	}
	
	setSelectedFilesSize( size );
	if( result.length > 0 )
		result = result.substr( 0, result.length - 1 );
	setFieldValue( 'FileManager-SelectedFiles', result );
}
	
function unSelectFile( name, record, table )
{
	if ( !isFileSelected( name ) )
		return;
	
	var result = '';
	var filelist = getFileList();
	for ( var i in filelist )
	{
		if ( filelist[ i ] != name )
			result += filelist[ i ] + filesSeparator;
	}
	
	updateSelectedSize( record.getData( 'Size' ), false );
	
	//skip final separator
	//I don't think that length less than 1 is possible, but check it anyway.
	if( result.length > 0 )
		result = result.substr( 0, result.length - 1 );
	setFieldValue( 'FileManager-SelectedFiles', result );
	
	setFieldChecked( 'FileManager-TableHeader-NameCheckbox', false );
}

function unSelectAllFiles( records )
{
	for( var i in records )
	{
		setFieldChecked( records[ i ].getData( 'Name' ), false );
	}
	setFieldValue( 'FileManager-SelectedFiles', '' );
	setSelectedFilesSize( 0 );
}

//If list of files were changed on server we need to remove not existed files
function updateSelectedFilesField( jsonFilelist )
{
	var result = '';
	var filelist = getFileList();
	if( filelist.length < 1 )
		return;
		
	//TODO: it can be donw in more optimal way.	Sort values as example.
	for ( var i in filelist )
	{
		if( filelist[ i ] == '' )
			continue;
			
		for( var j in jsonFilelist )
		{
			if( filelist[ i ] == jsonFilelist[ j ].Name )
			{
				result += filelist[ i ] + filesSeparator;
				break;
			}
		}
	}
	
	if ( result.length > 0 )
		setFieldValue( 'FileManager-SelectedFiles', result.substr( 0, result.length - 1 ) );
}

function getFileList()
{
	return getFieldValue( 'FileManager-SelectedFiles' ).split( filesSeparator );
}

function changeLocation()
{
	var field = YAHOO.util.Dom.get( 'FileManager-TotalFileSize' );
	field.innerHTML = getResource( 'FileManager-Resource-TotalSelection' ) + '';

	setFieldValue( 'FileManager-SelectedFiles', '' );
	setFieldValue( 'FileManager-TotalFileSize-IU', 0 );
	requestFileList();
}

//Detect by mult to increse or decrease size
function updateSelectedSize( value, positive )
{
	if ( value == null )
		return;
		
	var size = 0;
	var current = getFieldValue( 'FileManager-TotalFileSize-IU' );
	//It is ok. We unselect folder, as example.
	if ( current == '' )
		return;
		
	size = parseFloat( current );
	
	if ( !isNaN( size ) )
	{
		size += parseFloat( value ) * ( positive ? 1 : -1 );
	
		setSelectedFilesSize( size );
	}
}

function initSelectedFilesSize( table )
{
	var filelist = getFileList();
	
	var set = table.getRecordSet();
	var records = set.getRecords();
	var size = 0;
	var curSize = 0;
	var name = '';
	
	for( var i in records )
	{
		name = records[ i ].getData( 'Name' );
		if ( isFileSelectedImpl( name, filelist ) )
		{
			curSize = records[ i ].getData( 'Size' );
			if ( curSize != null )
				curSize = parseFloat( curSize );
			
			if ( curSize != null && !isNaN( curSize ) )
				size += curSize;
		}
	}
	
	setSelectedFilesSize( size );
}


function setSelectedFilesSize( size )
{
	setFieldValue( 'FileManager-TotalFileSize-IU', size );
	
	var field = YAHOO.util.Dom.get( 'FileManager-TotalFileSize' );
	field.innerHTML = getResource( 'FileManager-Resource-TotalSelection' ) + formatTextAsFileSize( size );
}

function validating_Comment( ev, provider )
{
	var field = YAHOO.util.Event.getTarget( ev );
	var valid = field.value.length <= 255;
	var strArray = field.value.split( '\n' );
	for ( i in strArray )
	{
		if ( strArray[ i ].length > 60 )
		{
			valid = false;
			break;
		}
	}
	
	notifyErrorProvider( provider, !valid );
}

function validating_Accuracy( ev, provider )
{
	var field = YAHOO.util.Event.getTarget( ev );
	var valid = field.value >= 0 && field.value <= 100;
	notifyErrorProvider( provider, !valid );
}

function validating_Rate( ev, provider )
{
	var field = YAHOO.util.Event.getTarget( ev );
	var valid = !isNaN(field.value) && field.value >= 0 && field.value <= 60;
	notifyErrorProvider( provider, !valid );
}