ethernetStreamingServerMode = 1;
ethernetStreamingClientMode = 2;
var configGlobal;

function initFullSetup()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initFullSetup()", 5000);
				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigFullSetup;
			if (config == null) return;

			// Check Mode
			if (config.Mode != null)
			{	
				if (config.Mode == 1)
				{
					//TODO: warning, you are in rover mode!
				}
			}
			
			//Remove CSD Mode if ProFlex800
			var elSel = document.getElementById('FullSetup-Field-Network1-ConnectionType');
			var network1ReceiverModel = document.getElementById('FullSetup-Field-Network1-ReceiverModel');
			if (ProFlex.is800()) {
				elSel.remove(1);
				network1ReceiverModel.value = 800;
			} else {
				network1ReceiverModel.value = 500;
			}
			
			processBaseSetup( config );
			setFieldValue( 'FullSetup-Field-Dynamic', config.Dynamic );
				
			setFieldChecked( 'FullSetup-Field-IsPositionMoving', config.IsPositionMoving );
			
			setItemDisplayed('FullSetup-Group-Position', !config.IsPositionMoving );
			
            

			
			// -- Internal Radio --
			setFieldValue('FullSetup-Field-InternalRadioConnection', "");
			if (config.InternalRadio != null && config.InternalRadio.ConnectionType > 0)
			{
				setItemDisplayed('FullSetup-InternalRadio-Fieldset', true);
				switch (config.InternalRadio.ConnectionType)
				{
				case 8: value = "ADL Foundation"; break;
				default: value = config.InternalRadio.ConnectionType; break;
				}
				setFieldValue('FullSetup-Field-InternalRadioConnection', value);
				setFieldChecked('FullSetup-Field-InternalRadioPowerOn', config.InternalRadio.Power == 1);
				setFieldChecked('FullSetup-Field-InternalRadioPowerOff', config.InternalRadio.Power == 0);
				
				// -- Add Port D to Differential Streams 1 and 2 --
				var text1 = document.getElementById('FullSetup-Field-Stream1-Port|D-Trans').innerHTML;
				var stream1 = document.getElementById('FullSetup-Field-Stream1-Port');
				stream1.options[stream1.options.length] = new Option(text1, "D");
				
				var text2 = document.getElementById('FullSetup-Field-Stream2-Port|D-Trans').innerHTML;
				var stream2 = document.getElementById('FullSetup-Field-Stream2-Port');
				stream2.options[stream2.options.length] = new Option(text2, "D");
			} else {
				setFieldChecked('FullSetup-Field-InternalRadioPowerOn', false);
				setFieldChecked('FullSetup-Field-InternalRadioPowerOff', true);
			}
			
			// -- Serial Port A --
			selectValueElseDefault('FullSetup-Field-PortA-ConnectionType', config.SerialPortA.ConnectionType, 0); // If selected radio not allowed here then select None
			setFieldValue('FullSetup-Field-PortA-BaudRate', config.SerialPortA.BaudRate);
			setFieldChecked('FullSetup-Field-PortA-RtsCts', config.SerialPortA.RtsCts);
			setFieldValue('FullSetup-Field-PortA-Mode', config.SerialPortA.Mode);
			//enablePortAParameters(config.SerialPortA.ConnectionType);// Do not call: better to show real status
			enablePortARtsCts( config.SerialPortA.Mode );
			
			// -- Serial Port B --
			selectValueElseDefault('FullSetup-Field-PortB-ConnectionType', config.SerialPortB.ConnectionType, 0); // If selected radio not allowed here then select None
			setFieldValue('FullSetup-Field-PortB-BaudRate', config.SerialPortB.BaudRate);
			setFieldChecked('FullSetup-Field-PortB-RtsCts', config.SerialPortB.RtsCts);
			//enablePortBParameters(config.SerialPortB.ConnectionType);// Do not call: better to show real status
			
			// -- Serial Port F --
			selectValueElseDefault('FullSetup-Field-PortF-ConnectionType', config.SerialPortF.ConnectionType, 0); // If selected radio not allowed here then select None
			setFieldValue('FullSetup-Field-PortF-BaudRate', config.SerialPortF.BaudRate);
			setFieldChecked('FullSetup-Field-PortF-RtsCts', config.SerialPortF.RtsCts);
			//enablePortFParameters(config.SerialPortF.ConnectionType);// Do not call: better to show real status

			// -- Mount Point List --
			var names = new Array();
			var fullnames = new Array();
			for (i in config.Caster.MountPoints)
			{	
				names.push(config.Caster.MountPoints[i].Name);
				fullnames.push(config.Caster.MountPoints[i].Name + ' (' + config.Caster.MountPoints[i].Identifier + ')');
			}
			
			setFieldOptions( 'FullSetup-Field-Network1-Ntrip-MountPointsView', fullnames, names);
			setFieldOptions( 'FullSetup-Field-Network2-Ntrip-MountPointsView', fullnames, names);
			
			setFieldValue('FullSetup-Field-Network1-Ntrip-MountStorage', config.Network1.NtripPortP.Mount );
			setFieldValue('FullSetup-Field-Network2-Ntrip-MountStorage', config.Network2.NtripPortQ.Mount );

			setFieldValue('FullSetup-Field-Network1-Ntrip-MountPointsView', config.Network1.NtripPortP.Mount);
			setFieldValue('FullSetup-Field-Network2-Ntrip-MountPointsView', config.Network2.NtripPortQ.Mount);
			
			// -- Differential Stream 1 --
			setFieldValue('FullSetup-Field-Stream1-Port', config.DifferentialStream1.Port);
			processStream1DiffMessage( config );
			
			// -- Differential Stream 2 --
			setFieldValue('FullSetup-Field-Stream2-Port', config.DifferentialStream2.Port);
			processStream2DiffMessage( config );
			
			processDataStreamingParameters( config );
			
			// -- Option [C] --
			if (optionsGlobal.indexOf("C") == -1) {
				var network1ConnectionType = document.getElementById('FullSetup-Field-Network1-ConnectionType');
				network1ConnectionType.remove(6);
				
				var network2ConnectionType = document.getElementById('FullSetup-Field-Network2-ConnectionType');
				network2ConnectionType.remove(3);
				
				if (config.Network1.ConnectionType == 7) {
					config.Network1.ConnectionType = 0;
					
					if (config.Network1.NtripPortE.AddressIp == "localhost" ||
						config.Network1.NtripPortE.AddressIp == "127.0.0.1")
						config.Network1.NtripPortE.AddressIp = "0.0.0.0";
						
					if (config.Network1.NtripPortP.AddressIp == "localhost" ||
						config.Network1.NtripPortP.AddressIp == "127.0.0.1")
						config.Network1.NtripPortP.AddressIp = "0.0.0.0";
				} else {
					//config.Network1.NtripPortE.AddressIp = "";
					//config.Network1.NtripPortP.AddressIp = "";
				}
				
				if (config.Network2.ConnectionType == 7) {
					config.Network2.ConnectionType = 0;

					if (config.Network2.NtripPortQ.AddressIp == "localhost" ||
						config.Network2.NtripPortQ.AddressIp == "127.0.0.1")
						config.Network2.NtripPortQ.AddressIp = "0.0.0.0";
				} else {
					//config.Network2.NtripPortQ.AddressIp = "";
				}
			}
			
			configGlobal = config;
			
			//Options
			optionsGlobal = config.Options;
			
			// -- Network1 --
			setFieldValue('FullSetup-Field-Network1-ConnectionType', config.Network1.ConnectionType);
			setFieldChecked('FullSetup-Field-Network1-ConnectNow', 1 /*config.Network1.Connected*/); // Always checked by default
			enableNetwork1Parameters(config.Network1.ConnectionType);

			// -- Network2 --
			setFieldValue('FullSetup-Field-Network2-ConnectionType', config.Network2.ConnectionType);
			setFieldChecked('FullSetup-Field-Network2-ConnectNow', 1 /*config.Network2.Connected*/); // Always checked by default
			enableNetwork2Parameters(config.Network2.ConnectionType);
			
			// Show form
			showConfigForm();
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initFullSetup()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigFullSetupURL, callbacks);
	
	setBaseSetupValidators();
	setDataStreamingValidators();
	
	//Moving Position Checkbox
	YAHOO.util.Event.addListener('FullSetup-Field-IsPositionMoving', 'click', onMovingPositionChecked);
	
	//Tooltip
	YAHOO.util.Event.addListener('FullSetup-Label-Stream1-Tooltip', 'mouseover', onTooltipOver);
	YAHOO.util.Event.addListener('FullSetup-Label-Stream2-Tooltip', 'mouseover', onTooltipOver);
	
	//Mount POST
	YAHOO.util.Event.addListener('FullSetup-Field-Network1-Ntrip-MountPointsView', 'change', onNetwork1MountChanged);
	YAHOO.util.Event.addListener('FullSetup-Field-Network1-Ntrip-Mount', 'change', onNetwork1MountChanged);
	YAHOO.util.Event.addListener('FullSetup-Field-Network2-Ntrip-MountPointsView', 'change', onNetwork2MountChanged);
	YAHOO.util.Event.addListener('FullSetup-Field-Network2-Ntrip-Mount', 'change', onNetwork2MountChanged);
	
	// Show Characters
	YAHOO.util.Event.addListener('FullSetup-Field-Network1-Ntrip-Password-Show', 'click', onNetwork1PasswordShowClick);
	YAHOO.util.Event.addListener('FullSetup-Field-Network2-Ntrip-Password-Show', 'click', onNetwork2PasswordShowClick);
	
	// ConnectionType changed
	YAHOO.util.Event.addListener('FullSetup-Field-PortA-ConnectionType', 'change', onPortAConnectionTypeChanged);
	YAHOO.util.Event.addListener('FullSetup-Field-PortB-ConnectionType', 'change', onPortBConnectionTypeChanged);
	YAHOO.util.Event.addListener('FullSetup-Field-PortF-ConnectionType', 'change', onPortFConnectionTypeChanged);
	YAHOO.util.Event.addListener('FullSetup-Field-Network1-ConnectionType', 'change', onNetwork1ConnectionTypeChanged);
	YAHOO.util.Event.addListener('FullSetup-Field-Network2-ConnectionType', 'change', onNetwork2ConnectionTypeChanged);
	
	// Port mode changed
	YAHOO.util.Event.addListener('FullSetup-Field-PortA-Mode', 'change', onPortAModeChanged);
	
	YAHOO.util.Event.addListener('FullSetup-Field-Stream1-MessageType', 'change', onDiffMessageChanged );
	YAHOO.util.Event.addListener('FullSetup-Field-Stream2-MessageType', 'change', onDiffMessageChanged );

	// Field validation
	makeFieldValidator('FullSetup-Field-Network1-DirectIP-AddressIP', 'validating_Host');
	makeFieldValidator('FullSetup-Field-Network1-Ntrip-AddressIP', 'validating_Host');
	makeFieldValidator('FullSetup-Field-Network2-DirectIP-AddressIP', 'validating_Host');
	makeFieldValidator('FullSetup-Field-Network2-Ntrip-AddressIP', 'validating_Host');
	makeFieldValidator('FullSetup-Field-Network1-DirectIP-AddressPort', 'validating_Port');
	makeFieldValidator('FullSetup-Field-Network1-Ntrip-AddressPort', 'validating_Port');
	makeFieldValidator('FullSetup-Field-Network2-DirectIP-AddressPort', 'validating_Port');
	makeFieldValidator('FullSetup-Field-Network2-Ntrip-AddressPort', 'validating_Port');
}

function onMovingPositionChecked( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	setItemDisplayed('FullSetup-Group-Position', !isFieldChecked(field));
}

function onNetwork1MountChanged( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	setFieldValue( 'FullSetup-Field-Network1-Ntrip-MountStorage', field.value );
}

function onNetwork2MountChanged( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	setFieldValue( 'FullSetup-Field-Network2-Ntrip-MountStorage', field.value );
}

function onNetwork1PasswordShowClick( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	setFieldPasswordVisible('FullSetup-Field-Network1-Ntrip-Password', isFieldChecked(field));
}

function onNetwork2PasswordShowClick( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	setFieldPasswordVisible('FullSetup-Field-Network2-Ntrip-Password', isFieldChecked(field));
}

function onPortAConnectionTypeChanged(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	enablePortAParameters(field.value);
}

function onPortAModeChanged(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	enablePortARtsCts(field.value);
}

function onPortBConnectionTypeChanged(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);

	enablePortBParameters(field.value);
}

function onPortFConnectionTypeChanged(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);

	enablePortFParameters(field.value);
}

function onNetwork1ConnectionTypeChanged(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	enableNetwork1Parameters(field.value);
}

function onNetwork2ConnectionTypeChanged(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	enableNetwork2Parameters(field.value);
}

function enablePosition(status)
{
	setFieldVisible('FullSetup-Group-Position',
		status == 0 /* Static Position */);	
}

function enableSHMP(MeasurementType)
{
	setFieldVisible('FullSetup-Group-SHMP',
		MeasurementType == 0 /* Slant Height */);	
}

function enablePortAParameters(connection)
{
	if (connection == 2)
	{ // Magellan U-Link 
	    setFieldValue('FullSetup-Field-PortA-BaudRate',7); // 38400 
	    enableField('FullSetup-Field-PortA-BaudRate',false);
	    setFieldValue('FullSetup-Field-PortA-Mode',422); 
	    enableField('FullSetup-Field-PortA-Mode',false);
	}
	else if (connection == 3)
	{ // Magellan UHF
	    setFieldValue('FullSetup-Field-PortA-BaudRate',6); // 19200 
	    enableField('FullSetup-Field-PortA-BaudRate',false);
	    setFieldValue('FullSetup-Field-PortA-Mode',422);
	    enableField('FullSetup-Field-PortA-Mode',false);
	}
	else if ((connection == 5)||(connection == 6))
	{ // Licence Free
	    setFieldValue('FullSetup-Field-PortA-BaudRate',5); // 9600 
	    enableField('FullSetup-Field-PortA-BaudRate',false);
	    setFieldValue('FullSetup-Field-PortA-Mode',232);
	    enableField('FullSetup-Field-PortA-Mode',false);
	    
	    //Bugfix RTS/CTS
	    setFieldChecked('FullSetup-Field-PortA-RtsCts', 0);
	}
	else if (connection == 9)
	{   // XDL Rover
	    setFieldValue('FullSetup-Field-PortA-BaudRate', 7); // 38400 
	    setFieldValue('FullSetup-Field-PortA-Mode', 232); 
	    setFieldChecked('FullSetup-Field-PortA-RtsCts', 0);
	}
	else
	{
	    setFieldValue('FullSetup-Field-PortA-BaudRate',5); // 9600 
	    enableField('FullSetup-Field-PortA-BaudRate',true);
	    setFieldValue('FullSetup-Field-PortA-Mode',232);
	    enableField('FullSetup-Field-PortA-Mode',true);
	}
	
	enablePortARtsCts(getFieldValue('FullSetup-Field-PortA-Mode'));
}

function enablePortARtsCts(mode)
{
	setFieldVisible('FullSetup-Field-PortA-RtsCts', mode == 232);
}

function enablePortBParameters(connection)
{
    if ((connection == 5)||(connection == 6)) { // Licence Free
	    setFieldValue('FullSetup-Field-PortB-BaudRate',5); // 9600 
	    enableField('FullSetup-Field-PortB-BaudRate',false);
	    
	    //Bugfix RTS/CTS
	    setFieldChecked('FullSetup-Field-PortB-RtsCts', 0);
	} 
	else
	{
	    enableField('FullSetup-Field-PortB-BaudRate',true);
	    if (connection == 9)
	    {   // XDL Rover
	        setFieldValue('FullSetup-Field-PortB-BaudRate',7); // 38400 
	        setFieldChecked('FullSetup-Field-PortB-RtsCts', 0);
	    }
    }
}

function enablePortFParameters(connection)
{
    if ((connection == 5)||(connection == 6)) { // Licence Free
	    setFieldValue('FullSetup-Field-PortF-BaudRate',5); // 9600 
	    enableField('FullSetup-Field-PortF-BaudRate',false);
	    
	    //Bugfix RTS/CTS
	    setFieldChecked('FullSetup-Field-PortF-RtsCts', 0);
	}
    else
    {
    	enableField('FullSetup-Field-PortF-BaudRate',true);
	    if (connection == 9)
	    {   // XDL Rover
	        setFieldValue('FullSetup-Field-PortF-BaudRate',7); // 38400 
            setFieldChecked('FullSetup-Field-PortF-RtsCts', 0);
        }
	}
}

function enableNetwork1Parameters(connection)
{
	switch (connection)
	{
	case 2:
	case "2":
		// -- Network1 / Direct IP Port E --
		setFieldValue('FullSetup-Field-Network1-DirectIP-AddressIP', configGlobal.Network1.DirectIPPortE.AddressIp);
		setFieldValue('FullSetup-Field-Network1-DirectIP-AddressPort', configGlobal.Network1.DirectIPPortE.AddressPort);
		setFieldValue('FullSetup-Field-Network1-DirectIP-Login', configGlobal.Network1.DirectIPPortE.Login);
		setFieldValue('FullSetup-Field-Network1-DirectIP-Password', configGlobal.Network1.DirectIPPortE.Password);
		setFieldPasswordVisible('FullSetup-Field-Network1-Ntrip-Password', false);
		setFieldValue( 'FullSetup-Field-Network1-Ntrip-MountStorage', configGlobal.Network1.NtripPortE.Mount );
	break;
	case 3:
	case "3":
		// -- Network1 / Ntrip Port E --
		setFieldValue('FullSetup-Field-Network1-Ntrip-AddressIP', configGlobal.Network1.NtripPortE.AddressIp);
		setFieldValue('FullSetup-Field-Network1-Ntrip-AddressPort', configGlobal.Network1.NtripPortE.AddressPort);
		setFieldValue('FullSetup-Field-Network1-Ntrip-Mount', configGlobal.Network1.NtripPortE.Mount);
		setFieldValue('FullSetup-Field-Network1-Ntrip-Login', configGlobal.Network1.NtripPortE.Login);
		setFieldValue('FullSetup-Field-Network1-Ntrip-Password', configGlobal.Network1.NtripPortE.Password);
		setFieldPasswordVisible('FullSetup-Field-Network1-Ntrip-Password', false);
		setFieldValue( 'FullSetup-Field-Network1-Ntrip-MountStorage', configGlobal.Network1.NtripPortE.Mount );
	break;
	case 4:
	case "4":
		// -- Network1 / Direct IP Port P --
		setFieldValue('FullSetup-Field-Network1-DirectIP-AddressIP', configGlobal.Network1.DirectIPPortP.AddressIp);
		setFieldValue('FullSetup-Field-Network1-DirectIP-AddressPort', configGlobal.Network1.DirectIPPortP.AddressPort);
		setFieldValue('FullSetup-Field-Network1-DirectIP-Login', configGlobal.Network1.DirectIPPortP.Login);
		setFieldValue('FullSetup-Field-Network1-DirectIP-Password', configGlobal.Network1.DirectIPPortP.Password);
		setFieldPasswordVisible('FullSetup-Field-Network1-Ntrip-Password', false);
		setFieldValue( 'FullSetup-Field-Network1-Ntrip-MountStorage', configGlobal.Network1.NtripPortP.Mount );
	break;
	case 5:
	case "5":
		// -- Network1 / Ntrip Port P --
		setFieldValue('FullSetup-Field-Network1-Ntrip-AddressIP', configGlobal.Network1.NtripPortP.AddressIp);
		setFieldValue('FullSetup-Field-Network1-Ntrip-AddressPort', configGlobal.Network1.NtripPortP.AddressPort);
		setFieldValue('FullSetup-Field-Network1-Ntrip-Mount', configGlobal.Network1.NtripPortP.Mount);
		setFieldValue('FullSetup-Field-Network1-Ntrip-Login', configGlobal.Network1.NtripPortP.Login);
		setFieldValue('FullSetup-Field-Network1-Ntrip-Password', configGlobal.Network1.NtripPortP.Password);
		setFieldPasswordVisible('FullSetup-Field-Network1-Ntrip-Password', false);
		setFieldValue( 'FullSetup-Field-Network1-Ntrip-MountStorage', configGlobal.Network1.NtripPortP.Mount );
	break;
	case 7:
	case "7":
		// -- Network1 / Ntrip (Embedded) Port P --
	    setFieldValue('FullSetup-Field-Network1-Ntrip-AddressIP', configGlobal.Caster.AddressIP);
	    setFieldValue('FullSetup-Field-Network1-Ntrip-AddressPort', configGlobal.Caster.AddressPort);
	    setFieldValue('FullSetup-Field-Network1-Ntrip-Password', configGlobal.Caster.Password);

		setFieldPasswordVisible( 'FullSetup-Field-Network1-Ntrip-Password', isFieldChecked( 'FullSetup-Field-Network1-Ntrip-Password-Show' ) );
		
		var select = document.getElementById('FullSetup-Field-Network1-Ntrip-MountPointsView');
		if (select.selectedIndex == -1)
			select.selectedIndex = 0;
		if (select.options.length > 0) {
			var selectedValue = select.options[select.selectedIndex].value;
			setFieldValue( 'FullSetup-Field-Network1-Ntrip-MountStorage', selectedValue );
		} else {
			setFieldValue('FullSetup-Field-Network1-Ntrip-MountStorage', "" );
		}
	break;
	}
	
	
	setItemDisplayed('FullSetup-Group-Network1-DirectIP',
		connection == 2 /* Modem Direct IP */ ||
		connection == 4 /* Ethernet Direct IP */);

	setItemDisplayed('FullSetup-Group-Network1-Ntrip',
		connection == 3 /* Modem Ntrip server */ ||
		connection == 5 /* Ethernet Ntrip server */ ||
		connection == 7 /* Embedded Ntrip Caster */);

	//Hide field for ethernet ntrip server
	setFieldVisible( 'FullSetup-Field-Network1-Ntrip-Login', connection != 3 && connection != 5 && connection != 7);
    
	if (connection == 3) { /* Modem Ntrip server */
	    setFieldValue('FullSetup-Field-Network1-Ntrip-Login',"");
	}

	setFieldVisible('FullSetup-Field-Network1-ConnectNow', connection > 1);
	
	setFieldVisible( 'FullSetup-Field-Network1-Ntrip-Mount', connection == 3 || connection == 5 || connection == 7);
	setDisplayElement('FullSetup-Field-Network1-Ntrip-Mount', connection == 3 || connection == 5);
	setDisplayElement('FullSetup-Field-Network1-Ntrip-MountPointsView', connection == 7);
	
	setFieldVisible( 'FullSetup-Field-Network1-Ntrip-Password-Show', connection == 7);
	
    setReadOnly('FullSetup-Field-Network1-Ntrip-AddressIP', connection == 7);
    setReadOnly('FullSetup-Field-Network1-Ntrip-AddressPort', connection == 7);
    setReadOnly('FullSetup-Field-Network1-Ntrip-Password', connection == 7);
}

function enableNetwork2Parameters(connection)
{
	switch (connection)
	{
	case 4:
	case "4":
		// -- Network2 / Direct IP Port Q --
		setFieldValue('FullSetup-Field-Network2-DirectIP-AddressIP', configGlobal.Network2.DirectIPPortQ.AddressIp);
		setFieldValue('FullSetup-Field-Network2-DirectIP-AddressPort', configGlobal.Network2.DirectIPPortQ.AddressPort);
		setFieldValue('FullSetup-Field-Network2-DirectIP-Login', configGlobal.Network2.DirectIPPortQ.Login);
		setFieldValue('FullSetup-Field-Network2-DirectIP-Password', configGlobal.Network2.DirectIPPortQ.Password);
		setFieldPasswordVisible('FullSetup-Field-Network2-Ntrip-Password', false);
		setFieldValue( 'FullSetup-Field-Network2-Ntrip-MountStorage', configGlobal.Network2.NtripPortQ.Mount );

	break;
	case 5:
	case "5":
		// -- Network2 / Ntrip Port Q --
		setFieldValue('FullSetup-Field-Network2-Ntrip-AddressIP', configGlobal.Network2.NtripPortQ.AddressIp);
		setFieldValue('FullSetup-Field-Network2-Ntrip-AddressPort', configGlobal.Network2.NtripPortQ.AddressPort);
		setFieldValue('FullSetup-Field-Network2-Ntrip-Mount', configGlobal.Network2.NtripPortQ.Mount);
		setFieldValue('FullSetup-Field-Network2-Ntrip-Login', configGlobal.Network2.NtripPortQ.Login);
		setFieldValue('FullSetup-Field-Network2-Ntrip-Password', configGlobal.Network2.NtripPortQ.Password);
		setFieldPasswordVisible('FullSetup-Field-Network2-Ntrip-Password', false);
		setFieldValue( 'FullSetup-Field-Network2-Ntrip-MountStorage', configGlobal.Network2.NtripPortQ.Mount );
	break;
	case 7:
	case "7":
		// -- Network2 / Ntrip (Embedded) Port Q --
	    setFieldValue('FullSetup-Field-Network2-Ntrip-AddressIP', configGlobal.Caster.AddressIP);
	    setFieldValue('FullSetup-Field-Network2-Ntrip-AddressPort', configGlobal.Caster.AddressPort);
	    setFieldValue('FullSetup-Field-Network2-Ntrip-Password', configGlobal.Caster.Password);

		setFieldPasswordVisible( 'FullSetup-Field-Network2-Ntrip-Password', isFieldChecked( 'FullSetup-Field-Network2-Ntrip-Password-Show' ) );
		
		var select = document.getElementById('FullSetup-Field-Network2-Ntrip-MountPointsView');
		if (select.selectedIndex == -1)
			select.selectedIndex = 0;
		if (select.options.length > 0) {
			var selectedValue = select.options[select.selectedIndex].value;
			setFieldValue( 'FullSetup-Field-Network2-Ntrip-MountStorage', selectedValue );	
		} else {
			setFieldValue('FullSetup-Field-Network2-Ntrip-MountStorage', "" );
		}
	break;
	}
	
	setItemDisplayed('FullSetup-Group-Network2-DirectIP',
		connection == 4 /* Ethernet Direct IP */);

	setItemDisplayed('FullSetup-Group-Network2-Ntrip',
		connection == 5 /* Ethernet Ntrip server */ ||
		connection == 7 /* Embedded Ntrip Caster */);

	//Hide field for ethernet ntrip server
	setFieldVisible( 'FullSetup-Field-Network2-Ntrip-Login', connection != 5 && connection != 7 );

	setFieldVisible('FullSetup-Field-Network2-ConnectNow', connection > 0);
	
	setFieldVisible( 'FullSetup-Field-Network2-Ntrip-Mount', connection == 5 || connection == 7);
	setDisplayElement( 'FullSetup-Field-Network2-Ntrip-Mount', connection == 5);
	setDisplayElement( 'FullSetup-Field-Network2-Ntrip-MountPointsView', connection == 7);
	
	setFieldVisible( 'FullSetup-Field-Network2-Ntrip-Password-Show', connection == 7);
	
    setReadOnly('FullSetup-Field-Network2-Ntrip-AddressIP', connection == 7);
    setReadOnly('FullSetup-Field-Network2-Ntrip-AddressPort', connection == 7);
    setReadOnly('FullSetup-Field-Network2-Ntrip-Password', connection == 7);
}

