function initHeading()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// -- Help link
			if (ProFlex.isDuo()) {
                setItemDisplayed('Index-Help', false);
				setItemDisplayed('Index-Help-HDS', true);
			} else {
				setItemDisplayed('Index-Help-HDS', false);
				setItemDisplayed('Index-Help', true);
			}

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initHeading()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigHeading;
			if (config == null) return;
			
			// -- Antenna List --
			if (config.Antenna.List != null)
			{
				var names = new Array();
				
				for (i in config.Antenna.List)
				{	
					if (config.Antenna.List[i].AntennaName != null)
					    names.push(config.Antenna.List[i].AntennaName);
				}
				
				addFieldOptions('Heading-Field-Antenna1Name', names, names);
				addFieldOptions('Heading-Field-Antenna2Name', names, names);
			}

			// -- Antenna 1 Name --
			setFieldValue('Heading-Field-Antenna1Name', config.Antenna.Antenna1Name);

			// -- Antenna 2 Name --
			if (ProFlex.isDuo()) {
				setItemDisplayed('Heading-Label-Antenna2Name', true);
				setItemDisplayed('Heading-Field-Antenna2Name', true);
				setFieldValue('Heading-Field-Antenna2Name', config.Antenna.Antenna2Name);
				setItemText('Heading-Label-Antenna1Name',getResource('Heading-Ressource-Antenna1Name'));
			} else {
				removeFieldFromPost('Heading-Field-Antenna2Name');
			}
			
			// -- FastOutput --
			setFieldChecked('Heading-Field-FastOutput', (config.FastOutput == 1));
			
			// -- Position Mask --
			setFieldValue('Heading-Field-ElevationMask', config.PositionElevationMask);
			
	        //Options
	        optionsGlobal = config.Options;

	        // -- GPS --
	        setFieldChecked('Heading-Field-GPS', config.SatelliteGPS);
        	
	        // -- GLONASS --
			//setFieldChecked('Heading-Field-GLONASS', (config.SatelliteGlonass == 1));
	        if (optionsGlobal.indexOf("S") != -1)
	        {
	            setFieldVisible('Heading-Field-GLONASS', 1);
	            setFieldChecked('Heading-Field-GLONASS', config.SatelliteGlonass);
	        } else {
	            setFieldVisible('Heading-Field-GLONASS', 0);
	        }
        	
	        // -- SBAS --
			setFieldChecked('Heading-Field-SBAS', config.SatelliteSbas);

	        // -- GALILEO --
	        //setFieldChecked('Heading-Field-GALILEO', config.SatelliteGALILEO);
	        if (optionsGlobal.indexOf("O") != -1)
	        {
	            setFieldVisible('Heading-Field-GALILEO', 1);
	            setFieldChecked('Heading-Field-GALILEO', config.SatelliteGALILEO);
	        } else {
	            setFieldVisible('Heading-Field-GALILEO', 0);
	        }

	        // -- QZSS --
	        setFieldChecked('Heading-Field-QZSS', config.SatelliteQZSS);
	        
			// -- Mode --
			if (!ProFlex.isDuo())
			{
				var elSel = document.getElementById('Heading-Field-Mode');
				elSel.remove(3);    // Internal&External Mode
				elSel.remove(1);    // Internal Mode
			}
			selectValueElseDefault('Heading-Field-Mode', config.HeadingMode.Heading, 0);
			
			// -- Input Port --
			setFieldVisible('Heading-Field-InputPort', (config.HeadingMode.Heading >= 2));
			if (config.HeadingMode.HeadingPort == 'H')
			{
				setFieldValue('Heading-Field-InputPort', 'A');
			}
			else
			{
				setFieldValue('Heading-Field-InputPort', config.HeadingMode.HeadingPort);
			}
			
			// -- HEADING 1 --
			// -- Baseline Length --
			setFieldValueAsDistance('Heading-Field-BaselineLength', config.Heading1.BaselineLength);
			setFieldVisible('Heading-Field-BaselineLength', (config.Heading1.BaselineLength != 0));
			
			// -- Auto Calibration --
			setFieldChecked('Heading-Field-AutoCalibration', (config.Heading1.BaselineLength == 0));
			
			// -- Azimuth Offset --
			setFieldValueAsSimpleAngle('Heading-Field-AzimuthOffset', config.Heading1.AzimuthOffset);
			
			// -- Elevation Offset --
			setFieldValueAsSimpleAngle('Heading-Field-ElevationOffset', config.Heading1.ElevationOffset);
			
			// -- Maximum Baseline Elevation --
			setFieldValueAsSimpleAngleInteger('Heading-Field-MaximumBaselineElevation', config.Heading1.MaximumBaselineElevation);
			
			// -- Maximum Baseline Error Length --
			setFieldValueAsDistance('Heading-Field-MaximumBaselineErrorLength', config.Heading1.MaximumBaselineErrorLength);

			if (ProFlex.isDuo()) {
			
			    //setItemDisplayed('Heading-Group-Heading2',(config.HeadingMode.Heading == 3));
			    if (config.HeadingMode.Heading == 3) {
				    setItemDisplayed('Heading-Group-Heading2', true);
				    setItemText('Heading-Heading1-Parameters',getResource('Heading-Ressource-Heading1-Parameters'));
			    }		        

                // -- HEADING 2 --
			    // -- Baseline Length --
			    setFieldValueAsDistance('Heading-Field-BaselineLength2', config.Heading2.BaselineLength);
			    setFieldVisible('Heading-Field-BaselineLength2', (config.Heading2.BaselineLength != 0));
    			
			    // -- Auto Calibration --
			    setFieldChecked('Heading-Field-AutoCalibration2', (config.Heading2.BaselineLength == 0));
    			
			    // -- Azimuth Offset --
			    setFieldValueAsSimpleAngle('Heading-Field-AzimuthOffset2', config.Heading2.AzimuthOffset);
    			
			    // -- Elevation Offset --
			    setFieldValueAsSimpleAngle('Heading-Field-ElevationOffset2', config.Heading2.ElevationOffset);
    			
			    // -- Maximum Baseline Elevation --
			    setFieldValueAsSimpleAngleInteger('Heading-Field-MaximumBaselineElevation2', config.Heading2.MaximumBaselineElevation);
    			
			    // -- Maximum Baseline Error Length --
			    setFieldValueAsDistance('Heading-Field-MaximumBaselineErrorLength2', config.Heading2.MaximumBaselineErrorLength);
            }
            
			// Show form
			showConfigForm();
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initRoverSetup()", 5000);
		},

		timeout : 10000,
		cache : false
    };

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigHeading, callbacks);
	
	// Units changed
	YAHOO.util.Event.addListener('distances', 'change', onDistanceUnitChanged);
	
	// Heading Mode changed
	YAHOO.util.Event.addListener('Heading-Field-Mode', 'change', onModeChanged);
	
	// HEADING
	// Distance changed
	YAHOO.util.Event.addListener('Heading-Field-AutoCalibration', 'click', onAutoCalibrationClick);
	YAHOO.util.Event.addListener('Heading-Field-BaselineLength', 'change', onDistanceValueChanged);
	YAHOO.util.Event.addListener('Heading-Field-MaximumBaselineErrorLength', 'change', onDistanceValueChanged);
	
	// Degree changed
	YAHOO.util.Event.addListener('Heading-Field-AzimuthOffset', 'change', onSimpleAngleValueChanged);
	YAHOO.util.Event.addListener('Heading-Field-ElevationOffset', 'change', onSimpleAngleValueChanged);
	YAHOO.util.Event.addListener('Heading-Field-MaximumBaselineElevation', 'change', onSimpleAngleIntegerValueChanged);
	
	// INTERNAL HEADING if mode DUO
	// Distance changed
	YAHOO.util.Event.addListener('Heading-Field-AutoCalibration2', 'click', onAutoCalibration2Click);
	YAHOO.util.Event.addListener('Heading-Field-BaselineLength2', 'change', onDistanceValueChanged);
	YAHOO.util.Event.addListener('Heading-Field-MaximumBaselineErrorLength2', 'change', onDistanceValueChanged);
	
	// Degree changed
	YAHOO.util.Event.addListener('Heading-Field-AzimuthOffset2', 'change', onSimpleAngleValueChanged);
	YAHOO.util.Event.addListener('Heading-Field-ElevationOffset2', 'change', onSimpleAngleValueChanged);
	YAHOO.util.Event.addListener('Heading-Field-MaximumBaselineElevation2', 'change', onSimpleAngleIntegerValueChanged);
	
    // GPS and GLONASS Check Box			
	YAHOO.util.Event.addListener('Heading-Field-GPS', 'click', onFieldGPSChange );
	YAHOO.util.Event.addListener('Heading-Field-GLONASS', 'click', onFieldGLONASSChange );

	//Validators
	makeFieldValidator('Heading-Field-BaselineLength', 'validating_BaselineLength');
	makeFieldValidator('Heading-Field-AzimuthOffset', 'validating_AzimuthOffset');
	makeFieldValidator('Heading-Field-ElevationOffset', 'validating_ElevationOffset');
	makeFieldValidator('Heading-Field-MaximumBaselineElevation', 'validating_MaximumBaselineElevation');
	makeFieldValidator('Heading-Field-MaximumBaselineErrorLength', 'validating_MaximumBaselineErrorLength');

	makeFieldValidator('Heading-Field-BaselineLength2', 'validating_BaselineLength');
	makeFieldValidator('Heading-Field-AzimuthOffset2', 'validating_AzimuthOffset');
	makeFieldValidator('Heading-Field-ElevationOffset2', 'validating_ElevationOffset');
	makeFieldValidator('Heading-Field-MaximumBaselineElevation2', 'validating_MaximumBaselineElevation');
	makeFieldValidator('Heading-Field-MaximumBaselineErrorLength2', 'validating_MaximumBaselineErrorLength');
}

function getPrefixName()
{
	return "Heading";
}

function onModeChanged(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	// -- Input Port --
	setFieldVisible('Heading-Field-InputPort', (field.value >= 2));
	setItemDisplayed('Heading-Group-Heading2',(field.value == 3));
	if (field.value == 3)
    	setItemText('Heading-Heading1-Parameters',getResource('Heading-Ressource-Heading1-Parameters'));
    else
        setItemText('Heading-Heading1-Parameters',getResource('Heading-Heading1-Parameters-Trans'));
}

function onAutoCalibrationClick(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	// -- Baseline Length --
	if (isFieldChecked(field))
	{
		setFieldValueAsDistance('Heading-Field-BaselineLength', 0);
		setFieldVisible('Heading-Field-BaselineLength', false);
	}
	else
	{
		setFieldVisible('Heading-Field-BaselineLength', true);
	}	
}

function onAutoCalibration2Click(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	// -- Baseline Length --
	if (isFieldChecked(field))
	{
		setFieldValueAsDistance('Heading-Field-BaselineLength2', 0);
		setFieldVisible('Heading-Field-BaselineLength2', false);
	}
	else
	{
		setFieldVisible('Heading-Field-BaselineLength2', true);
	}	
}

function onDistanceUnitChanged()
{
	updateFieldValueAsDistance('Heading-Field-BaselineLength');
	updateFieldValueAsDistance('Heading-Field-MaximumBaselineErrorLength');
}

function onDistanceValueChanged(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	updateFieldValueAsDistance(field.id);
}

function onSimpleAngleValueChanged(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	updateFieldValueAsSimpleAngle(field.id);
}

function onSimpleAngleIntegerValueChanged(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	updateFieldValueAsSimpleAngleInteger(field.id);
}

function onFieldGPSChange( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	var field_GLO = YAHOO.util.Dom.get(getPrefixName() + '-Field-GLONASS');
	
	if ((isFieldChecked(field) == 0) && (isFieldChecked(field_GLO) == 0)) 
	{
	    setFieldChecked(getPrefixName() + '-Field-GPS', 1);
	}
}

function onFieldGLONASSChange( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	var field_GPS = YAHOO.util.Dom.get(getPrefixName() + '-Field-GPS');
	
	if (!isFieldChecked(field) && !isFieldChecked(field_GPS)) 
	{
	    setFieldChecked(getPrefixName() + '-Field-GLONASS', 1);
	}
}