function initMeteorologicalUnit()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initMeteorologicalUnit()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigMeteorologicalUnit;
			if (config == null) return;
			
			function setPortFields( name, data )
			{
				setFieldChecked( name + '-' + 'ProcessMeteorologicalUnit', data.ProcessMeteorologicalUnit );
				setFieldValue( name + '-' + 'BaudRate', data.BaudRate );
				setFieldChecked( name + '-' + 'RtsCts', data.RtsCts );
				setFieldValue( name + '-' + 'InitializationString', data.InitializationString );
				setFieldValue( name + '-' + 'TriggerString', data.TriggerString );
				setFieldValue( name + '-' + 'Interval', data.Interval );
			}
			
			setFieldChecked('MeteoUnit-Field-LegacyDFileSupport', config.DFileSupport );
			
			setPortFields( 'MeteoUnit-Field-PortA', config.PortA );
			setFieldValue( 'MeteoUnit-Field-PortA-Mode', config.PortA.Mode );
			
			enableRtsCtsForPortA( config.PortA.Mode );
			
			setPortFields( 'MeteoUnit-Field-PortB', config.PortB );
			setPortFields( 'MeteoUnit-Field-PortF', config.PortF );
			
			// Show form
			showConfigForm();
		},
		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initMeteorologicalUnit()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	
	YAHOO.util.Connect.asyncRequest('GET', getConfigMeteorologicalUnit, callbacks);
	
	makeFieldValidator( 'MeteoUnit-Field-PortA-Interval', 'validating_Interval' );
	makeFieldValidator( 'MeteoUnit-Field-PortB-Interval', 'validating_Interval' );
	makeFieldValidator( 'MeteoUnit-Field-PortF-Interval', 'validating_Interval' );
	
	YAHOO.util.Event.addListener( 'MeteoUnit-Field-PortA-Mode', 'change', onPortAModeChanged );
}

function onPortAModeChanged( ev )
{
	enableRtsCtsForPortA( YAHOO.util.Event.getTarget(ev).value );
}

function enableRtsCtsForPortA( value )
{
	setFieldVisible( 'MeteoUnit-Field-PortA-RtsCts', true );
	if( value == '422' )
		setFieldVisible( 'MeteoUnit-Field-PortA-RtsCts', false );
}