var messageArray = new Array("ALM","ATT","AT2","CRT","DCR","DDS","DPO","DTM","GGA","GLL","GMP","GNS","GRS","GSA","GST","GSV","HDT","HD2","LTN","POS","PTT","RMC","RRE","SAT", "SGA", "SGL", "SGP", "TTT","VEC","VE2","VTG", "XDR", "ZDA" );
var portArray = new Array("A", "B", "F", "C", "E", "I", "P", "Q", "M", "U", "R", "I1", "I2", "I3", "I4", "I5", "I6", "I7", "I8", "I9");

//--------------------------------------------------------------------------------------------------------
//<input type="checkbox" class="hidden" name="ALM_I1_ON" value="1" id="NmeaMsg-Field-ALM-I1-ON" />
//<input type="text" class="hidden" name="ALM_I1" size="4" id="NmeaMsg-Field-ALM-I1" />
function createNewNMEAHidden() {
    var nmea = '';
    for (j = 0; j < portArray.length; j++) {
        for (i = 0; i < messageArray.length; i++) {
            nmea += "<input type=\"checkbox\" class=\"hidden\" name=\"" + messageArray[i] + "_" + portArray[j] + "_ON\" value=\"1\" id=\"NmeaMsg-Field-" + messageArray[i] + "-" + portArray[j] + "-ON\" />";
            nmea += "<input type=\"text\" class=\"hidden\" name=\"" + messageArray[i] + "_" + portArray[j] + "\" size=\"4\" id=\"NmeaMsg-Field-" + messageArray[i] + "-" + portArray[j] + "\" />"
        }
    }
    document.getElementById('Cfg-NMEA-Hidden').innerHTML = nmea;
}
function cleanPost() {
    for (j = 0; j < portArray.length; j++) {
        for (i = 0; i < messageArray.length; i++) {
            if (!isFieldChecked("NmeaMsg-Field-" + messageArray[i] + "-" + portArray[j] + "-ON"))
                disableField("NmeaMsg-Field-" + messageArray[i] + "-" + portArray[j]);
        } 
    }
}
//--------------------------------------------------------------------------------------------------------
function initNmeaMessages()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// -- Help link
			if (ProFlex.isDuo()) {
                setItemDisplayed('Index-Help', false);
				setItemDisplayed('Index-Help-HDS', true);
			} else {
				setItemDisplayed('Index-Help-HDS', false);
				setItemDisplayed('Index-Help', true);
			}

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initNmeaMessages()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			// Get config
			var config = data.ConfigNmeaMessage;
			if (config == null) return;

			
            // -- Refresh Rates --
            //setFieldValue('NmeaMsg-Field-Default-Per', config.NmeaDefaultRate);
			for (i in config.NmeaMessage)
			{
		        var name = "NmeaMsg-Field-" + config.NmeaMessage[i].Message + "-" + config.NmeaMessage[i].Port;
                setFieldValue(name, config.NmeaMessage[i].Rate);
                setFieldChecked(name + '-ON', true);
			}
			
			// PTT rate boxes shall be hidden
			for (var j=0; j<portArray.length; j++)
			{
				setItemVisible("NmeaMsg-Field-PTT" + "-" + portArray[j], false);
			}
			// Show form
			showConfigForm();
			
			
			//-------------------------------------------------------------------------------------------------------------
			
			var portName = getResource('portArrayLabel').split(",");
			
			var messageSelect = document.getElementById('NmeaMsg-Add-Lines-Message');
			var customTooltip = null;
			
			//Add Select Tooltip for WebKit and Presto
			var userAgent = navigator.userAgent;
			/*if (userAgent.indexOf("WebKit") != -1
				|| userAgent.indexOf("Presto") != -1)*/
			if (userAgent.indexOf("Presto") != -1)
			{
				customTooltip = document.createElement("div");
				customTooltip.className = "customTooltip";
				customTooltip.style.top = messageSelect.offsetTop + "px";
				customTooltip.style.left = (messageSelect.offsetLeft + 60) + "px";
				
				messageSelect.parentNode.appendChild(customTooltip);
				
				YAHOO.util.Event.addListener(messageSelect, 'change', function () {
					customTooltip.innerHTML = getResource('Nmea-Table-Resource-' + getFieldValue(messageSelect));
					customTooltip.style.visibility = "visible";
				});
				YAHOO.util.Event.addListener(messageSelect, 'blur', function () {
					customTooltip.style.visibility = "hidden";
				});
			}
			
            for (var j=0; j<messageArray.length; j++)
			{
    			var Option = document.createElement("OPTION");
				Option.text = messageArray[j];
				Option.value = messageArray[j];
				Option.title = getResource('Nmea-Table-Resource-' + messageArray[j]);
				
				try {
					messageSelect.add(Option, null); // firefox solution
				}
				catch(ex) {
					messageSelect.add(Option); // All browsers except firefox 
				}
			}

			for (var j=0; j<portArray.length; j++)
			{
				var Option = document.createElement("OPTION");
			    Option.text = portArray[j] + ' - ' + portName[j];
			    Option.value = portArray[j];
				try {
					document.getElementById('NmeaMsg-Add-Lines-Output').add(Option, null); // Firefox solution 
				}
				catch(ex) {
					document.getElementById('NmeaMsg-Add-Lines-Output').add(Option); // All browsers except Firefox 
				}
			}
			
			//document.getElementById('NmeaMsg-Add-Lines-Value').value = document.getElementById('NmeaMsg-Field-Default-Per').value;
			
			var button = document.getElementById("NmeaButton");
			
			var ck = document.getElementById('NmeaMsg-Field-' + messageArray[0] + '-' + portArray[0] + '-ON');
			var tx = document.getElementById('NmeaMsg-Field-' + messageArray[0] + '-' + portArray[0]);
			
			var label;
			if (ck.checked == true)
				label = getResource('modifyLabel');
			else
				label = getResource('addLabel');
			button.value = label;

			buildStatus();
			
			//
			if (ProFlex.isDuo()) 
			{
			    setItemDisplayed('NMEAMsg-Group-SelectAntenna', true);
			    
			    for (var j=0; j<portArray.length; j++)
			    {
				    var Option = document.createElement("OPTION");
			        Option.text = portArray[j] + ' - ' + portName[j];
			        Option.value = portArray[j];
				    try {
					    document.getElementById('NmeaMsg-Select-Output').add(Option, null); // Firefox solution 
				    }
				    catch(ex) {
					    document.getElementById('NmeaMsg-Select-Output').add(Option); // All browsers except Firefox 
				    }
			    }
			    
				var button = document.getElementById("NmeaSelectButton");
				button.value = getResource('modifyLabel');

		        for (i in config.NmeaAntenna)
		        {
	                var name = "NmeaMsg-Field-Select-ANT-" + config.NmeaAntenna[i].Port;
                    setFieldValue(name, config.NmeaAntenna[i].Select);
	            }
	            buildSelect();
			}
			else
			{
			    removeFieldFromPost('NmeaMsg-Field-Antenna2');
			}
			
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("initNmeaMessages()", 5000);
		},

		timeout : 10000,
		cache : false
    };

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigNmeaMessage, callbacks);

	// Field validation
	//setFieldValidator('NmeaMsg-Field-Default-Per');
	for (var i=0; i<messageArray.length; i++) {
	    for (var j=0; j<portArray.length; j++) {
	        var editName = "NmeaMsg-Field-" + messageArray[i] + "-" + portArray[j];
            setFieldValidator(editName);
            var checkName = editName + '-ON';
	        YAHOO.util.Event.addListener(checkName, 'click', onCheckMessage);
        }
	}
	
	initFieldValidator();
}

function checkNmeaButtonLabel()
{
	var button = document.getElementById("NmeaButton");
	var message = document.getElementById('NmeaMsg-Add-Lines-Message');
	messageValue = message.options[message.selectedIndex].value;
	var output = document.getElementById('NmeaMsg-Add-Lines-Output');
	outputValue = output.options[output.selectedIndex].value;
	
	var ck = document.getElementById('NmeaMsg-Field-' + messageValue + '-' + outputValue + '-ON');
	var tx = document.getElementById('NmeaMsg-Field-' + messageValue + '-' + outputValue);
	
	var label;
	if (ck.checked == true)
		label = getResource('modifyLabel');
	else
		label = getResource('addLabel');
	
	elementLabel = document.getElementById('NmeaMsg-Add-Lines-Value-Label');
	elementValue = document.getElementById('NmeaMsg-Add-Lines-Value');
	
	if ((messageValue == "PTT") || (messageValue == "TTT") || (messageValue == "XDR")){
		elementLabel.style.visibility = "hidden";
		elementValue.style.visibility = "hidden";
		if (label == getResource('modifyLabel'))
			button.disabled = true;
		else
			button.disabled = false;
	} else {
		elementLabel.style.visibility = "";
		elementValue.style.visibility = "";
		button.disabled = false;
	}
	
	button.value = label;
}

function checkNmeaAntennaSelected()
{
	var output = document.getElementById('NmeaMsg-Select-Output').value;
	var antenna = document.getElementById('NmeaMsg-Select-Antenna');

//  var tx = document.getElementById('NmeaMsg-Field-Select-ANT-' + output.substr(0,1));
	var tx = document.getElementById('NmeaMsg-Field-Select-ANT-' + output);
	antenna.value = tx.value;
}

function buildStatus()
{	
	var source = new Array();
	var sourceInd = 0;
	var portName = getResource('portArrayLabel').split(","); 
	
	for (var k=0; k<portArray.length; k++) {
		for (var j=0; j<messageArray.length; j++) {
			var ck = document.getElementById('NmeaMsg-Field-' + messageArray[j] + '-' + portArray[k] + '-ON');
			var tx = document.getElementById('NmeaMsg-Field-' + messageArray[j] + '-' + portArray[k]);
			if (ck.checked == true) {
				if ((messageArray[j] == "PTT") || (messageArray[j] == "TTT") || (messageArray[j] == "XDR"))
					value = "";
				else {
					if (tx.value != "")
						value = tx.value;
					else
						value = 1;
					value += " s";
				}
				source[sourceInd] = {"Port": portArray[k], "Output": portName[k], "Message": messageArray[j], "Rate": value, "Suppress": '<a class="Item-Delete" href="#" onclick="deleteNmeaMessage(\'' + messageArray[j] +  '\',\'' + portArray[k] + '\');">&emsp;</a>'};
				sourceInd++;
			}
		}
	}
	sourceFinal = {
		"Response": source
	};

	// Columns definition
	var baseColumnDefs = 
	[
	 	{label:getResource('Nmea-Table-Resource-Port'), key:"Port", resizeable:true, className: "centered"},
		{label:getResource('Nmea-Table-Resource-Output'), key:"Output", resizeable:true},
		{label:getResource('Nmea-Table-Resource-Message'), key:"Message", resizeable:true},
		{label:getResource('Nmea-Table-Resource-Rate'), key:"Rate", resizeable:true},
		{label:getResource('Nmea-Table-Resource-Clear'), key:"Suppress", resizeable:true, className: "centered"}
	];

	// Fields
	var baseFields = ["Port", "Output", "Message", "Rate", "Suppress"];
	
	// Data source
	var myDataSource = new YAHOO.util.LocalDataSource(sourceFinal);
	myDataSource.responseType = YAHOO.util.LocalDataSource.TYPE_JSON;
	myDataSource.responseSchema = {
		resultsList : "Response",
		fields: [
	        { key: "Port" },
	        { key: "Output" },
	        { key: "Message" },
	        { key: "Rate" },
	        { key: "Suppress" }
        ]
	};

	// Table configs
	var myConfigs = {
		width:"auto",
		height:"auto"
	};

	// Localized messages
	myConfigs.MSG_EMPTY = getResource('Nmea-Table-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('Nmea-Table-Resource-Loading');
	
	// Create table
	var myDataTable = new YAHOO.widget.DataTable('NmeaTableView', baseColumnDefs, myDataSource, myConfigs);
	myDataTable.set("selectionMode", "single");
	myDataTable.subscribe("rowClickEvent", myDataTable.onEventSelectRow);
	myDataTable.subscribe("rowClickEvent", function(oArgs) {
		var target = oArgs.target;
		var record = this.getRecord(target);

		message = record.getData("Message");
		port = record.getData("Port");
		portName = record.getData("Output");
		output = port + " - " + portName;
		space = record.getData("Rate").indexOf(" s");
		rate = record.getData("Rate").substr(0,space);
		
		messageInd = 0;
		portInd = 0;
		
		for (var j=0; j<messageArray.length; j++){
			if (messageArray[j] == message){
				messageInd = j;
				break;
			}
		}
		
		for (var j=0; j<portArray.length; j++){
			if (portArray[j] == port){
				portInd = j;
				break;
			}
		}
		
		document.getElementById('NmeaMsg-Add-Lines-Message').selectedIndex = messageInd;
		document.getElementById('NmeaMsg-Add-Lines-Output').selectedIndex = portInd;
		document.getElementById('NmeaMsg-Add-Lines-Value').value = rate;
		
		checkNmeaButtonLabel();
	});
	
	var recordSet = myDataTable.getRecordSet();
	
	for (j = 0; j < recordSet.getLength(); j++){
		var record = recordSet.getRecord(j);
		
		if ((j > 0) && (record.getData("Port") != recordSet.getRecord(j - 1).getData("Port"))) {
			var trEl = myDataTable.getTrEl(recordSet.getRecordIndex(record));
			var tds = trEl.getElementsByTagName("td");
			for (k = 0; k < tds.length; k++)
				tds[k].style.borderTop = '1px solid #000000';
		}
	}
}

function deleteNmeaMessage(messagedel, outputdel)
{
	var ck = document.getElementById('NmeaMsg-Field-' + messagedel + '-' + outputdel + '-ON');
	var tx = document.getElementById('NmeaMsg-Field-' + messagedel + '-' + outputdel);

	ck.checked = false;
	tx.value = "";
	
	var button = document.getElementById("NmeaButton");
	var message = document.getElementById('NmeaMsg-Add-Lines-Message');
	messageValue = message.options[message.selectedIndex].value;
	var output = document.getElementById('NmeaMsg-Add-Lines-Output');
	outputValue = output.options[output.selectedIndex].value;
	space = outputValue.indexOf(" s");
	
	if ((messagedel == messageValue) && (outputdel == outputValue.substr(0,space)))
	{
		var button = document.getElementById("NmeaButton");	
		button.value = getResource('addLabel');
		button.disabled = false;
		
		if ((messageValue == "PTT") || (messageValue == "TTT") || (messageValue == "XDR"))
		{
		} else {
			document.getElementById('NmeaMsg-Add-Lines-Value-Label').style.visibility = "";
			document.getElementById('NmeaMsg-Add-Lines-Value').style.visibility = "";
		}
	}
	
	//Refresh
	buildStatus();
	checkNmeaButtonLabel();
}

function addNmeaMessage()
{
	var message = document.getElementById('NmeaMsg-Add-Lines-Message').value;
	var output = document.getElementById('NmeaMsg-Add-Lines-Output').value;
	var value = document.getElementById('NmeaMsg-Add-Lines-Value').value;
	var valid = !isNaN(value) && (value > 0);
	
	if ((valid == true) || ((messageValue == "PTT") || (messageValue == "TTT") || (messageValue == "XDR")))
	{
//      var ck = document.getElementById('NmeaMsg-Field-' + message + '-' + output.substr(0,1) + '-ON');
//      var tx = document.getElementById('NmeaMsg-Field-' + message + '-' + output.substr(0,1));
		var ck = document.getElementById('NmeaMsg-Field-' + message + '-' + output + '-ON');
		var tx = document.getElementById('NmeaMsg-Field-' + message + '-' + output);
	
		ck.checked = true;
		tx.value = value;
			
		var button = document.getElementById("NmeaButton");	
		button.value = getResource('modifyLabel');
		
		if ((message == "PTT") || (message == "TTT") || (message == "XDR"))
		{
			button.disabled = true;
		} else {
			button.disabled = false;
		}
		
		//Refresh
		buildStatus();
	}
}

function addNmeaSelect()
{
	var output = document.getElementById('NmeaMsg-Select-Output').value;
	var antenna = document.getElementById('NmeaMsg-Select-Antenna').value;

//	var tx = document.getElementById('NmeaMsg-Field-Select-ANT-' + output.substr(0,1));
	var tx = document.getElementById('NmeaMsg-Field-Select-ANT-' + output);
	tx.value = antenna;
	
	//Refresh
	buildSelect();
}

function buildSelect()
{	
    var text = new Array("","");
    var index = new Array(0,0);
    
    for (var k=0; k<portArray.length; k++)
    {
		var tx = document.getElementById('NmeaMsg-Field-Select-ANT-' + portArray[k]);

		if ((tx.value == 0) || (tx.value == 1))
		{
		    // Antenna 1
		    j=0;
		    if (index[j] != 0 ) text[j] += ",";
			text[j] += portArray[k];
			index[j]++;
		}

		if ((tx.value == 0) || (tx.value == 2))
		{
		    // Antenna 2
		    j=1;
		    if (index[j] != 0 ) text[j] += ",";
			text[j] += portArray[k];
			index[j]++;
		}
	}

    setItemText('NMEAMsg-Field-SelectAntenna-Antenna1', text[0] );
    setItemText('NMEAMsg-Field-SelectAntenna-Antenna2', text[1] );

	checkNmeaAntennaSelected();
}

function validating_NmeaMsg_Field_Default_Per(ev, provider) 
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = !isNaN(field.value) && (field.value > 0);
	notifyErrorProvider(provider, !valid);
}

function onCheckMessage(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	if (field.checked != 'checked') {
	    editName = field.id.replace("-ON","");
	    setFieldValue(editName, "");
	}
}

function checkRefreshRate(ev, provider)
{
	var field = YAHOO.util.Event.getTarget(ev);
	notifyErrorProvider(provider, isNaN(field.value));
	if (field.value.length > 0) {
    	setFieldChecked(field.id + '-ON', true);
    }
}

function clearAll()
{
	for (var i=0; i<messageArray.length; i++)
	{
	    for (var j=0; j<portArray.length; j++)
	    {
	        var editName = "NmeaMsg-Field-" + messageArray[i] + "-" + portArray[j];
    	    setFieldValue(editName, "");
    	    var checkName = editName + '-ON';
    	    setFieldChecked(checkName, false);
        }
	}
	
	var button = document.getElementById("NmeaButton");	
	button.value = getResource('addLabel');
	button.disabled = false;
	document.getElementById('NmeaMsg-Add-Lines-Value-Label').style.visibility = "";
	document.getElementById('NmeaMsg-Add-Lines-Value').style.visibility = "";
	
	checkNmeaButtonLabel();
	
	buildStatus();
}

function validating_NmeaMsg_Field_ALM_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ALM_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ALM_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ALM_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ALM_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ALM_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ALM_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ALM_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ALM_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ALM_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ALM_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_ATT_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ATT_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ATT_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ATT_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ATT_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ATT_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ATT_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ATT_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ATT_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ATT_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ATT_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_AT2_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_AT2_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_AT2_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_AT2_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_AT2_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_AT2_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_AT2_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_AT2_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_AT2_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_AT2_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_AT2_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_CRT_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_CRT_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_CRT_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_CRT_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_CRT_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_CRT_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_CRT_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_CRT_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_CRT_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_CRT_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_CRT_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_DCR_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DCR_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DCR_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DCR_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DCR_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DCR_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DCR_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DCR_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DCR_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DCR_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DCR_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_DDS_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DDS_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DDS_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DDS_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DDS_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DDS_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DDS_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DDS_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DDS_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DDS_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DDS_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_DPO_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DPO_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DPO_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DPO_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DPO_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DPO_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DPO_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DPO_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DPO_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DPO_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DPO_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_DTM_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DTM_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DTM_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DTM_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DTM_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DTM_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DTM_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DTM_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DTM_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DTM_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_DTM_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_GGA_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GGA_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GGA_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GGA_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GGA_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GGA_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GGA_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GGA_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GGA_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GGA_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GGA_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_GLL_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GLL_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GLL_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GLL_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GLL_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GLL_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GLL_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GLL_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GLL_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GLL_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GLL_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_GMP_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GMP_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GMP_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GMP_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GMP_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GMP_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GMP_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GMP_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GMP_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GMP_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GMP_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_GRS_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GRS_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GRS_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GRS_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GRS_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GRS_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GRS_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GRS_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GRS_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GRS_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GRS_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_GSA_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSA_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSA_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSA_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSA_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSA_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSA_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSA_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSA_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSA_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSA_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_GST_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GST_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GST_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GST_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GST_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GST_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GST_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GST_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GST_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GST_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GST_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_GSV_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSV_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSV_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSV_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSV_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSV_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSV_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSV_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSV_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSV_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_GSV_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_HDT_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HDT_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HDT_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HDT_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HDT_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HDT_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HDT_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HDT_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HDT_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HDT_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HDT_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_HD2_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HD2_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HD2_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HD2_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HD2_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HD2_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HD2_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HD2_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HD2_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HD2_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_HD2_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_LTN_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_LTN_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_LTN_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_LTN_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_LTN_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_LTN_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_LTN_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_LTN_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_LTN_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_LTN_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_LTN_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_POS_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_POS_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_POS_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_POS_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_POS_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_POS_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_POS_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_POS_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_POS_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_POS_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_POS_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_PTT_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_PTT_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_PTT_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_PTT_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_PTT_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_PTT_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_PTT_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_PTT_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_PTT_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_PTT_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_PTT_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_RMC_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RMC_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RMC_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RMC_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RMC_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RMC_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RMC_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RMC_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RMC_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RMC_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RMC_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_RRE_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RRE_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RRE_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RRE_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RRE_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RRE_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RRE_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RRE_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RRE_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RRE_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_RRE_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_SAT_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SAT_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SAT_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SAT_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SAT_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SAT_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SAT_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SAT_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SAT_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SAT_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SAT_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_SGL_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGL_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGL_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGL_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGL_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGL_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGL_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGL_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGL_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGL_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGL_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_SGP_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGP_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGP_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGP_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGP_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGP_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGP_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGP_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGP_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGP_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_SGP_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_TTT_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_TTT_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_TTT_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_TTT_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_TTT_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_TTT_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_TTT_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_TTT_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_TTT_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_TTT_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_TTT_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_VEC_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VEC_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VEC_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VEC_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VEC_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VEC_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VEC_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VEC_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VEC_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VEC_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VEC_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_VE2_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VE2_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VE2_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VE2_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VE2_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VE2_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VE2_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VE2_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VE2_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VE2_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VE2_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_VTG_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VTG_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VTG_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VTG_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VTG_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VTG_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VTG_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VTG_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VTG_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VTG_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_VTG_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_XDR_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_XDR_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_XDR_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_XDR_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_XDR_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_XDR_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_XDR_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_XDR_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_XDR_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_XDR_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_XDR_R(e, p) {checkRefreshRate(e, p);}

function validating_NmeaMsg_Field_ZDA_A(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ZDA_B(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ZDA_F(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ZDA_C(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ZDA_E(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ZDA_I(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ZDA_P(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ZDA_Q(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ZDA_M(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ZDA_U(e, p) {checkRefreshRate(e, p);}
function validating_NmeaMsg_Field_ZDA_R(e, p) {checkRefreshRate(e, p);}
