var externalChannelSpacing = null;

var previousRadio = null;
var previousConfigRadio = null;
var previousBaudRateA = null;

function getRadioPrefixName()
{
	return YAHOO.util.Dom.get('TransmitterRadio-PagePrefix').value;
}

function processFullSetupAndRadio()
{
	//Rebuild an "config.ExternalRadio" dataset in order to use it with "processRadioTransmitter"
	//Because of ADL Foundation in Transmitter page

	if (configIFS != null && configIR != null)
	{
		processRadioTransmitter(configIR);
	}
}

function processRadioTransmitter( config )
{
	var prefixName = getRadioPrefixName();
	var configTransmitter;
	
	if (prefixName == "Transmitter")
	{
		if (((configIFS.DifferentialStream1.Port == 'D' && configIFS.DifferentialStream1.MessageType > 0)
				|| (configIFS.DifferentialStream2.Port == 'D' && configIFS.DifferentialStream2.MessageType > 0))
				&& configIFS.InternalRadio.ConnectionType == 8)
		{
			configTransmitter = config.InternalRadio;
		}
		else
		{
			configTransmitter = config.ExternalRadio;
		}
	}
	else
	{
		configTransmitter = config.ExternalRadio;
	}

	setFieldValue( prefixName + '-Field-External-SerialPort', configTransmitter.SerialPort);
	setSerialPortOptions(config.InternalRadio.RadioType, config.ExternalRadio.RadioType);
	
	setFieldValue( prefixName + '-Field-External-SerialBaudRate', configTransmitter.SerialBaudRate);
	setFieldChecked( prefixName + '-Field-External-SerialRtsCts', configTransmitter.SerialRtsCts);
	setFieldValue( prefixName + '-Field-External-SerialMode', configTransmitter.SerialMode);
	setOutputMode();

	// -- External Radio Type -- 
	setFieldValue( prefixName + '-Field-External-RadioType', configTransmitter.RadioType);
	enableExternalRadioParameters(configTransmitter.RadioType, true, config);	// to check
	
	setExternalAirLinkSpeed( configTransmitter.Protocol );
	
	// -- External Frequencies --
	if (configTransmitter.ChannelTable.length > 0)
	{
		clearAllFieldOptions( prefixName + '-Field-External-ChannelNumber');
		for (ch in configTransmitter.ChannelTable)
		{
			var channel = configTransmitter.ChannelTable[ch];
			addFieldOption( prefixName + '-Field-External-ChannelNumber', formatChannel(channel), channel.ChannelIndex);
		}
		setFieldValue( prefixName + '-Field-External-ChannelNumber', configTransmitter.ChannelNumber);
	}
	else
	{
		setFieldValue( prefixName + '-Field-External-ChannelNumber', 255);
	}

	// -- External Parameters --
	setFieldValue( prefixName + '-Field-External-Protocol', configTransmitter.Protocol);
	setFieldValue( prefixName + '-Field-External-AirLinkSpeed', configTransmitter.AirLinkSpeed);
	
//	setFieldValue( prefixName + '-Field-External-CurrentPower', configTransmitter.CurrentPower);
	
	if (configTransmitter.PowerTable.length > 0)
	{
		clearAllFieldOptions( prefixName + '-Field-External-CurrentPower');
		for (ch in configTransmitter.PowerTable)
		{
			var power = configTransmitter.PowerTable[ch];
			addFieldOption( prefixName + '-Field-External-CurrentPower', formatPower(power), power.Index);
		}
		setFieldValue( prefixName + '-Field-External-CurrentPower', configTransmitter.CurrentPower);
	}
	else
	{
		setFieldValue( prefixName + '-Field-External-CurrentPower', 255);
	}
	
	//Status	
	setFieldChecked( prefixName + '-Field-External-Scrambler', configTransmitter.Scrambler);
	setFieldChecked( prefixName + '-Field-External-FEC', configTransmitter.FEC);
	
	// Add
	externalChannelSpacing = configTransmitter.ChannelSpacing;
	
	if (configTransmitter.RadioType == 7 || configTransmitter.RadioType == 8 || configTransmitter.RadioType == 9)
	{
		if (externalAirlinkSpeedSelect == null) externalAirlinkSpeedSelect = new SelectFieldManager( prefix + '-Field-External-AirLinkSpeed');
		setADLRadio(configTransmitter.Protocol, externalChannelSpacing, externalAirlinkSpeedSelect,  prefixName + '-Field-External-FEC');
	}
}

function setRadioTransmitterListeners()
{
	var prefixName = getRadioPrefixName();
	
	// External Radio Type changed
	YAHOO.util.Event.addListener( prefixName + '-Field-External-RadioType', 'change', onExternalRadioTypeChange);
	
	// External Serial Port changed
	YAHOO.util.Event.addListener( prefixName + '-Field-External-SerialPort', 'change', onExternalSerialPortChange);
	
	// External Serial Mode changed
	YAHOO.util.Event.addListener( prefixName + '-Field-External-SerialMode', 'change', onExternalSerialModeChange);
	
	// Load radio settings click
	YAHOO.util.Event.addListener( prefixName + '-Button-External-LoadSettings', 'click', onExternalRadioLoadSettings);
	
	YAHOO.util.Event.addListener( prefixName + '-Field-External-Protocol', 'change', onExternalRadioProtocolChange);
}

function formatChannel(channel)
{
	var text = channel.ChannelIndex + ': ';
	if (channel.ReceiveFrequency > 0)
	{
		text += 'RX:' + channel.ReceiveFrequency.toFixed(4) + 'MHz ';
	}
	if (channel.TransmitFrequency > 0)
	{
		text += 'TX:' + channel.TransmitFrequency.toFixed(4) + 'MHz';
	}

	return text;
}

function formatPower(power)
{
	var text = '';

	if (power.Value == 0.1) text += '100mW';
	else if (power.Value == 0.5) text += '500mW';
	else if (power.Value >= 1) text += power.Value.toFixed(0) + 'W';

	return text;
}

function onExternalRadioTypeChange(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	enableExternalRadioParameters(field.value);
	
	if (field.value == 7 || field.value == 8 || field.value == 9)
	{
		var prefixName = getRadioPrefixName();
		var protocolValue = getFieldValue(prefixName + '-Field-External-Protocol');	
				
		if (externalAirlinkSpeedSelect == null) externalAirlinkSpeedSelect = new SelectFieldManager( prefixName + '-Field-External-AirLinkSpeed');
		setADLRadio(parseInt(protocolValue,10), externalChannelSpacing, externalAirlinkSpeedSelect,  prefixName + '-Field-External-FEC');
	}
	setOutputMode();
}

function onExternalSerialPortChange(ev)
{
	//var field = YAHOO.util.Event.getTarget(ev);
	//enableExternalRadioParameters(getFieldValue( getRadioPrefixName() + '-Field-External-RadioType'));
	//setSerialPortOptions( field.value );
	setOutputMode();
}

function onExternalSerialModeChange(ev)
{
	//var field = YAHOO.util.Event.getTarget(ev);
	//var fieldname = getRadioPrefixName() + '-Field-External-RadioType';
	//enableExternalRadioParameters( getFieldValue( fieldname ) );
	setOutputMode();
}

var externalSerialPortSelect = null;
var externalProtocolSelect = null;
var externalAirlinkSpeedSelect = null;

function setSerialPortOptions( radioInterne, radioExterne )
{
	var name = getRadioPrefixName() + '-Field-External-RadioType';
	var prevValue = getFieldValue( name );
	clearAllFieldOptions(name);
	
	addFieldOption(name, getResource( getRadioPrefixName() + '-Resource-NoneCable' ), '0');

	addFieldOption(name, 'U-Link TRx', '2');
	addFieldOption(name, 'Magellan UHF', '3');
	addFieldOption(name, 'PDL HPB/LPB', '4');
	addFieldOption(name, 'ARF7474B EU', '5');
	addFieldOption(name, 'ARF7474A NA', '6');
	addFieldOption(name, 'ADL Vantage / Vantage Pro', '7');
	if ((getRadioPrefixName() == 'Transmitter') && (radioInterne == 8))
		addFieldOption(name, 'ADL Foundation', '8');
	if ((getRadioPrefixName() == 'Rover') || (radioExterne == 9))
		addFieldOption(name, 'XDL Rover', '9');
	
	setFieldValue( name, prevValue );
}

function setOutputMode()
{
	var prefix = getRadioPrefixName();
	var port = getFieldValue( prefix + '-Field-External-SerialPort');

	if (port == 'D')
	{
		if (prefix == "Transmitter")
		{
			setFieldVisible('Transmitter-Field-External-SerialBaudRate',false);
			setFieldVisible('Transmitter-Field-External-SerialMode',false);
			setFieldVisible('Transmitter-Field-External-SerialRtsCts',false);
		}
	}
	else
	{
		if (prefix == "Transmitter")
		{
			setFieldVisible('Transmitter-Field-External-SerialBaudRate',true);
			setFieldVisible('Transmitter-Field-External-SerialMode',true);
			setFieldVisible('Transmitter-Field-External-SerialRtsCts',true);
		}
		
		enableField( prefix + '-Field-External-SerialMode', true );
		if ( port != "A" )
		{
			setFieldValue(prefix + '-Field-External-SerialMode', '232');
			disableField(prefix + '-Field-External-SerialMode');
		}
		
		var mode = getFieldValue(prefix + '-Field-External-SerialMode');
		setFieldVisible(prefix + '-Field-External-SerialRtsCts', true);
		if ( mode == "422" )
		{
			setFieldVisible(prefix + '-Field-External-SerialRtsCts', false);
		}
	}
}

function enableExternalRadioParameters(type, pageinit, config_radio_init)
{
	var prefix = getRadioPrefixName();

	// Init select managers
	if (externalSerialPortSelect == null) externalSerialPortSelect = new SelectFieldManager( prefix + '-Field-External-SerialPort');
	if (externalProtocolSelect == null) externalProtocolSelect = new SelectFieldManager( prefix + '-Field-External-Protocol');
	if (externalAirlinkSpeedSelect == null) externalAirlinkSpeedSelect = new SelectFieldManager( prefix + '-Field-External-AirLinkSpeed');

	if (pageinit == true)
	{
		previousConfigRadio = config_radio_init;
	}

	var reload = false;
	if (previousRadio != eval(type))
		reload = true;

	if (prefix == "Transmitter")
	{
		if (eval(type) == previousConfigRadio.InternalRadio.RadioType)
		{
			fillExternalRadioSettings(previousConfigRadio.InternalRadio,reload);
			externalChannelSpacing = previousConfigRadio.InternalRadio.ChannelSpacing;
		}
		else if (eval(type) == previousConfigRadio.ExternalRadio.RadioType)
		{
			fillExternalRadioSettings(previousConfigRadio.ExternalRadio,reload);
			externalChannelSpacing = previousConfigRadio.ExternalRadio.ChannelSpacing;
		}
		else
		{
			clearAllFieldOptions(prefix + '-Field-External-ChannelNumber');
			addFieldOption(prefix + '-Field-External-ChannelNumber', getResource(prefix + '-Resource-NoFrequencies'), 255);
			setFieldValue(prefix + '-Field-External-ChannelNumber', 255);

			clearAllFieldOptions(prefix + '-Field-External-CurrentPower');
			addFieldOption(prefix + '-Field-External-CurrentPower', '----', 255);
			setFieldValue(prefix + '-Field-External-CurrentPower', 255);
		}
	}
	else
	{
		if (previousConfigRadio.ExternalRadio.RadioType != eval(type))
		{
			clearAllFieldOptions(prefix + '-Field-External-ChannelNumber');
			addFieldOption(prefix + '-Field-External-ChannelNumber', getResource(prefix + '-Resource-NoFrequencies'), 255);
			setFieldValue(prefix + '-Field-External-ChannelNumber', 255);

			clearAllFieldOptions(prefix + '-Field-External-CurrentPower');
			addFieldOption(prefix + '-Field-External-CurrentPower', '----', 255);
			setFieldValue(prefix + '-Field-External-CurrentPower', 255);
		}
		else
		{
			fillExternalRadioSettings(previousConfigRadio.ExternalRadio,reload);
		}
	}
	previousRadio = eval(type);

	// Filter on select fields
	switch (eval(type))
	{
		case 2: // MDL
			externalSerialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			externalProtocolSelect.setFieldOptions([0,2]); // Transparent, Dsnp
			externalAirlinkSpeedSelect.setFieldOptions([4,16,5]); // 4800, 7600, 9600
			
			if (pageinit != true)
			{
				setFieldValue( prefix + '-Field-External-SerialPort', 'A');
				enableField(prefix + '-Field-External-SerialPort', true);
				setFieldVisible(prefix + '-Field-External-SerialPort', true);
				
				setFieldValue(prefix + '-Field-External-SerialBaudRate', 7); // 38400
				enableField(prefix + '-Field-External-SerialBaudRate', false);
				setFieldVisible(prefix + '-Field-External-SerialBaudRate', true);
				
				setFieldValue(prefix + '-Field-External-SerialMode', 422); // 422
				setFieldVisible(prefix + '-Field-External-SerialMode', true);
				
				setFieldVisible(prefix + '-Field-External-SerialRtsCts', false );

				if (eval(type) == previousConfigRadio.ExternalRadio.RadioType)
				{
					setFieldValue(prefix + '-Field-External-SerialPort', previousConfigRadio.ExternalRadio.SerialPort);	
					setFieldValue(prefix + '-Field-External-SerialBaudRate', previousConfigRadio.ExternalRadio.SerialBaudRate);	
					setFieldValue(prefix + '-Field-External-SerialMode', previousConfigRadio.ExternalRadio.SerialMode);	
					setFieldValue(prefix + '-Field-External-SerialRtsCts', previousConfigRadio.ExternalRadio.SerialRtsCts);	
				}
			}
			break;
			
		case 3: // MGL
			externalSerialPortSelect.setFieldOptions(['A']); // A
			if (pageinit != true)
			{
				setFieldValue(prefix + '-Field-External-SerialPort', 'A');	// Port A only
				enableField(prefix + '-Field-External-SerialPort', false);
				setFieldVisible(prefix + '-Field-External-SerialPort', true);
				
				setFieldValue(prefix + '-Field-External-SerialBaudRate', 6); // 19200
				enableField(prefix + '-Field-External-SerialBaudRate', false);
				setFieldVisible(prefix + '-Field-External-SerialBaudRate', true);
				
				setFieldValue(prefix + '-Field-External-SerialMode', 422); // 422
				setFieldVisible(prefix + '-Field-External-SerialMode', true);
				
				setFieldVisible(prefix + '-Field-External-SerialRtsCts', false );

				if (eval(type) == previousConfigRadio.ExternalRadio.RadioType)
				{
					setFieldValue(prefix + '-Field-External-SerialPort', previousConfigRadio.ExternalRadio.SerialPort);	
					setFieldValue(prefix + '-Field-External-SerialBaudRate', previousConfigRadio.ExternalRadio.SerialBaudRate);	
					setFieldValue(prefix + '-Field-External-SerialMode', previousConfigRadio.ExternalRadio.SerialMode);	
					setFieldValue(prefix + '-Field-External-SerialRtsCts', previousConfigRadio.ExternalRadio.SerialRtsCts);	
				}
			}
			break;
			
		case 4: // PDL
			externalSerialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			externalProtocolSelect.setFieldOptions([0,1]); // Transparent, Trimtalk. Dsnp not allowed.
			externalAirlinkSpeedSelect.setFieldOptions([4,5,6]); // 4800, 9600, 19200
			
			if (pageinit != true)
			{
				enableField(prefix + '-Field-External-SerialPort', true); // Ports A, B, F
				setFieldVisible(prefix + '-Field-External-SerialPort', true);
			
				enableField(prefix + '-Field-External-SerialBaudRate', true); // All rates
				setFieldVisible(prefix + '-Field-External-SerialBaudRate', true);
			
				setFieldValue(prefix + '-Field-External-SerialMode', 232);
				setFieldVisible(prefix + '-Field-External-SerialMode', true);
			
				setFieldVisible(prefix + '-Field-External-SerialRtsCts', true );

				if (eval(type) == previousConfigRadio.ExternalRadio.RadioType)
				{
					setFieldValue(prefix + '-Field-External-SerialPort', previousConfigRadio.ExternalRadio.SerialPort);	
					setFieldValue(prefix + '-Field-External-SerialBaudRate', previousConfigRadio.ExternalRadio.SerialBaudRate);	
					setFieldValue(prefix + '-Field-External-SerialMode', previousConfigRadio.ExternalRadio.SerialMode);	
					setFieldValue(prefix + '-Field-External-SerialRtsCts', previousConfigRadio.ExternalRadio.SerialRtsCts);	
				}
			}
			break;
			
		case 5: // LFE
			externalSerialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			enableField(prefix + '-Field-External-SerialPort', true); // Ports A, B, F
			setFieldVisible(prefix + '-Field-External-SerialPort', true);

			if (pageinit != true)
			{
				setFieldValue(prefix + '-Field-External-SerialBaudRate', 5); // 9600
				enableField(prefix + '-Field-External-SerialBaudRate', false);
				setFieldVisible(prefix + '-Field-External-SerialBaudRate', true);
				
				setFieldValue(prefix + '-Field-External-SerialMode', 232); // 232
				setFieldVisible(prefix + '-Field-External-SerialMode', true);
				
				setFieldChecked( prefix + '-Field-External-SerialRtsCts', 0);
				setFieldVisible(prefix + '-Field-External-SerialRtsCts', true );

				if (eval(type) == previousConfigRadio.ExternalRadio.RadioType)
				{
					setFieldValue(prefix + '-Field-External-SerialPort', previousConfigRadio.ExternalRadio.SerialPort);	
					setFieldValue(prefix + '-Field-External-SerialBaudRate', previousConfigRadio.ExternalRadio.SerialBaudRate);	
					setFieldValue(prefix + '-Field-External-SerialMode', previousConfigRadio.ExternalRadio.SerialMode);	
					setFieldValue(prefix + '-Field-External-SerialRtsCts', previousConfigRadio.ExternalRadio.SerialRtsCts);	
				}
			}
			break;

		case 6: // LFA
			externalSerialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			enableField(prefix + '-Field-External-SerialPort', true); // Ports A, B, F
			setFieldVisible(prefix + '-Field-External-SerialPort', true);			

			if (pageinit != true)
			{
				setFieldValue(prefix + '-Field-External-SerialBaudRate', 5); // 9600
				enableField(prefix + '-Field-External-SerialBaudRate', false);
				setFieldVisible(prefix + '-Field-External-SerialBaudRate', true);
				
				setFieldValue(prefix + '-Field-External-SerialMode', 232); // 232
				setFieldVisible(prefix + '-Field-External-SerialMode', true);
				
				setFieldChecked( prefix + '-Field-External-SerialRtsCts', 0);
				setFieldVisible(prefix + '-Field-External-SerialRtsCts', true );

				if (eval(type) == previousConfigRadio.ExternalRadio.RadioType)
				{
					setFieldValue(prefix + '-Field-External-SerialPort', previousConfigRadio.ExternalRadio.SerialPort);	
					setFieldValue(prefix + '-Field-External-SerialBaudRate', previousConfigRadio.ExternalRadio.SerialBaudRate);	
					setFieldValue(prefix + '-Field-External-SerialMode', previousConfigRadio.ExternalRadio.SerialMode);	
					setFieldValue(prefix + '-Field-External-SerialRtsCts', previousConfigRadio.ExternalRadio.SerialRtsCts);	
				}
			}
			break;
			
		case 7: // ADL Vantage / Vantage Pro
			externalSerialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			externalAirlinkSpeedSelect.setFieldOptions([4,17,5,18,6]); // 4800, 8000, 9600, 16000, 19200
			externalProtocolSelect.setFieldOptions([0,1,3,4,5,6,7,8]); // Transparent, TrimTalk 450S, SATEL, TrimMarkII/IIe, TT450S, TRIMMARK3, Transparent FST, U-Link
			//externalCurrentPowerSelect.setFieldOptions([0,1,2,3,4]); // 100mW, 500mW, 1W, 2W, 4W
			
			if (pageinit != true)
			{
				enableField(prefix + '-Field-External-SerialPort', true); // Ports A, B, F
				setFieldVisible(prefix + '-Field-External-SerialPort', true);
				
				enableField(prefix + '-Field-External-SerialBaudRate', true); // All rates
				setFieldVisible(prefix + '-Field-External-SerialBaudRate', true);
				
				setFieldValue(prefix + '-Field-External-SerialMode', 232);
				setFieldVisible(prefix + '-Field-External-SerialMode', true);
				
				setFieldVisible(prefix + '-Field-External-SerialRtsCts', true );

				if (eval(type) == previousConfigRadio.ExternalRadio.RadioType)
				{
					setFieldValue(prefix + '-Field-External-SerialPort', previousConfigRadio.ExternalRadio.SerialPort);	
					setFieldValue(prefix + '-Field-External-SerialBaudRate', previousConfigRadio.ExternalRadio.SerialBaudRate);	
					setFieldValue(prefix + '-Field-External-SerialMode', previousConfigRadio.ExternalRadio.SerialMode);	
					setFieldValue(prefix + '-Field-External-SerialRtsCts', previousConfigRadio.ExternalRadio.SerialRtsCts);	
				}
			}
			break;
			
		case 8: // ADL Foundation
			externalSerialPortSelect.setFieldOptions(['D']); // D
			externalAirlinkSpeedSelect.setFieldOptions([4,17,5,18,6]); // 4800, 8000, 9600, 16000, 19200
			externalProtocolSelect.setFieldOptions([0,1,3,4,5,6,7,8]); // Transparent, TrimTalk 450S, SATEL, TrimMarkII/IIe, TT450S, TRIMMARK3, Transparent FST, U-Link
			//externalCurrentPowerSelect.setFieldOptions([0,1,2]); // 100mW, 500mW, 1W

			if (pageinit != true)
			{
				setFieldValue(prefix + '-Field-External-SerialPort', 'D');	// Port D only
				setFieldVisible(prefix + '-Field-External-SerialPort', false);

				setFieldValue( prefix + '-Field-External-SerialBaudRate', 8);
				enableField(prefix + '-Field-External-SerialBaudRate', true); // All rates
				setFieldVisible(prefix + '-Field-External-SerialBaudRate', false);

				setFieldValue(prefix + '-Field-External-SerialMode', 232);
				setFieldVisible(prefix + '-Field-External-SerialMode', false);
				
				setFieldVisible(prefix + '-Field-External-SerialRtsCts', false );

				if (eval(type) == previousConfigRadio.InternalRadio.RadioType)
				{
					setFieldValue(prefix + '-Field-External-SerialPort', previousConfigRadio.InternalRadio.SerialPort);	
				}
			}
			break;
			
		case 9: // XDL Rover
			externalSerialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			externalAirlinkSpeedSelect.setFieldOptions([4,17,5,18,6]); // 4800, 8000, 9600, 16000, 19200
			externalProtocolSelect.setFieldOptions([0,1,3,4,5,6,7]); // Transparent, TrimTalk 450S, SATEL, TrimMarkII/IIe, TT450S, TRIMMARK3, Transparent FST
			
			if (pageinit != true)
			{
				enableField(prefix + '-Field-External-SerialPort', true); // Ports A, B, F
				setFieldVisible(prefix + '-Field-External-SerialPort', true);
				
				enableField(prefix + '-Field-External-SerialBaudRate', true); // All rates
				setFieldVisible(prefix + '-Field-External-SerialBaudRate', true);
				
				setFieldValue(prefix + '-Field-External-SerialMode', 232);
				setFieldVisible(prefix + '-Field-External-SerialMode', true);
				
                setFieldChecked( prefix + '-Field-External-SerialRtsCts', 0);
				setFieldVisible(prefix + '-Field-External-SerialRtsCts', true );

				if (eval(type) == previousConfigRadio.ExternalRadio.RadioType)
				{
					setFieldValue(prefix + '-Field-External-SerialPort', previousConfigRadio.ExternalRadio.SerialPort);	
					setFieldValue(prefix + '-Field-External-SerialBaudRate', previousConfigRadio.ExternalRadio.SerialBaudRate);	
					setFieldValue(prefix + '-Field-External-SerialMode', previousConfigRadio.ExternalRadio.SerialMode);	
					setFieldValue(prefix + '-Field-External-SerialRtsCts', previousConfigRadio.ExternalRadio.SerialRtsCts);	
				}
			}
			break;

		default:
			externalSerialPortSelect.setFieldOptions(['A','B','F']); // A, B, F

			setFieldValue(prefix + '-Field-External-SerialPort', 'A');
			enableField(prefix + '-Field-External-SerialPort', true);
			setFieldVisible(prefix + '-Field-External-SerialPort', true);

			setFieldValue(prefix + '-Field-External-SerialBaudRate', 7);
			enableField(prefix + '-Field-External-SerialBaudRate', true);

			setFieldVisible(prefix + '-Field-External-SerialMode', 232);
			setFieldVisible(prefix + '-Field-External-SerialRtsCts', true );
			break;
	}

	// TRIMTALK different protocols
	externalProtocolSelect.setFieldOptionText(1, getResource((type != 7 && type != 8) ? prefix + '-Resource-Protocol-Trimtalk' : prefix + '-Resource-Protocol-TrimTalk450S'));

	// Parameters
	setItemVisible(prefix + '-Group-External-RadioParameters',
		type == 2 /* MDL */ ||
		type == 4 /* PDL */ ||
		type == 7 /* ADL */ ||
		type == 8 /* ADL */ ||
		type == 9 /* XDL */);
	
	//BUG EMPTY HERE
	
	// No radio?
	setFieldVisible(prefix + '-Field-External-ChannelNumber', type > 0 && type != 6); // LFA: no choice for channel
	setItemVisible(prefix + '-Button-External-LoadSettings', type > 0 && type != 6 && type != 8);  // LFA: no choice for channel

	// Get new port
	var port = getFieldValue(prefix + '-Field-External-SerialPort');
	if (port == 'B' || port == 'F' || port == 'D')
	{
		setFieldValue(prefix + '-Field-External-SerialMode', 232);
		enableField(prefix + '-Field-External-SerialMode', false);
	}
	
	// Get new mode
	//var mode = getFieldValue(prefix + '-Field-External-SerialMode');
	//setFieldVisible(prefix + '-Field-External-SerialRtsCts', mode == 232);
	
	//Scrambler + FEC
	setFieldVisible(prefix + '-Field-External-Scrambler', 
		type == 4 /* PDL */ ||
		type == 7 /* ADL */ ||
		type == 8 /* ADL */ ||
		type == 9 /* XDL */);
	
	setFieldVisible(prefix + '-Field-External-FEC', 
		type == 4 /* PDL */ ||
		type == 7 /* ADL */ ||
		type == 8 /* ADL */ ||
		type == 9 /* XDL */);
		
	setFieldVisible(prefix + '-Field-External-CurrentPower',
		type == 7 /* ADL */ ||
		type == 8 /* ADL */);
}

function onExternalRadioProtocolChange( event )
{
	var field = YAHOO.util.Event.getTarget(event);
	setExternalAirLinkSpeed( field.value );

	var prefix = getRadioPrefixName();
	var radioType = getFieldValue( prefix + '-Field-External-RadioType' );

	if (radioType == 7 || radioType == 8 || radioType == 9)
	{
		if (externalAirlinkSpeedSelect == null) externalAirlinkSpeedSelect = new SelectFieldManager( prefix + '-Field-External-AirLinkSpeed');
		setADLRadio(parseInt(field.value,10), externalChannelSpacing, externalAirlinkSpeedSelect, prefix + '-Field-External-FEC');
	}
}

function setExternalAirLinkSpeed( protocol )
{
	var prefix = getRadioPrefixName();
	if ( protocol == '2' )//DSNP
	{
		if (externalAirlinkSpeedSelect == null) externalAirlinkSpeedSelect = new SelectFieldManager( prefix + '-Field-External-AirLinkSpeed');
		externalAirlinkSpeedSelect.setFieldOptions([4]);
	}
	else
	{
		enableExternalRadioParameters( getFieldValue( prefix + '-Field-External-RadioType' ) );
	}
}

function onExternalRadioLoadSettings()
{
	var prefix = getRadioPrefixName();
	
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("onExternalRadioLoadSettings()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get settings
			var settings = data.StatusExternalRadioChannelTable;
			if (settings == null) return;

			// Fill radio settings
			fillExternalRadioSettings(settings,true);

			externalChannelSpacing = settings.ChannelSpacing;
			
			var radioType = getFieldValue( prefix + '-Field-External-RadioType' );		
			if (radioType == 7 || radioType == 8 || radioType == 9)
			{
				if (externalAirlinkSpeedSelect == null) externalAirlinkSpeedSelect = new SelectFieldManager( prefix + '-Field-External-AirLinkSpeed');
				setADLRadio(settings.Protocol, externalChannelSpacing, externalAirlinkSpeedSelect, prefix + '-Field-External-FEC');
			}
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}

		},

		timeout : 60000,
		cache : false
    };

	// Loading...
	fillExternalRadioSettings(null);

	// Make the call to the server for JSON data
	var url = getStatusExternalRadioChannelTableURL;
	if (simul != 1)
	{	
		url += 
			"&SerialPort=" + getFieldValue(prefix + '-Field-External-SerialPort') +
			"&RadioType=" + getFieldValue(prefix + '-Field-External-RadioType') +
			"&SerialBaudRate=" + getFieldValue(prefix + '-Field-External-SerialBaudRate') +
			"&SerialMode=" + getFieldValue(prefix + '-Field-External-SerialMode') +
			"&SerialRtsCts=" + (isFieldChecked(prefix + '-Field-External-SerialRtsCts') ? "1" : "0");
	}
	YAHOO.util.Connect.asyncRequest('GET', url, callbacks);
}

function fillExternalRadioSettings(settings, reload)
{
	var prefix = getRadioPrefixName();

	clearAllFieldOptions(prefix + '-Field-External-ChannelNumber');
	clearAllFieldOptions(prefix + '-Field-External-CurrentPower');

	if (settings == null)
	{
		addFieldOption(prefix + '-Field-External-ChannelNumber', getResource(prefix + '-Resource-Loading'), 255);
		setFieldValue(prefix + '-Field-External-ChannelNumber', 255);

		addFieldOption(prefix + '-Field-External-CurrentPower', getResource(prefix + '-Resource-Loading'), 255);
		setFieldValue(prefix + '-Field-External-CurrentPower', 255);
	}
	else
	{
		if (settings.ChannelTable.length > 0)
		{
			for (ch in settings.ChannelTable)
			{
				var channel = settings.ChannelTable[ch];
				addFieldOption(prefix + '-Field-External-ChannelNumber', formatChannel(channel), channel.ChannelIndex);
			}
			setFieldValue(prefix + '-Field-External-ChannelNumber', settings.ChannelNumber);
		}
		else
		{
			addFieldOption(prefix + '-Field-External-ChannelNumber', getResource(prefix + '-Resource-NoFrequencies'), 255);
			setFieldValue(prefix + '-Field-External-ChannelNumber', 255);
		}

		if (settings.PowerTable.length > 0)
		{
			for (ch in settings.PowerTable)
			{
				var power = settings.PowerTable[ch];
				addFieldOption(prefix + '-Field-External-CurrentPower', formatPower(power), power.Index);
			}
			setFieldValue(prefix + '-Field-External-CurrentPower', settings.CurrentPower);
		}
		else
		{
			addFieldOption(prefix + '-Field-External-CurrentPower', '----', 255);
			setFieldValue(prefix + '-Field-External-CurrentPower', 255);
		}

		if (reload == true)
		{
			setFieldValue(prefix + '-Field-External-Protocol', settings.Protocol);
			setFieldValue(prefix + '-Field-External-AirLinkSpeed', settings.AirLinkSpeed);

			setFieldChecked(prefix + '-Field-External-Scrambler', settings.Scrambler);
			setFieldChecked(prefix + '-Field-External-FEC', settings.FEC);
		}
	}
}

function setADLRadio(protocol, channelspacing, airlinkSpeedSelect, fecField)
{
	/*
	- 0: transparent (w EOT time-out)
    - 1: TrimTalk 450S
    - 2: not used
    - 3: SATEL
    - 4: TrimMarkII/IIe
    - 5: TT450S (HW)
    - 6: TRIMMARK3
    - 7: Transparent FST
	- 8: U-Link
	*/
	//internalAirlinkSpeedSelect.setFieldOptions([4,17,5,18,6]); // 4800, 8000, 9600, 16000, 19200
	
	switch (protocol)
	{
	case 0://0: transparent (w EOT time-out)
		enableField(fecField, true);
		if (channelspacing == 25)
		{
			airlinkSpeedSelect.setFieldOptions([5,6]); // 9600, 19200
		} else {
			airlinkSpeedSelect.setFieldOptions([4,5]); // 4800, 9600
		}
	break;
	case 1://1: TrimTalk 450S
		disableField(fecField);
		if (channelspacing == 25)
		{
			airlinkSpeedSelect.setFieldOptions([4,5,18]); // 4800, 9600, 16000
		} else {
			airlinkSpeedSelect.setFieldOptions([4,17]); // 4800, 8000
		}
	break;
	case 3://3: SATEL
		enableField(fecField, true);
		if (channelspacing == 25)
		{
			airlinkSpeedSelect.setFieldOptions([6]); // 19200
		} else {
			airlinkSpeedSelect.setFieldOptions([5]); // 9600
		}
	break;
	case 4://4: TrimMarkII/IIe
		disableField(fecField);
		if (channelspacing == 25)
		{
			airlinkSpeedSelect.setFieldOptions([4]); // 4800
		} else {
			airlinkSpeedSelect.setFieldOptions([4]); // 4800
		}
	break;
	case 5://5: TT450S (HW)
		disableField(fecField);
		if (channelspacing == 25)
		{
			airlinkSpeedSelect.setFieldOptions([4,5,18]); // 4800, 9600, 16000
		} else {
			airlinkSpeedSelect.setFieldOptions([4,17]); // 4800, 8000
		}
	break;
	case 6://6: TRIMMARK3
		disableField(fecField);
		if (channelspacing == 25)
		{
			airlinkSpeedSelect.setFieldOptions([6]); // 19200
		} else {
			airlinkSpeedSelect.setFieldOptions([5]); // 9600
		}
	break;
	case 7://7: Transparent FST
		enableField(fecField, true);
		if (channelspacing == 25)
		{
			airlinkSpeedSelect.setFieldOptions([6]); // 19200
		} else {
			airlinkSpeedSelect.setFieldOptions([5]); // 9600
		}
	break;
	case 8://8: U-Link
		disableField(fecField);
		airlinkSpeedSelect.setFieldOptions([4,5]); // 4800, 9600
	break;
	case 2:
	default:
	break;
	}
}