var atomNavigationArray = new Array("NAV");
var atomMessageArray = new Array("ATR","PVT","DAT", "EVT", "RNX");
var atomPortArray = new Array("A","B","F","C","E","I","M","U", "R");
var ashtechNavigationArray = new Array("SNV","SNG","SNW","SAL","SAG","SAW","ION","SBD");
var ashtechMessageArray = new Array("MPC","PBN","DPC");
var ashtechPortArray = new Array("A","B","F","C","I","M","U", "R");

var atomMessagesArray = atomNavigationArray;
for (var x = 0; x < atomMessageArray.length; x++)
	atomMessagesArray.push(atomMessageArray[x]);

var ashtechMessagesArray = ashtechNavigationArray;
for (var x = 0; x < ashtechMessageArray.length; x++)
	ashtechMessagesArray.push(ashtechMessageArray[x]);

function initRawData()
{

	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// -- Help link
			if (ProFlex.isDuo()) {
                setItemDisplayed('Index-Help', false);
				setItemDisplayed('Index-Help-HDS', true);
			} else {
				setItemDisplayed('Index-Help-HDS', false);
				setItemDisplayed('Index-Help', true);
			}

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initRawData()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigRawData;
			if (config == null) return;

            // -- Atom --
			for (i in config.AtomMessage.Navigation)
			{
		        var name = "AtomMsg-Field-" + config.AtomMessage.Navigation[i].Message;
                setFieldValue(name, config.AtomMessage.Navigation[i].Rate);
                name = name + "-" + config.AtomMessage.Navigation[i].Port + "-ON";
                setFieldChecked(name, true);
			}
            setFieldValue('AtomMsg-Field-Default-Per', config.AtomMessage.MeasureDefaultRate);
			for (i in config.AtomMessage.Measure)
			{
		        var name = "AtomMsg-Field-" + config.AtomMessage.Measure[i].Message + "-" + config.AtomMessage.Measure[i].Port;
                setFieldValue(name, config.AtomMessage.Measure[i].Rate);
                setFieldChecked(name + '-ON', true);
			}
			
			// DAT rate boxes shall be not displayed
			for (var j=0; j<atomPortArray.length; j++)
			{
				var name = "AtomMsg-Field-DAT" + "-" + atomPortArray[j];
				setItemDisplayed(name, false);
				
				// Dot not display <br/>,just before for good alignment
				var br = YAHOO.util.Dom.getPreviousSibling(name);
				setItemDisplayed(br, false);
			}

            // -- Ashetch --
			for (i in config.AshtechLegacyMessage.Navigation)
			{
			    var msg = config.AshtechLegacyMessage.Navigation[i].Message;
		        var name = "RawMsg-Field-" + msg;
		        if (msg != "SBD") {
                    setFieldValue(name, config.AshtechLegacyMessage.Navigation[i].Rate);
                }
                name = name + "-" + config.AshtechLegacyMessage.Navigation[i].Port + "-ON";
                setFieldChecked(name, true);
			}
            setFieldValue('RawMsg-Field-Default-Per', config.AshtechLegacyMessage.MeasureDefaultRate);
			for (i in config.AshtechLegacyMessage.Measure)
			{
		        var name = "RawMsg-Field-" + config.AshtechLegacyMessage.Measure[i].Message + "-" + config.AshtechLegacyMessage.Measure[i].Port;
                setFieldValue(name, config.AshtechLegacyMessage.Measure[i].Rate);
                setFieldChecked(name + '-ON', true);
			}

			// Show form
			showConfigForm();
			
			//-------------------------------------------------------------------------------------------------------------
			
			var portAtomName = getResource('portAtomArrayLabel').split(",");
			
			var messageSelect1 = document.getElementById('RawData-ATOM-Message');
			var customTooltip1 = null;
			
			//Add Select Tooltip for WebKit and Presto
			var userAgent = navigator.userAgent;
			/*if (userAgent.indexOf("WebKit") != -1
			|| userAgent.indexOf("Presto") != -1)*/
			if (userAgent.indexOf("Presto") != -1)
			{
				customTooltip1 = document.createElement("div");
				customTooltip1.className = "customTooltip";
				customTooltip1.style.top = messageSelect1.offsetTop + "px";
				customTooltip1.style.left = (messageSelect1.offsetLeft + 60) + "px";
				
				messageSelect1.parentNode.appendChild(customTooltip1);
				
				YAHOO.util.Event.addListener(messageSelect1, 'change', function () {
					customTooltip1.innerHTML = getResource('RawData-ATOM-Resource-' + getFieldValue(messageSelect1));
					customTooltip1.style.visibility = "visible";
				});
				YAHOO.util.Event.addListener(messageSelect1, 'blur', function () {
					customTooltip1.style.visibility = "hidden";
				});
			}
			
			for (var j=0; j<atomMessagesArray.length; j++)
			{
				var Option = document.createElement("OPTION");
				Option.text = atomMessagesArray[j];
				Option.value = atomMessagesArray[j];
				Option.title = getResource('RawData-ATOM-Resource-' + atomMessagesArray[j]);
				try {
					document.getElementById('RawData-ATOM-Message').add(Option, null); // firefox solution
				}
				catch(ex) {
					document.getElementById('RawData-ATOM-Message').add(Option); // All browsers except firefox 
				}
			}

    		for (var j=0; j<atomPortArray.length; j++)
			{
				var Option = document.createElement("OPTION");
			    Option.text = atomPortArray[j] + ' - ' + portAtomName[j];
			    Option.value = atomPortArray[j];
				try {
					document.getElementById('RawData-ATOM-Output').add(Option, null); // Firefox solution 
				}
				catch(ex) {
					document.getElementById('RawData-ATOM-Output').add(Option); // All browsers except Firefox 
				}
			}
			
			var button = document.getElementById("RawData-ATOM-Button");
			
			var ck = document.getElementById('AtomMsg-Field-' + atomMessagesArray[0] + '-' + atomPortArray[0] + '-ON');
			
			var label;
			if (ck.checked == true)
				label = getResource('modifyLabel');
			else
				label = getResource('addLabel');
			
			button.value = label;
			
			buildATOMStatus();
			
			//-------------------------------------------------------------------------------------------------------------
			if (ProFlex.isDuo()) 
			{
			    setItemDisplayed('RawData-ATOM-Group-SelectAntenna', true);
			    
			    for (var j=0; j<atomPortArray.length; j++)
			    {
				    var Option = document.createElement("OPTION");
			        Option.text = atomPortArray[j] + ' - ' + portAtomName[j];
			        Option.value = atomPortArray[j];
				    try {
					    document.getElementById('RawData-ATOM-Select-Output').add(Option, null); // Firefox solution 
				    }
				    catch(ex) {
					    document.getElementById('RawData-ATOM-Select-Output').add(Option); // All browsers except Firefox 
				    }
			    }
			    
				var button = document.getElementById("RawDataSelectButton");
				button.value = getResource('modifyLabel');

		        for (i in config.AtomMessage.Antenna)
		        {
	                var name = "RawData-ATOM-Field-Select-ANT-" + config.AtomMessage.Antenna[i].Port;
                       setFieldValue(name, config.AtomMessage.Antenna[i].Select);
	            }
	            buildATOMAntenna();
			}
			else
			{
			    removeFieldFromPost('RawData-ATOM-Field-Antenna2');
			}
			
			//-------------------------------------------------------------------------------------------------------------
			
			var portAshtechName = getResource('portAshtechArrayLabel').split(",");

			var messageSelect2 = document.getElementById('RawData-Ashtech-Legacy-Message');
			var customTooltip2 = null;
			
			//Add Select Tooltip for WebKit and Presto
			if (userAgent.indexOf("WebKit") != -1
				|| userAgent.indexOf("Presto") != -1)
			{
				customTooltip2 = document.createElement("div");
				customTooltip2.className = "customTooltip";
				customTooltip2.style.top = messageSelect2.offsetTop + "px";
				customTooltip2.style.left = (messageSelect2.offsetLeft + 60) + "px";
				
				messageSelect2.parentNode.appendChild(customTooltip2);
				
				YAHOO.util.Event.addListener(messageSelect2, 'change', function () {
					customTooltip2.innerHTML = getResource('RawData-Ashtech-Legacy-Resource-' + getFieldValue(messageSelect2));
					customTooltip2.style.visibility = "visible";
				});
				YAHOO.util.Event.addListener(messageSelect2, 'blur', function () {
					customTooltip2.style.visibility = "hidden";
				});
			}
			
            for (var j=0; j<ashtechMessagesArray.length; j++)
			{
				var Option = document.createElement("OPTION");
				Option.text = ashtechMessagesArray[j];
				Option.value = ashtechMessagesArray[j];
				Option.title = getResource('RawData-Ashtech-Legacy-Resource-' + ashtechMessagesArray[j]);
				try {
					document.getElementById('RawData-Ashtech-Legacy-Message').add(Option, null); // firefox solution
				}
				catch(ex) {
					document.getElementById('RawData-Ashtech-Legacy-Message').add(Option); // All browsers except firefox 
				}
			}

            for (var j=0; j<ashtechPortArray.length; j++)
			{
				var Option = document.createElement("OPTION");
			    Option.text = ashtechPortArray[j] + ' - ' + portAshtechName[j];
			    Option.value = ashtechPortArray[j];
				try {
					document.getElementById('RawData-Ashtech-Legacy-Output').add(Option, null); // Firefox solution 
				}
				catch(ex) {
					document.getElementById('RawData-Ashtech-Legacy-Output').add(Option); // All browsers except Firefox 
				}
			}
			
			var button = document.getElementById("RawData-Ashtech-Legacy-Button");
			
			var ck = document.getElementById('RawMsg-Field-' + ashtechMessagesArray[0] + '-' + ashtechPortArray[0] + '-ON');
			
			var label;
			if (ck.checked == true)
				label = getResource('modifyLabel');
			else
				label = getResource('addLabel');
			
			button.value = label;
			
			buildAshtechLegacyStatus();
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("initRawData()", 5000);
		},

		timeout : 10000,
		cache : false
    };

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigRawData, callbacks);

	// Field validation
	setFieldValidator('AtomMsg-Field-Default-Per');
	for (var i=0; i<atomNavigationArray.length; i++)
	{
        var editName = "AtomMsg-Field-" + atomNavigationArray[i];
        setFieldValidator(editName);
    }
	for (var i=0; i<atomMessageArray.length; i++)
	{
    	for (var j=0; j<atomPortArray.length; j++)
	    {
	        var editName = "AtomMsg-Field-" + atomMessageArray[i] + "-" + atomPortArray[j];
            setFieldValidator(editName);
            var checkName = editName + '-ON';
 	        YAHOO.util.Event.addListener(checkName, 'click', onCheckMessage);
        }
	}
	for (var i=0; i<ashtechNavigationArray.length; i++)
	{
	    var msg = ashtechNavigationArray[i];
	    if (msg != "SBD") {
            var editName = "RawMsg-Field-" + msg;
            setFieldValidator(editName);
        }
    }	
	setFieldValidator('RawMsg-Field-Default-Per');
    for (var i=0; i<ashtechMessageArray.length; i++)
	{
	    for (var j=0; j<ashtechPortArray.length; j++)
	    {
	        var editName = "RawMsg-Field-" + ashtechMessageArray[i] + "-" + ashtechPortArray[j];
            setFieldValidator(editName);
            var checkName = editName + '-ON';
	        YAHOO.util.Event.addListener(checkName, 'click', onCheckMessage);
        }
	}
	
	initFieldValidator();
}

function checkATOMButtonLabel(){
	var button = document.getElementById("RawData-ATOM-Button");
	var message = document.getElementById('RawData-ATOM-Message');
	messageValue = message.options[message.selectedIndex].value;
	var output = document.getElementById('RawData-ATOM-Output');
	outputValue = output.options[output.selectedIndex].value;
	
	var ck = document.getElementById('AtomMsg-Field-' + messageValue + '-' + outputValue + '-ON');
	
	var label;
	if (ck.checked == true)
		label = getResource('modifyLabel');
	else
		label = getResource('addLabel');
	
	elementLabel = document.getElementById('RawData-ATOM-Value-Label');
	elementValue = document.getElementById('RawData-ATOM-Value');
	
	switch (messageValue) {
	case "NAV":
	case "PVT":
		elementLabel.style.visibility = "";
		elementValue.style.visibility = "";
		button.disabled = false;
	break;
	case "ATR":
	case "DAT":
	case "EVT":
		elementLabel.style.visibility = "hidden";
		elementValue.style.visibility = "hidden";
		if (label == getResource('modifyLabel'))
			button.disabled = true;
		else
			button.disabled = false;
	break;
		case "RNX":
			if (outputValue == 'R')
			{
				elementLabel.style.visibility = "hidden";
				elementValue.style.visibility = "hidden";
				if (label == getResource('modifyLabel'))
					button.disabled = true;
				else
					button.disabled = false;								
			}
			else
			{

				elementLabel.style.visibility = "";
				elementValue.style.visibility = "";
				button.disabled = false;
			}
	}
	
	button.value = label;
}

function checkAshtechLegacyButtonLabel(){
	var button = document.getElementById("RawData-Ashtech-Legacy-Button");
	var message = document.getElementById('RawData-Ashtech-Legacy-Message');
	messageValue = message.options[message.selectedIndex].value;
	var output = document.getElementById('RawData-Ashtech-Legacy-Output');
	outputValue = output.options[output.selectedIndex].value;
	
	var ck = document.getElementById('RawMsg-Field-' + messageValue + '-' + outputValue + '-ON');
	
	var label;
	if (ck.checked == true)
		label = getResource('modifyLabel');
	else
		label = getResource('addLabel');
	
	elementLabel = document.getElementById('RawData-Ashtech-Legacy-Value-Label');
	elementValue = document.getElementById('RawData-Ashtech-Legacy-Value');
	
	switch (messageValue) {
	case "SAL":
	case "SAG":
	case "SAW":
	case "SNG":
	case "SNV":
	case "SNW":
	case "ION":
		elementLabel.style.visibility = "";
		elementValue.style.visibility = "";
		button.disabled = false;
	break;
	case "SBD":
		elementLabel.style.visibility = "hidden";
		elementValue.style.visibility = "hidden";
		if (label == getResource('modifyLabel'))
			button.disabled = true;
		else
			button.disabled = false;
	break;
	case "PBN":
	case "DPC":
		elementLabel.style.visibility = "";
		elementValue.style.visibility = "";
		button.disabled = false;
	break;
	case "MPC":
		if (outputValue == 'R')
		{
			elementLabel.style.visibility = "hidden";
			elementValue.style.visibility = "hidden";
			if (label == getResource('modifyLabel'))
				button.disabled = true;
			else
				button.disabled = false;								
		}
		else
		{
			elementLabel.style.visibility = "";
			elementValue.style.visibility = "";
			button.disabled = false;
		}	
	break;
	}
	
	button.value = label;
}

function buildATOMStatus(){	
	var source = new Array();
	var sourceInd = 0;
	var portAtomName = getResource('portAtomArrayLabel').split(",");
	
	for (var k=0; k<atomPortArray.length; k++){
    	for (var j=0; j<atomMessagesArray.length; j++){
			switch (atomMessagesArray[j]) {
			case "NAV":
				var ck = document.getElementById('AtomMsg-Field-' + atomMessagesArray[j] + '-' + atomPortArray[k] + '-ON');
				if (ck.checked == true){
					value = document.getElementById('AtomMsg-Field-' + atomMessagesArray[j]).value;
					//Former values (Update) check
					if (value == "")
						value = document.getElementById('AtomMsg-Field-Default-Per').value;
					value += " s";
					source[sourceInd] = {"Port": atomPortArray[k], "Output": portAtomName[k], "Message": atomMessagesArray[j], "Rate": value, "Suppress": '<a class="Item-Delete" href="#" onclick="deleteATOMMessage(\'' + atomMessagesArray[j] +  '\',\'' + atomPortArray[k] + '\');return false;">&emsp;</a>'};
					sourceInd++;
				}
			break;
			case "PVT":
				var ck = document.getElementById('AtomMsg-Field-' + atomMessagesArray[j] + '-' + atomPortArray[k] + '-ON');
				var tx = document.getElementById('AtomMsg-Field-' + atomMessagesArray[j] + '-' + atomPortArray[k]);
				if (ck.checked == true){
					if (tx.value != "")
						value = tx.value;
					else
						value = 1;
					value += " s";
					source[sourceInd] = {"Port": atomPortArray[k], "Output": portAtomName[k], "Message": atomMessagesArray[j], "Rate": value, "Suppress": '<a class="Item-Delete" href="#" onclick="deleteATOMMessage(\'' + atomMessagesArray[j] +  '\',\'' + atomPortArray[k] + '\');return false;">&emsp;</a>'};
					sourceInd++;
				}
			break;
			case "ATR":
			case "DAT":
			case "EVT":
				var ck = document.getElementById('AtomMsg-Field-' + atomMessagesArray[j] + '-' + atomPortArray[k] + '-ON');
				if (ck.checked == true){
					value ="";
					source[sourceInd] = {"Port": atomPortArray[k], "Output": portAtomName[k], "Message": atomMessagesArray[j], "Rate": value, "Suppress": '<a class="Item-Delete" href="#" onclick="deleteATOMMessage(\'' + atomMessagesArray[j] +  '\',\'' + atomPortArray[k] + '\');return false;">&emsp;</a>'};
					sourceInd++;
				}
			break;
			case "RNX":
				if (atomPortArray[k] == 'R')
				{
					var ck = document.getElementById('AtomMsg-Field-' + atomMessagesArray[j] + '-' + atomPortArray[k] + '-ON');
					if (ck.checked == true){
						value ="";
						source[sourceInd] = {"Port": atomPortArray[k], "Output": portAtomName[k], "Message": atomMessagesArray[j], "Rate": value, "Suppress": '<a class="Item-Delete" href="#" onclick="deleteATOMMessage(\'' + atomMessagesArray[j] +  '\',\'' + atomPortArray[k] + '\');return false;">&emsp;</a>'};
						sourceInd++;
					}
				}
				else
				{
					var ck = document.getElementById('AtomMsg-Field-' + atomMessagesArray[j] + '-' + atomPortArray[k] + '-ON');
					var tx = document.getElementById('AtomMsg-Field-' + atomMessagesArray[j] + '-' + atomPortArray[k]);
					if (ck.checked == true){
						if (tx.value != "")
							value = tx.value;
						else
							value = 1;
						value += " s";
						source[sourceInd] = {"Port": atomPortArray[k], "Output": portAtomName[k], "Message": atomMessagesArray[j], "Rate": value, "Suppress": '<a class="Item-Delete" href="#" onclick="deleteATOMMessage(\'' + atomMessagesArray[j] +  '\',\'' + atomPortArray[k] + '\');return false;">&emsp;</a>'};
						sourceInd++;
					}					
				}
			break;
			}
		}
	}
	sourceFinal = {
		"Response": source
	};

	// Columns definition
	var baseColumnDefs = 
	[
	 	{label:getResource('RawData-Table-Resource-Port'), key:"Port", resizeable:true, className: "centered"},
		{label:getResource('RawData-Table-Resource-Output'), key:"Output", resizeable:true},
		{label:getResource('RawData-Table-Resource-Message'), key:"Message", resizeable:true},
		{label:getResource('RawData-Table-Resource-Rate'), key:"Rate", resizeable:true},
		{label:getResource('RawData-Table-Resource-Clear'), key:"Suppress", resizeable:true, className: "centered"}
	];
	
	// Data source
	var myDataSource = new YAHOO.util.LocalDataSource(sourceFinal);
	myDataSource.responseType = YAHOO.util.LocalDataSource.TYPE_JSON;
	myDataSource.responseSchema = {
		resultsList : "Response",
		fields: [
	        { key: "Port" },
	        { key: "Output" },
	        { key: "Message" },
	        { key: "Rate" },
	        { key: "Suppress" }
        ]
	};

	// Table configs
	var myConfigs = {
		width:"auto",
		height:"auto"
	};

	// Localized messages
	myConfigs.MSG_EMPTY = getResource('RawData-Table-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('RawData-Table-Resource-Loading');
	
	// Create table
	var myDataTable = new YAHOO.widget.DataTable('RawData-ATOM-TableView', baseColumnDefs, myDataSource, myConfigs);
	myDataTable.set("selectionMode", "single");
	myDataTable.subscribe("rowClickEvent", myDataTable.onEventSelectRow);
	myDataTable.subscribe("rowClickEvent", function(oArgs) {
		var target = oArgs.target;
		var record = this.getRecord(target);

		message = record.getData("Message");
		port = record.getData("Port");
		portName = record.getData("Output");
		output = port + " - " + portName;
		space = record.getData("Rate").indexOf(" s");
		rate = record.getData("Rate").substr(0,space);
		
		messageInd = 0;
		portInd = 0;
		
		for (var j=0; j<atomMessagesArray.length; j++){
			if (atomMessagesArray[j] == message) {
				messageInd = j;
				break;
			}
		}
		
		for (var j=0; j<atomPortArray.length; j++){
			if (atomPortArray[j] == port) {
				portInd = j;
				break;
			}
		}
		
		document.getElementById('RawData-ATOM-Message').selectedIndex = messageInd;
		document.getElementById('RawData-ATOM-Output').selectedIndex = portInd;
		document.getElementById('RawData-ATOM-Value').value = rate;
		
		checkATOMButtonLabel();
	});
	
	var recordSet = myDataTable.getRecordSet();
	
	for (var j = 0; j < recordSet.getLength(); j++){
		var record = recordSet.getRecord(j);
		
		if ((j > 0) && (record.getData("Port") != recordSet.getRecord(j - 1).getData("Port"))) {
			var trEl = myDataTable.getTrEl(recordSet.getRecordIndex(record));
			var tds = trEl.getElementsByTagName("td");
			for (var k = 0; k < tds.length; k++)
				tds[k].style.borderTop = '1px solid #000000';
		}
	}
}

function buildATOMAntenna()
{	
    var text = new Array("","");
    var index = new Array(0,0);
    
    for (var k=0; k<atomPortArray.length; k++)
    {
		var tx = document.getElementById('RawData-ATOM-Field-Select-ANT-' + atomPortArray[k]);

		if ((tx.value == 0) || (tx.value == 1))
		{
		    // Antenna 1
		    j=0;
		    if (index[j] != 0 ) text[j] += ",";
			text[j] += atomPortArray[k];
			index[j]++;
		}

		if ((tx.value == 0) || (tx.value == 2))
		{
		    // Antenna 2
		    j=1;
		    if (index[j] != 0 ) text[j] += ",";
			text[j] += atomPortArray[k];
			index[j]++;
		}
	}

    setItemText('RawData-ATOM-Field-SelectAntenna-Antenna1', text[0] );
    setItemText('RawData-ATOM-Field-SelectAntenna-Antenna2', text[1] );
    
    checkAtomAntennaSelected();
}

function buildAshtechLegacyStatus(){	
	var source = new Array();
	var sourceInd = 0;
	var portAshtechName = getResource('portAshtechArrayLabel').split(",");
	
	for (var k=0; k<ashtechPortArray.length; k++){
	    for (var j=0; j<ashtechMessagesArray.length; j++){
			switch (ashtechMessagesArray[j]) {
			case "SAL":
			case "SAG":
			case "SAW":
			case "SNG":
			case "SNV":
			case "SNW":
			case "ION":
				var ck = document.getElementById('RawMsg-Field-' + ashtechMessagesArray[j] + '-' + ashtechPortArray[k] + '-ON');
				if (ck.checked == true){
					value = document.getElementById('RawMsg-Field-' +  ashtechMessagesArray[j]).value;
					//Former values (Update) check
					if (value == "")
						value = document.getElementById('RawMsg-Field-Default-Per').value;
					value += " s";
					source[sourceInd] = {"Port": ashtechPortArray[k], "Output": portAshtechName[k], "Message": ashtechMessagesArray[j], "Rate": value, "Suppress": '<a class="Item-Delete" href="#" onclick="deleteAshtechLegacyMessage(\'' + ashtechMessagesArray[j] +  '\',\'' + ashtechPortArray[k] + '\');return false;">&emsp;</a>'};
					sourceInd++;
				}
			break;
			case "SBD":
				var ck = document.getElementById('RawMsg-Field-' + ashtechMessagesArray[j] + '-' + ashtechPortArray[k] + '-ON');
				if (ck.checked == true){
					value = "";
					source[sourceInd] = {"Port": ashtechPortArray[k], "Output": portAshtechName[k], "Message": ashtechMessagesArray[j], "Rate": value, "Suppress": '<a class="Item-Delete" href="#" onclick="deleteAshtechLegacyMessage(\'' + ashtechMessagesArray[j] +  '\',\'' + ashtechPortArray[k] + '\');return false;">&emsp;</a>'};
					sourceInd++;
				}
			break;
			case "PBN":
			case "DPC":
				var ck = document.getElementById('RawMsg-Field-' + ashtechMessagesArray[j] + '-' + ashtechPortArray[k] + '-ON');
				var tx = document.getElementById('RawMsg-Field-' + ashtechMessagesArray[j] + '-' + ashtechPortArray[k]);
				if (ck.checked == true){
					if (tx.value != "")
						value = tx.value;
					else
						value = 1;
					value += " s";
					source[sourceInd] = {"Port": ashtechPortArray[k], "Output": portAshtechName[k], "Message": ashtechMessagesArray[j], "Rate": value, "Suppress": '<a class="Item-Delete" href="#" onclick="deleteAshtechLegacyMessage(\'' + ashtechMessagesArray[j] +  '\',\'' + ashtechPortArray[k] + '\');return false;">&emsp;</a>'};
					sourceInd++;
				}
			break;
			case "MPC":
				if (ashtechPortArray[k] == 'R')
				{
					var ck = document.getElementById('RawMsg-Field-' + ashtechMessagesArray[j] + '-' + ashtechPortArray[k] + '-ON');
					if (ck.checked == true){
						value = "";
						source[sourceInd] = {"Port": ashtechPortArray[k], "Output": portAshtechName[k], "Message": ashtechMessagesArray[j], "Rate": value, "Suppress": '<a class="Item-Delete" href="#" onclick="deleteAshtechLegacyMessage(\'' + ashtechMessagesArray[j] +  '\',\'' + ashtechPortArray[k] + '\');return false;">&emsp;</a>'};
						sourceInd++;
					}
				}
				else
				{
					var ck = document.getElementById('RawMsg-Field-' + ashtechMessagesArray[j] + '-' + ashtechPortArray[k] + '-ON');
					var tx = document.getElementById('RawMsg-Field-' + ashtechMessagesArray[j] + '-' + ashtechPortArray[k]);
					if (ck.checked == true){
						if (tx.value != "")
							value = tx.value;
						else
							value = 1;
						value += " s";
						source[sourceInd] = {"Port": ashtechPortArray[k], "Output": portAshtechName[k], "Message": ashtechMessagesArray[j], "Rate": value, "Suppress": '<a class="Item-Delete" href="#" onclick="deleteAshtechLegacyMessage(\'' + ashtechMessagesArray[j] +  '\',\'' + ashtechPortArray[k] + '\');return false;">&emsp;</a>'};
						sourceInd++;
					}
				}
			break;
			}
		}
	}
	sourceFinal = {
		"Response": source
	};

	// Columns definition
	var baseColumnDefs = 
	[
	 	{label:getResource('RawData-Table-Resource-Port'), key:"Port", resizeable:true, className: "centered"},
		{label:getResource('RawData-Table-Resource-Output'), key:"Output", resizeable:true},
		{label:getResource('RawData-Table-Resource-Message'), key:"Message", resizeable:true},
		{label:getResource('RawData-Table-Resource-Rate'), key:"Rate", resizeable:true},
		{label:getResource('RawData-Table-Resource-Clear'), key:"Suppress", resizeable:true, className: "centered"}
	];
	
	// Data source
	var myDataSource = new YAHOO.util.LocalDataSource(sourceFinal);
	myDataSource.responseType = YAHOO.util.LocalDataSource.TYPE_JSON;
	myDataSource.responseSchema = {
		resultsList : "Response",
		fields: [
	        { key: "Port" },
	        { key: "Output" },
	        { key: "Message" },
	        { key: "Rate" },
	        { key: "Suppress" }
        ]
	};

	// Table configs
	var myConfigs = {
		width:"auto",
		height:"auto"
	};

	// Localized messages
	myConfigs.MSG_EMPTY = getResource('RawData-Table-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('RawData-Table-Resource-Loading');
	
	// Create table
	var myDataTable = new YAHOO.widget.DataTable('RawData-Ashtech-Legacy-TableView', baseColumnDefs, myDataSource, myConfigs);
	myDataTable.set("selectionMode", "single");
	myDataTable.subscribe("rowClickEvent", myDataTable.onEventSelectRow);
	myDataTable.subscribe("rowClickEvent", function(oArgs) {
		var target = oArgs.target;
		var record = this.getRecord(target);

		message = record.getData("Message");
		port = record.getData("Port");
		portName = record.getData("Output");
		output = port + " - " + portName;
		space = record.getData("Rate").indexOf(" s");
		rate = record.getData("Rate").substr(0,space);
		
		messageInd = 0;
		portInd = 0;
		
		for (var j=0; j<ashtechMessagesArray.length; j++){
			if (ashtechMessagesArray[j] == message){
				messageInd = j;
				break;
			}
		}
		
		for (var j=0; j<ashtechPortArray.length; j++){
			if (ashtechPortArray[j] == port){
				portInd = j;
				break;
			}
		}
		
		document.getElementById('RawData-Ashtech-Legacy-Message').selectedIndex = messageInd;
		document.getElementById('RawData-Ashtech-Legacy-Output').selectedIndex = portInd;
		document.getElementById('RawData-Ashtech-Legacy-Value').value = rate;
		
		checkAshtechLegacyButtonLabel();
	});
	
	var recordSet = myDataTable.getRecordSet();
	
	for (var j = 0; j < recordSet.getLength(); j++){
		var record = recordSet.getRecord(j);
		
		if ((j > 0) && (record.getData("Port") != recordSet.getRecord(j - 1).getData("Port"))) {
			var trEl = myDataTable.getTrEl(recordSet.getRecordIndex(record));
			var tds = trEl.getElementsByTagName("td");
			for (var k = 0; k < tds.length; k++)
				tds[k].style.borderTop = '1px solid #000000';
		}
	}
}

function deleteATOMMessage(messagedel, outputdel){
	switch (messagedel) {
	case "NAV":
	case "DAT":
	case "ATR":
	case "EVT":
		var ck = document.getElementById('AtomMsg-Field-' + messagedel + '-' + outputdel + '-ON');

		ck.checked = false;
	break;
	case "PVT":
		var ck = document.getElementById('AtomMsg-Field-' + messagedel + '-' + outputdel + '-ON');
		var tx = document.getElementById('AtomMsg-Field-' + messagedel + '-' + outputdel);

		ck.checked = false;
		tx.value = "";
	break;
	case "RNX":
		if (outputdel == 'R')
		{
			var ck = document.getElementById('AtomMsg-Field-' + messagedel + '-' + outputdel + '-ON');

			ck.checked = false;
		}
		else
		{
			var ck = document.getElementById('AtomMsg-Field-' + messagedel + '-' + outputdel + '-ON');
			var tx = document.getElementById('AtomMsg-Field-' + messagedel + '-' + outputdel);

			ck.checked = false;
			tx.value = "";
		}		
	break;
	}
	
	var button = document.getElementById("RawData-ATOM-Button");
	var message = document.getElementById('RawData-ATOM-Message');
	messageValue = message.options[message.selectedIndex].value;
	var output = document.getElementById('RawData-ATOM-Output');
	outputValue = output.options[output.selectedIndex].value;
	space = outputValue.indexOf(" s");
	
	if ((messagedel == messageValue) && (outputdel == outputValue.substr(0,space))){
		button.value = getResource('addLabel');
		button.disabled = false;
		
		switch (messagedel) {
		case "ATR":
		case "DAT":
		case "EVT":
			
		break;
		case "NAV":
		case "PVT":
			document.getElementById('RawData-ATOM-Value-Label').style.visibility = "";
			document.getElementById('RawData-ATOM-Value').style.visibility = "";
		break;
		case "RNX":
			if (outputdel == 'R')
			{
			}
			else
			{
				document.getElementById('RawData-ATOM-Value-Label').style.visibility = "";
				document.getElementById('RawData-ATOM-Value').style.visibility = "";		
			}
		break;
		}
	}
	
	//Refresh
	buildATOMStatus();
	checkATOMButtonLabel();
}

function deleteAshtechLegacyMessage(messagedel, outputdel){
	switch (messagedel) {
	case "SAL":
	case "SAG":
	case "SAW":
	case "SNG":
	case "SNV":
	case "SNW":
	case "ION":
	case "SBD":
		var ck = document.getElementById('RawMsg-Field-' + messagedel + '-' + outputdel + '-ON');

		ck.checked = false;
	break;
	case "PBN":
	case "DPC":
		var ck = document.getElementById('RawMsg-Field-' + messagedel + '-' + outputdel + '-ON');
		var tx = document.getElementById('RawMsg-Field-' + messagedel + '-' + outputdel);

		ck.checked = false;
		tx.value = "";
	break;
	case "MPC":
		if (outputdel == 'R')
		{
			var ck = document.getElementById('RawMsg-Field-' + messagedel + '-' + outputdel + '-ON');

			ck.checked = false;
		}
		else
		{
			var ck = document.getElementById('RawMsg-Field-' + messagedel + '-' + outputdel + '-ON');
			var tx = document.getElementById('RawMsg-Field-' + messagedel + '-' + outputdel);

			ck.checked = false;
			tx.value = "";
		}
	break;
	}
	
	var button = document.getElementById("RawData-Ashtech-Legacy-Button");
	var message = document.getElementById('RawData-Ashtech-Legacy-Message');
	messageValue = message.options[message.selectedIndex].value;
	var output = document.getElementById('RawData-Ashtech-Legacy-Output');
	outputValue = output.options[output.selectedIndex].value;
	space = outputValue.indexOf(" s");
	
	if ((messagedel == messageValue) && (outputdel == outputValue.substr(0,space)))	{
		button.value = getResource('addLabel');
		button.disabled = false;
		
		switch (messagedel) {
		case "SAL":
		case "SAG":
		case "SAW":
		case "SNG":
		case "SNV":
		case "SNW":
		case "ION":
		case "SBD":
			
		break;
		case "PBN":
		case "DPC":
			document.getElementById('RawData-ATOM-Value-Label').style.visibility = "";
			document.getElementById('RawData-ATOM-Value').style.visibility = "";
		break;
		case "MPC":
			if (outputdel == 'R')
			{
			}
			else
			{
				document.getElementById('RawData-ATOM-Value-Label').style.visibility = "";
				document.getElementById('RawData-ATOM-Value').style.visibility = "";
			}
		break;
		}
	}
	
	//Refresh
	buildAshtechLegacyStatus();
	checkAshtechLegacyButtonLabel();
}

function addATOMMessage(){
	var message = document.getElementById('RawData-ATOM-Message').value;
	var output = document.getElementById('RawData-ATOM-Output').value;
	var value = document.getElementById('RawData-ATOM-Value').value;
	
	var valid = !isNaN(value) && (value > 0);
	
	if ((valid == true) || (messageValue == "DAT") || (messageValue == "EVT") ||
		(messageValue == "RNX") || (messageValue == "ATR"))	{
		switch (message) {
		case "NAV":
			var ck = document.getElementById('AtomMsg-Field-' + message + '-' + output.substr(0,1) + '-ON');
			var tx = document.getElementById('AtomMsg-Field-' + message);
		
			ck.checked = true;
			tx.value = value;
			
			var button = document.getElementById("RawData-ATOM-Button");	
			button.value = getResource('modifyLabel');
			
			button.disabled = false;
		break;
		case "PVT":
			var ck = document.getElementById('AtomMsg-Field-' + message + '-' + output.substr(0,1) + '-ON');
			var tx = document.getElementById('AtomMsg-Field-' + message + '-' + output.substr(0,1));
		
			ck.checked = true;
			tx.value = value;
				
			var button = document.getElementById("RawData-ATOM-Button");	
			button.value = getResource('modifyLabel');
			
			button.disabled = false;
		break;
		case "ATR":
		case "DAT":
		case "EVT":
			var ck = document.getElementById('AtomMsg-Field-' + message + '-' + output.substr(0,1) + '-ON');
			var tx = document.getElementById('AtomMsg-Field-' + message + '-' + output.substr(0,1));
		
			ck.checked = true;
			tx.value = value;
				
			var button = document.getElementById("RawData-ATOM-Button");	
			button.value = getResource('modifyLabel');

			button.disabled = true;
		break;
		case "RNX":
			if (output.substr(0,1) == 'R')
			{
				var ck = document.getElementById('AtomMsg-Field-' + message + '-' + output.substr(0,1) + '-ON');
				var tx = document.getElementById('AtomMsg-Field-' + message + '-' + output.substr(0,1));
			
				ck.checked = true;
				tx.value = value;
					
				var button = document.getElementById("RawData-ATOM-Button");	
				button.value = getResource('modifyLabel');

				button.disabled = true;
			}
			else
			{
				var ck = document.getElementById('AtomMsg-Field-' + message + '-' + output.substr(0,1) + '-ON');
				var tx = document.getElementById('AtomMsg-Field-' + message + '-' + output.substr(0,1));
			
				ck.checked = true;
				tx.value = value;
					
				var button = document.getElementById("RawData-ATOM-Button");	
				button.value = getResource('modifyLabel');
				
				button.disabled = false;
			}
		break;
		}
		
		//Refresh
		buildATOMStatus();
	}
}

function addAntennaSelect()
{
	var output = document.getElementById('RawData-ATOM-Select-Output').value;
	var antenna = document.getElementById('RawData-ATOM-Select-Antenna').value;
	
	var tx = document.getElementById('RawData-ATOM-Field-Select-ANT-' + output.substr(0,1));
	tx.value = antenna;
	
	//Refresh
	buildATOMAntenna();
}

function checkAtomAntennaSelected()
{
	var output = document.getElementById('RawData-ATOM-Select-Output').value;
	var antenna = document.getElementById('RawData-ATOM-Select-Antenna');
	
	var tx = document.getElementById('RawData-ATOM-Field-Select-ANT-' + output.substr(0,1));
	antenna.value = tx.value;
}

function addAshtechLegacyMessage(){
	var message = document.getElementById('RawData-Ashtech-Legacy-Message').value;
	var output = document.getElementById('RawData-Ashtech-Legacy-Output').value;
	var value = document.getElementById('RawData-Ashtech-Legacy-Value').value;
	
	var valid = !isNaN(value) && (value > 0);
	
	if ((valid == true) || (messageValue == "SBD") || (messageValue == "MPC"))	{
		switch (message) {
		case "SAL":
		case "SAG":
		case "SAW":
		case "SNG":
		case "SNV":
		case "SNW":
		case "ION":
			var ck = document.getElementById('RawMsg-Field-' + message + '-' + output.substr(0,1) + '-ON');
			var tx = document.getElementById('RawMsg-Field-' + message);
		
			ck.checked = true;
			tx.value = value;
				
			var button = document.getElementById("RawData-Ashtech-Legacy-Button");	
			button.value = getResource('modifyLabel');
			
			button.disabled = false;
		break;
		case "SBD":
			var ck = document.getElementById('RawMsg-Field-' + message + '-' + output.substr(0,1) + '-ON');
			//var tx = document.getElementById('RawMsg-Field-' + message);
		
			ck.checked = true;
			//tx.value = value;
				
			var button = document.getElementById("RawData-Ashtech-Legacy-Button");	
			button.value = getResource('modifyLabel');
			
			button.disabled = true;
		break;
		case "PBN":
		case "DPC":
			var ck = document.getElementById('RawMsg-Field-' + message + '-' + output.substr(0,1) + '-ON');
			var tx = document.getElementById('RawMsg-Field-' + message + '-' + output.substr(0,1));
		
			ck.checked = true;
			tx.value = value;
				
			var button = document.getElementById("RawData-Ashtech-Legacy-Button");	
			button.value = getResource('modifyLabel');
			
			button.disabled = false;
		break;
		case "MPC":
			if (output.substr(0,1) == 'R')
			{
				var ck = document.getElementById('RawMsg-Field-' + message + '-' + output.substr(0,1) + '-ON');
				//var tx = document.getElementById('RawMsg-Field-' + message);
			
				ck.checked = true;
				//tx.value = value;
					
				var button = document.getElementById("RawData-Ashtech-Legacy-Button");	
				button.value = getResource('modifyLabel');
				
				button.disabled = true;
			}
			else
			{
				var ck = document.getElementById('RawMsg-Field-' + message + '-' + output.substr(0,1) + '-ON');
				var tx = document.getElementById('RawMsg-Field-' + message + '-' + output.substr(0,1));
			
				ck.checked = true;
				tx.value = value;
					
				var button = document.getElementById("RawData-Ashtech-Legacy-Button");	
				button.value = getResource('modifyLabel');
				
				button.disabled = false;
			}
		break;
		}
		
		//Refresh
		buildAshtechLegacyStatus();
	}
}

function validating_AtomMsg_Field_Default_Per(ev, provider) 
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = !isNaN(field.value) && (field.value > 0);
	notifyErrorProvider(provider, !valid);
}

function validating_RawMsg_Field_Default_Per(ev, provider) 
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = !isNaN(field.value) && (field.value > 0);
	notifyErrorProvider(provider, !valid);
}

function onCheckMessage(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	if (field.checked != 'checked') {
	    editName = field.id.replace("-ON","");
	    setFieldValue(editName, "");
	}
}

function checkNavigationRate(ev, provider)
{
	var field = YAHOO.util.Event.getTarget(ev);
	notifyErrorProvider(provider, isNaN(field.value));
}

function checkRefreshRate(ev, provider)
{
	var field = YAHOO.util.Event.getTarget(ev);
	notifyErrorProvider(provider, isNaN(field.value));
	if (field.value.length > 0) {
    	setFieldChecked(field.id + '-ON', true);
    }
}

function clearAllATOM()//OK
{
	for (var i=0; i<atomNavigationArray.length; i++)
	{
        var editName = "AtomMsg-Field-" + atomNavigationArray[i];
        setFieldValue(editName, "");
    	for (var j=0; j<atomPortArray.length; j++)
	    {   
            var checkName = editName + "-" + atomPortArray[j] + '-ON';
            setFieldChecked(checkName, false);
	    }
    }	
	for (var i=0; i<atomMessageArray.length; i++)
	{
    	for (var j=0; j<atomPortArray.length; j++)
	    {
	        var editName = "AtomMsg-Field-" + atomMessageArray[i] + "-" + atomPortArray[j];
    	    setFieldValue(editName, "");
            var checkName = editName + '-ON';
            setFieldChecked(checkName, false);
        }
	}
	
	var button = document.getElementById("RawData-ATOM-Button");	
	button.value = getResource('addLabel');
	button.disabled = false;
	document.getElementById('RawData-ATOM-Value-Label').style.visibility = "";
	document.getElementById('RawData-ATOM-Value').style.visibility = "";
	
	checkATOMButtonLabel();
	
	buildATOMStatus();
}

function clearAllAshtechLegacy()//OK
{
	for (var i=0; i<ashtechNavigationArray.length; i++)
	{
        var editName = "RawMsg-Field-" + ashtechNavigationArray[i];
        setFieldValue(editName, "");
	    for (var j=0; j<ashtechPortArray.length; j++)
	    {   
            var checkName = editName + "-" + ashtechPortArray[j] + '-ON';
            setFieldChecked(checkName, false);
	    }
    }
	for (var i=0; i<ashtechMessageArray.length; i++)
	{
	    for (var j=0; j<ashtechPortArray.length; j++)
	    {
	        var editName = "RawMsg-Field-" + ashtechMessageArray[i] + "-" + ashtechPortArray[j];
    	    setFieldValue(editName, "");
            var checkName = editName + '-ON';
            setFieldChecked(checkName, false);
        }
	}
	
	var button = document.getElementById("RawData-Ashtech-Legacy-Button");	
	button.value = getResource('addLabel');
	button.disabled = false;
	document.getElementById('RawData-Ashtech-Legacy-Value-Label').style.visibility = "";
	document.getElementById('RawData-Ashtech-Legacy-Value').style.visibility = "";
	
	checkAshtechLegacyButtonLabel();
	
	buildAshtechLegacyStatus();
}

function validating_AtomMsg_Field_NAV(e, p) {checkNavigationRate(e, p);}

function validating_AtomMsg_Field_PVT_A(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_PVT_B(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_PVT_F(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_PVT_C(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_PVT_E(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_PVT_I(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_PVT_M(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_PVT_U(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_PVT_R(e, p) {checkRefreshRate(e, p);}

function validating_AtomMsg_Field_ATR_A(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_ATR_B(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_ATR_F(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_ATR_C(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_ATR_E(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_ATR_I(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_ATR_M(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_ATR_U(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_ATR_R(e, p) {checkRefreshRate(e, p);}

function validating_AtomMsg_Field_EVT_A(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_EVT_B(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_EVT_F(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_EVT_C(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_EVT_E(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_EVT_I(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_EVT_M(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_EVT_U(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_EVT_R(e, p) {checkRefreshRate(e, p);}

function validating_AtomMsg_Field_DAT_A(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_DAT_B(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_DAT_F(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_DAT_C(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_DAT_E(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_DAT_I(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_DAT_M(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_DAT_U(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_DAT_R(e, p) {checkRefreshRate(e, p);}

function validating_AtomMsg_Field_RNX_A(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_RNX_B(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_RNX_F(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_RNX_C(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_RNX_E(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_RNX_I(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_RNX_M(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_RNX_U(e, p) {checkRefreshRate(e, p);}
function validating_AtomMsg_Field_RNX_R(e, p) {checkRefreshRate(e, p);}

function validating_RawMsg_Field_SNV(e, p) {checkNavigationRate(e, p);}
function validating_RawMsg_Field_SNG(e, p) {checkNavigationRate(e, p);}
function validating_RawMsg_Field_SNW(e, p) {checkNavigationRate(e, p);}
function validating_RawMsg_Field_SAL(e, p) {checkNavigationRate(e, p);}
function validating_RawMsg_Field_SAG(e, p) {checkNavigationRate(e, p);}
function validating_RawMsg_Field_SAW(e, p) {checkNavigationRate(e, p);}
function validating_RawMsg_Field_ION(e, p) {checkNavigationRate(e, p);}

function validating_RawMsg_Field_MPC_A(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_MPC_B(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_MPC_F(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_MPC_C(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_MPC_I(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_MPC_M(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_MPC_U(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_MPC_R(e, p) {checkRefreshRate(e, p);}

function validating_RawMsg_Field_PBN_A(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_PBN_B(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_PBN_F(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_PBN_C(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_PBN_I(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_PBN_M(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_PBN_U(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_PBN_R(e, p) {checkRefreshRate(e, p);}

function validating_RawMsg_Field_DPC_A(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_DPC_B(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_DPC_F(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_DPC_C(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_DPC_I(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_DPC_M(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_DPC_U(e, p) {checkRefreshRate(e, p);}
function validating_RawMsg_Field_DPC_R(e, p) {checkRefreshRate(e, p);}