var loadStorageRadioItems = new Array( 'ReceiverConfiguration-Load-Button-InternalMemory', 'ReceiverConfiguration-Load-Button-UsbKey' );
var saveStorageRadioItems = new Array( 'ReceiverConfiguration-Save-Button-InternalMemory', 'ReceiverConfiguration-Save-Button-UsbKey' );
var myDataTable;

function initReceiverConfiguration()
{
	requestFileList();
	
	// Show form
	showConfigForm();
	
	YAHOO.util.Event.addListener( 'ReceiverConfiguration-Load-Button-InternalMemory', 'click', onLoadStorageChanged );
	YAHOO.util.Event.addListener( 'ReceiverConfiguration-Load-Button-UsbKey', 'click', onLoadStorageChanged );
	
	YAHOO.util.Event.addListener( 'ReceiverConfiguration-Field-BrowseFile', 'change', onBrowseFileChanged );

	YAHOO.util.Event.addListener('SaveConfiguration', 'click', onSaveReceiverConfiguration);
}

function getPrefixName()
{
	return "ReceiverConfiguration";
}

function requestFileList()
{
	var callbacks =
	{
		success : function (o)
		{
			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				//setTimeout("location.reload()", 5000);
				setTimeout("requestFileList()", 5000);
				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigFileList;
			if (config == null) return;
			
			setFieldChecked( 'ReceiverConfiguration-Load-Button-InternalMemory', config.Storage == 0 );
			setFieldChecked( 'ReceiverConfiguration-Load-Button-UsbKey', config.Storage == 2 );
						
			var fileView = new FileTableView(config.Files);
		},
		failure : function(o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
					YAHOO.log("ERROR: Async call failed!");
			}
				
			// Retry
			setTimeout("requestFileList()", 5000);
		},

		timeout : 10000,
		cache : false
	};
	
	//Show user that we processing his request
	var div = YAHOO.util.Dom.get('FileTableView');
	div.innerHTML = getResource('ReceiverConfiguration-Resource-Loading');
	
	var url = getFileListURL + '&Storage=' + getLoadStorageFieldValue() + '&Path=/';
	
	YAHOO.util.Connect.asyncRequest('GET', url, callbacks);
}

function FileTableView(source)
{
	//Try to duplicate exist field
	//I'm not sure that it is a best way to do this, but haven't found better way
	for( var i in source )
	{
		source[ i ].dummy = 'dummy';
	}
	
	var myColumnDefs =
	[
		{label:'', key:'dummy', formatter:FileTableView.checkboxFormatter, resizeable:false, sortable:false },
		{label:getResource('ReceiverConfiguration-Resource-Name'), key:"Name", width:345, formatter:FileTableView.formatFilename, resizeable:true, sortable:true },
		{label:getResource('ReceiverConfiguration-Resource-Size'), key:"Size", formatter:FileTableView.formatSize, resizeable:true, sortable:true},
		{label:getResource('ReceiverConfiguration-Resource-Type'), key:"Type", hidden:true, formatter:FileTableView.formatType, resizeable:true, sortable:true},
		{label:getResource('ReceiverConfiguration-Resource-ModificationDate'), key:"ModificationDate", formatter:FileTableView.formatDateTime, resizeable:true, sortable:true}
	];

	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema =
	{
		fields: [ "dummy", "Name","Size","Type","ModificationDate"]
	};
	
	myDataSource.doBeforeCallback = function( req, raw, res, cb )
	{
		var filtered = [];
		for( var i in res.results )
		{
			var filename = res.results[ i ].Name;			
			if ((res.results[ i ].Type == 2) && (validConfigurationFileName(filename)))
			{
				filtered.push( res.results[ i ] );
			}
		}		
		res.results = filtered;
		return res;
	};

	// Table configs
	var myConfigs = {
		width:"auto",
		height:"auto"
	};

	// Localized messages
	myConfigs.MSG_EMPTY = getResource('ReceiverConfiguration-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('ReceiverConfiguration-Resource-Loading');
	myConfigs.MSG_SORTASC = getResource('ReceiverConfiguration-Resource-SortAsc');
	myConfigs.MSG_SORTDESC = getResource('ReceiverConfiguration-Resource-SortDesc');

	// Create table
	myDataTable = new YAHOO.widget.ScrollingDataTable("FileTableView", myColumnDefs, myDataSource, myConfigs);
	
	var checkboxClick = function onCheckboxClick( event )
	{
		var target = event.target;
		var record = myDataTable.getRecord( target );
		var name = record.getData( 'Name' );
		
		if ( isFieldChecked( name ) )
		{
			selectFile( name, record, myDataTable );
		}
		else
		{
			unSelectFile( name, record, myDataTable );
		}
	};
	
	myDataTable.subscribe( "checkboxClickEvent", checkboxClick );
		
	function updateTable()
	{
		myDataTable.showTableMessage(getResource('ReceiverConfiguration-Resource-Loading'));
		myDataTable.getDataSource().sendRequest('', { success: myDataTable.onDataReturnInitializeTable, scope: myDataTable });
	}
	
	YAHOO.util.Event.addListener('timezone', 'change', updateTable );
}

function formatTextAsFileSize(size)
{
	return formatTextAsMemorySize( size );
}

FileTableView.checkboxFormatter = function( elem, record, column, data )
{
	var id = record.getData('Name');
	var checked = isFileSelected( id ) ? 'checked="checked"' : '';
	var checkbox = '<input type="checkbox" id="' + id + '" ' + checked + ' class="yui-dt-checkbox" />';
	if( id == '..' || record.getData( 'InUse' ) )
		return;
	elem.innerHTML = checkbox;
};

FileTableView.formatText = function( elem , record , oColumn , data)
{	
	elem.innerHTML = data;
};

FileTableView.formatFilename = function( elem, record, column, data )
{
	var prefix = getLoadStorageFieldValue() == 0 ? '/nand' : '/usb';
	var path = '/';
	var d = new Date();
	
	link = '{0}{1}{2}?{3}'.format( prefix, path, data, d.getTime() );
	YAHOO.util.Dom.addClass( elem, 'filemngr-file' );
	
	var str = '<a href="{0}">{1}</a>'.format( link, data );

	elem.innerHTML = str;
};

FileTableView.formatSize = function(elem, record, oColumn, data)
{
	elem.innerHTML = formatTextAsFileSize( data);
};

FileTableView.formatType = function( elem, record, column, data )
{
	elem.innerHTML = getResource('ReceiverConfiguration-Resource-ConfigurationFile');
};

FileTableView.formatDateTime = function(elem, record, oColumn, data)
{
	try
	{
		if (data != 'null' )
		{
			var text = datetimeToCurrentTimezone( data ).full;
			elem.innerHTML = text;
		}
	}
	catch (x) {
		YAHOO.log("FileTableView.formatDateTime: '" + data + "' bad format");
	}
};

function getLoadStorageFieldValue()
{
	return getRadioButtonCheckedValue( loadStorageRadioItems );
}

function getSaveStorageFieldValue()
{
	return getRadioButtonCheckedValue( saveStorageRadioItems );
}

function onLoadStorageChanged( event )
{
	changeLocation();
}

function onBrowseFileChanged( event )
{
	var field = YAHOO.util.Event.getTarget(event);
	
	var value = field.value;
	
	if (value.lastIndexOf('\\') != -1)
	{
		value = value.substring(value.lastIndexOf('\\') + 1, value.length); 
	}
	
	if (validConfigurationFileName(value))
	{
		setItemText( 'ReceiverConfiguration-Field-ConfigurationFile', value);
		
		var records = myDataTable.getRecordSet().getRecords();
		for( var i in records )
		{
			setFieldChecked(records[i].getData('Name'), false );
		}
	}
}

function isFileSelected( name )
{
	var filelist = getFileList();
	return isFileSelectedImpl( name, filelist ); 
}

function isFileSelectedImpl( name, filelist )
{
	for( i in filelist )
	{
		if ( filelist[ i ] == name )
			return true;
	}
	
	return false;
}

function clearFileInput( id )
{
	// Event need to be remove because cloneNode copy events in ie8
	// 1 event => 2 events => 3 events => 4 events...
    YAHOO.util.Event.removeListener( id, 'change', onBrowseFileChanged );
    var elem = document.getElementById( id );
    var elem2 = elem.cloneNode(false);
    elem.parentNode.replaceChild(elem2,elem);
    
    YAHOO.util.Event.addListener( id, 'change', onBrowseFileChanged );

    setFieldValue(id,'');
}

function selectFile( name, record, table )
{
	if ( isFileSelected( name ) )
		return;

	var records = myDataTable.getRecordSet().getRecords();
	for( var i in records )
	{
		if (records[i].getData('Name') != name) {
			setFieldChecked(records[i].getData('Name'), false );
		}
	}

	clearFileInput('ReceiverConfiguration-Field-BrowseFile');
	
	setFieldValue( 'ReceiverConfiguration-SelectedFile', name );
	setItemText( 'ReceiverConfiguration-Field-ConfigurationFile', name);
}
	
function unSelectFile( name, record, table )
{
	setFieldValue( 'ReceiverConfiguration-SelectedFile', '' );
	if (document.getElementById('ReceiverConfiguration-Field-BrowseFile').value == '') {
		setItemText( 'ReceiverConfiguration-Field-ConfigurationFile', '' );
	}
	
	if ( !isFileSelected( name ) )
		return;
}

function getFileList()
{
	return getFieldValue( 'ReceiverConfiguration-SelectedFile' );
}

function changeLocation()
{
	setFieldValue( 'ReceiverConfiguration-SelectedFile', '' );
	requestFileList();
}

function validConfigurationFileName(name)
{
	// Configuration file extension
	var start = "PF_";
	var extension = ".par";
	var filename = name;			
	if ((filename.substr(0, start.length) == start) &&	
		(filename.substr(filename.length-4, extension.length) == extension))
	{
		return true;
	} else {
		return false;
	}
}

function updateResult()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateResult()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get result
			var result = data.ResultData;
			if (result == null) return;
			
			// -- Overall status --
			if (result.OverallStatus != null)
			{
				switch (result.OverallStatus)
				{
					case 0: 
						updateLink();
						break;
					case 1:
						setItemText("ReceiverConfiguration-SaveLink-Loading",
							getResource('ReceiverConfiguration-Resource-NAK'));
						setItemDisplayed("ReceiverConfiguration-SaveLink", false);
						break;
					case 2: 
						setTimeout("updateResult()", 1000);
						break;
				}
			} else {
				setTimeout("updateResult()", 1000);
			}
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateResult()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getResultURL, callbacks);
}

function updateLink()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateLink()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get result
			var config = data.ConfigFileList;
			if (config == null) return;
			
			var nbFiles = config.Files.length;
			
			var lastFilename = "";
			
			for (var i = nbFiles - 1; i >= 0; i--)
			{
				var currentFilename = config.Files[i].Name;
				if (validConfigurationFileName(currentFilename))
				{
					lastFilename = currentFilename;
					break;
				}				
			}
			
			setItemDisplayed("ReceiverConfiguration-SaveLink-Loading", false);
			setItemDisplayed("ReceiverConfiguration-SaveLink", true);
			
			var itemLink = document.getElementById('ReceiverConfiguration-SaveLink');
			var href = (getSaveStorageFieldValue() == 0) ? '/nand/' : '/usb/';
			itemLink.href = href + lastFilename;
			itemLink.innerHTML = lastFilename;
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateLink()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	var url = getFileListURL + '&Storage=' + getSaveStorageFieldValue() + '&Path=/';
	YAHOO.util.Connect.asyncRequest('GET', url, callbacks);
}

function onSaveReceiverConfiguration()
{
	setItemDisplayed("ReceiverConfiguration-SaveLink-Loading", true);
	setItemText("ReceiverConfiguration-SaveLink-Loading",
		getResource('ReceiverConfiguration-Resource-Loading'));
	
	var url = "/cgi-bin/WebService.cgic";
	
	// Define the callbacks for the asyncRequest POST
	var callbacks = {
		
		success : function (o) {
			YAHOO.util.Connect.asyncRequest('GET', exeConfigURL, null);
			
			updateResult();
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
		},

		timeout : 10000,
		cache : false
    };
	
	var params = "Page=6900&Type=SaveConfiguration&SaveStorageLocation=" + getSaveStorageFieldValue();
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('POST', url, callbacks, params);
}

