var freeNAND = "";
var freeUSB = "";

function FreeMemoryLabel(size)
{
	return formatTextAsMemorySize( size );
}

function initRecording()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initRecording()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigRawDataRecording;
			if (config == null) return;

			// -- Site Name --
			setFieldValue('Recording-Field-SiteName', config.SiteName);

			// -- Elevation Mask --
			setFieldValue('Recording-Field-ElevationMask', config.ElevationMask);

			// Free Memory
			freeNAND = FreeMemoryLabel(config.AvailableInternalMemory);
			freeUSB = FreeMemoryLabel(config.AvailableUsbKeyMemory);

			// -- Storage Location --
			setFieldValue('Recording-Field-StorageLocation', config.StorageLocation);
			showFreeMemory(config.StorageLocation);
				
			//Data Type
			setFieldValue( 'Recording-Field-UsbMemoryDataType',  config.UsbKeyDataType );
			setFieldValue( 'Recording-Field-InternalMemoryDataType', config.InternalMemoryDataType );
			
			setStorageDataType( config.StorageLocation );
			
			// -- Recording Mode --
			//setFieldValue('Recording-Field-RecordingMode', config.RecordingMode);
			setFieldChecked('Recording-Field-DataRecording', config.DataRecording );
			setFieldValue('Recording-Field-RecordingInterval', config.RecordingInterval);
			
			if (config.RingFileBuffer == 1)
			{
				setFieldValue('Recording-Field-RingFileBuffer', 1);
				setFieldChecked('Recording-Field-FileCutting', 0);	
				setFieldVisible('Recording-Field-FileDuration', false);
				setReadOnly('Recording-Field-FileCutting', true);
				document.getElementById('Recording-Label-FileCutting').style.color = "#AAAAAA";
			} else {
				if (config.FileDuration == 0)
				{
					setFieldChecked('Recording-Field-FileCutting', false);
					setFieldVisible('Recording-Field-FileDuration', false);
				} else {
					setFieldChecked('Recording-Field-FileCutting', true);
					setFieldValue('Recording-Field-FileDuration', config.FileDuration);
					setFieldVisible('Recording-Field-FileDuration', true);
				}
			}
			
			// Ring File Memory
			setFieldChecked('Recording-Field-RingFileMemory', config.RingFileMemory);
		
			// Show form
			showConfigForm();
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("initRecording()", 5000);
		},

		timeout : 10000,
		cache : false
    };

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigRawDataRecording, callbacks);

	// Units changed
	YAHOO.util.Event.addListener('Recording-Field-StorageLocation', 'change', onStorageChange);
	YAHOO.util.Event.addListener('Recording-Field-RingFileBuffer', 'click', onRFBModeChange);
	YAHOO.util.Event.addListener('Recording-Field-FileCutting', 'click', onFileCuttingChange);
	
	// Tooltip
	YAHOO.util.Event.addListener('Recording-Field-Tooltip', 'mouseover', onTooltipOver);
	
	makeFieldValidator( 'Recording-Field-SiteName', 'validating_SiteName' );
	makeFieldValidator( 'Recording-Field-ElevationMask', 'validating_ElevationMask' );
	//makeFieldValidator( 'Recording-Field-FileDuration', 'validating_FileDuration' );
	makeFieldValidator( 'Recording-Field-RecordingInterval', 'validating_RecordingInterval' );
}

function onFileCuttingChange(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	if (field.className.indexOf("readonly") == -1)
	{
		setFieldVisible('Recording-Field-FileDuration', isFieldChecked( field ));
	} else {
		setFieldChecked('Recording-Field-FileCutting', false);
	}
}

function onStorageChange(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	showFreeMemory(field.value);
	
	setStorageDataType( field.value );
}

function showFreeMemory(storage)
{
    if (storage == 0) {
        setItemText('Recording-Field-AvailableMemory', freeNAND);
    } else {
        setItemText('Recording-Field-AvailableMemory', freeUSB);
    }
}

function onRFBModeChange(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);
	enableFileDuration( isFieldChecked( field ) );
}

function setStorageDataType( value )
{
	var text = '';
	switch( value )
	{
		case 0:
		case "0":
		{
			text = getFieldValue( 'Recording-Field-InternalMemoryDataType' );
			break;
		}
		case 2:
		case "2":
		{
			text = getFieldValue( 'Recording-Field-UsbMemoryDataType' );
			break;
		}
	}

	setItemText( 'Recording-Field-DataType', text );
}
function enableFileDuration( value )
{
	disableField( 'Recording-Field-FileDuration' );
	enableField( 'Recording-Field-FileDuration', value );
	setFieldVisible( 'Recording-Field-FileDuration', value );
}
