function updateResult()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateResult()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get result
			var result = data.ResultData;
			if (result == null) return;

			// -- Title -- 
			var title = getResource('Result-Resource-Page-' + result.Page);
			if (title.length > 0) {
				setItemText('Result-Item-Title', title);
			}

			// -- Overall status --
			if (result.OverallStatus != null)
			{
				var item = 'Result-Item-OverallStatus';
				switch (result.OverallStatus)
				{
					case 0: 
						setItemText(item, getResource('Result-Resource-Successful')); 
						setItemClass(item, 'result-sucessful');
						break;
					case 1: 
						setItemText(item, getResource('Result-Resource-Failed')); 
						setItemClass(item, 'result-failed');
						break;
					case 2: 
						setItemText(item, getResource('Result-Resource-InProgress'));
						setItemClass(item, 'result-progress');
						break;
				}
			}

			// -- Fields --
			// TODO: localized field names
			if (result.Fields != null)
			{
				var table = new YAHOO.util.Dom.get('Result-Item-Fields');

				var currentStep = null;
				var stepCount = null;
				
				for (i in result.Fields)
				{
					var field = result.Fields[i];
					
					if (field.Field == 'CurrentStep')
					{
						// Command Script progress
						currentStep = field.Status;
					}
					else if (field.Field == 'StepCount')
					{
						// Command Script progress
						stepCount = field.Status;
					}
					else if (field.Field == 'EmailTest' && field.Status == 0)
					{
						// Message for Email test
						addTableRow('Result-Item-Messages', null, getResource('Result-Resource-EmailTest'), null);
					}
					else if (i >= table.rows.length)
					{	
						// General case
						addTableRow('Result-Item-Fields', 
							field.Field, 
							field.Status == 0 ? getResource('Result-Resource-OK') : getResource('Result-Resource-Error'),
							field.Status == 0 ? 'result-successful' : 'result-failed');
					}
				}
				
				// Command Script
				if (currentStep != null && stepCount != null)
				{
					emptyTable('Result-Item-Fields');
					addTableRow('Result-Item-Fields', getResource('Result-Resource-Step'), currentStep + ' / ' + stepCount, null);
				}
			}
			
			//optional parameter - log file
			try
			{
				if ( result.LogFile != null )
				{
					var fileparts = result.LogFile.split('/');
					var filename = fileparts[fileparts.length - 1];
					
					var d = new Date(); // To avoid cache effect
					var value = '<a href="' + result.LogFile + '?' + d.getTime() + '">' + filename + '</a>';
					addTableRow( 'Result-Item-Fields', getResource( 'Result-Resource-LogFile' ), value );
				}
			}
			catch(x)
			{
				
			}
			
			// Update every second while in progress
			if (result.OverallStatus == null || result.OverallStatus == 2)
			{
				setTimeout("updateResult()", 1000);
			}
			else
			{
				setItemVisible('Result-Back', true );
			}
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateResult()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getResultURL, callbacks);
}

function emptyTableResultItems() {
	emptyTable('Result-Item-Fields');
}
