function updateResult()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateResult()", 1000);	

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get result
			var result = data.ResultData;
			if (result == null) return;

			var upload = false;
			var field = null;
			
			// -- Step --
			if (result.Fields != null)
			{
				if (result.Fields.length > 0)
				{
					field = result.Fields[0];
					if (field.Field == 'Percent')
					{
						upload = true;
					}
				}
			}

			// -- Overall status --
			if (result.OverallStatus != null)
			{
				var item = 'Result-Item-OverallStatus';
				switch (result.OverallStatus)
				{
					case 0: 
						setItemText(item, getResource('Result-Resource-UpgradeSuccessful'));
						setItemClass(item, 'result-sucessful');
						//setTimeout("goToHome()", 5000);
						break;
					case 1: 
						setItemText(item, getResource(upload ? 
							'Result-Resource-UploadFailed' : 'Result-Resource-UpgradeFailed'));
						setItemClass(item, 'result-failed');
						break;
					case 2: 
						setItemText(item, getResource(upload ? 
							'Result-Resource-UploadInProgress' : 'Result-Resource-UpgradeInProgress'));
						setItemClass(item, 'result-progress');
						break;
				}
			}

			emptyTable('Result-Item-Fields');						
			if (upload)
			{
				// Display upload progress			
				if (field.Status < 90)
				{
					addTableRow('Result-Item-Fields', getResource('Result-Resource-Progress'), formatString('{0}%', field.Status), 'result-successful');
				}
				else
				{
					setItemText(item, getResource('Result-Resource-Restart'));
					setItemClass(item, 'result-progress');
				}
			}
			else if (field != null)
			{	
				// Or display error
				addTableRow('Result-Item-Fields', 
					field.Field, getResource('Result-Resource-Error'),
					field.Status == 0 ? 'result-successful' : 'result-failed');
			}

			// Update every second while in progress
			if (result.OverallStatus == null || result.OverallStatus == 2)
			{
				setTimeout("updateResult()", 1000);
			}
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Default text when no file
			setItemText('Result-Item-OverallStatus', getResource('Result-Resource-UpgradeInProgress'));
			setItemClass('Result-Item-OverallStatus', 'result-progress');
			emptyTable('Result-Item-Fields');
			
			// Retry to update
			setTimeout("updateResult()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getResultURL, callbacks);
}

function goToHome()
{
	document.location.href="../../";
}
