var configBridge = null;

function initRtcBridge()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initRtcBridge()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigRtcBridge;
			if (config == null) return;

			configBridge = config;

			setFieldValue('RtcBridge-Field-Mode', config.Mode );
			setFieldChecked('RtcBridge-Field-Input-UseDataForPvt', config.Input.UseDataForPvt);
			setFieldValue('RtcBridge-Field-Input-Port', config.Input.Port);
			
			setFieldValue('RtcBridge-Field-Output-SerialPort', config.Output.SerialPort);
			
			//setConnectionOptions( config.Output.SerialPort );
			enableRadioParameters(config.Output.ConnectionType);
			
			var selectedPort = document.getElementById('RtcBridge-Field-Output-SerialPort');
			var selectedValue = selectedPort.options[selectedPort.selectedIndex].value;
			
			if (selectedValue == "B" || selectedValue == "F" || selectedValue == "D") {
				var select = document.getElementById('RtcBridge-Field-Output-BaudRate');
				var children = select.options;

				for (i = 0; i < children.length; i++) {
					if (parseFloat(children[i].innerHTML,10) > 115200) {
						children[i].disabled = true;
						if (i == select.selectedIndex) {
							select.selectedIndex = 0;
						}
					}
				}

				if (selectedValue == "D" ) {
        			disableField('RtcBridge-Field-Output-BaudRate');
		        }
			}
			
			setFieldValue('RtcBridge-Field-Output-Connection', config.Output.ConnectionType );
			setFieldValue('RtcBridge-Field-Output-BaudRate', config.Output.BaudRate);
			setFieldValue('RtcBridge-Field-Output-Mode', config.Output.Mode);
			setFieldChecked('RtcBridge-Field-Output-RtsCts', config.Output.RtsCts);
			
			setOutputMode();
			setOutputConnection();
						
			// Show form
			showConfigForm();
		},

		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initRtcBridge()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigRtcBridge, callbacks);

	YAHOO.util.Event.addListener( 'RtcBridge-Field-Output-Connection', 'change', onRadioTypeChanged);
	YAHOO.util.Event.addListener( 'RtcBridge-Field-Output-SerialPort', 'change', onSerialPortChanged);
	YAHOO.util.Event.addListener( 'RtcBridge-Field-Output-Mode', 'change', onOutputModeChanged );
	YAHOO.util.Event.addListener( 'RtcBridge-Field-Output-Connection', 'change', onConnectionChanged );
}

function setOutputMode()
{
	var port = getFieldValue('RtcBridge-Field-Output-SerialPort');
	enableField('RtcBridge-Field-Output-Mode', true );
	if ( port != "A" )
	{
		setFieldValue('RtcBridge-Field-Output-Mode', '232');
		disableField('RtcBridge-Field-Output-Mode');
	}
	
	var mode = getFieldValue('RtcBridge-Field-Output-Mode');
	setFieldVisible('RtcBridge-Field-Output-RtsCts', true);
	if (( mode == "422" ) || ( port == "D" ))
	{
		setFieldVisible('RtcBridge-Field-Output-RtsCts', false);
	}
}

function setOutputBaudRate()
{
	var port = getFieldValue('RtcBridge-Field-Output-SerialPort');	
	var selectRate = document.getElementById('RtcBridge-Field-Output-BaudRate');
	var children = selectRate.options;
	
	enableField('RtcBridge-Field-Output-BaudRate', true );
	if (port == "B" || port == "F") {
		for (i = 0; i < children.length; i++) {
			if (parseFloat(children[i].innerHTML,10) > 115200) {
				children[i].disabled = true;
				if (i == selectRate.selectedIndex) {
					selectRate.selectedIndex = 0;
				}
			}
		}
	} else if (port == "D") {
		// BaudRate fixed at 38400 for internal port
		for (i = 0; i < children.length; i++) {
			if (parseFloat(children[i].innerHTML,10) == 38400) {
				selectRate.selectedIndex = i;
			}
		}
		disableField('RtcBridge-Field-Output-BaudRate');
	} else {
		for (i = 0; i < children.length; i++) {
			if (parseFloat(children[i].innerHTML,10) > 115200) {
				children[i].disabled = false;
			}
		}
	}
}

function setOutputConnection()
{
	var name = 'RtcBridge-Field-Output-Connection';
	var prevValue = getFieldValue(name);
	clearAllFieldOptions(name);
	
	addFieldOption(name, getResource( 'RtcBridge-Field-Output-Connection|0-Trans' ), '0');
	addFieldOption(name, 'U-Link TRx', '2');
	addFieldOption(name, 'Magellan UHF', '3');
	addFieldOption(name, 'PDL HPB/LPB', '4');
	addFieldOption(name, 'ARF7474B EU', '5');
	addFieldOption(name, 'ARF7474A NA', '6');
	addFieldOption(name, 'ADL Vantage / Vantage Pro', '7');
	if (configBridge.InternalRadio.ConnectionType == 8)
		addFieldOption(name, 'ADL Foundation', '8');
	if (configBridge.Output.ConnectionType == 9)
	    addFieldOption(name, 'XDL Rover', '9');
	setFieldValue( name, prevValue );
}

var serialPortSelect = null;

function onRadioTypeChanged(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);

	enableRadioParameters(field.value);
}

function enableRadioParameters(type)
{
	// Init select managers
	if (serialPortSelect == null) serialPortSelect = new SelectFieldManager( 'RtcBridge-Field-Output-SerialPort');

    // Others init
   	var selectRate = document.getElementById('RtcBridge-Field-Output-BaudRate');
	var children = selectRate.options;

	// Filter on select fields
    enableField('RtcBridge-Field-Output-BaudRate', true);
	switch (eval(type))
	{
	    case 0: // None/Cable
			serialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
    		setFieldValue('RtcBridge-Field-Output-SerialPort','A');
    		if (configBridge.Output.SerialPort == "A")
    		{
		        setFieldValue('RtcBridge-Field-Output-BaudRate', configBridge.Output.BaudRate);
		        setFieldValue('RtcBridge-Field-Output-Mode', configBridge.Output.Mode);
		        setFieldChecked('RtcBridge-Field-Output-RtsCts', configBridge.Output.RtsCts);
	        }	
	        break;	        
		case 2: // MDL
			serialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			setFieldValue('RtcBridge-Field-Output-SerialPort','A');
    		if (configBridge.Output.SerialPort == "A")
	        {
		        setFieldValue('RtcBridge-Field-Output-BaudRate', configBridge.Output.BaudRate);
		        setFieldValue('RtcBridge-Field-Output-Mode', configBridge.Output.Mode);
		        setFieldChecked('RtcBridge-Field-Output-RtsCts', configBridge.Output.RtsCts);
	        }	
			break;
		case 3: // MGL
			serialPortSelect.setFieldOptions(['A']); // A
			setFieldValue('RtcBridge-Field-Output-SerialPort','A');
    		if (configBridge.Output.SerialPort == "A")
	        {
		        setFieldValue('RtcBridge-Field-Output-BaudRate', configBridge.Output.BaudRate);
		        setFieldValue('RtcBridge-Field-Output-Mode', configBridge.Output.Mode);
		        setFieldChecked('RtcBridge-Field-Output-RtsCts', configBridge.Output.RtsCts);
	        }	
			break;
		case 4: // PDL
			serialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			setFieldValue('RtcBridge-Field-Output-SerialPort','A');
    		if (configBridge.Output.SerialPort == "A")
	        {
		        setFieldValue('RtcBridge-Field-Output-BaudRate', configBridge.Output.BaudRate);
		        setFieldValue('RtcBridge-Field-Output-Mode', configBridge.Output.Mode);
		        setFieldChecked('RtcBridge-Field-Output-RtsCts', configBridge.Output.RtsCts);
	        }	
			break;
		case 5: // LFE
			serialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			setFieldValue('RtcBridge-Field-Output-SerialPort','A');
       		if (configBridge.Output.SerialPort == "A")
	        {
		        setFieldValue('RtcBridge-Field-Output-BaudRate', configBridge.Output.BaudRate);
		        setFieldValue('RtcBridge-Field-Output-Mode', configBridge.Output.Mode);
		        setFieldChecked('RtcBridge-Field-Output-RtsCts', configBridge.Output.RtsCts);
	        }	
			break;
		case 6: // LFA
			serialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			setFieldValue('RtcBridge-Field-Output-SerialPort','A');
    		if (configBridge.Output.SerialPort == "A")
	        {
		        setFieldValue('RtcBridge-Field-Output-BaudRate', configBridge.Output.BaudRate);
		        setFieldValue('RtcBridge-Field-Output-Mode', configBridge.Output.Mode);
		        setFieldChecked('RtcBridge-Field-Output-RtsCts', configBridge.Output.RtsCts);
	        }	
			break;
		case 7: // ADL Vantage
			serialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			setFieldValue('RtcBridge-Field-Output-SerialPort','A');
    		if (configBridge.Output.SerialPort == "A")
	        {
		        setFieldValue('RtcBridge-Field-Output-BaudRate', configBridge.Output.BaudRate);
		        setFieldValue('RtcBridge-Field-Output-Mode', configBridge.Output.Mode);
		        setFieldChecked('RtcBridge-Field-Output-RtsCts', configBridge.Output.RtsCts);
	        }	
			break;
		case 8: // ADL Foundation
			serialPortSelect.setFieldOptions(['D']); // D
			setFieldValue('RtcBridge-Field-Output-SerialPort','D');
			
			// BaudRate fixed at 38400 for internal port
			for (i = 0; i < children.length; i++) {
				if (parseFloat(children[i].innerHTML,10) == 38400) {
					selectRate.selectedIndex = i;
				}
			}
			disableField('RtcBridge-Field-Output-BaudRate');
			break;
		default:
			break;
	}
    setOutputMode();
    setOutputBaudRate();
}

function onSerialPortChanged( ev )
{
	var field = YAHOO.util.Event.getTarget( ev );
	setOutputMode();
	setOutputBaudRate();
	/*
	var selectRate = document.getElementById('RtcBridge-Field-Output-BaudRate');
	var children = selectRate.options;
	
	enableField('RtcBridge-Field-Output-BaudRate', true );
	if (field.value == "B" || field.value == "F" || field.value == "D") {
		for (i = 0; i < children.length; i++) {
			if (parseFloat(children[i].innerHTML,10) > 115200) {
				children[i].disabled = true;
				if (i == selectRate.selectedIndex) {
					selectRate.selectedIndex = 0;
				}
			}
		}

		if ( field.value == "D" )
		{
			// BaudRate fixed at 38400 for internal port
			for (i = 0; i < children.length; i++) {
				if (parseFloat(children[i].innerHTML,10) == 38400) {
					selectRate.selectedIndex = i;
				}
			}
			disableField('RtcBridge-Field-Output-BaudRate');
		}
	} else {
		for (i = 0; i < children.length; i++) {
			if (parseFloat(children[i].innerHTML,10) > 115200) {
				children[i].disabled = false;
			}
		}
	}*/
	
	if (field.value == configBridge.Output.SerialPort)
	{
		setFieldValue('RtcBridge-Field-Output-BaudRate', configBridge.Output.BaudRate);
		setFieldValue('RtcBridge-Field-Output-Mode', configBridge.Output.Mode);
		setFieldChecked('RtcBridge-Field-Output-RtsCts', configBridge.Output.RtsCts);
	}	
}

function onOutputModeChanged( ev )
{
	setOutputMode();
}

function onConnectionChanged( ev )
{
	setFieldValue( 'RtcBridge-Field-Output-Mode', 232 );
	
	var field = YAHOO.util.Event.getTarget( ev );
	if ( field.value == 2 || field.value == 3 )
		setFieldValue( 'RtcBridge-Field-Output-Mode', 422 );
}