function initSerialPorts()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initSerialPorts()", 5000);
				
				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigSerialPorts;
			if (config == null) return;
			
			// -- Serial Port A --
			setFieldValue('SerialPorts-Field-PortA-BaudRate', config.SerialPortA.BaudRate);
			setFieldChecked('SerialPorts-Field-PortA-RtsCts', config.SerialPortA.RtsCts);
			setFieldValue('SerialPorts-Field-PortA-Mode', config.SerialPortA.Mode);
			
			enableRtsCtsForPortA( config.SerialPortA.Mode );
			
			// -- Serial Port B --
			setFieldValue('SerialPorts-Field-PortB-BaudRate', config.SerialPortB.BaudRate);
			setFieldChecked('SerialPorts-Field-PortB-RtsCts', config.SerialPortB.RtsCts);
			
			// -- Serial Port F --
			setFieldValue('SerialPorts-Field-PortF-BaudRate', config.SerialPortF.BaudRate);
			setFieldChecked('SerialPorts-Field-PortF-RtsCts', config.SerialPortF.RtsCts);
			
			// Power
			setFieldChecked('SerialPorts-Field-ECP-State', config.PowerExtented);

			// Show form
			showConfigForm();
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("initSerialPorts()", 5000);
		},

		timeout : 10000,
		cache : false
    };

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigSerialPortsURL, callbacks);
	
	YAHOO.util.Event.addListener( 'SerialPorts-Field-PortA-Mode', 'change', onPortAModeChanged );
}

function onPortAModeChanged( ev )
{
	enableRtsCtsForPortA( YAHOO.util.Event.getTarget(ev).value );
}

function enableRtsCtsForPortA( value )
{
	setFieldVisible( 'SerialPorts-Field-PortA-RtsCts', true );
	if( value == '422' )
		setFieldVisible( 'SerialPorts-Field-PortA-RtsCts', false );
}