var activeSession = 0;

function initSessionsScheduling()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initSessionsScheduling()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigSessionsScheduling;
			activeSession = config.ActiveSession;
			setFieldValue( 'SessionsSchedule-Field-F', config.F );
			
			var table = new fillSessionsTable( config.Sessions );
			// Show form
			showForm( 'config_form_auto' );
			showForm( 'config_form_manual' );
			showForm( 'config_form_sessions' );
		},

		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initSessionsScheduling()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigSessionsScheduling, callbacks);
	
	//Additional task for hours and minutes validator - switch to next time field, if it exist. Search based on field id's
	//Auto configuration
	makeFieldValidator( 'SessionsSchedule-AutoConfig-Field-StartHours', 'validating_SessionsSchedule_Hours' );
	makeFieldValidator( 'SessionsSchedule-AutoConfig-Field-StartMinutes', 'validating_SessionsSchedule_Minutes' );
	makeFieldValidator( 'SessionsSchedule-AutoConfig-Field-StartSeconds', 'validating_SessionsSchedule_Seconds' );
	
	makeFieldValidator( 'SessionsSchedule-AutoConfig-Field-DurationHours', 'validating_SessionsSchedule_Hours' );
	makeFieldValidator( 'SessionsSchedule-AutoConfig-Field-DurationMinutes', 'validating_SessionsSchedule_Minutes' );
	
	//validate duration for auto
	makeFieldValidator( 'SessionsSchedule-AutoConfig-Field-DurationHours', 'validating_SessionsSchedule_Auto_Duration' );
	makeFieldValidator( 'SessionsSchedule-AutoConfig-Field-DurationMinutes', 'validating_SessionsSchedule_Auto_Duration' );
	
	makeFieldValidator( 'SessionsSchedule-AutoConfig-Field-Interval', 'validating_SessionsSchedule_Interval' );
	
	makeFieldValidator( 'SessionsSchedule-AutoConfig-Field-NumberOfSessions', 'validating_SessionsSchedule_NumberOfSessions' );
	
	//Manual configuration	
	makeFieldValidator( 'SessionsSchedule-ManualConfig-Field-SessionId', 'validating_SessionsSchedule_SessionId' );
	
	makeFieldValidator( 'SessionsSchedule-ManualConfig-Field-StartHours', 'validating_SessionsSchedule_Hours' );
	makeFieldValidator( 'SessionsSchedule-ManualConfig-Field-StartMinutes', 'validating_SessionsSchedule_Minutes' );
	makeFieldValidator( 'SessionsSchedule-ManualConfig-Field-StartSeconds', 'validating_SessionsSchedule_Seconds' );
	
	makeFieldValidator( 'SessionsSchedule-ManualConfig-Field-EndHours', 'validating_SessionsSchedule_Hours' );
	makeFieldValidator( 'SessionsSchedule-Manual-Field-EndMinutes', 'validating_SessionsSchedule_Minutes' );
	makeFieldValidator( 'SessionsSchedule-Manual-Field-EndSeconds', 'validating_SessionsSchedule_Seconds' );
	
	//validate duration for manual
	makeFieldValidator( 'SessionsSchedule-ManualConfig-Field-StartHours', 'validating_SessionsSchedule_Manual_Duration' );
	makeFieldValidator( 'SessionsSchedule-ManualConfig-Field-StartMinutes', 'validating_SessionsSchedule_Manual_Duration' );
	makeFieldValidator( 'SessionsSchedule-ManualConfig-Field-StartSeconds', 'validating_SessionsSchedule_Manual_Duration' );
	
	makeFieldValidator( 'SessionsSchedule-ManualConfig-Field-EndHours', 'validating_SessionsSchedule_Manual_Duration' );
	makeFieldValidator( 'SessionsSchedule-ManualConfig-Field-EndMinutes', 'validating_SessionsSchedule_Manual_Duration' );
	makeFieldValidator( 'SessionsSchedule-ManualConfig-Field-EndSeconds', 'validating_SessionsSchedule_Manual_Duration' );
	
	makeFieldValidator( 'SessionsSchedule-ManualConfig-Field-Interval', 'validating_SessionsSchedule_Interval' );
	
	YAHOO.util.Event.addListener( 'SessionsSchedule-AutoConfig-Field-StartHours', 'change', onAutoTimeChanged );
	YAHOO.util.Event.addListener( 'SessionsSchedule-AutoConfig-Field-StartMinutes', 'change', onAutoTimeChanged );
	YAHOO.util.Event.addListener( 'SessionsSchedule-AutoConfig-Field-StartSeconds', 'change', onAutoTimeChanged );
	
	YAHOO.util.Event.addListener( 'SessionsSchedule-ManualConfig-Field-StartHours', 'change', onManualStartTimeChanged );
	YAHOO.util.Event.addListener( 'SessionsSchedule-ManualConfig-Field-StartMinutes', 'change', onManualStartTimeChanged );
	YAHOO.util.Event.addListener( 'SessionsSchedule-ManualConfig-Field-StartSeconds', 'change', onManualStartTimeChanged );
	
	YAHOO.util.Event.addListener( 'SessionsSchedule-ManualConfig-Field-EndHours', 'change', onManualEndTimeChanged );
	YAHOO.util.Event.addListener( 'SessionsSchedule-ManualConfig-Field-EndMinutes', 'change', onManualEndTimeChanged );
	YAHOO.util.Event.addListener( 'SessionsSchedule-ManualConfig-Field-EndSeconds', 'change', onManualEndTimeChanged );
	
	YAHOO.util.Event.addListener( 'timezone', 'change', onSessionsSheduleTimezoneChanged );
	
	YAHOO.util.Event.addListener( 'SessionsSchedule-AutoConfig-Field-Utc', 'click', onAutoUtcMarkerChanged );
	YAHOO.util.Event.addListener( 'SessionsSchedule-ManualConfig-Field-Utc', 'click', onManualUtcMarkerChanged );
}

function fillSessionsTable( source )
{
	// Columns definition
	var myColumnDefs = [
		{label:getResource('SessionsSchedule-Resource-SessionNumber'), key:"SessionNum", formatter:fillSessionsTable.formatText, resizeable:true, sortabel:false},
		{label:getResource('SessionsSchedule-Resource-SessionsId'), key:"SessionId", formatter:fillSessionsTable.formatText, resizeable:true, sortable:false},
		{label:getResource('SessionsSchedule-Resource-Use'), key:"Use", formatter:fillSessionsTable.formatReadOnlyCheckBox, resizeable:true, sortable:false },
		{label:getResource('SessionsSchedule-Resource-StartTime'), key:"StartTime", formatter:fillSessionsTable.formatDateTime, resizeable:true, sortable:false},
		{label:getResource('SessionsSchedule-Resource-EndTime'), key:"EndTime", formatter:fillSessionsTable.formatDateTime, resizeable:true, sortable:false},
		{label:getResource('SessionsSchedule-Resource-Interval'), key:"Interval", formatter:fillSessionsTable.formatText, resizeable:true, sortable:false}
	];

	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = {
		fields: ["SessionNum", "SessionId", "Use", "StartTime", "EndTime", "Interval" ]
	};

	// Table configs
	var myConfigs = {
		width:"auto",
		height:"auto"
	};

	// Localized messages
	myConfigs.MSG_EMPTY = getResource('SessionsSchedule-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('SessionsSchedule-Resource-Loading');
	
	// Create table
	var table = new YAHOO.widget.DataTable("SessionsScheduleView", myColumnDefs, myDataSource, myConfigs);
	
	var rowClick = function selectRow( event )
	{
		var target = event.target;
		var record = table.getRecord( target );
		table.unselectAllCells();
		table.unselectAllRows();
		table.selectRow( table.getTrEl( record.getCount() ) );
		
		//Remember session to delete
		setFieldValue( 'SessionsSchedule_Delete_SessionId', record.getData( "SessionId" ) );
		
		//Fill sessions parameters for editing
		setFieldValue( 'SessionsSchedule-ManualConfig-Field-SessionId', record.getData( "SessionId") );
		
		setFieldChecked( 'SessionsSchedule-ManualConfig-Field-Use', record.getData( "Use" ) );
		
		
		setTimeFromTable( record.getData( 'StartTime' ), 'SessionsSchedule-ManualConfig-Field-Start' );
		setTimeFromTable( record.getData( 'EndTime' ), 'SessionsSchedule-ManualConfig-Field-End' );
		
		setFieldValue( 'SessionsSchedule-ManualConfig-Field-Interval', record.getData( "Interval" ) );	
	};
	
	table.subscribe( "rowClickEvent", rowClick );
	
	function updateTable()
	{
		table.showTableMessage("Loading...");
		table.getDataSource().sendRequest('', { success: table.onDataReturnInitializeTable, scope: table });
		onSessionsSheduleTimezoneChanged();
	}
	
	YAHOO.util.Event.addListener('timezone', 'change', updateTable );
}

function postFormat( oRecord, text )
{
	var data = oRecord.getData();
	if ( data.SessionNum == activeSession )
		return "<strong>" + text + "</strong>";
	
	return text;
}
fillSessionsTable.formatText = function(el , oRecord , oColumn , oData)
{
	el.innerHTML = postFormat( oRecord, oData );
};

fillSessionsTable.formatDateTime = function(el, oRecord, oColumn, oData)
{
	try
	{
		var params = oData.split( ':' );
		
		var date = new Date();
		date.setUTCHours( params[ 0 ] );
		date.setUTCMinutes( params[ 1 ] );
		date.setUTCSeconds( params[ 2 ] );
		
		el.innerHTML = postFormat( oRecord, datetimeToCurrentTimezone( date ).time );
	}
	catch (x) {
		YAHOO.log("fillSessionsTable.formatDateTime: '" + oData + "' bad format");
	}
};

fillSessionsTable.formatReadOnlyCheckBox = function(el, oRecord, oColumn, oData)
{
    var checked = oData ? " checked=\"checked\"" : "";
    el.innerHTML = "<input type=\"checkbox\"" + checked + " disabled='disabled'" + " class=\"" + "yui-dt-checkbox"  + "\" />";
};


function validating_SessionsSchedule_Hours( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = isValidInteger( field.value ) && field.value >= 0 && field.value <= 23;
	if ( valid && field.value.length == 2 )
	{
		//switch focus to minutes
		sessionsSchedule_ChangeFocus( field.id, 'Hour', 'Minute' );
	}
	notifyErrorProvider( provider, !valid );
}

function validating_SessionsSchedule_Minutes( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = isValidInteger( field.value ) && field.value >= 0 && field.value <= 59;
	if ( valid && field.value.length == 2 )
	{
		//switch focus to seconds
		sessionsSchedule_ChangeFocus( field.id, 'Minute', 'Second' );
	}
	notifyErrorProvider( provider, !valid );
}

function validating_SessionsSchedule_Seconds( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = isValidInteger( field.value ) && field.value >= 0 && field.value <= 59;
	notifyErrorProvider( provider, !valid );
}

function validating_SessionsSchedule_Auto_Duration( ev, provider )
{
	//validate that duration is more than 5 minutes and less that 24 hours
	var hours = parseInt( YAHOO.util.Dom.get( 'SessionsSchedule-AutoConfig-Field-DurationHours' ).value );
	var minutes = parseInt( YAHOO.util.Dom.get( 'SessionsSchedule-AutoConfig-Field-DurationMinutes' ).value );
	
	var result = hours * 60 + minutes;
	var valid = result >= 5 && result <= 24*60;
	
	notifyErrorProvider( getErrorProvider( 'SessionsSchedule-AutoConfig-Field-DurationHours' ), !( valid && isValidHour24( hours ) ) );
	notifyErrorProvider( getErrorProvider( 'SessionsSchedule-AutoConfig-Field-DurationMinutes'), !( valid && isValidMinSec( minutes ) ) );
}

function validating_SessionsSchedule_Manual_Duration( ev, provider )
{
	//validate that duration is more than 5 minutes and less than 24 hours
	var h1 = YAHOO.util.Dom.get( 'SessionsSchedule-ManualConfig-Field-StartHours' ).value;
	var m1 = YAHOO.util.Dom.get( 'SessionsSchedule-ManualConfig-Field-StartMinutes' ).value;
	var s1 = YAHOO.util.Dom.get( 'SessionsSchedule-ManualConfig-Field-StartSeconds' ).value;
	
	var h2 = YAHOO.util.Dom.get( 'SessionsSchedule-ManualConfig-Field-EndHours' ).value;
	var m2 = YAHOO.util.Dom.get( 'SessionsSchedule-ManualConfig-Field-EndMinutes' ).value;
	var s2 = YAHOO.util.Dom.get( 'SessionsSchedule-ManualConfig-Field-EndSeconds' ).value;
	
	var t1 = parseInt( h1 )*60*60 + parseInt( m1 )*60 + parseInt( s1 );
	var t2 = parseInt( h2 )*60*60 + parseInt( m2 )*60 + parseInt( s2 );

	var dt = t2 - t1;
	var day = 24*60*60;
	
	if ( dt < 0 )
	{
		dt = day - t1 + t2;
	}
	
	var valid = dt >= 5*60 && dt <= day;
	
	notifyErrorProvider( getErrorProvider( 'SessionsSchedule-ManualConfig-Field-StartHours' ), !( valid && isValidHour( h1 ) ) );
	notifyErrorProvider( getErrorProvider( 'SessionsSchedule-ManualConfig-Field-StartMinutes' ), !( valid && isValidMinSec( m1 ) ) );
	notifyErrorProvider( getErrorProvider('SessionsSchedule-ManualConfig-Field-StartSeconds' ), !( valid && isValidMinSec( s1 ) ) );
	
	notifyErrorProvider( getErrorProvider('SessionsSchedule-ManualConfig-Field-EndHours' ), !( valid && isValidMinSec( h2 ) ) );
	notifyErrorProvider( getErrorProvider('SessionsSchedule-ManualConfig-Field-EndMinutes' ), !( valid && isValidMinSec( m2 ) ) );
	notifyErrorProvider( getErrorProvider('SessionsSchedule-ManualConfig-Field-EndSeconds' ), !( valid && isValidMinSec( s2 ) ) );
}

function validating_SessionsSchedule_Interval( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	var isFActive = YAHOO.util.Dom.get( 'SessionsSchedule-Field-F' ).getAttribute( 'value' );
	var valid = ( field.value >= 0.5 && field.value <= 0.9 ) || ( field.value >= 1 && field.value <= 999 );
	if ( isFActive )
	{
		valid = valid || field.value == 0.05 || ( field.value >= 0.1 && field.value <= 0.4 );
	}

	notifyErrorProvider( provider, !valid );
}

function validating_SessionsSchedule_SessionId( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	var regexp = new RegExp("^[A-X][A-K]?$");
	var valid = regexp.test( field.value );
	
	notifyErrorProvider( provider, !valid );
}

function validating_SessionsSchedule_NumberOfSessions( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = isValidInteger( field.value ) && field.value >= 1 && field.value <= 288;
	notifyErrorProvider( provider, !valid );
}

function sessionsSchedule_ChangeFocus( id, base, replacement )
{
	var nextField = YAHOO.util.Dom.get( id.replace( base, replacement ) );
	if ( nextField )
	{
		nextField.focus();
	}
}

function sessionsSchedule_DeleteSingleSession()
{
	setFieldValue( 'SessionsSchedule_DeleteType', 'DeleteSingle' );
}

function sessionsSchedule_DeleteAllSessions()
{
	setFieldValue( 'SessionsSchedule_DeleteType', 'DeleteAll' );
}

function onSessionsSheduleTimezoneChanged()
{
	//updateTimeView( 'SessionsSchedule-AutoConfig-Field-Start' );
	//updateTimeView( 'SessionsSchedule-ManualConfig-Field-Start' );
	//updateTimeView( 'SessionsSchedule-ManualConfig-Field-End' );
}

function onAutoTimeChanged( )
{
	updateTimeValue( 'SessionsSchedule-AutoConfig-Field-Start' );
}

function onManualStartTimeChanged()
{
	updateTimeValue( 'SessionsSchedule-ManualConfig-Field-Start' );
}

function onManualEndTimeChanged()
{
	updateTimeValue( 'SessionsSchedule-ManualConfig-Field-End' );
}

function onAutoUtcMarkerChanged()
{
	updateTimeValue( 'SessionsSchedule-AutoConfig-Field-Start' );
}

function onManualUtcMarkerChanged()
{
	updateTimeValue( 'SessionsSchedule-ManualConfig-Field-Start' );
	updateTimeValue( 'SessionsSchedule-ManualConfig-Field-End' );
}

function getUtcMarkerName( prefix )
{
	var utcMarker = prefix.replace( 'Start', '' );
	utcMarker = utcMarker.replace( 'End', '' );
	utcMarker += 'Utc';
	return utcMarker;
}

function updateTimeView( prefix )
{
	//if utc checked. no conversion required. Just copy value from IU to fields
	//if utc unchecked, do a conversion
	//how to make utc field name: replace 'Start' or 'End' by empty string and add 'UTC'
	var utcMarker = getUtcMarkerName( prefix );
	
	if ( isFieldChecked( utcMarker ) )
	{
		updateTimeViewAsUtc( prefix );
	}
	else
	{
		updateTimeViewAsLocal( prefix );
	}
}

function updateTimeViewAsLocal( prefix )
{
	var hours = getFieldValue( prefix + 'Hours-IU' );
	var minutes = getFieldValue( prefix + 'Minutes-IU' );
	var seconds = getFieldValue( prefix + 'Seconds-IU' );
		
	var utcDate = new Date();
	utcDate.setUTCHours( hours != null ? hours : 0 );
	utcDate.setUTCMinutes( minutes != null ? minutes : 0 );
	utcDate.setUTCSeconds( seconds != null ? seconds : 0 );
	
	var date = datetimeToCurrentTimezone( utcDate, isFieldChecked( getUtcMarkerName( prefix ) ) );
	
	setFieldValue(  prefix + 'Hours', date.datetime.getHours() );
	setFieldValue(  prefix + 'Minutes', date.datetime.getMinutes() );
	setFieldValue(  prefix + 'Seconds', date.datetime.getSeconds() );
}

function updateTimeViewAsUtc( prefix )
{
	setFieldValue( prefix + 'Hours', getFieldValue( prefix + 'Hours-IU' ) );
	setFieldValue( prefix + 'Minutes', getFieldValue( prefix + 'Minutes-IU' ) );
	setFieldValue( prefix + 'Seconds', getFieldValue( prefix + 'Seconds-IU' ) );
}

function updateTimeValue( prefix )
{
	var utcMarker = getUtcMarkerName( prefix );
	if ( isFieldChecked( utcMarker ) )
	{
		updateTimeValueFromUtc( prefix );
	}
	else
	{
		updateTimeValueFromLocal( prefix );
	}
}

function updateTimeValueFromLocal( prefix )
{
	//Force to use current timezone, not use current gloabl setting.
	var utcDate = datetimeToUTC( getTime( prefix ), true );
	
	setFieldValue(  prefix + 'Hours-IU', utcDate.getHours() );
	setFieldValue(  prefix + 'Minutes-IU', utcDate.getMinutes() );
	setFieldValue(  prefix + 'Seconds-IU', utcDate.getSeconds() );
}

function updateTimeValueFromUtc( prefix )
{
	setFieldValue(  prefix + 'Hours-IU', getFieldValue( prefix + 'Hours' ) );
	setFieldValue(  prefix + 'Minutes-IU', getFieldValue( prefix + 'Minutes' ) );
	setFieldValue(  prefix + 'Seconds-IU', getFieldValue( prefix + 'Seconds' ) );
}

function setTimeFromTable( value, prefix )
{
	var time = value.split( ":" );
	setFieldValue( prefix + 'Hours-IU', time[ 0 ] );
	setFieldValue( prefix + 'Minutes-IU', time[ 1 ] );
	setFieldValue( prefix + 'Seconds-IU', time[ 2 ] );
	
	updateTimeView( prefix );
}

function getTime( prefix )
{
	var hours = getFieldValue( prefix + 'Hours' );
	var minutes = getFieldValue( prefix + 'Minutes' );
	var seconds = getFieldValue( prefix + 'Seconds' );
	
	var date = new Date();
	date.setHours( hours != null ? hours : 0 );
	date.setMinutes( minutes != null ? minutes : 0 );
	date.setSeconds( seconds != null ? seconds : 0 );
	
	return date;
}