function initSessionsSettings()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initSessionsSettings()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigSessionsSettings;
			
			//Options
			optionsGlobal = config.Options;
			
			// Fake JSON
//			optionsGlobal = "OQPR";
			if (ProFlex.is800()) {
				setItemDisplayed('PowerOffBetweenSessionsDiv',true);
				setFieldChecked( 'SessionsSettings-Field-PowerOffBetweenSessions', config.PowerOffBetweenSessions == 1);
			} else {
				setItemDisplayed('PowerOffBetweenSessionsDiv',false);
				setFieldChecked( 'SessionsSettings-Field-PowerOffBetweenSessions', false);			
			}
			
			setFieldVisible('SessionsSettings-GFileConversion-Field-DisableGALILEO',(optionsGlobal.indexOf("O") != -1));
			setItemDisplayed('SessionsSettings-Rinex-Field-GalileoNavComment-Fieldset', (optionsGlobal.indexOf("O") != -1));
			
			//General group
			setFieldChecked( 'SessionsSettings-Field-SessionProgramming', config.SessionProgramming == 'Y' );
			setFieldValue( 'SessionsSettings-Field-ReferenceDay', config.ReferenceDay );
			setFieldValue( 'SessionsSettings-Field-SiteName', config.SiteName );
			setFieldValue( 'SessionsSettings-Field-Storage', config.StorageLocation );
			setFieldValue( 'SessionsSettings-Field-Offset-Minutes', config.OffsetPerDay.Minutes );
			setFieldValue( 'SessionsSettings-Field-Offset-Seconds', config.OffsetPerDay.Seconds );			
			setFieldValue( 'SessionsSettings-Field-RecordingElevationMask', config.RecordingElevationMask );
			setFieldChecked( 'SessionsSettings-Field-RingFileMemory', config.RingFileMemory );

			//setItemText( 'SessionsSettings-Field-Messages', config.PortRDataType );
			setItemText( 'SessionsSettings-Field-DataTypeSetToPortR', config.PortRDataType );
			
			//G-File
			setFieldChecked( 'SessionsSettings-GFileConversion-Field-Rinex2_11', config.GFileConversion.Rinex2_11 );
			setFieldChecked( 'SessionsSettings-GFileConversion-Field-Rinex3_01', config.GFileConversion.Rinex3_01 );
			setFieldChecked( 'SessionsSettings-GFileConversion-Field-HatanakaCompression', config.GFileConversion.HatanakaCompression );
			enableField( 'SessionsSettings-GFileConversion-Field-HatanakaCompression', config.GFileConversion.Rinex2_11 );
			enableHatanaka( isFieldChecked('SessionsSettings-GFileConversion-Field-Rinex2_11') || isFieldChecked('SessionsSettings-GFileConversion-Field-Rinex3_01') );
			enableRinex( isFieldChecked('SessionsSettings-GFileConversion-Field-Rinex2_11') || isFieldChecked('SessionsSettings-GFileConversion-Field-Rinex3_01') );
			
			setFieldChecked( 'SessionsSettings-GFileConversion-Field-TarzCompression', config.GFileConversion.TarzCompression );
			setFieldChecked( 'SessionsSettings-GFileConversion-Field-DeleteGFileAfterConversion', config.GFileConversion.DeleteGFile );
			
			//Rinex Settings
			setFieldChecked( 'SessionsSettings-GFileConversion-Field-ModifyRate', config.GFileConversion.ModifyRate == 1 );
			setFieldValue( 'SessionsSettings-GFileConversion-Field-Rate', config.GFileConversion.Rate );
			setFieldVisible( 'SessionsSettings-GFileConversion-Field-Rate', config.GFileConversion.ModifyRate == 1 );
			setFieldChecked( 'SessionsSettings-GFileConversion-Field-TwoFiles', config.GFileConversion.TwoFiles == 1 );
			setFieldValue( 'SessionsSettings-GFileConversion-Field-SecondRate', config.GFileConversion.SecondRate );
			setFieldVisible( 'SessionsSettings-GFileConversion-Field-SecondRate', config.GFileConversion.TwoFiles == 1 );
			setFieldChecked( 'SessionsSettings-GFileConversion-Field-DisableGLONASS', config.GFileConversion.DisableGLONASS == 1 );
			setFieldChecked( 'SessionsSettings-GFileConversion-Field-DisableSBAS', config.GFileConversion.DisableSBAS == 1 );
			setFieldChecked( 'SessionsSettings-GFileConversion-Field-DisableGALILEO', config.GFileConversion.DisableGALILEO == 1 );
			
			
			//Move converted
			setFieldChecked( 'SessionsSettings-FileMove-Field-MoveConvertedFiles', config.FileMove.MoveConvertedFiles );
			setFieldChecked( 'SessionsSettings-FileMove-Field-MoveGFiles', config.FileMove.MoveGFiles );
			setFieldValue( 'SessionsSettings-FileMove-Field-DestinationLocation', config.FileMove.DestinationLocation );
			setFieldValue( 'SessionsSettings-FileMove-Field-SubDirectoryPath', config.FileMove.SubDirectoryPath );
			enableMoveGFiles( config.FileMove.MoveConvertedFiles );
			
			// Check session status
			enableRecordingSession(!isRecordingSession());
			
			//Ftp settings
			setFieldChecked( 'SessionsSettings-Ftp-Field-AutomaticTransfer', config.Ftp.AutomaticTransfer );
			setFieldChecked( 'SessionsSettings-Ftp-Field-DeleteFilesAfterTransfer', config.Ftp.DeleteFilesAfter );
			setFieldValue( 'SessionsSettings-Ftp-Field-FtpServer', config.Ftp.FtpServer );
			setFieldValue( 'SessionsSettings-Ftp-Field-Port', config.Ftp.Port );
			setFieldValue( 'SessionsSettings-Ftp-Field-Login', config.Ftp.Login );
			setFieldValue( 'SessionsSettings-Ftp-Field-Password', config.Ftp.Password );
			setFieldValue( 'SessionsSettings-Ftp-Field-Path', config.Ftp.Path );
			setFieldValue( 'SessionsSettings-Ftp-Field-SubdirectoryFormat', config.Ftp.SubdirectoryFormat );
			//Uncomment when Push Modem works (Gilles)
			/*
			if (config.Ftp.IPP == "")
			{
				config.Ftp.IPP = "P";
			}
			setFieldValue( 'SessionsSettings-Ftp-Field-IPP', config.Ftp.IPP );
			*/
			
			enableDeleteFilesAfterTransfer( config.Ftp.AutomaticTransfer );
			
			//Back-up FTP settings
			switch (config.BackupFtp.Mode)
			{
			case 0:
				setFieldChecked( 'SessionsSettings-BackupFtp-Field-UsedWhenPrimaryOff', 0 );
				setFieldChecked( 'SessionsSettings-BackupFtp-Field-AlwaysUsed', 0 );
				enableBackupFTP( false );
			break;
			case 1:
				setFieldChecked( 'SessionsSettings-BackupFtp-Field-UsedWhenPrimaryOff', 1 );
				setFieldChecked( 'SessionsSettings-BackupFtp-Field-AlwaysUsed', 0 );
				enableBackupFTP( false );
			break;
			case 2:
				setFieldChecked( 'SessionsSettings-BackupFtp-Field-UsedWhenPrimaryOff', 0 );
				setFieldChecked( 'SessionsSettings-BackupFtp-Field-AlwaysUsed', 1 );
				enableBackupFTP( true );
			break;			
			}
			
			setFieldValue('SessionsSettings-BackupFtp-Mode', config.BackupFtp.Mode);

			setFieldValue( 'SessionsSettings-BackupFtp-Field-FtpServer', config.BackupFtp.FtpServer );
			setFieldValue( 'SessionsSettings-BackupFtp-Field-Port', config.BackupFtp.Port );
			setFieldValue( 'SessionsSettings-BackupFtp-Field-Login', config.BackupFtp.Login );
			setFieldValue( 'SessionsSettings-BackupFtp-Field-Password', config.BackupFtp.Password );
			setFieldValue( 'SessionsSettings-BackupFtp-Field-Path', config.BackupFtp.Path );
			
			//Rinex settings
			setFieldValue( 'SessionsSettings-Rinex-Field-Agency', config.Rinex.Agency );
			setFieldValue( 'SessionsSettings-Rinex-Field-Observer', config.Rinex.Observer );
			setFieldValue( 'SessionsSettings-Rinex-Field-MarkerName', config.Rinex.MarkerName );
			setFieldValue( 'SessionsSettings-Rinex-Field-MarkerNumber', config.Rinex.MarkerNumber );
			setFieldValue( 'SessionsSettings-Rinex-Field-ObservationComment', config.Rinex.ObservationComment );
			setFieldValue( 'SessionsSettings-Rinex-Field-GpsNavComment', config.Rinex.GpsNavComment );
			setFieldValue( 'SessionsSettings-Rinex-Field-GlonassNavComment', config.Rinex.GlonassNavComment );
			setFieldValue( 'SessionsSettings-Rinex-Field-SbasNavComment', config.Rinex.SbasNavComment );
			setFieldValue( 'SessionsSettings-Rinex-Field-GalileoNavComment', config.Rinex.GalileoNavComment );
			setFieldValue( 'SessionsSettings-Rinex-Field-MeteoComment', config.Rinex.MeteoComment );
			setFieldValue( 'SessionsSettings-Rinex-Field-MeteoManufacturer', config.Rinex.MeteoSensorManufacturer );
			setFieldValue( 'SessionsSettings-Rinex-Field-MeteoSensorType', config.Rinex.MeteoSensorType );
			setFieldValue( 'SessionsSettings-Rinex-Field-TemperatureAccuracy', parseFloat( config.Rinex.TemperatureAccuracy ).toFixed( 1 ) );
			setFieldValue( 'SessionsSettings-Rinex-Field-PressureAccuracy', parseFloat( config.Rinex.PressureAccuracy ).toFixed( 1 ) );
			setFieldValue( 'SessionsSettings-Rinex-Field-HumidityAccuracy', parseFloat( config.Rinex.HumidityAccuracy ).toFixed( 1 ) );
			
			// Show form
			showConfigForm();
		},

		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initSessionsSettings()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigSessionsSettings, callbacks);
	
	//validating main data
	makeFieldValidator( 'SessionsSettings-Field-ReferenceDay', 'validating_SessionsReferenceDay' );
	makeFieldValidator( 'SessionsSettings-Field-SiteName', 'validating_SessionsSiteName' );
	makeFieldValidator( 'SessionsSettings-Field-Offset-Minutes', 'validating_SessionsMinutes' );
	makeFieldValidator( 'SessionsSettings-Field-Offset-Seconds', 'validating_SessionsTime' );
	makeFieldValidator( 'SessionsSettings-Field-RecordingElevationMask', 'validating_Sessions_ElevationMask' );
	makeFieldValidator( 'SessionsSettings-FileMove-Field-SubDirectoryPath', 'validating_SessionsPath' );
	
	//ftp server validation
	makeFieldValidator( 'SessionsSettings-Ftp-Field-FtpServer', 'validating_FtpString' );
	makeFieldValidator( 'SessionsSettings-Ftp-Field-Port', 'validating_FtpPort' );
	makeFieldValidator( 'SessionsSettings-Ftp-Field-Login', 'validating_FtpString' );
	makeFieldValidator( 'SessionsSettings-Ftp-Field-Password', 'validating_FtpString' );
	makeFieldValidator( 'SessionsSettings-Ftp-Field-Path', 'validating_SessionsFreePath' );
	makeFieldValidator( 'SessionsSettings-Ftp-Field-SubdirectoryFormat', 'validating_SessionsPath' );
	
	//Backup ftp server validation
	makeFieldValidator( 'SessionsSettings-BackupFtp-Field-FtpServer', 'validating_FtpString' );
	makeFieldValidator( 'SessionsSettings-BackupFtp-Field-Port', 'validating_FtpPort' );
	makeFieldValidator( 'SessionsSettings-BackupFtp-Field-Login', 'validating_FtpString' );
	makeFieldValidator( 'SessionsSettings-BackupFtp-Field-Password', 'validating_FtpString' );
	makeFieldValidator( 'SessionsSettings-BackupFtp-Field-Path', 'validating_SessionsFreePath' );
	
	//validating GConversion
	makeFieldValidator( 'SessionsSettings-GFileConversion-Field-Rate', 'validating_Rate' );
	makeFieldValidator( 'SessionsSettings-GFileConversion-Field-SecondRate', 'validating_Rate' );
	
	//validating Rinex file info
	makeFieldValidator( 'SessionsSettings-Rinex-Field-ObservationComment', 'validating_Comment' );
	makeFieldValidator( 'SessionsSettings-Rinex-Field-GpsNavComment', 'validating_Comment' );
	makeFieldValidator( 'SessionsSettings-Rinex-Field-GlonassNavComment', 'validating_Comment' );
	makeFieldValidator( 'SessionsSettings-Rinex-Field-SbasNavComment', 'validating_Comment' );
	makeFieldValidator( 'SessionsSettings-Rinex-Field-GalileoNavComment', 'validating_Comment' );
	makeFieldValidator( 'SessionsSettings-Rinex-Field-MeteoComment', 'validating_Comment' );
	makeFieldValidator( 'SessionsSettings-Rinex-Field-TemperatureAccuracy', 'validating_Accuracy' );
	makeFieldValidator( 'SessionsSettings-Rinex-Field-PressureAccuracy', 'validating_Accuracy' );
	makeFieldValidator( 'SessionsSettings-Rinex-Field-HumidityAccuracy', 'validating_Accuracy' );
	
	YAHOO.util.Event.addListener('SessionsSettings-GFileConversion-Field-Rinex2_11', 'click', onRinexConversionChange211 );
	YAHOO.util.Event.addListener('SessionsSettings-GFileConversion-Field-Rinex3_01', 'click', onRinexConversionChange301 );
	YAHOO.util.Event.addListener('SessionsSettings-FileMove-Field-MoveConvertedFiles', 'click', onFileMoveChange );
	YAHOO.util.Event.addListener('SessionsSettings-Ftp-Field-AutomaticTransfer', 'click', onAutomaticTransferChange );
	YAHOO.util.Event.addListener('SessionsSettings-Field-Tooltip', 'mouseover', onTooltipOver );
	
	YAHOO.util.Event.addListener( 'SessionsSettings-GFileConversion-Field-ModifyRate', 'click', onModifyRateChanged );
	YAHOO.util.Event.addListener( 'SessionsSettings-GFileConversion-Field-TwoFiles', 'click', onTwoFilesChanged );
}

function validating_SessionsReferenceDay( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	var valid = isValidInteger(field.value) && field.value >= 1 && field.value <= 366;
	
	notifyErrorProvider(provider, !valid);
}

function validating_SessionsTime( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	var valid = isValidInteger(field.value) && field.value >= 0 && field.value <= 59;
	
	notifyErrorProvider(provider, !valid);
}
function validating_SessionsMinutes( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	var valid = isValidInteger(field.value) && field.value >= 0 && field.value <= 59;
	
	//change focus automatically
	if ( valid && field.value.length == 2 )
	{
		YAHOO.util.Dom.get( 'SessionsSettings-Field-Offset-Seconds').focus();
	}
	
	notifyErrorProvider(provider, !valid);
}
function validating_SessionsSiteName( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	var regexp = new RegExp("^[^\\\\*./]{4}$" );
	var valid = regexp.test( field.value );
	//notifyErrorProvider(provider, (field.value.length > 4));
	notifyErrorProvider(provider, !valid );
}

//String, up to 32 symbols
function validating_FtpPath( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = field.value.length <= 32 && isValidHostName( field.value );
	notifyErrorProvider( provider, !valid );
}
function validating_FtpString(ev, provider)
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = field.value.length <= 32;
	notifyErrorProvider( provider, !valid );
}

//0-65535
function validating_FtpPort( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	var valid = isValidInteger(field.value) && field.value >= 0 && field.value <= 65535;
	
	notifyErrorProvider(provider, !valid);
}

function validating_SessionsPath( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	var re = new RegExp("^[sSYymMdDpPhH/]*$");
	
	var valid = field.value.length <= 40 && re.test( field.value );
	notifyErrorProvider( provider, !valid );
}

function validating_SessionsFreePath( ev, provider )
{
	var field = YAHOO.util.Event.getTarget(ev);
	var valid = field.value.length <= 40;
	notifyErrorProvider( provider, !valid );
}

function validating_Sessions_ElevationMask(ev, provider)
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	var valid = !isNaN(field.value) && isValidInteger(field.value) && field.value >= 0 && field.value <= 90;
	
	notifyErrorProvider(provider, !valid);
}

function validating_Comment( ev, provider )
{
	var field = YAHOO.util.Event.getTarget( ev );
	var valid = field.value.length <= 255;
	var strArray = field.value.split( '\n' );
	for ( i in strArray )
	{
		if ( strArray[ i ].length > 60 )
		{
			valid = false;
			break;
		}
	}
	
	notifyErrorProvider( provider, !valid );
}

function validating_Accuracy( ev, provider )
{
	var field = YAHOO.util.Event.getTarget( ev );
	var valid = field.value >= 0 && field.value <= 100;
	notifyErrorProvider( provider, !valid );
}

function validating_Rate( ev, provider )
{
	var field = YAHOO.util.Event.getTarget( ev );
	var valid = !isNaN(field.value) && isValidInteger(field.value) && field.value >= 0 && field.value  <= 60;
	notifyErrorProvider( provider, !valid );
}

function onModifyRateChanged( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	setFieldVisible("SessionsSettings-GFileConversion-Field-Rate", isFieldChecked( field ) );
}

function onTwoFilesChanged( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	setFieldVisible("SessionsSettings-GFileConversion-Field-SecondRate", isFieldChecked( field ) );
}

function onRinexConversionChange211( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	enableHatanaka( isFieldChecked(field) );
	enableRinex( isFieldChecked(field) );
	
	setFieldChecked('SessionsSettings-GFileConversion-Field-Rinex3_01', false);
	
}

function onRinexConversionChange301( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	enableHatanaka( isFieldChecked(field) );
	enableRinex( isFieldChecked(field) );
	
	setFieldChecked('SessionsSettings-GFileConversion-Field-Rinex2_11', false);	
}

function onFileMoveChange( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	enableMoveGFiles( isFieldChecked( field ) );
}
	
function onAutomaticTransferChange( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	enableDeleteFilesAfterTransfer( isFieldChecked( field ) );
}

function onBackupFtpClick( ev )
{
	var field = YAHOO.util.Dom.get( 'SessionsSettings-BackupFtp-Field-AlwaysUsed');
	enableBackupFTP( isFieldChecked( field ) );
	
	var field2 = YAHOO.util.Dom.get( 'SessionsSettings-BackupFtp-Field-UsedWhenPrimaryOff');
	
	var mode;
	
	if ((field2.disabled == false) && (field2.checked == true)) {
		mode = 1;
	} else {
		if (field.checked == true) {
			mode = 2;
		} else {
			mode = 0;
		}
	}
	
	setFieldValue('SessionsSettings-BackupFtp-Mode', mode);
}

function enableRinex( value )
{
	setItemDisplayed('SessionsSettings-GFileConversion-Rinex-Fieldset', value);
}

//enable is work only for enabling field. So, we need to disable field by different function
function enableHatanaka( value )
{
	disableField( 'SessionsSettings-GFileConversion-Field-HatanakaCompression' );
	enableField( 'SessionsSettings-GFileConversion-Field-HatanakaCompression', value );
}

function enableMoveGFiles( value )
{
	disableField( 'SessionsSettings-FileMove-Field-MoveGFiles' );
	enableField( 'SessionsSettings-FileMove-Field-MoveGFiles', value );
}

function enableDeleteFilesAfterTransfer( value )
{
	disableField( 'SessionsSettings-Ftp-Field-DeleteFilesAfterTransfer' );
	enableField( 'SessionsSettings-Ftp-Field-DeleteFilesAfterTransfer', value );
}

function enableBackupFTP( value )
{
	disableField( 'SessionsSettings-BackupFtp-Field-UsedWhenPrimaryOff' );
	enableField( 'SessionsSettings-BackupFtp-Field-UsedWhenPrimaryOff', !value );
}

function enableRecordingSession( value )
{
	disableField('SessionsSettings-Field-Storage');	
	enableField('SessionsSettings-Field-Storage', value);
	
	disableField('SessionsSettings-FileMove-Field-DestinationLocation');
	enableField('SessionsSettings-FileMove-Field-DestinationLocation', value);
	
	disableField('SessionsSettings-FileMove-Field-SubDirectoryPath');
	enableField('SessionsSettings-FileMove-Field-SubDirectoryPath', value);
}