function initSoftwareUpdate()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initSoftwareUpdate()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigSoftwareUpdate;
			if (config == null) return;

			// -- Connection to server --
			setFieldValue('SWUpdate-Field-AddressIp', config.AddressIp);
			setFieldValue('SWUpdate-Field-AddressPort', config.AddressPort);
			setFieldValue('SWUpdate-Field-Login', config.Login);
			setFieldValue('SWUpdate-Field-Password', config.Password);

			// -- File --
			setFieldValue('SWUpdate-Field-Path', config.Path);
			setFieldValue('SWUpdate-Field-FileName', config.FileName);
			
			// -- Current Version --
			setItemText('SWUpdate-Item-CurrentVersion', config.ReceiverVersion);
			
			// -- New version --
			setItemDisplayed('SWUpdate-Item-NewVersionAvailable', config.IsNewerVersionAvailable == 1);
			if (config.IsNewerVersionAvailable == 1)
			{
				setItemText('SWUpdate-Item-NewVersion', config.NewVersion);
			}
			setItemDisplayed('SWUpdate-Item-NewVersionAvailable2', config.IsNewerVersionAvailable == 1);

			// Show form
			showConfigForm();
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("initSoftwareUpdate()", 5000);
		},

		timeout : 10000,
		cache : false
    };

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigSoftwareUpdateURL, callbacks);
	
	// Field validation
	makeFieldValidator('SWUpdate-Field-AddressIp','validating_Host');
	makeFieldValidator('SWUpdate-Field-AddressPort','validating_Port');
}
