function initTerminalWindow()
{
	// Clear View button click
	YAHOO.util.Event.on('TerminalWindow-Button-ClearView', 'click', clearTerminalWindow);
	// Check Input Content
	YAHOO.util.Event.on('TerminalWindow-Field-Command', 'keyup', checkKeyboardInput);
	//YAHOO.util.Event.on('TerminalWindow-Field-Command', 'keydown', checkKeyboardInput);
	//YAHOO.util.Event.on('TerminalWindow-Field-Command', 'change', checkKeyboardInput);
	YAHOO.util.Event.on('TerminalWindow-Field-Command', 'blur', checkKeyboardInput);
}

function checkKeyboardInput(ev)
{
	var input = getFieldValue('TerminalWindow-Field-Command');
	var filtered = "";
	var commandId = 'TerminalWindow-Field-Command';
	var commandInput = document.getElementById(commandId);
	
	for (var i = 0; i < input.length; i++) {
		if (!(input.charCodeAt(i) >= 32 && input.charCodeAt(i) <= 126)) {
			commandInput.value = commandInput.value.replace(input[i],'');
			//filtered += input[i];
		}
	}
	//setFieldValue('TerminalWindow-Field-Command', filtered);
}

function updateTerminalWindow()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("updateTerminalWindow()", 1000);			

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get output
			var output = data.ConfigTerminalWindow;
			if (output == null) return;

			// Remove content if less data than currently displayed
			if (output.length < YAHOO.util.Dom.getChildren('TerminalWindow-Item-Output').length)
			{
				removeAllItemChildren('TerminalWindow-Item-Output');
			}

			// Update content display
			for (line in output)
			{
				if (line >= YAHOO.util.Dom.getChildren('TerminalWindow-Item-Output').length)
				{
					addItemParagraph('TerminalWindow-Item-Output', 
						output[line].Command.replace( / /gi, '&nbsp;' ), 
						output[line].Type == 0 ? 'terminal-query' : 'terminal-answer');
						
					var yitem = new YAHOO.util.Dom.get('TerminalWindow-Item-Output');
					yitem.scrollTop = yitem.scrollHeight;						
				}
			}


			// Update every second
			setTimeout("updateTerminalWindow()", 1000);
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("updateTerminalWindow()", 1000);			
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigTerminalWindowURL, callbacks);
}

function clearTerminalWindow()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Don't care about the response: server will empty JSON file, that is periodically read in updateTerminalWindow()
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server, which will execute the wanted action
	YAHOO.util.Connect.asyncRequest('GET', getConfigTerminalWindowClearURL, callbacks);	
}