//We need both json data to set default selection
//Due to this, two bools
var configIFS = null;
var configIR = null;

function initTransmitter()
{
	// Define the callbacks for the asyncRequest
	var callbacks = 
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initTransmitter()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigFullSetup;
			if (config == null) return;
			
			configIFS = config;
			processFullSetupAndRadio();

			processBaseSetup( config );
			processStream1DiffMessage( config );
			
			// Show form
			showConfigForm();
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("initTransmitter()", 5000);
		},

		timeout : 10000,
		cache : false
    };

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigFullSetupURL, callbacks);
	
	setBaseSetupValidators();
	
	YAHOO.util.Event.addListener('Transmitter-Field-Stream1-MessageType', 'change', onDiffMessageChanged );
}

function initTransmitterRadio()
{
	// Define the callbacks for the asyncRequest
	var callbacks = 
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initTransmitterRadio()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigRadio;
			if (config == null) return;
			
			configIR = config;
			processFullSetupAndRadio();

			//processRadioTransmitter( config );
			// Show form
			showConfigForm();
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("initTransmitterRadio()", 5000);
		},

		timeout : 10000,
		cache : false
    };

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigRadioURL, callbacks);
	
	setRadioTransmitterListeners();
}