function initUsers()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initUsers()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigUsers;
			
			var table = new fillUsersTable( config.Users );
			
			setFieldValue( 'Users-Field-Username', '' );
			setFieldValue( 'Users-Field-Password', '' );
			
			setFieldPasswordVisible( 'Users-Field-Password', isFieldChecked( 'Users-Field-Password-Show' ) );
			//setFieldChecked('Users-Field-Password-Show', isFieldPasswordVisible('Users-Field-Password'));
			
			// Show form
			showConfigForm();
		},

		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initUsers()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigUsers, callbacks);

	// Show Characters
	YAHOO.util.Event.addListener('Users-Field-Password-Show', 'click', onUsersPasswordShowClick);
}

function fillUsersTable( source )
{
	// Columns definition
	var myColumnDefs = 
	[
		{label:getResource('Users-Resource-Username'), key:"Username", formatter:fillUsersTable.formatText, resizeable:true, sortable:false},
		{label:getResource('Users-Resource-Password'), key:"Password", formatter:fillUsersTable.formatText, resizeable:true, sortable:false}
	];
	
		// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = { fields: ["Username", "Password" ] };
	
		// Table configs
	var myConfigs =
	{
		width:"auto",
		height:"auto"
	};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('Users-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('Users-Resource-Loading');

	// Create table	
	var table = new YAHOO.widget.DataTable("UsersView", myColumnDefs, myDataSource, myConfigs);
	
	var rowClick = function selectRow( event )
	{
		var target = event.target;
		var record = table.getRecord( target );
		table.unselectAllCells();
		table.unselectAllRows();
		table.selectRow( table.getTrEl( record.getCount() ) );
		
		setFieldValue( 'Users-Field-Username', record.getData( "Username" ) );
		setFieldValue( 'Users-Field-Password', record.getData( "Password" ) );
	};
	
	table.subscribe( "rowClickEvent", rowClick );
	table.hideColumn('Password');
}

fillUsersTable.formatText = function(el , oRecord , oColumn , oData)
{
	el.innerHTML = oData;
};

function users_Modify()
{
	setFieldValue( 'Users-Field-Type', 'Modify' );
}

function users_Delete()
{
	setFieldValue( 'Users-Field-Type', 'Delete' );
}

function onUsersPasswordShowClick( ev )
{
	var field = YAHOO.util.Event.getTarget(ev);
	
	setFieldPasswordVisible('Users-Field-Password', isFieldChecked(field));
}