// Static class
var ProFlex = {};

// Different receiver names
ProFlex.ReceiverName = {
		PF500:"ProFlex500", 
		PF800:"ProFlex800", 
		PF800_DUO:"ProFlex800 Duo"
};

// Different part numbers
ProFlex.PartNumber = {
		HDS800:"990661"
};

// Different brands
ProFlex.Brand = {
		Ashtech:"Ashtech",
		Spectra:"Spectra Precision"
};

// Different web sites
ProFlex.WebSite = {
		Ashtech:"http://www.ashtech.com/",
		Spectra:"http://www.spectraprecision.com/"
};

// Different logos
ProFlex.Logo = {
		Ashtech:"../../../images/logo_ash.png",
		Spectra:"../../../images/logo_sp.png"
};

// Different home pages
ProFlex.Home = {
		ProFlex:"/ProFlex/home/index.html",
		HDS800:"/HDS800/home/index.html"
};

// Is receiver model 800?
ProFlex.is800 = function() {
	switch (ReceiverModel)
	{
	case ProFlex.ReceiverName.PF800:
	case ProFlex.ReceiverName.PF800_DUO:
		return true;
	default:
		return false;
	}
};

// Is receiver model duo?
ProFlex.isDuo = function() {
	// Get from data/ReceiverModel.js (written by Service Layer at startup)
	return (ReceiverModel == ProFlex.ReceiverName.PF800_DUO);
};

// Is receiver model HDS800?
ProFlex.isHDS800 = function() {
	// Get from data/PartNumber.js (written by Service Layer at startup)
	return (PartNumber == ProFlex.PartNumber.HDS800);
};

// Set Web page title
ProFlex.setTitle = function() {
	if (this.isHDS800()) {
		document.title = "HDS800";
	} else if (this.isDuo()) {
		document.title = "ProFlex800";
	} else {
		document.title = ReceiverModel;
	}
};

// Set Web page logo
ProFlex.setLogo = function() {
	var logo = document.getElementById("logo");
	var logo_link = document.getElementById("logo_link");
 
	if (this.isHDS800()) {
		logo.alt = ProFlex.Brand.Ashtech;		
		logo.src = ProFlex.Logo.Ashtech;
		logo_link.href = ProFlex.WebSite.Ashtech;
	}
	else {
		logo.alt = ProFlex.Brand.Spectra;		
		logo.src = ProFlex.Logo.Spectra;
		logo_link.href = ProFlex.WebSite.Spectra;		
	}
};

// Redirect to default home page (URL)
ProFlex.redirectToHome = function() {
	if (this.isHDS800()) {
		window.location.replace(ProFlex.Home.HDS800);
	} else {
		window.location.replace(ProFlex.Home.ProFlex);
	}
};

// Write welcome image in the Web page
ProFlex.writeWelcomeImage = function() {
	if (this.isHDS800()) {
		document.write('<img height="285" width="930px" alt="HDS 800" src="../../../images/img_hero_hds800.jpg"/>');
	}
	else {
        switch (ReceiverModel)
        {
        case ProFlex.ReceiverName.PF800:
        case ProFlex.ReceiverName.PF800_DUO:
        	document.write('<img height="285" width="930px" alt="ProFlex 800" src="../../../images/img_hero.jpg"/>');
        	break;
        case ProFlex.ReceiverName.PF500:
        default:
        	document.write('<img height="285" width="930px" alt="ProFlex 500" src="../../../images/img_hero.jpg"/>');
        	break;
        }		
	}
};



