// JScript File

function updateReceiver()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateReceiver()", 5000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get status
			var status = data.Receiver;
			if (status == null) return;
			
            setItemText('Receiver-ReceiverSerialNumber', status.ReceiverSerialNumber);
            setItemText('Receiver-OwnerName',status.OwnerName);
            setItemText('Receiver-CompanyName',status.CompanyName);
            setItemText('Receiver-Phone',status.Phone);
			if (status.EmailContact != null) {			
				setItemText('Receiver-EmailContact',"<a href='mailto:" + status.EmailContact + "'>" + status.EmailContact + "</a>");
			}
   		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry to update
			setTimeout("updateReceiver()", 5000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getReceiverURL, callbacks);
}


function updateReceiverStatusBar()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o)
		{
	
			YAHOO.log("RAW JSON DATA: " + o.responseText);
	
			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");
	
				// Retry
				setTimeout("updateReceiverStatusBar()", 1000);
	
				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
	
			// Get status
			var status = data.StatusBar;
			if (status == null) return;
			
			latitude = status.Latitude;
			longitude = status.Longitude;
			elevation = status.Elevation;
			
			updateWebMissionPlanning(latitude, longitude);
			
			// Update every 1 seconds
			setTimeout("updateReceiverStatusBar()", 1000);
		},
	
		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("updateReceiverStatusBar()", 1000);
		},
	
		timeout : 10000,
		cache : false
	};
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getStatusBarURL, callbacks);
}
