function updateStatusBluetoothModem()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusBluetoothModem()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get status
			var status = data.StatusBlueToothModem;
			if (status == null) return;
			
			//Remove CSD Mode if ProFlex800
			if (ProFlex.is800()) {
				setItemDisplayed("Label-ModemBand",false);
				setItemDisplayed("Modem-Band",false);
				setItemDisplayed("BluetoothModem-CSD-Section",false);
			} else {
				setItemDisplayed("Label-ModemBand",true);
				setItemDisplayed("Modem-Band",true);
				setItemDisplayed("BluetoothModem-CSD-Section",true);
			}
			
			// Update values
			var value;
			
			// -- Bluetooth --
			setItemText('BT-Address', status.BlueTooth.Address);
			setItemText('BT-Name', status.BlueTooth.Name);

			// -- Modem  Power --
			switch (status.Modem.Power)
			{
            case 0: value = getResource('Modem-Resource-Off'); break;
            case 1: value = getResource('Modem-Resource-On'); break;
			default: value = status.Modem.Power;
			}	
            setItemText('Modem-Power', value);
			
			// -- Modem Power Mode --
			switch (status.Modem.PowerMode)
			{
            case 0: value = getResource('Modem-Resource-No'); break;
            case 1: value = getResource('Modem-Resource-Yes'); break;
			default: value = status.Modem.Power;
			}	
            setItemText('Modem-PowerMode', value);
			
            // -- Modem Band --
			switch (status.Modem.Band)
			{
			case 0: value = getResource('Modem-Resource-Band-850-1900'); break;
			case 1: value = getResource('Modem-Resource-Band-900-1800'); break;
			case 2: value = getResource('Modem-Resource-Band-900-1900'); break;
			default: value = status.Modem.Band;
			}
			setItemText('Modem-Band', value);
			
            // -- Modem 2G Only --
			switch (status.Modem.TwoGOnly)
			{
			case 0: value = getResource('Modem-Resource-Off'); break;
			case 1: value = getResource('Modem-Resource-On'); break;
			default: value = status.Modem.TwoGOnly;
			}
			setItemText('Modem-2GOnly', value);
			setItemDisplayed('Label-Modem2GOnly', value != null);				

			// -- Modem AutoConnect
			switch (status.Modem.AutoConnect)
			{
			case 0: value = getResource('Modem-Resource-No'); break;
			case 1: value = getResource('Modem-Resource-Yes'); break;
			default: value = status.Modem.AutoConnect;
			}
			setItemText('Modem-AutoConnect', value);

			// -- Modem CSD Mode --
			switch (status.Modem.CsdMode)
			{
			case 0: value = getResource('Modem-Resource-CsdMode-V32'); break;
			case 1: value = getResource('Modem-Resource-CsdMode-V110'); break;
			default: value = status.Modem.CsdMode;
			}
			setItemText('Modem-CsdMode', value);

			// -- Modem CSD Phone Number --
			setItemText('Modem-PhoneNumber', status.Modem.PhoneNumber);

			// -- Modem CSD Maximum Redial --
			setItemText('Modem-MaximumRedial', status.Modem.MaximumRedial);

			// -- Modem GPRS Internet Protocol --
			switch (status.Modem.InternetProtocol)
			{
			case 0: value = getResource('Modem-Resource-InternetProtocol-TCP'); break;
			case 1: value = getResource('Modem-Resource-InternetProtocol-UDP'); break;
			default: value = status.Modem.InternetProtocol; break;
			}
			setItemText('Modem-InternetProtocol', value);

			// -- Modem GPRS Access Point --
			setItemText('Modem-AccessPointName', status.Modem.AccessPointName);
			setItemText('Modem-Login', status.Modem.Login);

			// Update every 1 seconds
			setTimeout("updateStatusBluetoothModem()", 1000);
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusBluetoothModem()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getStatusBlueToothModemURL, callbacks);
}

