function updateStatusDifferentialMessage()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// -- Help link
			if (ProFlex.isDuo()) {
                setItemDisplayed('Index-Help', false);
				setItemDisplayed('Index-Help-HDS', true);
			} else {
				setItemDisplayed('Index-Help-HDS', false);
				setItemDisplayed('Index-Help', true);
			}

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusDifferentialMessage()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get status
			var status = data.StatusDifferentialMessage;
			if (status == null) return;
			
			// Update values
			var value;
			
			function formatAtomMessages( type, items )
			{
				var caption = null;
				var text = null;

				for ( i in items )
				{
					if ( items[ i ].Message == "RNXScenario" )
					{
						caption = getResource("DiffMsg-Label-RNXScenario" );
						text = getResource("DiffMsg-Label-RNXScenario-" + items[ i ].Frequency );
						
					}
					else
					{
						caption = getResource("DiffMsg-Label-" + items[ i ].Message );
						text = formatString( getResource("DiffMsg-Label-FrequencyFormat" ), items[ i ].Frequency );
					}
					
					addTableRow( "DiffMsg-Table-MessagesType1", caption, text, null );
				}
			}
			
			function formatDbenMessages( type, items )
			{
				var caption = null;
				var text = null;

				for ( i in items )
				{
					caption = getResource("DiffMsg-Label-" + items[ i ].Message );
					text = formatString( getResource("DiffMsg-Label-FrequencyFormat" ), items[ i ].Frequency );
					
					addTableRow( "DiffMsg-Table-MessagesType6", caption, text, null );
				}
			}
			
			function formatMessages( type, items )
			{
				for ( i in items )
				{
					var labelFormat = getResource('DiffMsg-LabelType' + type);
            		var labelText = formatString(labelFormat, items[ i ].Message);
            		var refreshRate = formatString( getResource("DiffMsg-Label-FrequencyFormat" ), items[ i ].Frequency );;
                    addTableRow(tableName, labelText, refreshRate, null);
				}
			}
			for (i in status.Differential)
			{
			    if (status.Differential[i].Messages) 
			    {
			        if (status.Differential[i].Messages.length > 0) 
			        {
			            var type = status.Differential[i].Type;

			            var captionName = 'DiffMsg-Caption-MessagesType' + type;
			            var captionText = getResource('DiffMsg-CaptionType' + type);
                        setItemText(captionName, captionText);
                        var tableName = 'DiffMsg-Table-MessagesType'+type;
                        emptyTable(tableName);
						
						if ( type == "1" )
						{
							formatAtomMessages( type, status.Differential[ i ].Messages );
						}
						else
						{
							if ( type == "6" )
							{
								formatDbenMessages( type, status.Differential[ i ].Messages );
							}
							else
							{
								formatMessages( type, status.Differential[ i ].Messages );
							}
						}
            			//for (j in status.Differential[i].Messages)
            			//{
            			//    var labelFormat = getResource('DiffMsg-LabelType' + type);
            			//    var labelText = formatString(labelFormat, status.Differential[i].Messages[j].Message);
            			//    var refreshRate = status.Differential[i].Messages[j].Frequency + ' s';
                        //    addTableRow(tableName, labelText, refreshRate, null);
                        //}
			        }
                }
			}
			
			// Periodic update required. Someone can change settings 
			setTimeout("updateStatusDifferentialMessage()", 1000);
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusDifferentialMessage()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getStatusDifferentialMessageURL, callbacks);
}

