function updateStatusEthernet()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusEthernet()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get status
			var status = data.StatusEthernet;
			if (status == null) return;

			// Update values
			var value;

			emptyTable( 'Ethernet-Table-Main' );
			
			// -- MAC Address --
			addTableRow( "Ethernet-Table-Main", getResource( 'Ethernet-Resource-MacAddress'  ), status.Ethernet.MacAddress );
			// -- DHCP --
			switch (status.Ethernet.Dhcp)
			{
			case 0: value = getResource('Ethernet-Resource-No'); break;
			case 1: value = getResource('Ethernet-Resource-Yes'); break;
			default: value = status.Ethernet.Dhcp;
			}	

			addTableRow( "Ethernet-Table-Main", getResource( 'Ethernet-Resource-Dhcp'  ), value );
			if ( status.Ethernet.Dhcp != 1 )
			{
				// -- IP Address --
				addTableRow( 'Ethernet-Table-Main', getResource( 'Ethernet-Resource-IpAddress' ), status.Ethernet.IpAddress, null );
				
				// -- Subnetwork Mask --
				addTableRow( 'Ethernet-Table-Main', getResource( 'Ethernet-Resource-SubnetMask' ), status.Ethernet.SubNetworkMask, null );
				
				// -- Gateway --
				addTableRow( 'Ethernet-Table-Main', getResource( 'Ethernet-Resource-Gateway' ), status.Ethernet.GatewayIpAddress, null );
				
				// -- DNS 1 IP Address --
				addTableRow( 'Ethernet-Table-Main', getResource( 'Ethernet-Resource-Dns1IpAddress' ), status.Ethernet.Dns1IpAddress, null );
				
				// -- DNS 2 IP Address --
				addTableRow( 'Ethernet-Table-Main', getResource( 'Ethernet-Resource-Dns2IpAddress' ), status.Ethernet.Dns2IpAddress, null );
			}
			
			// -- TCP Mode --
			switch (status.Tcp.Mode)
			{
			case 0: value = getResource('Tcp-Resource-Disabled'); break;
			case 1: value = getResource('Tcp-Resource-Secured'); break;
			case 2: value = getResource('Tcp-Resource-Enabled'); break;
			default: value = status.Tcp.Mode;
			}
			setItemText('Tcp-Mode', value);

			// -- TCP Port --
			setItemText('Tcp-Port', status.Tcp.Port);

			// -- TCP Login --
			setItemText('Tcp-Login', status.Tcp.Login);
			
			
			// -- DynDNS --
			switch (status.DynDNS.Activation)
			{
			case 0: value = getResource('Ethernet-Resource-No'); break;
			case 1: value = getResource('Ethernet-Resource-Yes'); break;
			default: value = status.DynDNS.Activation;
			}	

			setItemText('DDN-Activation', value);
			setItemText('DDN-System', status.DynDNS.System);
			setItemText('DDN-Username', status.DynDNS.Username);
			setItemText('DDN-Hostname', status.DynDNS.Hostname);
			setItemText('DDN-Period', status.DynDNS.Period + " s");
			

			// Update every 1 seconds
			setTimeout("updateStatusEthernet()", 1000);
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusEthernet()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getStatusEthernetURL, callbacks);
}
