//var speed = new Array(300,600,1200,2400,4800,9600,19200,38400,57600,115200,230400,460800,921600,1428571,2500000,5000000);
function updateStatusMeteorologicalUnit()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusMeteorologicalUnit()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var status = data.StatusMeteorologicalUnit;
			//set data for measurement
			//setItemText( 'MeteoUnit-Measurement-Temperature', status.MeteorologicalMeasurement.Temperature );
			setItemText('MeteoUnit-Measurement-Temperature', formatString('{0} &deg;C', status.MeteorologicalMeasurement.Temperature));
			
			var pressure = parseFloat( status.MeteorologicalMeasurement.Pressure ).toFixed(6);
			if ( !isNaN( pressure ) )
				setItemText( 'MeteoUnit-Measurement-Pressure', formatString( getResource('MeteoUnit-Resource-Pressure'), pressure ) );
			
			setItemText( 'MeteoUnit-Measurement-Humidity', formatString( '{0} %', status.MeteorologicalMeasurement.Humidity ) );
			
			var value;
			function setPortFields( name, data )
			{
				switch (data.ProcessMeteorologicalUnit)
				{
					case 0: value = getResource('MeteoUnit-Resource-Off'); break;
					case 1: value = getResource('MeteoUnit-Resource-On'); break;
					default: value = data.ProcessMeteorologicalUnit;
				}
				setItemText( name + '-' + 'ProcessMeteorologicalUnit', value );
				
				setItemText( name + '-' + 'BaudRate', portSpeed[ data.BaudRate ] );
				switch (data.RtsCts)
				{
					case 0: value = getResource('MeteoUnit-Resource-Disabled'); break;
					case 1: value = getResource('MeteoUnit-Resource-Enabled'); break;
					default: value = data.RtsCts;
				}
				setItemText( name + '-' + 'RtsCts', value );
				setItemText( name + '-' + 'InitializationString', data.InitializationString );
				setItemText( name + '-' + 'TriggerString', data.TriggerString );
				setItemText( name + '-' + 'Interval', formatString( '{0} s', data.Interval ) );
			}
			
			setPortFields( 'MeteoUnit-PortA', status.PortA );
			//port A supports additional field mode
			setItemText( 'MeteoUnit-PortA-Mode', status.PortA.Mode );
			
			setPortFields( 'MeteoUnit-PortB', status.PortB );
			setPortFields( 'MeteoUnit-PortF', status.PortF );
			
			var text="";
			switch( status.DFileSupport )
			{
				case 0: text = getResource('MeteoUnit-Resource-No'); break;
				case 1: text = getResource('MeteoUnit-Resource-Yes'); break;
			}
			
			setItemText( 'MeteoUnit-LegacyDFileSupport', text );
			
			setTimeout("updateStatusMeteorologicalUnit()", 1000);
		},
		failure : function ( o )
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusMeteorologicalUnit()", 1000);
		},
		
		timeout : 10000,
		cache : false		
	};
		
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getStatusMeteorologicalUnit, callbacks);
}