function updateStatusPositionAntenna()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusPositionAntenna()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get status
			var status = data.StatusPositionAntenna;
			if (status == null) return;
			
			// Update values
			var value;
			
			// -- FAST RTK --
			switch (status.Settings.FastRtk)
			{
			case 0: value = getResource('Settings-Resource-Off'); break;
			case 1: value = getResource('Settings-Resource-On'); break;
			default: value = status.Settings.FastRtk;
			}	
			setItemText('Settings-FastRtk', value);
			
			//-- Ambiguity --
            setItemText('Settings-AmbiguityFixing',status.Settings.AmbiguityFixing);
            
            //-- Dynamics --
			switch (status.Settings.ReceiverDynamics)
			{
            case 1: value = getResource('Settings-Resource-Static'); break;
            case 2: value = getResource('Settings-Resource-Quasi-static'); break;
            case 3: value = getResource('Settings-Resource-Walking'); break; 
            case 4: value = getResource('Settings-Resource-Ship'); break; 
            case 5: value = getResource('Settings-Resource-Automobile'); break; 
            case 6: value = getResource('Settings-Resource-Aircraft'); break;
            case 7: value = getResource('Settings-Resource-Unlimited'); break;
            case 8: value = getResource('Settings-Resource-Adaptive'); break;
            case 9: value = getResource('Settings-Resource-User-defined'); break;			
			default: value = status.Settings.ReceiverDynamics;
			}	
            setItemText('Settings-ReceiverDynamics',value);
            
            //-- Elevation Masks
            setItemText('Settings-RoverElevationMask',status.Settings.RoverElevationMask);
            setItemText('Settings-ReferenceElevationMask',status.Settings.ReferenceElevationMask);
            
            // Position Status
			switch (status.ReceiverPosition.Status)
			{
			case 0: value = getResource('ReceiverPosition-Resource-StaticPosition'); break;
			case 1: value = getResource('ReceiverPosition-Resource-MovingPosition'); break;
			default: value = status.ReceiverPosition.Status;
			}	
            setItemText('ReceiverPosition-Status',value);
            
            //-- Position Mode --
			switch (status.ReceiverPosition.PositionMode)
			{
            case 0: value = getResource('ReceiverPosition-Resource-NoPosition'); break;
            case 1: value = getResource('ReceiverPosition-Resource-Standalone'); break;
            case 2: value = getResource('ReceiverPosition-Resource-DGPS'); break;
            case 3: value = getResource('ReceiverPosition-Resource-S-DGPS'); break; 
            case 4: value = getResource('ReceiverPosition-Resource-RTKFixed'); break; 
            case 5: value = getResource('ReceiverPosition-Resource-RTKFloat'); break; 
            case 6: value = getResource('ReceiverPosition-Resource-RTKFlying'); break;
			default: value = status.ReceiverPosition.PositionMode;
			}	
            setItemText('ReceiverPosition-PositionMode',value);

            //-- Rover Position (lat,long,height)
            setItemTextAsLatitude('ReceiverPosition-Latitude',status.ReceiverPosition.Latitude);
            setItemTextAsLongitude('ReceiverPosition-Longitude',status.ReceiverPosition.Longitude);
            setItemTextAsDistance('ReceiverPosition-EllipsoidHeight',status.ReceiverPosition.EllipsoidHeight);
            
            //-- Rover Position (X,Y,Z ECEF)
            setItemTextAsDistance('ReceiverPosition-EcefX',status.ReceiverPosition.EcefX);
            setItemTextAsDistance('ReceiverPosition-EcefY',status.ReceiverPosition.EcefY);
            setItemTextAsDistance('ReceiverPosition-EcefZ',status.ReceiverPosition.EcefZ);
            
            //-- Rover Position RMS
            setItemTextAsDistance('ReceiverPosition-RmsLattitude',status.ReceiverPosition.RmsLattitude);
            setItemTextAsDistance('ReceiverPosition-RmsLongitude',status.ReceiverPosition.RmsLongitude);
            setItemTextAsDistance('ReceiverPosition-RmsHeight',status.ReceiverPosition.RmsHeight);
            
            //-- Baseline
            setItemTextAsDistance('ReceiverPosition-DistanceToReferenceStation',status.ReceiverPosition.DistanceToReferenceStation);
            
            //-- Rover Antenna
            setItemText('ReceiverPosition-AntennaName',status.ReceiverPosition.AntennaName);
            setItemText('ReceiverPosition-OutAntennaName',status.ReceiverPosition.OutAntennaName);
            
            //-- Rover Antenna Reduction Mode
			switch (status.ReceiverPosition.AntennaReductionMode)
			{
			case 0 /* Off */: value = getResource('ReceiverPosition-Resource-L1PhaseCenter'); break;
			case 1 /* On  */: value = getResource('ReceiverPosition-Resource-SurveyPoint'); break;
			case 2 /* ARP */: value = getResource('ReceiverPosition-Resource-AntennaReferencePoint'); break;
			default: value = status.ReceiverPosition.AntennaReductionMode;
			}	
            setItemText('ReceiverPosition-AntennaReductionMode',value);
            
            //-- Rover Antenna Height
            setItemTextAsDistance('ReceiverPosition-AntennaHeight',status.ReceiverPosition.AntennaHeight);
            
            //-- Rover Antenna Height Type
			switch (status.ReceiverPosition.MeasurementType)
			{
			case 0: value = getResource('ReceiverPosition-Resource-Slant'); break;
			case 1: value = getResource('ReceiverPosition-Resource-Vertical'); break;
			default: value = status.ReceiverPosition.MeasurementType;
			}	
            setItemText('ReceiverPosition-MeasurementType',value);

            //-- Rover Antenna Radius
            setItemTextAsDistance('ReceiverPosition-AntennaRadius',status.ReceiverPosition.AntennaRadius);
            
            //-- Rover Antenna SHMP
            setItemTextAsDistance('ReceiverPosition-AntennaVerticalOffset',status.ReceiverPosition.AntennaVerticalOffset);
            
            //-- Station ID 
            setItemText('ReferencePosition-StationId',status.ReferencePosition.StationId);
            
            // Station Position (lat,long,height)
            setItemTextAsLatitude('ReferencePosition-Latitude',status.ReferencePosition.Latitude);
            setItemTextAsLongitude('ReferencePosition-Longitude',status.ReferencePosition.Longitude);
            setItemTextAsDistance('ReferencePosition-EllipsoidHeight',status.ReferencePosition.EllipsoidHeight);
            
            //-- Station Antenna
            setItemText('ReferencePosition-AntennaName',status.ReferencePosition.AntennaName);
            
            //-- Station Antenna Height
            setItemTextAsDistance('ReferencePosition-AntennaHeight',status.ReferencePosition.AntennaHeight);
            
            //-- Station Position (X,Y,Z ECEF)
            setItemTextAsDistance('ReferencePosition-EcefX',status.ReferencePosition.EcefX);
            setItemTextAsDistance('ReferencePosition-EcefY',status.ReferencePosition.EcefY);
            setItemTextAsDistance('ReferencePosition-EcefZ',status.ReferencePosition.EcefZ);
            
			// Update every 1 seconds
			setTimeout("updateStatusPositionAntenna()", 1000);
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusPositionAntenna()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getStatusPositionAntennaURL, callbacks);
}

