var portArray = new Array("A","B","F","C","E","I","P","Q","M","U", "R" );

var atomArray = new Array("NAV","PVT","ATR","DAT", "EVT", "RNX");
var atomPortArray = new Array("A","B","F","C","E","I","M","U", "R");
var ashtechNavigationArray = new Array("SNV","SNG","SNW","SAL","SAG","SAW","ION","SBD");
var ashtechMessageArray = new Array("MPC","PBN","DPC");
var ashtechPortArray = new Array("A","B","F","C","I","M","U", "R");
var antennaArray = new Array("1-2","1","2");

var theAtomMessagesTableView = null;
var theAshtechLegacyMessagesTableView = null;
var AtomMessage = null;
var AshtechLegacyMessage = null;

function getAtomMessagesSource() {
	if (AtomMessage != null)
	{
		var portName = getResource('portArrayLabel').split(",");
		var messages = new Array();
		var finalMessages = new Array();
		
		for (i in AtomMessage.Navigation) {
			messages.push({
				"Port": AtomMessage.Navigation[i].Port,
				"Message": AtomMessage.Navigation[i].Message,
				"Rate": AtomMessage.Navigation[i].Rate
			});
		}
		
		for (i in AtomMessage.Measure) {
			messages.push({
				"Port": AtomMessage.Measure[i].Port,
				"Message": AtomMessage.Measure[i].Message,
				"Rate": AtomMessage.Measure[i].Rate
			});
		}
		
		for (i in messages) {
			for (j in portArray) {
				if (portArray[j] == messages[i].Port) {
					messages[i].Output = portName[j];
					
					if (ProFlex.isDuo()) 
					{
					    if ((messages[i].Message == "RNX") || 
				            (messages[i].Message == "NAV") ||
            				(messages[i].Message == "PVT")
            			    )
            			{
					        for (k in AtomMessage.Antenna) {
					            if (messages[i].Port == AtomMessage.Antenna[k].Port) {
					                messages[i].Antenna = antennaArray[AtomMessage.Antenna[k].Select];
					            }
					        }
					    }
					    else
					    {
            			    messages[i].Antenna = "1";
            			}
					}
				}
			}
			
			//There is no null messages within JSON but DAT & EVT & ATR  & RNX
			//Therefore, theses lines are useless
			if (messages[i].Message != "ATR" &&
				messages[i].Message != "DAT" &&
				messages[i].Message != "EVT" &&
				messages[i].Message != "RNX" &&
				messages[i].Rate == null) {
				messages[i].Rate = AtomMessage.MeasureDefaultRate;
			}
			
			if (messages[i].Rate != null) {
				var rate = messages[i].Rate + "";
				if (rate.indexOf(" s") == -1) {
					rate += " s";
					messages[i].Rate = rate;
				}
			}
		}
		
		for (i in atomPortArray)
		{
			for (j in messages)
			{
				if (messages[j].Port == atomPortArray[i]) {
				
				    if (ProFlex.isDuo())
				    {
					    finalMessages.push({
						    "Port": messages[j].Port,
						    "Message": messages[j].Message,
						    "Output": messages[j].Output,
						    "Rate": messages[j].Rate,
						    "Antenna":messages[j].Antenna
					    });
				    }
				    else
				    {
					    finalMessages.push({
						    "Port": messages[j].Port,
						    "Message": messages[j].Message,
						    "Output": messages[j].Output,
						    "Rate": messages[j].Rate
					    });
           			}
				}
			}
		}
		
		return finalMessages;//messages;
	}
	else return [];
}

function getAshtechLegacyMessagesSource() {
	if (AshtechLegacyMessage != null)
	{
		var portName = getResource('portArrayLabel').split(",");
		var messages = new Array();
		
		for (i in AshtechLegacyMessage.Navigation) {
			messages.push({
				"Port": AshtechLegacyMessage.Navigation[i].Port,
				"Message": AshtechLegacyMessage.Navigation[i].Message,
				"Rate": AshtechLegacyMessage.Navigation[i].Rate
			});
		}
		
		for (i in AshtechLegacyMessage.Measure) {
			messages.push({
				"Port": AshtechLegacyMessage.Measure[i].Port,
				"Message": AshtechLegacyMessage.Measure[i].Message,
				"Rate": AshtechLegacyMessage.Measure[i].Rate
			});
		}
		
		for (i in messages) {
			for (j in portArray) {
				if (portArray[j] == messages[i].Port) {
					messages[i].Output = portName[j];
				}
			}
			
			if (messages[i].Message != "SBD" && 
				messages[i].Rate == null) {
				messages[i].Rate = AshtechLegacyMessage.MeasureDefaultRate;
			}
			
			if (messages[i].Rate != null) {
				var rate = messages[i].Rate + "";
				if (rate.indexOf(" s") == -1) {
					rate += " s";
					messages[i].Rate = rate;
				}
			}
		}
		
		return messages;
	}
	else return [];
}

function updateStatusRawData()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// -- Help link
			if (ProFlex.isDuo()) {
                setItemDisplayed('Index-Help', false);
				setItemDisplayed('Index-Help-HDS', true);
			} else {
				setItemDisplayed('Index-Help-HDS', false);
				setItemDisplayed('Index-Help', true);
			}

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusRawData()", 5000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get status
			var status = data.StatusRawData;
			if (status == null) return;
			
			AtomMessage = status.AtomMessage;
			AshtechLegacyMessage = status.AshtechLegacyMessage;
			
			if (theAtomMessagesTableView == null)
			{
//				theAtomMessagesTableView = new AtomMessagesTableView( getAtomMessagesSource );
			    if (ProFlex.isDuo()) 
			    {
			        setItemDisplayed('AtomMessagesTableViewDuo', true);
    				theAtomMessagesTableView = new AtomMessagesTableViewDuo( getAtomMessagesSource );
    			}
			    else
			    {
			        setItemDisplayed('AtomMessagesTableView', true);
    				theAtomMessagesTableView = new AtomMessagesTableView( getAtomMessagesSource );
    			}
			}
			
			if (theAshtechLegacyMessagesTableView == null)
			{
				theAshtechLegacyMessagesTableView = new AshtechLegacyMessagesTableView( getAshtechLegacyMessagesSource );
			}
			
			setTimeout("updateStatusRawData()", 5000);
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusRawData()", 5000);
		},

		timeout : 10000,
		cache : false
	};
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getStatusRawDataURL, callbacks);
}



function AtomMessagesTableView(source) {
	
	// Columns definition
	var myColumnDefs = 
	[
		{label:getResource('RawData-Table-Resource-Port'), key:"Port", resizeable:true, className: "centered"},
		{label:getResource('RawData-Table-Resource-Output'), key:"Output", resizeable:true},
		{label:getResource('RawData-Table-Resource-Message'), key:"Message", resizeable:true},
		{label:getResource('RawData-Table-Resource-Rate'), key:"Rate", resizeable:true}
	];
	
	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = {
		fields: ["Port", "Output", "Message", "Rate"]
	};
	
	// Table configs
	var myConfigs = {
		width:"auto",
		caption:getResource('RawData-Table-Resource-ATOM')
	};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('RawData-Table-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('RawData-Table-Resource-Loading');
	
	// Create table
	var myDataTable = new YAHOO.widget.DataTable('AtomMessagesTableView', myColumnDefs, myDataSource, myConfigs);
	
	var recordSet = myDataTable.getRecordSet();
	for (var j = 0; j < recordSet.getLength(); j++){
		var record = recordSet.getRecord(j);
		
		if ((j > 0) && (record.getData("Port") != recordSet.getRecord(j - 1).getData("Port"))) {
			var trEl = myDataTable.getTrEl(recordSet.getRecordIndex(record));
			var tds = trEl.getElementsByTagName("td");
			for (var k = 0; k < tds.length; k++)
				tds[k].style.borderTop = '1px solid #000000';
		}
	}
	
	// Set up polling
	var myCallback =
	{
		success: function()
		{
			var myDataTable = new YAHOO.widget.DataTable('AtomMessagesTableView', myColumnDefs, myDataSource, myConfigs);
			
			var recordSet = myDataTable.getRecordSet();
			for (var j = 0; j < recordSet.getLength(); j++){
				var record = recordSet.getRecord(j);
				
				if ((j > 0) && (record.getData("Port") != recordSet.getRecord(j - 1).getData("Port"))) {
					var trEl = myDataTable.getTrEl(recordSet.getRecordIndex(record));
					var tds = trEl.getElementsByTagName("td");
					for (var k = 0; k < tds.length; k++)
						tds[k].style.borderTop = '1px solid #000000';
				}
			}
		},
		failure: function()
		{
			YAHOO.log("AtomMessagesTableView: Polling failure", "error");
		},
		scope: myDataTable
	};
	myDataSource.setInterval(1000, null, myCallback);
}

function AtomMessagesTableViewDuo(source) {
	
	// Columns definition
	var myColumnDefs = 
	[
		{label:getResource('RawData-Table-Resource-Port'), key:"Port", resizeable:true, className: "centered"},
		{label:getResource('RawData-Table-Resource-Output'), key:"Output", resizeable:true},
		{label:getResource('RawData-Table-Resource-Message'), key:"Message", resizeable:true},
		{label:getResource('RawData-Table-Resource-Rate'), key:"Rate", resizeable:true},
		{label:getResource('RawData-Table-Resource-Antenna'), key:"Antenna", resizeable:true}
	];
	
	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = {
		fields: ["Port", "Output", "Message", "Rate", "Antenna"]
	};
	
	// Table configs
	var myConfigs = {
		width:"auto",
		caption:getResource('RawData-Table-Resource-ATOM')
	};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('RawData-Table-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('RawData-Table-Resource-Loading');
	
	// Create table
	var myDataTable = new YAHOO.widget.DataTable('AtomMessagesTableViewDuo', myColumnDefs, myDataSource, myConfigs);
	
	var recordSet = myDataTable.getRecordSet();
	for (var j = 0; j < recordSet.getLength(); j++){
		var record = recordSet.getRecord(j);
		
		if ((j > 0) && (record.getData("Port") != recordSet.getRecord(j - 1).getData("Port"))) {
			var trEl = myDataTable.getTrEl(recordSet.getRecordIndex(record));
			var tds = trEl.getElementsByTagName("td");
			for (var k = 0; k < tds.length; k++)
				tds[k].style.borderTop = '1px solid #000000';
		}
	}
	
	// Set up polling
	var myCallback =
	{
		success: function()
		{
			var myDataTable = new YAHOO.widget.DataTable('AtomMessagesTableViewDuo', myColumnDefs, myDataSource, myConfigs);
			
			var recordSet = myDataTable.getRecordSet();
			for (var j = 0; j < recordSet.getLength(); j++){
				var record = recordSet.getRecord(j);
				
				if ((j > 0) && (record.getData("Port") != recordSet.getRecord(j - 1).getData("Port"))) {
					var trEl = myDataTable.getTrEl(recordSet.getRecordIndex(record));
					var tds = trEl.getElementsByTagName("td");
					for (var k = 0; k < tds.length; k++)
						tds[k].style.borderTop = '1px solid #000000';
				}
			}
		},
		failure: function()
		{
			YAHOO.log("AtomMessagesTableViewDuo: Polling failure", "error");
		},
		scope: myDataTable
	};
	myDataSource.setInterval(1000, null, myCallback);
}

function AshtechLegacyMessagesTableView(source) {
	
	// Columns definition
	var myColumnDefs = 
	[
		{label:getResource('RawData-Table-Resource-Port'), key:"Port", resizeable:true, className: "centered"},
		{label:getResource('RawData-Table-Resource-Output'), key:"Output", resizeable:true},
		{label:getResource('RawData-Table-Resource-Message'), key:"Message", resizeable:true},
		{label:getResource('RawData-Table-Resource-Rate'), key:"Rate", resizeable:true}
	];
	
	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = {
		fields: ["Port", "Output", "Message", "Rate"]
	};
	
	// Table configs
	var myConfigs = {
		width:"auto",
		caption:getResource('RawData-Table-Resource-AshtechLegacy')
	};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('RawData-Table-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('RawData-Table-Resource-Loading');
	
	// Create table
	var myDataTable = new YAHOO.widget.DataTable('AshtechLegacyMessagesTableView', myColumnDefs, myDataSource, myConfigs);
	
	var recordSet = myDataTable.getRecordSet();
	for (var j = 0; j < recordSet.getLength(); j++){
		var record = recordSet.getRecord(j);
		
		if ((j > 0) && (record.getData("Port") != recordSet.getRecord(j - 1).getData("Port"))) {
			var trEl = myDataTable.getTrEl(recordSet.getRecordIndex(record));
			var tds = trEl.getElementsByTagName("td");
			for (var k = 0; k < tds.length; k++)
				tds[k].style.borderTop = '1px solid #000000';
		}
	}
	
	// Set up polling
	var myCallback =
	{
		success: function()
		{
			var myDataTable = new YAHOO.widget.DataTable('AshtechLegacyMessagesTableView', myColumnDefs, myDataSource, myConfigs);
			
			var recordSet = myDataTable.getRecordSet();
			for (var j = 0; j < recordSet.getLength(); j++){
				var record = recordSet.getRecord(j);
				
				if ((j > 0) && (record.getData("Port") != recordSet.getRecord(j - 1).getData("Port"))) {
					var trEl = myDataTable.getTrEl(recordSet.getRecordIndex(record));
					var tds = trEl.getElementsByTagName("td");
					for (var k = 0; k < tds.length; k++)
						tds[k].style.borderTop = '1px solid #000000';
				}
			}
		},
		failure: function()
		{
			YAHOO.log("AshtechLegacyMessagesTableView: Polling failure", "error");
		},
		scope: myDataTable
	};
	myDataSource.setInterval(1000, null, myCallback);
}
