//0 is base. All other modes are rover
var mode = 0;

function updateStatusReceiver()
{
	var callbacks = 
	{
		success:function( o )
		{
			statusSuccessCallback( o, parseStatusReceiver, "updateStatusReceiver()" );

			// -- Help link
			if (ProFlex.isDuo()) {
                setItemDisplayed('Index-Help', false);
				setItemDisplayed('Index-Help-HDS', true);
			} else {
				setItemDisplayed('Index-Help-HDS', false);
				setItemDisplayed('Index-Help', true);
			}
		},
		failure: function( o )
		{
			statusFailureCallback( o, "updateStatusReceiver()" );
		},
		timeout : 10000,
		cache : false
	};
	
	YAHOO.util.Connect.asyncRequest('GET', getStatusReceiverURL, callbacks );
}

function parseStatusReceiver( data )
{
	var status = data.StatusReceiver;
	if (status == null) return;
	
	// Simulation
/*	status.Heading.Heading = Math.random() * 360;
	status.Heading.Pitch = Math.random() * 90;
	if (Math.random() * 1 < 0.5) status.Heading.Pitch = status.Heading.Pitch * -1;
	status.Heading.Roll = Math.random() * 90;
	if (Math.random() * 1 < 0.5) status.Heading.Roll = status.Heading.Roll * -1;
	
	status.Heading2.Status = 1;
	status.Heading2.Heading = Math.random() * 360;
	status.Heading2.Pitch = Math.random() * 90;
	if (Math.random() * 1 < 0.5) status.Heading2.Pitch = status.Heading2.Pitch * -1;
	status.Heading2.Roll = Math.random() * 90;
	if (Math.random() * 1 < 0.5) status.Heading2.Roll = status.Heading2.Roll * -1;
*/
	setReceiverSettings(status);
	setReceiverAntenna(status);
	setComputedHeading(status);
//	if (status.Settings.Heading == 3) setHeadingDUO(status);
//	else if (status.Settings.Heading != 0) setHeading(status);
	setComputedPosition(status);
//	if (status.Settings.Antenna2Status != 0) setComputedPosition2(status);
	setComputedVector(status)
//	if ((status.Settings.Mode == 3) || (status.Settings.Mode == 4)) setInternalVector(status);
	setReferencePosition(status);
	setDifferentialMessages(status);
}

function setReceiverSettings( status )
{
	var text = "";
	mode = status.Settings.Mode;
	switch( status.Settings.Mode )
	{
		case 0:
		{
			text = getResource('Receiver-Resource-Base');
			break;
		}
		case 1:
		{
			text = getResource('Receiver-Resource-Rover');
			break;
		}
		case 2:
		{
			text = getResource('Receiver-Resource-BackupRtk') 
				+ ' (' + getResource('Receiver-Resource-Port') + ' ' + status.Settings.Port + ')';
			break;
		}
		case 3:
		{
			text = getResource('Receiver-Resource-Relative');
			break;
		}
		case 4:
		{
			text = getResource('Receiver-Resource-RelativeRTK');
			break;
		}
		case 5:
		{
			text = getResource('Receiver-Resource-DualRTK');
			break;
		}
	}
	setItemText('Settings-Mode', text );
	
	// Check if MovingBase information is visible
	if ((status.Settings.Mode == 2)         // BKP
	    || (status.Settings.Mode == 3)      // REL
	    || (status.Settings.Heading == 3))  // DUO heading
	{
	    setItemDisplayed('Status-Set-MovingBase', false);
	}
	else
	{
	    setItemDisplayed('Status-Set-MovingBase', true);
    
    	var suffix = status.Settings.IsBaseMoving ? "Yes" : "No";
    	setItemText('Settings-IsBaseMoving', getResource('Receiver-Resource-' + suffix) );
    }
	
	suffix = status.Settings.FastRtk ? "On" : "Off";
	setItemText('Settings-FastRtk', getResource('Receiver-Resource-' + suffix) );

	setItemText('Settings-AmbiguityFixing', formatString( '{0} %', status.Settings.AmbiguityFixing ) );
			
	var dyn = new Object();
	dyn[1] = "Static";
	dyn[2] = "Quasi-static";
	dyn[3] = "Walking";
	dyn[4] = "Ship";
	dyn[5] = "Automobile";
	dyn[6] = "Aircraft";
	dyn[7] = "Unlimited";
	dyn[8] = "Adaptive";
	dyn[9] = "User-defined";
	
	text = "";
	text = getResource('Receiver-Resource-' + dyn[status.Settings.ReceiverDynamics] );
	setItemText('Settings-ReceiverDynamics', text );
	
	setItemText('Settings-RoverElevationMask', formatString( '{0} &deg;', status.Settings.RoverElevationMask ) );
	setItemText('Settings-ReferenceElevationMask', formatString( '{0} &deg;', status.Settings.ReferenceElevationMask ) );
	
	//Settings for Heading(s)
	var value = "";
	var value2 = "";
	switch( status.Settings.Heading )
	{
		case 0: // None
			value = getResource('Receiver-Resource-Off');
			setItemDisplayed('Status-Set-Heading', true);
        	setItemText('Settings-Heading', value );
			setItemDisplayed('Status-Set-HeadingPort', false);
			setItemText('Settings-HeadingPort', null );			
			setItemDisplayed('Status-Set-Heading2', false);
        	setItemText('Settings-Heading2', null );
			setItemDisplayed('Status-Set-HeadingPort2', false);
			setItemText('Settings-HeadingPort2', null );
		    //-- One Heading --
            updateSettingsHeading(0);		    
			//-- Two Headings  --
            updateSettingsHeadingDUO(0);
		break;

		case 1: // Internal
			value = getResource('Receiver-Resource-Internal');
			setItemDisplayed('Status-Set-Heading', true);
        	setItemText('Settings-Heading', value );
			setItemDisplayed('Status-Set-HeadingPort', false);
			setItemText('Settings-HeadingPort', null );
			setItemDisplayed('Status-Set-Heading2', false);
        	setItemText('Settings-Heading2', null );
			setItemDisplayed('Status-Set-HeadingPort2', false);
			setItemText('Settings-HeadingPort2', null );
		    //-- One Heading --
            updateSettingsHeading(1,status);		    
			//-- Two Headings  --
            updateSettingsHeadingDUO(0);
		break;
		
		case 2: // Externe
			value = getResource('Receiver-Resource-External');
			setItemDisplayed('Status-Set-Heading', true);
        	setItemText('Settings-Heading', value );
			setItemDisplayed('Status-Set-HeadingPort', true);
			setItemText('Settings-HeadingPort', status.Settings.HeadingPort );
			setItemDisplayed('Status-Set-Heading2', false);
        	setItemText('Settings-Heading2', null );
			setItemDisplayed('Status-Set-HeadingPort2', false);
			setItemText('Settings-HeadingPort2', null );
		    //-- One Heading --
            updateSettingsHeading(1,status);		    
			//-- Two Headings  --
            updateSettingsHeadingDUO(0);
		break;
		
		case 3: // Externe (Blade1) and Internal (Blade2)
			value = getResource('Receiver-Resource-External');
			setItemDisplayed('Status-Set-Heading', true);
        	setItemText('Settings-Heading', value );
			setItemDisplayed('Status-Set-HeadingPort', true);
			setItemText('Settings-HeadingPort', status.Settings.HeadingPort );
            value2 = getResource('Receiver-Resource-Internal');
			setItemDisplayed('Status-Set-Heading2', true);
        	setItemText('Settings-Heading2', value2 );
			setItemDisplayed('Status-Set-HeadingPort2', false);
			setItemText('Settings-HeadingPort2', null);
		    //-- One Heading --
            updateSettingsHeading(1,status);
			//-- Two Headings  --
            updateSettingsHeadingDUO(1,status);
		break;
	}
}

function updateSettingsHeading(mode,status)
{
    if (mode)
    {
	    setItemDisplayed('Status-Set-AzimuthOffset', true);
	    setItemTextAsSimpleAngle('Settings-AzimuthOffset', status.Settings.AzimuthOffset );
	    setItemDisplayed('Status-Set-ElevationOffset', true);
	    setItemTextAsSimpleAngle('Settings-ElevationOffset', status.Settings.ElevationOffset );
	    setItemDisplayed('Status-Set-MaximumBaselineElevation', true);
	    setItemTextAsSimpleAngle('Settings-MaximumBaselineElevation', status.Settings.MaximumBaselineElevation );
	    setItemDisplayed('Status-Set-MaximumBaselineErrorLength', true);
	    setItemTextAsDistance('Settings-MaximumBaselineErrorLength', status.Settings.MaximumBaselineErrorLength );
    }
    else
    {
		setItemDisplayed('Status-Set-AzimuthOffset', false);
		setItemText('Settings-AzimuthOffset', null );
		setItemDisplayed('Status-Set-ElevationOffset', false);
		setItemText('Settings-ElevationOffset', null );
		setItemDisplayed('Status-Set-MaximumBaselineElevation', false);
		setItemText('Settings-MaximumBaselineElevation', null );
		setItemDisplayed('Status-Set-MaximumBaselineErrorLength', false);
		setItemText('Settings-MaximumBaselineErrorLength', null );
    }
}

function updateSettingsHeadingDUO(mode,status)
{
    if (mode)
    {
	    setItemDisplayed('Status-Set-AzimuthOffset2', true);
	    setItemTextAsSimpleAngle('Settings-AzimuthOffset2', status.Settings.AzimuthOffset2 );
	    setItemDisplayed('Status-Set-ElevationOffset2', true);
	    setItemTextAsSimpleAngle('Settings-ElevationOffset2', status.Settings.ElevationOffset2 );
	    setItemDisplayed('Status-Set-MaximumBaselineElevation2', true);
	    setItemTextAsSimpleAngle('Settings-MaximumBaselineElevation2', status.Settings.MaximumBaselineElevation2 );
	    setItemDisplayed('Status-Set-MaximumBaselineErrorLength2', true);
	    setItemTextAsDistance('Settings-MaximumBaselineErrorLength2', status.Settings.MaximumBaselineErrorLength2 );
    }
    else
    {
		setItemDisplayed('Status-Set-AzimuthOffset2', false);
		setItemText('Settings-AzimuthOffset2', null );
		setItemDisplayed('Status-Set-ElevationOffset2', false);
		setItemText('Settings-ElevationOffset2', null );
		setItemDisplayed('Status-Set-MaximumBaselineElevation2', false);
		setItemText('Settings-MaximumBaselineElevation2', null );
		setItemDisplayed('Status-Set-MaximumBaselineErrorLength2', false);
		setItemText('Settings-MaximumBaselineErrorLength2', null );
    }
}

function setReceiverAntenna(status)
{
/*	if (ProFlex.isDuo()) {
		setItemDisplayed('Status-Ant-ReceiverAntenna1', true);
		setItemDisplayed('Status-Ant-ReceiverAntenna2', true);
		setItemText('Antenna-Receiver1', status.Antenna.Receiver);
		setItemText('Antenna-Receiver2', status.Antenna.Receiver2);
	} else {
		setItemDisplayed('Status-Ant-ReceiverAntenna', true);
		setItemText('Antenna-Receiver', status.Antenna.Receiver);
	}
*/	
	setItemDisplayed('Status-Ant-ReceiverAntenna', true);
	if (ProFlex.isDuo()) {
        setItemText('Antenna-Receiver', status.Antenna.Receiver + " / " + status.Antenna.Receiver2);
    } else {
        setItemText('Antenna-Receiver', status.Antenna.Receiver);
    }
	
	var text = status.Antenna.ReferencePosition;
	switch (status.Antenna.ReferencePosition)
	{
		case 0 /* Off */: text = getResource('ReceiverPosition-Resource-L1PhaseCenter'); break;
		case 1 /* On  */: text = getResource('ReceiverPosition-Resource-SurveyPoint'); break;
		case 2 /* ARP */: text = getResource('ReceiverPosition-Resource-AntennaReferencePoint'); break;
	}	
    setItemText('Antenna-ReferencePosition', text);

	if (ProFlex.isDuo()) {
		setItemTextAsDistance2('Antenna-Height', status.Antenna.Height, status.Antenna.Height2);
	} else {
		setItemTextAsDistance('Antenna-Height', status.Antenna.Height);
    }
	
	text = status.Antenna.MeasurementType;
	switch (status.Antenna.MeasurementType)
	{
		case 0: text = getResource('ReceiverPosition-Resource-Slant'); break;
		case 1: text = getResource('ReceiverPosition-Resource-Vertical'); break;
	}
	if (ProFlex.isDuo()) {
	    var text2 = status.Antenna.MeasurementType2;
	    switch (status.Antenna.MeasurementType2)
	    {
		    case 0: text2 = getResource('ReceiverPosition-Resource-Slant'); break;
		    case 1: text2 = getResource('ReceiverPosition-Resource-Vertical'); break;
	    }
        setItemText('Antenna-MeasurementType', text + " / " + text2);
	}
	else {
        setItemText('Antenna-MeasurementType',text);
	}
	
	//-- Rover Antenna Radius
	if (ProFlex.isDuo()) {
        setItemTextAsDistance2('Antenna-Radius',status.Antenna.Radius,status.Antenna.Radius2);
	}else {
        setItemTextAsDistance('Antenna-Radius',status.Antenna.Radius);
    }
            
    //-- Rover Antenna SHMP
	if (ProFlex.isDuo()) {
        setItemTextAsDistance2('Antenna-ShmpOffset',status.Antenna.ShmpOffset,status.Antenna.ShmpOffset2);
	}else {
        setItemTextAsDistance('Antenna-ShmpOffset',status.Antenna.ShmpOffset);
    }
    
    if (status.Antenna.Virtual == "OFF")
    {
    	text = getResource("Receiver-Resource-NoVirtualAntenna");
    } else {
    	text = status.Antenna.Virtual;
    }
    setItemText('Antenna-Virtual',text);
}

function setComputedHeading(status)
{
	//-- Heading --
	if (status.Settings.Heading == 0)
	{
	    setItemDisplayed('Receiver-Heading-Table', false);
	    setItemDisplayed('Heading-Attitude', false);
		setItemDisplayed('Receiver-Heading1-Table', false);
		setItemDisplayed('Heading1-Attitude', false);
		setItemDisplayed('Receiver-Heading2-Table', false);
		setItemDisplayed('Heading2-Attitude', false);
    }
    else if (status.Settings.Heading == 3)
    {
	    setItemDisplayed('Receiver-Heading-Table', false);
	    setItemDisplayed('Heading-Attitude', false);
		setItemDisplayed('Receiver-Heading1-Table', true);
		setItemDisplayed('Heading1-Attitude', true);
		setItemDisplayed('Receiver-Heading2-Table', true);
		setItemDisplayed('Heading2-Attitude', true);
	}
	else
	{
	    setItemDisplayed('Receiver-Heading-Table', true);
	    setItemDisplayed('Heading-Attitude', true);
		setItemDisplayed('Receiver-Heading1-Table', false);
		setItemDisplayed('Heading1-Attitude', false);
		setItemDisplayed('Receiver-Heading2-Table', false);
		setItemDisplayed('Heading2-Attitude', false);
	}

	if (status.Settings.Heading == 3) setHeadingDUO(status);
	else if (status.Settings.Heading != 0) setHeading(status);
}

function setHeading(status)
{	
    if (status.Settings.Heading == 1)
    {
   	    setItemText('Status-Heading', getResource('Status-Heading1-Trans'));
   	}
   	else //if (status.Settings.Heading == 2)
   	{
   	    setItemText('Status-Heading', getResource('Status-Heading2-Trans'));
   	}

	var value = "";
	switch( status.Heading.Status )
	{
		case 0: value = getResource('Receiver-Resource-Fixed'); break;
		case 1: value = getResource('Receiver-Resource-Float'); break;
		default: value = getResource('Receiver-Resource-None');break;
		//default: value = status.Heading.Status; break;
	}
				
	if (status.Heading.Status == 2)
	{
	    // No Heading
	    setItemText('Heading-Status', value);
	    setItemVisible('Heading-Heading', false);
	    setItemVisible('Heading-Pitch', false);
	    setItemVisible('Heading-Roll', false);
    	setItemTextAsDistance('Heading-MRMS', null);
    	setItemTextAsDistance('Heading-BRMS', null);
        setItemVisible('Heading-BaselineLength', false);
        setItemDisplayed('Heading-Attitude', false);
    	return;
	}
	
	var valueMode = "";
	switch( status.Heading.CalibrationMode )
	{
		case 0: valueMode = getResource('Receiver-Resource-Calibration'); break;
		case 1: valueMode = getResource('Receiver-Resource-Operation'); break;
        default: valueMode = getResource('Receiver-Resource-None');break;
		//default: valueMode = status.Heading.CalibrationMode; break;
	}
    
//    setItemText('Heading-Status', value + " / " + valueMode);
    if (status.Heading.CalibrationMode == 1)
        setItemText('Heading-Status', value + " / " + valueMode);
    else
        setItemText('Heading-Status', valueMode);
    
	setItemTextAsSimpleAngle('Heading-Heading', status.Heading.Heading);
	setItemTextAsSimpleAngle('Heading-Pitch', status.Heading.Pitch);
	setItemTextAsSimpleAngle('Heading-Roll', status.Heading.Roll);
	setItemTextAsDistance('Heading-MRMS', (status.Heading.MRMS == 1.023) ? null : status.Heading.MRMS);
	setItemTextAsDistance('Heading-BRMS', (status.Heading.BRMS == 1.023) ? null : status.Heading.BRMS);
	
	if (status.Heading.BaselineFlag == 0)
	{
		setItemVisible('Heading-BaselineLength', false);
	}
	else
	{
		setItemVisible('Heading-BaselineLength', true);
		setItemTextAsDistance('Heading-BaselineLength', status.Heading.BaselineLength);
	}
	
	if ((status.Heading.Heading >= 0) && (status.Heading.Heading < 360))
		setItemVisible('Heading-Heading', true);
	else
		setItemVisible('Heading-Heading', false);
	
	if ((status.Heading.Roll >= -90) && (status.Heading.Roll <= 90))
		setItemVisible('Heading-Roll', true);
	else
		setItemVisible('Heading-Roll', false);
	
	if ((status.Heading.Pitch >= -90) && (status.Heading.Pitch <= 90))
		setItemVisible('Heading-Pitch', true);
	else
		setItemVisible('Heading-Pitch', false);
	
	if (isHeadingShown == true)
	{
		updateCompassMap(status.Heading);
	}
}

function setHeadingDUO(status)
{	
    //-- Internal Heading --
	var value1 = "";
	switch( status.Heading.Status )
	{
		case 0: value1 = getResource('Receiver-Resource-Fixed'); break;
		case 1: value1 = getResource('Receiver-Resource-Float'); break;
		default: value1 = getResource('Receiver-Resource-None');break;
		//default: value1 = status.Heading.Status; break;
	}
    if (status.Heading.Status == 2)
	{
	    // No Heading
	    setItemText('Heading1-Status', value1);
	    setItemVisible('Heading1-Heading', false);
	    setItemVisible('Heading1-Pitch', false);
	    setItemVisible('Heading1-Roll', false);
    	setItemTextAsDistance('Heading1-MRMS', null);
    	setItemTextAsDistance('Heading1-BRMS', null);
        setItemVisible('Heading1-BaselineLength', false);
        setItemDisplayed('Heading1-Attitude', false);
	}
	else
	{
	    var valueMode = "";
	    switch( status.Heading.CalibrationMode )
	    {
		    case 0: valueMode = getResource('Receiver-Resource-Calibration'); break;
		    case 1: valueMode = getResource('Receiver-Resource-Operation'); break;
            default: valueMode = getResource('Receiver-Resource-None');break;
		    //default: valueMode = status.Heading.CalibrationMode; break;
	    }

//       setItemText('Heading1-Status', value1 + " / " + valueMode);
       if (status.Heading.CalibrationMode == 1)
            setItemText('Heading1-Status', value1 + " / " + valueMode);
        else
            setItemText('Heading1-Status', valueMode);
	    setItemTextAsSimpleAngle('Heading1-Heading', status.Heading.Heading);
	    setItemTextAsSimpleAngle('Heading1-Pitch', status.Heading.Pitch);
	    setItemTextAsSimpleAngle('Heading1-Roll', status.Heading.Roll);
	    setItemTextAsDistance('Heading1-MRMS', (status.Heading.MRMS == 1.023) ? null : status.Heading.MRMS);
	    setItemTextAsDistance('Heading1-BRMS', (status.Heading.BRMS == 1.023) ? null : status.Heading.BRMS);
    	
	    if (status.Heading.BaselineFlag == 0)
	    {
		    setItemVisible('Heading1-BaselineLength', false);
	    }
	    else
	    {
		    setItemVisible('Heading1-BaselineLength', true);
		    setItemTextAsDistance('Heading1-BaselineLength', status.Heading.BaselineLength);
	    }
    	
	    if ((status.Heading.Heading >= 0) && (status.Heading.Heading < 360))
		    setItemVisible('Heading1-Heading', true);
	    else
		    setItemVisible('Heading1-Heading', false);
    	
	    if ((status.Heading.Roll >= -90) && (status.Heading.Roll <= 90))
		    setItemVisible('Heading1-Roll', true);
	    else
		    setItemVisible('Heading1-Roll', false);
    	
	    if ((status.Heading.Pitch >= -90) && (status.Heading.Pitch <= 90))
		    setItemVisible('Heading1-Pitch', true);
	    else
		    setItemVisible('Heading1-Pitch', false);
    	
	    if (isHeadingShown == true)
	    {
		    updateCompassMap1(status.Heading);
	    }
	}
	
	var value2 = "";
	switch( status.Heading2.Status )
	{
		case 0: value2 = getResource('Receiver-Resource-Fixed'); break;
		case 1: value2 = getResource('Receiver-Resource-Float'); break;
		default: value2 = getResource('Receiver-Resource-None'); break;
		//default: value2 = status.Heading2.Status; break;
	}
	if (status.Heading2.Status == 2)
	{
	    // No Heading
	    setItemText('Heading2-Status', value2);
	    setItemVisible('Heading2-Heading', false);
	    setItemVisible('Heading2-Pitch', false);
	    setItemVisible('Heading2-Roll', false);
    	setItemTextAsDistance('Heading2-MRMS', null);
    	setItemTextAsDistance('Heading2-BRMS', null);
        setItemVisible('Heading2-BaselineLength', false);
        setItemDisplayed('Heading2-Attitude', false);
    	return;
	}

	var valueMode = "";
	switch( status.Heading2.CalibrationMode )
	{
		case 0: valueMode = getResource('Receiver-Resource-Calibration'); break;
		case 1: valueMode = getResource('Receiver-Resource-Operation'); break;
		default: valueMode = status.Heading2.CalibrationMode; break;
	}
//	setItemText('Heading2-Status', value2 + " / " + valueMode);
    if (status.Heading2.CalibrationMode == 1)
        setItemText('Heading2-Status', value2 + " / " + valueMode);
    else
        setItemText('Heading2-Status', valueMode);

	setItemTextAsSimpleAngle('Heading2-Heading', status.Heading2.Heading);
	setItemTextAsSimpleAngle('Heading2-Pitch', status.Heading2.Pitch);
	setItemTextAsSimpleAngle('Heading2-Roll', status.Heading2.Roll);
	setItemTextAsDistance('Heading2-MRMS', (status.Heading2.MRMS == 1.023) ? null : status.Heading2.MRMS);
	setItemTextAsDistance('Heading2-BRMS', (status.Heading2.BRMS == 1.023) ? null : status.Heading2.BRMS);
	if (status.Heading2.BaselineFlag == 0)
	{
		setItemVisible('Heading2-BaselineLength', false);
	}
	else
	{
		setItemVisible('Heading2-BaselineLength', true);
		setItemTextAsDistance('Heading2-BaselineLength', status.Heading2.BaselineLength);
	}
	
	if ((status.Heading2.Heading >= 0) && (status.Heading2.Heading < 360))
		setItemVisible('Heading2-Heading', true);
	else
		setItemVisible('Heading2-Heading', false);
	
	if ((status.Heading2.Roll >= -90) && (status.Heading2.Roll <= 90))
		setItemVisible('Heading2-Roll', true);
	else
		setItemVisible('Heading2-Roll', false);
	
	if ((status.Heading2.Pitch >= -90) && (status.Heading2.Pitch <= 90))
		setItemVisible('Heading2-Pitch', true);
	else
		setItemVisible('Heading2-Pitch', false);
	
	if (isHeadingShown == true)
	{
		updateCompassMap2(status.Heading2);
	}
}

function setComputedPosition(status)
{
	var value = status.ComputedPosition.Type;
	switch (status.ComputedPosition.Type)
	{
        case 0: value = getResource('ReceiverPosition-Resource-NoPosition'); break;
        case 1: value = getResource('ReceiverPosition-Resource-Standalone'); break;
        case 2: value = getResource('ReceiverPosition-Resource-DGPS'); break;
        case 3: value = getResource('ReceiverPosition-Resource-S-DGPS'); break; 
        case 4: value = getResource('ReceiverPosition-Resource-RTKFixed'); break; 
        case 5: value = getResource('ReceiverPosition-Resource-RTKFloat'); break;
	}	
    setItemText('ComputedPosition-Type',value);
	setItemText('ComputedPosition-CorrectionAge', formatString( '{0} s', status.ComputedPosition.CorrectionAge ) );

	// Data Link Quality
	if (status.ComputedPosition.DataLinkQuality == null)
	{
		setItemText('ComputedPosition-DataLinkQuality', null);
	}
	else
	{
		setItemText('ComputedPosition-DataLinkQuality', formatString( '{0} %', status.ComputedPosition.DataLinkQuality));
	}

	setItemTextAsLatitude('ComputedPosition-Latitude', status.ComputedPosition.Latitude);
	setItemTextAsLongitude('ComputedPosition-Longitude', status.ComputedPosition.Longitude);
	setItemTextAsDistance('ComputedPosition-Height', status.ComputedPosition.EllipsoidHeight);
	

    if ((status.Settings.Mode == 3) 
        || (status.Settings.IsBaseMoving && (status.Settings.Mode != 0)))
    {
        // REL and all moving mode (except Base)
        setItemDisplayed('Status-CP-Distance', false);
        setItemDisplayed('Status-CP-RMSLatitude', false);
        setItemDisplayed('Status-CP-RMSLongitude', false);
        setItemDisplayed('Status-CP-RMSHeight', false);
    }
    else
    {
    	setItemTextAsDistance('ComputedPosition-DistanceToRefStation', status.ComputedPosition.DistanceToRefStation);
	    setItemTextAsDistance('ComputedPosition-RmsLatitude', status.ComputedPosition.RmsLatitude);
	    setItemTextAsDistance('ComputedPosition-RmsLongitude', status.ComputedPosition.RmsLongitude);
	    setItemTextAsDistance('ComputedPosition-RmsHeight', status.ComputedPosition.RmsHeight);
        setItemDisplayed('Status-CP-Distance', true);
        setItemDisplayed('Status-CP-RMSLatitude', true);
        setItemDisplayed('Status-CP-RMSLongitude', true);
        setItemDisplayed('Status-CP-RMSHeight', true);
    }
    	
	if (status.ComputedPosition.CoordinateSystemName.length > 30)
	{
		setItemText('ComputedPosition-CoordinateSystemName', status.ComputedPosition.CoordinateSystemName.substring(0,30));
	}
	else
	{
		setItemText('ComputedPosition-CoordinateSystemName', status.ComputedPosition.CoordinateSystemName);
	}
	
	//-- Computed Position from Antenna 2 -- 
	if (status.Settings.Antenna2Status)
	{
		setItemDisplayed('Receiver-ComputedPosition2-Table', true);
	    setComputedPosition2(status);
	}
	else
		setItemDisplayed('Receiver-ComputedPosition2-Table', false);
}

function setComputedPosition2(status)
{
	var value = status.ComputedPosition2.Type;
	switch (status.ComputedPosition2.Type)
	{
        case 0: value = getResource('ReceiverPosition-Resource-NoPosition'); break;
        case 1: value = getResource('ReceiverPosition-Resource-Standalone'); break;
        case 2: value = getResource('ReceiverPosition-Resource-DGPS'); break;
        case 3: value = getResource('ReceiverPosition-Resource-S-DGPS'); break; 
        case 4: value = getResource('ReceiverPosition-Resource-RTKFixed'); break; 
        case 5: value = getResource('ReceiverPosition-Resource-RTKFloat'); break;
	}	
    setItemText('ComputedPosition2-Type',value);
	
	if (status.ComputedPosition2.Type == 0)
	{
	    setItemText('ComputedPosition2-CorrectionAge', null);
	    setItemText('ComputedPosition2-DataLinkQuality', null);
	    setItemText('ComputedPosition2-Latitude', null);
	    setItemText('ComputedPosition2-Longitude', null);
	    setItemText('ComputedPosition2-Height', null);
//	    setItemText('ComputedPosition2-DistanceToRefStation', null);
	    setItemText('ComputedPosition2-RmsLatitude', null);
	    setItemText('ComputedPosition2-RmsLongitude', null);
	    setItemText('ComputedPosition2-RmsHeight', null);
	    setItemText('ComputedPosition2-CoordinateSystemName', null);
	}
	else
	{
	    setItemText('ComputedPosition2-CorrectionAge', formatString( '{0} s', status.ComputedPosition2.CorrectionAge ) );
	    // Data Link Quality
	    if (status.ComputedPosition2.DataLinkQuality == null)
	    {
		    setItemText('ComputedPosition2-DataLinkQuality', null);
	    }
	    else
	    {
		    setItemText('ComputedPosition2-DataLinkQuality', formatString( '{0} %', status.ComputedPosition2.DataLinkQuality));
	    }
    	
	    setItemTextAsLatitude('ComputedPosition2-Latitude', status.ComputedPosition2.Latitude);
	    setItemTextAsLongitude('ComputedPosition2-Longitude', status.ComputedPosition2.Longitude);
	    setItemTextAsDistance('ComputedPosition2-Height', status.ComputedPosition2.EllipsoidHeight);
    	
//	    setItemTextAsDistance('ComputedPosition2-DistanceToRefStation', status.ComputedPosition2.DistanceToRefStation);
/*       if ((status.Settings.Mode == 5) && (!status.Settings.IsBaseMoving))
        {
            setItemTextAsDistance('ComputedPosition2-DistanceToRefStation', status.ComputedPosition2.DistanceToRefStation);
            setItemDisplayed('Status-CP2-Distance', true);
        }
        else
        {
            setItemDisplayed('Status-CP2-Distance', false);
        }*/
        
//	    setItemTextAsDistance('ComputedPosition2-RmsLatitude', status.ComputedPosition2.RmsLatitude);
//	    setItemTextAsDistance('ComputedPosition2-RmsLongitude', status.ComputedPosition2.RmsLongitude);
//	    setItemTextAsDistance('ComputedPosition2-RmsHeight', status.ComputedPosition2.RmsHeight);
        if ((status.Settings.Mode == 5) && (status.Settings.IsBaseMoving))
        {
            setItemDisplayed('Status-CP2-RMSLatitude', false);
            setItemDisplayed('Status-CP2-RMSLongitude', false);
            setItemDisplayed('Status-CP2-RMSHeight', false);
        }
        else
        {
	        setItemTextAsDistance('ComputedPosition2-RmsLatitude', status.ComputedPosition.RmsLatitude);
	        setItemTextAsDistance('ComputedPosition2-RmsLongitude', status.ComputedPosition.RmsLongitude);
	        setItemTextAsDistance('ComputedPosition2-RmsHeight', status.ComputedPosition.RmsHeight);
            setItemDisplayed('Status-CP2-RMSLatitude', true);
            setItemDisplayed('Status-CP2-RMSLongitude', true);
            setItemDisplayed('Status-CP2-RMSHeight', true);
        }
    	
	    if (status.ComputedPosition2.CoordinateSystemName.length > 30)
	    {
		    setItemText('ComputedPosition2-CoordinateSystemName', status.ComputedPosition2.CoordinateSystemName.substring(0,30));
	    }
	    else
	    {
		    setItemText('ComputedPosition2-CoordinateSystemName', status.ComputedPosition2.CoordinateSystemName);
	    }
	}
}

function setComputedVector(status)
{
    //-- Vector of Computed Position (moving Base) --
//   	setItemText('Status-CP-DeltaX', getResource('Status-Resource-DeltaX'));
//  	setItemText('Status-CP-DeltaY', getResource('Status-Resource-DeltaY'));
//   	setItemText('Status-CP-DeltaZ', getResource('Status-Resource-DeltaZ'));

	//-- Internal Vector --
	if ((status.Settings.Mode == 3) || (status.Settings.Mode == 4))
	{
       	setItemText('Status-InternalVector-DeltaX', getResource('Status-Resource-DeltaX'));
       	setItemText('Status-InternalVector-DeltaY', getResource('Status-Resource-DeltaY'));
       	setItemText('Status-InternalVector-DeltaZ', getResource('Status-Resource-DeltaZ'));
       	setItemText('Status-InternalVector-Length', getResource('Status-Vector-Length-Trans'));
       	setItemText('Status-InternalVector-RMS-X', getResource('Status-Vector-RMS-X-Trans'));
       	setItemText('Status-InternalVector-RMS-Y', getResource('Status-Vector-RMS-Y-Trans'));
       	setItemText('Status-InternalVector-RMS-Z', getResource('Status-Vector-RMS-Z-Trans'));

	    setInternalVector(status);
	    setItemDisplayed('Receiver-InternalVector-Table', true);
	}
	else
	    setItemDisplayed('Receiver-InternalVector-Table', false);
	
	// External Vector (Antenna1)
	if ((status.Settings.Mode != 0) && (status.Settings.Heading != 3) && status.Settings.IsBaseMoving)
	{
       	setItemText('Status-ExternalVector-Type', getResource('Status-Vector-Type-Trans'));
       	setItemText('Status-ExternalVector-NbSVS', getResource('Status-Vector-NbSVS-Trans'));
       	setItemText('Status-ExternalVector-DeltaX', getResource('Status-Vector-Delta-X-Trans'));
       	setItemText('Status-ExternalVector-DeltaY', getResource('Status-Vector-Delta-Y-Trans'));
       	setItemText('Status-ExternalVector-DeltaZ', getResource('Status-Vector-Delta-Z-Trans'));
       	setItemText('Status-ExternalVector-Length', getResource('Status-Vector-Length-Trans'));
       	setItemText('Status-ExternalVector-RMS-X', getResource('Status-Vector-RMS-X-Trans'));
       	setItemText('Status-ExternalVector-RMS-Y', getResource('Status-Vector-RMS-Y-Trans'));
       	setItemText('Status-ExternalVector-RMS-Z', getResource('Status-Vector-RMS-Z-Trans'));
       	
       	setExternalVector(status);
	    setItemDisplayed('Receiver-ExternalVector-Table', true);
	}
	else
	    setItemDisplayed('Receiver-ExternalVector-Table', false);
		
	// External Vector (Antenna2)
	if ((status.Settings.Mode == 5) && status.Settings.IsBaseMoving)
	{
       	setItemText('Status-ExternalVector2-Type', getResource('Status-Vector-Type-Trans'));
       	setItemText('Status-ExternalVector2-NbSVS', getResource('Status-Vector-NbSVS-Trans'));
       	setItemText('Status-ExternalVector2-DeltaX', getResource('Status-Vector-Delta-X-Trans'));
       	setItemText('Status-ExternalVector2-DeltaY', getResource('Status-Vector-Delta-Y-Trans'));
       	setItemText('Status-ExternalVector2-DeltaZ', getResource('Status-Vector-Delta-Z-Trans'));
       	setItemText('Status-ExternalVector2-Length', getResource('Status-Vector-Length-Trans'));
       	setItemText('Status-ExternalVector2-RMS-X', getResource('Status-Vector-RMS-X-Trans'));
       	setItemText('Status-ExternalVector2-RMS-Y', getResource('Status-Vector-RMS-Y-Trans'));
       	setItemText('Status-ExternalVector2-RMS-Z', getResource('Status-Vector-RMS-Z-Trans'));
       	
       	setExternalVector2(status);
	    setItemDisplayed('Receiver-ExternalVector2-Table', true);
	}
	else
	    setItemDisplayed('Receiver-ExternalVector2-Table', false);
}

function setInternalVector(status)
{
	var value = status.InternalVector.BaseLineFlag;
	switch (status.InternalVector.BaseLineFlag)
	{
        case 0: value = getResource('Receiver-Resource-None'); break;
        case 1: value = getResource('ReceiverPosition-Resource-DGPS'); break;
        case 2: value = getResource('ReceiverPosition-Resource-RTKFloat'); break;
        case 3: value = getResource('ReceiverPosition-Resource-RTKFixed'); break; 
	}	
    setItemText('InternalVector-Type',value);
	
	if (status.InternalVector.BaseLineFlag == 0)
	{
	    setItemText('InternalVector-NbSVS', null);
	    setItemText('InternalVector-DeltaX', null);
	    setItemText('InternalVector-DeltaY', null);
	    setItemText('InternalVector-DeltaZ', null);
	    setItemText('InternalVector-Length', null);
	    setItemText('InternalVector-RMS-X', null);
	    setItemText('InternalVector-RMS-Y', null);
	    setItemText('InternalVector-RMS-Z', null);
	}
	else
	{
	    setItemText('InternalVector-NbSVS', status.InternalVector.NumberOfSVS);
	    setItemTextAsDistance('InternalVector-DeltaX', status.InternalVector.DeltaX);
	    setItemTextAsDistance('InternalVector-DeltaY', status.InternalVector.DeltaY);
	    setItemTextAsDistance('InternalVector-DeltaZ', status.InternalVector.DeltaZ);
	    setItemTextAsDistance('InternalVector-Length', status.InternalVector.Length);
   	    setItemTextAsDistance('InternalVector-RMS-X', status.ComputedPosition.RmsLatitude);
	    setItemTextAsDistance('InternalVector-RMS-Y', status.ComputedPosition.RmsLongitude);
	    setItemTextAsDistance('InternalVector-RMS-Z', status.ComputedPosition.RmsHeight);
	}
}

function setExternalVector(status)
{
// todo
	var value = status.ExternalVector.BaseLineFlag;
	switch (status.ExternalVector.BaseLineFlag)
	{
        case 0: value = getResource('Receiver-Resource-None'); break;
        case 1: value = getResource('ReceiverPosition-Resource-DGPS'); break;
        case 2: value = getResource('ReceiverPosition-Resource-RTKFloat'); break;
        case 3: value = getResource('ReceiverPosition-Resource-RTKFixed'); break; 
	}	
    setItemText('ExternalVector-Type',value);
	
	if (status.ExternalVector.BaseLineFlag == 0)
	{
	    setItemText('ExternalVector-NbSVS', null);
	    setItemText('ExternalVector-DeltaX', null);
	    setItemText('ExternalVector-DeltaY', null);
	    setItemText('ExternalVector-DeltaZ', null);
	    setItemText('ExternalVector-Length', null);
   	    setItemText('ExternalVector-RMS-X', null);
	    setItemText('ExternalVector-RMS-Y', null);
	    setItemText('ExternalVector-RMS-Z', null);
	}
	else
	{
	    setItemText('ExternalVector-NbSVS', status.ExternalVector.NumberOfSVS);
	    setItemTextAsDistance('ExternalVector-DeltaX', status.ExternalVector.DeltaX);
	    setItemTextAsDistance('ExternalVector-DeltaY', status.ExternalVector.DeltaY);
	    setItemTextAsDistance('ExternalVector-DeltaZ', status.ExternalVector.DeltaZ);
	    setItemTextAsDistance('ExternalVector-Length', status.ExternalVector.Length);
   	    setItemTextAsDistance('ExternalVector-RMS-X', status.ComputedPosition.RmsLatitude);
	    setItemTextAsDistance('ExternalVector-RMS-Y', status.ComputedPosition.RmsLongitude);
	    setItemTextAsDistance('ExternalVector-RMS-Z', status.ComputedPosition.RmsHeight);
	}
}

function setExternalVector2(status)
{
	var value = status.ExternalVector2.BaseLineFlag;
	switch (status.ExternalVector2.BaseLineFlag)
	{
        case 0: value = getResource('Receiver-Resource-None'); break;
        case 1: value = getResource('ReceiverPosition-Resource-DGPS'); break;
        case 2: value = getResource('ReceiverPosition-Resource-RTKFloat'); break;
        case 3: value = getResource('ReceiverPosition-Resource-RTKFixed'); break; 
        default: value = getResource('Receiver-Resource-None'); break;
	}	
    setItemText('ExternalVector2-Type',value);
	
	if (status.ExternalVector2.BaseLineFlag == 0)
	{
	    setItemText('ExternalVector2-NbSVS', null);
	    setItemText('ExternalVector2-DeltaX', null);
	    setItemText('ExternalVector2-DeltaY', null);
	    setItemText('ExternalVector2-DeltaZ', null);
	    setItemText('ExternalVector2-Length', null);
	    setItemText('ExternalVector2-RMS-X', null);
	    setItemText('ExternalVector2-RMS-Y', null);
	    setItemText('ExternalVector2-RMS-Z', null);
	}
	else
	{
	    setItemText('ExternalVector2-NbSVS', status.ExternalVector2.NumberOfSVS);
	    setItemTextAsDistance('ExternalVector2-DeltaX', status.ExternalVector2.DeltaX);
	    setItemTextAsDistance('ExternalVector2-DeltaY', status.ExternalVector2.DeltaY);
	    setItemTextAsDistance('ExternalVector2-DeltaZ', status.ExternalVector2.DeltaZ);
	    setItemTextAsDistance('ExternalVector2-Length', status.ExternalVector2.Length);
   	    setItemTextAsDistance('ExternalVector2-RMS-X', status.ComputedPosition2.RmsLatitude);
	    setItemTextAsDistance('ExternalVector2-RMS-Y', status.ComputedPosition2.RmsLongitude);
	    setItemTextAsDistance('ExternalVector2-RMS-Z', status.ComputedPosition2.RmsHeight);
	}
}

function setReferencePosition(status)
{
	if (status.Settings.Mode == 3) // REL
	{
	    setItemDisplayed('Receiver-ReferencePosition-Table', false);
	}
	else
	{
	    setItemDisplayed('Receiver-ReferencePosition-Table', true);
	    
        //-- Station ID 
        setItemText('ReferencePosition-StationId',status.ReferencePosition.StationId);
                
        // Station Position (lat,long,height)
        if ((status.Settings.Mode == 0) && status.Settings.IsBaseMoving)
        {
            setItemDisplayed('Status-Ref-Latitude', false);
            setItemDisplayed('Status-Ref-Longitude', false);
            setItemDisplayed('Status-Ref-EllipsoidHeight', false);
        }
        else
        {
            setItemTextAsLatitude('ReferencePosition-Latitude',status.ReferencePosition.Latitude);
            setItemTextAsLongitude('ReferencePosition-Longitude',status.ReferencePosition.Longitude);
            setItemTextAsDistance('ReferencePosition-EllipsoidHeight',status.ReferencePosition.EllipsoidHeight);
            setItemDisplayed('Status-Ref-Latitude', true);
            setItemDisplayed('Status-Ref-Longitude', true);
            setItemDisplayed('Status-Ref-EllipsoidHeight', true);
        }
                
        //-- Station Antenna
        setItemText('ReferencePosition-AntennaName',status.ReferencePosition.AntennaName);
                
        //-- Station Antenna Height
        setItemTextAsDistance('ReferencePosition-AntennaHeight',status.ReferencePosition.AntennaHeight);
    }
}

function setDifferentialMessages(status)
{
	emptyTable('Receiver-DiffMessages-Table');
	
	if (status.Settings.Mode == 3) // REL
	{
	    setItemDisplayed('Receiver-DiffMessages-Table', false);
	}
	else
	{
	    setItemDisplayed('Receiver-DiffMessages-Table', true);
	    for( i in status.DifferentialMessages)
	    {
		    putDifferentialMessage( status.DifferentialMessages[ i ] );
	    }
	}
}

function putDifferentialMessage(message)
{
	//Port
	var ixPattern = new RegExp('I[1-9]');
	
	if(message.Port == 'A' || message.Port == 'B' || message.Port == 'F' )
		putDiffMessage(message, buildSerialPortMsg, buildSerialPortCommType );
	else if( message.Port == 'D' && message.CommunicationType > 0)
		putDiffMessage(message, buildIntRadioPortMsg, buildSerialPortCommType );
	else if ( message.Port == 'C' )
		putDiffMessage( message, buildBluetoothPortMsg, buildBluetoothCommType );
	else if ( message.Port == 'E' && message.CommunicationType > 0)
		putDiffMessage( message, buildModemPortMsg, buildModemCommType );
	else if ( message.Port == 'P' && message.CommunicationType > 0)
		putDiffMessage( message, buildPPortMsg, buildPCommType );
	else if ( message.Port == 'Q' && message.CommunicationType > 0)
		putDiffMessage( message, buildQPortMsg, buildQCommType );
	else if ( message.Port == 'I' )
		putDiffMessage( message, buildIPortMsg, buildICommType );
	else if ( ixPattern.test( message.Port ) )
		putDiffMessage( message, buildIPortMsg, buildIxCommType );
}

function putDiffMessage(message, portFunc, msgTypeFunc )
{
	var table = 'Receiver-DiffMessages-Table';
	try
	{
		var portFuncValue = portFunc( message );
		var msgTypeFuncValue = msgTypeFunc( message );
		var buildMessageValue = buildMessage(message);
		var labelValue = null;
		
		var port = message.Port.substring(0,1);
		switch (port)
		{
		case "A":
			labelValue = getResource('Receiver-Resource-On');
		break;
		case "B":
			var value = null;
			switch (message.Status)
			{
			case 0:
				value = "Off";
			break;
			case 3:
				value = "On";	
			break;
			}
			labelValue = getResource('Receiver-Resource-' + value);
		break;
		case "F":
			var value = null;
			switch (message.Status)
			{
			case 0:
				value = "Off";
			break;
			case 3:
				value = "On";	
			break;
			}
			labelValue = getResource('Receiver-Resource-' + value);
		break;
		case "C":
			var value = null;
			switch (message.Status)
			{
			case 0:
				value = "Off";
			break;
			case 3:
				value = "On";	
			break;
			}
			labelValue = getResource('Receiver-Resource-' + value);
		break;
		case "D":
			var value = null;
			switch (message.Status)
			{
			case 0:
				value = "Off";
			break;
			case 3:
				value = "On";	
			break;
			}
			labelValue = getResource('Receiver-Resource-' + value);
		break;
		case "E":
			var value = null;
			switch (message.Status)
			{
			case 0:
				portFuncValue = null;
				msgTypeFuncValue = null;
				buildMessageValue = null;
			break;
			case 1:
				value = "Automatic";	
			break;			
			case 2:
				value = "Trying";
			break;
			case 3:
				value = "Connected";
			break;
			}
			labelValue = getResource('Receiver-Resource-' + value);
			
			if (message.Status == 1)
				labelValue += " (50 s)";
			
		break;
		case "P":
			var value = null;
			switch (message.Status)
			{
			case 0:
				portFuncValue = null;
				msgTypeFuncValue = null;
				buildMessageValue = null;
			break;
			case 1:
				value = "Automatic";
			break;				
			case 2:
				value = "Trying";
			break;
			case 3:
				value = "Connected";
			break;
			}
			labelValue = getResource('Receiver-Resource-' + value);
			
			if (message.Status == 1)
				labelValue += " (10 s)";
			
		break;
		case "Q":
			var value = null;
			switch (message.Status)
			{
			case 0:
				portFuncValue = null;
				msgTypeFuncValue = null;
				buildMessageValue = null;
			break;
			case 1:
				value = "Automatic";
			break;				
			case 2:
				value = "Trying";
			break;
			case 3:
				value = "Connected";
			break;
			}
			labelValue = getResource('Receiver-Resource-' + value);
			
			if (message.Status == 1)
				labelValue += " (10 s)";
			
		break;
		case "I":
			switch (message.CommunicationType)
			{
			case 1:
				labelValue = message.Status + " " + getResource('Receiver-Resource-Connections');
				break;
			case 2:
				var value = null;
				switch (message.Status)
				{
				case 0:
					portFuncValue = null;
					msgTypeFuncValue = null;
					buildMessageValue = null;
				break;
				case 1:
					value = "Automatic";	
				break;			
				case 2:
					value = "Trying";
				break;
				case 3:
					value = "Connected";
				break;
				}
				
				labelValue = getResource('Receiver-Resource-' + value);
				if (message.Status == 1)
					labelValue += " (10 s)";
				
				break;
			}
			
		break;
		}

		if (portFuncValue != null) {
			addTableRow(table, getResource('Receiver-Resource-Port'), portFuncValue, null );
			
			if (labelValue != null)
				addTableRow(table, getResource('Receiver-Resource-Status'), labelValue, null );
			
			addTableRow(table, getResource('Receiver-Resource-CommType'), msgTypeFuncValue, null );
			addTableRow(table, getResource('Receiver-Resource-DiffMessages'), buildMessageValue, null );
			addTableRow(table, null, '<br/>', null );
		}
	}
	catch(x)
	{
	}	
}

function buildSerialPortMsg( message )
{	
	var text =  getResource('Receiver-Resource-SerialPort') + ' ' + message.Port;
	if ( message.BaudRate != null )
	{
		text += ': ' + portSpeed[ message.BaudRate ] + 'Bds';
	}
	return text;
}
function buildIntRadioPortMsg( message )
{
	return getResource('Receiver-Resource-IntRadio') + ' ' + message.Port;
}

function buildSerialPortCommType(message)
{
	var text = '';
	switch(message.CommunicationType)
	{
		case 0:
		{
			text = 'Cable';
			break;
		}
		case 2:
		{
			text = 'U-Link TRx';
			if( message.Port == "D" )
			{
				text = "U-Link Rx";
			}
			break;
		}
		case 3:
		{
			text = "Magellan UHF";
			break;
		}
		case 4:
		{
			text = "PDL HPB/LBP";
			if( message.Port == "D" )
			{
				text = "PDL RXO";
			}
			break;
		}
		case 5:
		{
			text = 'ARF7474A EU';
			break;
		}
		case 6:
		{
			text = 'ARF7474A NA';
			break;
		}
		case 7:
		{
			if (message.CommunicationModelID == 2)
				text = 'ADL Vantage';
			else if (message.CommunicationModelID == 3)
				text = 'ADL Vantage Pro';
			else 
				text = 'ADL Vantage / Vantage Pro';
			break;
		}
		case 8:
		{
			text = 'ADL Foundation';
			break;
		}
		case 9:
		{
		    text = 'XDL Rover';
		    break;
		}
	}
	
	try
	{
		if ( message.Channel != null )
			text += ': channel ' + message.Channel;
		if ( message.Frequency != null )
			text += ' (' + message.Frequency + 'Mhz)';
			
	}
	catch( x )
	{
		
	}
	return text;
}

function buildBluetoothPortMsg( message )
{
	return getResource( 'Receiver-Resource-Bluetooth' ) + ' ' + message.Port;
}
function buildBluetoothCommType(message)
{
	var text = message.CommunicationType;
	if ( message.CommunicationType == 1 )
		text = getResource( 'Receiver-Resource-Bluetooth' );
	return text;
}

function buildModemPortMsg( message )
{
	return getResource('Receiver-Resource-Modem') + ' ' + message.Port;
}
function buildModemCommType(message)
{
	switch(message.CommunicationType)
	{
		case 1: return getResource( 'Receiver-Resource-Csd' );break;
		case 2:
		{
			return getResource( 'Receiver-Resource-DirectIP') + ': ' + message.IpAddress + ':' + message.IpPort;
		}
		case 3: 
		{
			if( mode > 0 )
			{
				return getResource( 'Receiver-Resource-NtripClient' ) + ' (' + message.Mount + ')';
			}
			return getResource( 'Receiver-Resource-NtripServer' );
			break;
		}
	}
	return '';
}

function buildPPortMsg( message )
{
	return getResource('Receiver-Resource-Ethernet') + ' ' + message.Port;
}
function buildPCommType(message)
{
	if ( message.CommunicationType == 4 )
	{
		return getResource( 'Receiver-Resource-DirectIP') + ': ' + message.IpAddress + ':' + message.IpPort;
	}
	else if ( message.CommunicationType == 5 )
	{
		if ( mode > 0 )
		{
			return getResource( 'Receiver-Resource-NtripClient' ) + ' (' + message.Mount + ')';
		}
		return getResource( 'Receiver-Resource-NtripServer' );
	}
	else if ( message.CommunicationType == 7 )
	{
		return getResource( 'Receiver-Resource-EmbeddedCaster' );
	}
	
	return '';
}

function buildQPortMsg( message )
{
	return getResource('Receiver-Resource-Ethernet') + ' ' + message.Port;
}
function buildQCommType(message)
{
	if ( message.CommunicationType == 4 )
	{
		return getResource( 'Receiver-Resource-DirectIP') + ': ' + message.IpAddress + ':' + message.IpPort;
	}
	else if ( message.CommunicationType == 5 )
	{
		if ( mode > 0 )
		{
			return getResource( 'Receiver-Resource-NtripClient' ) + ' (' + message.Mount + ')';
		}
		return getResource( 'Receiver-Resource-NtripServer' );
	}
	else if ( message.CommunicationType == 7 )
	{
		return getResource( 'Receiver-Resource-EmbeddedCaster' );
	}
	
	return '';
}

function buildIPortMsg( message )
{
	return getResource( 'Receiver-Resource-Ethernet' ) + ' ' + message.Port;
}
function buildICommType(message)
{
	if (message.CommunicationType == 1 )
	{
		return getResource( 'Receiver-Resource-DirectIPServer' ) + ': ' + getResource( 'Receiver-Resource-Port' ) + ' ' + message.IpPort; 
	}	
	return message.CommuncationType;
}

function buildIxCommType(message)
{
	var text = message.CommunicationType;
	switch(message.CommunicationType)
	{
		case 1:
		{
			text = getResource( 'Receiver-Resource-EthernetServer' ) + ': ' + getResource( 'Receiver-Resource-Port' ) + ' ' + message.IpPort;
			break;
		}
		case 2:
		{
			text = getResource( 'Receiver-Resource-EthernetClient' ) + ': ' + message.IpAddress + ':' + message.IpPort;
			break;
		}
	}
	return text;
} 

function buildMessage(message)
{
	var text = "";
	try
	{
		switch(message.MessageType)
		{
			case 1: text = 'ATOM';break;
			case 2: text = 'RTCM3.x';break;
			case 3: text = 'RTCM2.3';break;
			case 4: text = 'CMR';break;
			case 5: text = 'CMR+';break;
			case 6: text = 'DBEN';break;
			case 7: text = 'TOPAZE';break;
		}
		
		if ( message.Messages != null && message.Messages.length > 0)
			text = text + ": " + message.Messages;
	}
	catch(x)
	{
	}

    return text;
}

function getCurrentOpenLayersLonLat()
{
	var currentPosition = getCurrentPosition();
    return new OpenLayers.LonLat(currentPosition[1], currentPosition[0]).transform(projectionWGS84,map.getProjectionObject());
}

var isHeadingShown = true;
function toggle_map(element)
{
	if (element.className == "minus")
	{
		element.className = "plus";
		document.getElementById("paper").style.display = "none";
		isHeadingShown = false;
	}
	else
	{
		element.className = "minus";
		document.getElementById("paper").style.display = "block";
		isHeadingShown = true;
	}
}

// global
var rayon = 140, centerX = 150, centerY = 150, cardMargin = 20;
var doPitch = true;

// specific
var isAttitudeInit = false;
var azTicks, azCards, roHorizon, roLine, piLines, piDegs;
var formerPitch = 0;

function updateCompassMap(headings)
{
	var heading = headings.Heading;
	var roll = headings.Roll;
	var pitch = headings.Pitch;
	
	if ((heading >= 0) && (heading < 360))
	{
		if ((roll >= -90) && (roll <= 90))
		{
			// Pitch is invalid
			pitch = 0;
		}
		else //(pitch >= -90) && (pitch <= 90)
		{
			// Roll is invalid
			roll = 0;
		}
		
		if (isAttitudeInit == false)
		{
		    var paper;
		    var azCircle, azTriangle;
		    
			isAttitudeInit = true;
		    setItemDisplayed("Heading-Attitude", true);
   			paper = Raphael(document.getElementById("paper"), 300, 300);

			//Azimuth
			//Azimuth Circle
			azCircle = paper.circle(centerX,centerY,rayon).attr({ "stroke-width": 2, "stroke": "#007dc3" });
			
			//Azimuth Triangle
			azTriangle = paper.path(
				"M" + (centerX) + "," + (centerY - rayon - 2) +
				"L" + (centerX - 8) + "," + (centerY - rayon - 10 - 2) + 
				"L" + (centerX + 8) + "," + (centerY - rayon - 10 - 2) + " z");
			azTriangle.attr({ "fill": "#007dc3","stroke-width": 2, "stroke": "#007dc3" });
			
			//Azimuth Ticks
			azTicks = paper.set();
			
			for (var i = 0; i < 360; i+=30)
			{
				azTicks.push(paper.path("M"+ (centerX) +" "+ (centerY - rayon) +"L"+ (centerX) +" "+ (centerY - rayon + 10)).rotate(i,centerX,centerY));
			}
			
			azTicks.attr({ "stroke-width": 2, "stroke": "#007dc3" });
			
			//Azimuth Cards
			azCards = paper.set();
			azCards.push(paper.text(centerX, centerY - rayon + cardMargin, "N"));
			azCards.push(paper.text(centerX + rayon - cardMargin, centerY, "E"));
			azCards.push(paper.text(centerX, centerY + rayon - cardMargin, "S"));
			azCards.push(paper.text(centerX - rayon + cardMargin, centerY, "W"));
			azCards.attr({"font-size": 13, "font-weight": "bold", "fill": "#007dc3"});
			
			//Azimuth
			//Azimuth Ticks
			for (var i = 0; i < azTicks.items.length; i++){
				azTicks.items[i].rotate((i * 30) + (360 - heading), centerX, centerY);
			}
			
			//Azimuth Cards
			azCards.rotate((360 - heading), centerX, centerY);
			
			//Roll
			roPath = paper.path(
				"M" + (centerX - rayon + 1) + "," + (centerY) + 
				"L" + (centerX) + "," + (centerY) + 
				"L" + (centerX + rayon - 1) + "," + (centerY) + 
				" a" + (rayon - 1) + "," + (rayon - 1) + 
				" 0 0,1 " + ((-rayon + 1) * 2) + ",0 z");
			roPath.attr({ "fill": "#cccccc", "stroke": "#cccccc", "stroke-width": 1 });
			roPath.toBack();
			
			roLine = paper.path("M" + (centerX - (rayon * 0.65)) + "," + (centerY) + "L" + (centerX + (rayon * 0.65)) + "," + (centerY));
			roLine.attr({ "fill": "#ff7c00", "stroke": "#ff7c00", "stroke-width": 2 });
			
			
			//Pitch			
			piLines = paper.set();
			piDegs = paper.set();
			
			var fracRayon = rayon * 0.15;
			var index = 0;
			for (var j = 180; j >= 0; j-= 10)
			{
				var offset = (pitch + 90) - j;
				var i = j - 90;
				var fracI = Math.abs(i / 2);
				piLines.push(paper.path("M"+ (centerX - (fracRayon) - fracI) +" "+ (centerY - (i * 4)) +"L"+ (centerX + (fracRayon) + fracI) +" "+ (centerY - (i * 4))));
				piDegs.push(paper.text(centerX - (fracRayon) - fracI - 15, centerY - (i * 4), i));
				piDegs.push(paper.text(centerX + (fracRayon) + fracI + 15, centerY - (i * 4), i));
				
				if (Math.abs(offset) < 20)
				{
					piLines.items[index].show();
					piDegs.items[index * 2].show();
					piDegs.items[index * 2 + 1].show();
				}
				else
				{
					piLines.items[index].hide();
					piDegs.items[index * 2].hide();
					piDegs.items[index * 2 + 1].hide();
				}
				index++;
			}

			piLines.attr({ "stroke-width": 2, "stroke": "#007dc3" });
			piDegs.attr({"font-size": 12, "fill": "#007dc3"});
			// 0° => Orange
			piLines.items[9].attr({"stroke":"#ff7c00"});
			piDegs.items[18].attr({"fill":"#ff7c00"});
			piDegs.items[19].attr({"fill":"#ff7c00"});
			
			piLines.translate(0, (pitch * 4));
			piDegs.translate(0, (pitch * 4));
		}
		else
		{
			//Azimuth
			//Azimuth Ticks
			for (var i = 0; i < azTicks.items.length; i++){
				azTicks.items[i].rotate((i * 30) + (360 - heading), centerX, centerY);
			}
			
			//Azimuth Cards
			azCards.rotate((360 - heading), centerX, centerY);
			
			//Roll			
			roPath.rotate(roll, centerX, centerY);
			//roLine.rotate(roll, centerX, centerY);
			
			//Pitch
			var index = 0;
			for (var j = 180; j >= 0; j-= 10)
			{
				var offset = (pitch + 90) - j;
				if (Math.abs(offset) < 20)
				{
					piLines.items[index].show();
					piDegs.items[index * 2].show();
					piDegs.items[index * 2 + 1].show();
				}
				else
				{
					piLines.items[index].hide();
					piDegs.items[index * 2].hide();
					piDegs.items[index * 2 + 1].hide();
				}
				index++;
			}
			
			piLines.translate(0, -(formerPitch * 4));
			piDegs.translate(0, -(formerPitch * 4));
			piLines.translate(0, (pitch * 4));
			piDegs.translate(0, (pitch * 4));
			piLines.rotate(roll, centerX, centerY);
			piDegs.rotate(roll, centerX, centerY);
		}
		if (doPitch == true)
		{
			formerPitch = pitch;
		}
	} else {
   		setItemDisplayed("Heading-Attitude", false);
   		isAttitudeInit = false;
	}
}

// specific
var isAttitudeInit1 = false;
var azTicks1, azCards1, roHorizon1, roLine1, piLines1, piDegs1;
var formerPitch1 = 0;

function updateCompassMap1(headings)
{
	var heading = headings.Heading;
	var roll = headings.Roll;
	var pitch = headings.Pitch;
	
	if ((heading >= 0) && (heading < 360))
	{
		if ((roll >= -90) && (roll <= 90))
		{
			// Pitch is invalid
			pitch = 0;
		}
		else //(pitch >= -90) && (pitch <= 90)
		{
			// Roll is invalid
			roll = 0;
		}
		if (isAttitudeInit1 == false)
		{
		    var paper;
		    var azCircle, azTriangle;

			isAttitudeInit1 = true;
			setItemDisplayed("Heading1-Attitude", true);
			paper = Raphael(document.getElementById("paper1"), 300, 300);
			
			//Azimuth
			//Azimuth Circle
			azCircle = paper.circle(centerX,centerY,rayon).attr({ "stroke-width": 2, "stroke": "#007dc3" });
			
			//Azimuth Triangle
			azTriangle = paper.path(
				"M" + (centerX) + "," + (centerY - rayon - 2) +
				"L" + (centerX - 8) + "," + (centerY - rayon - 10 - 2) + 
				"L" + (centerX + 8) + "," + (centerY - rayon - 10 - 2) + " z");
			azTriangle.attr({ "fill": "#007dc3","stroke-width": 2, "stroke": "#007dc3" });
			
			//Azimuth Ticks
			azTicks1 = paper.set();
			
			for (var i = 0; i < 360; i+=30)
			{
				azTicks1.push(paper.path("M"+ (centerX) +" "+ (centerY - rayon) +"L"+ (centerX) +" "+ (centerY - rayon + 10)).rotate(i,centerX,centerY));
			}
			azTicks1.attr({ "stroke-width": 2, "stroke": "#007dc3" });
			
			//Azimuth Cards
			azCards1 = paper.set();
			azCards1.push(paper.text(centerX, centerY - rayon + cardMargin, "N"));
			azCards1.push(paper.text(centerX + rayon - cardMargin, centerY, "E"));
			azCards1.push(paper.text(centerX, centerY + rayon - cardMargin, "S"));
			azCards1.push(paper.text(centerX - rayon + cardMargin, centerY, "W"));
			azCards1.attr({"font-size": 13, "font-weight": "bold", "fill": "#007dc3"});
			
			//Azimuth
			//Azimuth Ticks
			for (var i = 0; i < azTicks1.items.length; i++){
				azTicks1.items[i].rotate((i * 30) + (360 - heading), centerX, centerY);
			}
			
			//Azimuth Cards
			azCards1.rotate((360 - heading), centerX, centerY);
			
			//Roll
			roPath1 = paper.path(
				"M" + (centerX - rayon + 1) + "," + (centerY) + 
				"L" + (centerX) + "," + (centerY) + 
				"L" + (centerX + rayon - 1) + "," + (centerY) + 
				" a" + (rayon - 1) + "," + (rayon - 1) + 
				" 0 0,1 " + ((-rayon + 1) * 2) + ",0 z");
			roPath1.attr({ "fill": "#cccccc", "stroke": "#cccccc", "stroke-width": 1 });
			roPath1.toBack();
			
			roLine1 = paper.path("M" + (centerX - (rayon * 0.65)) + "," + (centerY) + "L" + (centerX + (rayon * 0.65)) + "," + (centerY));
			roLine1.attr({ "fill": "#ff7c00", "stroke": "#ff7c00", "stroke-width": 2 });

			//Pitch			
			piLines1 = paper.set();
			piDegs1 = paper.set();
			
			var fracRayon = rayon * 0.15;
			var index = 0;
			for (var j = 180; j >= 0; j-= 10)
			{
				var offset = (pitch + 90) - j;
				var i = j - 90;
				var fracI = Math.abs(i / 2);
				piLines1.push(paper.path("M"+ (centerX - (fracRayon) - fracI) +" "+ (centerY - (i * 4)) +"L"+ (centerX + (fracRayon) + fracI) +" "+ (centerY - (i * 4))));
				piDegs1.push(paper.text(centerX - (fracRayon) - fracI - 15, centerY - (i * 4), i));
				piDegs1.push(paper.text(centerX + (fracRayon) + fracI + 15, centerY - (i * 4), i));
				
				if (Math.abs(offset) < 20)
				{
					piLines1.items[index].show();
					piDegs1.items[index * 2].show();
					piDegs1.items[index * 2 + 1].show();
				}
				else
				{
					piLines1.items[index].hide();
					piDegs1.items[index * 2].hide();
					piDegs1.items[index * 2 + 1].hide();
				}
				index++;
			}

			piLines1.attr({ "stroke-width": 2, "stroke": "#007dc3" });
			piDegs1.attr({"font-size": 12, "fill": "#007dc3"});
			// 0° => Orange
			piLines1.items[9].attr({"stroke":"#ff7c00"});
			piDegs1.items[18].attr({"fill":"#ff7c00"});
			piDegs1.items[19].attr({"fill":"#ff7c00"});
			
			piLines1.translate(0, (pitch * 4));
			piDegs1.translate(0, (pitch * 4));
		}
		else
		{
			//Azimuth
			//Azimuth Ticks
			for (var i = 0; i < azTicks1.items.length; i++){
				azTicks1.items[i].rotate((i * 30) + (360 - heading), centerX, centerY);
			}
			
			//Azimuth Cards
			azCards1.rotate((360 - heading), centerX, centerY);
			
			//Roll			
			roPath1.rotate(roll, centerX, centerY);
			//roLine1.rotate(roll, centerX, centerY);
			
			//Pitch
			var index = 0;
			for (var j = 180; j >= 0; j-= 10)
			{
				var offset = (pitch + 90) - j;
				if (Math.abs(offset) < 20)
				{
					piLines1.items[index].show();
					piDegs1.items[index * 2].show();
					piDegs1.items[index * 2 + 1].show();
				}
				else
				{
					piLines1.items[index].hide();
					piDegs1.items[index * 2].hide();
					piDegs1.items[index * 2 + 1].hide();
				}
				index++;
			}
			
			piLines1.translate(0, -(formerPitch1 * 4));
			piDegs1.translate(0, -(formerPitch1 * 4));
			piLines1.translate(0, (pitch * 4));
			piDegs1.translate(0, (pitch * 4));
			piLines1.rotate(roll, centerX, centerY);
			piDegs1.rotate(roll, centerX, centerY);
		}
		if (doPitch == true)
		{
			formerPitch1 = pitch;
		}
	} else {
		setItemDisplayed("Heading1-Attitude", false);
		isAttitudeInit1 = false;
	}
}

// specific
var isAttitudeInit2 = false;
var azTicks2, azCards2, roHorizon2, roLine2, piLines2, piDegs2;
var formerPitch2 = 0;

function updateCompassMap2(headings)
{
	var heading = headings.Heading;
	var roll = headings.Roll;
	var pitch = headings.Pitch;
	
	if ((heading >= 0) && (heading < 360))
	{
		if ((roll >= -90) && (roll <= 90))
		{
			// Pitch is invalid
			pitch = 0;
		}
		else //(pitch >= -90) && (pitch <= 90)
		{
			// Roll is invalid
			roll = 0;
		}
		if (isAttitudeInit2 == false)
		{
		    var paper;
		    var azCircle, azTriangle;

			isAttitudeInit2 = true;
			setItemDisplayed("Heading2-Attitude", true);
			paper = Raphael(document.getElementById("paper2"), 300, 300);
			
			//Azimuth
			//Azimuth Circle
			azCircle = paper.circle(centerX,centerY,rayon).attr({ "stroke-width": 2, "stroke": "#007dc3" });
			
			//Azimuth Triangle
			azTriangle = paper.path(
				"M" + (centerX) + "," + (centerY - rayon - 2) +
				"L" + (centerX - 8) + "," + (centerY - rayon - 10 - 2) + 
				"L" + (centerX + 8) + "," + (centerY - rayon - 10 - 2) + " z");
			azTriangle.attr({ "fill": "#007dc3","stroke-width": 2, "stroke": "#007dc3" });
			
			//Azimuth Ticks
			azTicks2 = paper.set();
			
			for (var i = 0; i < 360; i+=30)
			{
				azTicks2.push(paper.path("M"+ (centerX) +" "+ (centerY - rayon) +"L"+ (centerX) +" "+ (centerY - rayon + 10)).rotate(i,centerX,centerY));
			}
			azTicks2.attr({ "stroke-width": 2, "stroke": "#007dc3" });
			
			//Azimuth Cards
			azCards2 = paper.set();
			azCards2.push(paper.text(centerX, centerY - rayon + cardMargin, "N"));
			azCards2.push(paper.text(centerX + rayon - cardMargin, centerY, "E"));
			azCards2.push(paper.text(centerX, centerY + rayon - cardMargin, "S"));
			azCards2.push(paper.text(centerX - rayon + cardMargin, centerY, "W"));
			azCards2.attr({"font-size": 13, "font-weight": "bold", "fill": "#007dc3"});
			
			//Azimuth
			//Azimuth Ticks
			for (var i = 0; i < azTicks2.items.length; i++){
				azTicks2.items[i].rotate((i * 30) + (360 - heading), centerX, centerY);
			}
			
			//Azimuth Cards
			azCards2.rotate((360 - heading), centerX, centerY);
			
			//Roll
			roPath2 = paper.path(
				"M" + (centerX - rayon + 1) + "," + (centerY) + 
				"L" + (centerX) + "," + (centerY) + 
				"L" + (centerX + rayon - 1) + "," + (centerY) + 
				" a" + (rayon - 1) + "," + (rayon - 1) + 
				" 0 0,1 " + ((-rayon + 1) * 2) + ",0 z");
			roPath2.attr({ "fill": "#cccccc", "stroke": "#cccccc", "stroke-width": 1 });
			roPath2.toBack();
			
			roLine2 = paper.path("M" + (centerX - (rayon * 0.65)) + "," + (centerY) + "L" + (centerX + (rayon * 0.65)) + "," + (centerY));
			roLine2.attr({ "fill": "#ff7c00", "stroke": "#ff7c00", "stroke-width": 2 });

			//Pitch			
			piLines2 = paper.set();
			piDegs2 = paper.set();
			
			var fracRayon = rayon * 0.15;
			var index = 0;
			for (var j = 180; j >= 0; j-= 10)
			{
				var offset = (pitch + 90) - j;
				var i = j - 90;
				var fracI = Math.abs(i / 2);
				piLines2.push(paper.path("M"+ (centerX - (fracRayon) - fracI) +" "+ (centerY - (i * 4)) +"L"+ (centerX + (fracRayon) + fracI) +" "+ (centerY - (i * 4))));
				piDegs2.push(paper.text(centerX - (fracRayon) - fracI - 15, centerY - (i * 4), i));
				piDegs2.push(paper.text(centerX + (fracRayon) + fracI + 15, centerY - (i * 4), i));
				
				if (Math.abs(offset) < 20)
				{
					piLines2.items[index].show();
					piDegs2.items[index * 2].show();
					piDegs2.items[index * 2 + 1].show();
				}
				else
				{
					piLines2.items[index].hide();
					piDegs2.items[index * 2].hide();
					piDegs2.items[index * 2 + 1].hide();
				}
				index++;
			}

			piLines2.attr({ "stroke-width": 2, "stroke": "#007dc3" });
			piDegs2.attr({"font-size": 12, "fill": "#007dc3"});
			// 0° => Orange
			piLines2.items[9].attr({"stroke":"#ff7c00"});
			piDegs2.items[18].attr({"fill":"#ff7c00"});
			piDegs2.items[19].attr({"fill":"#ff7c00"});
			
			piLines2.translate(0, (pitch * 4));
			piDegs2.translate(0, (pitch * 4));
		}
		else
		{
			//Azimuth
			//Azimuth Ticks
			for (var i = 0; i < azTicks2.items.length; i++){
				azTicks2.items[i].rotate((i * 30) + (360 - heading), centerX, centerY);
			}
			
			//Azimuth Cards
			azCards2.rotate((360 - heading), centerX, centerY);
			
			//Roll			
			roPath2.rotate(roll, centerX, centerY);
			//roLine.rotate(roll, centerX, centerY);
			
			//Pitch
			var index = 0;
			for (var j = 180; j >= 0; j-= 10)
			{
				var offset = (pitch + 90) - j;
				if (Math.abs(offset) < 20)
				{
					piLines2.items[index].show();
					piDegs2.items[index * 2].show();
					piDegs2.items[index * 2 + 1].show();
				}
				else
				{
					piLines2.items[index].hide();
					piDegs2.items[index * 2].hide();
					piDegs2.items[index * 2 + 1].hide();
				}
				index++;
			}
			
			piLines2.translate(0, -(formerPitch2 * 4));
			piDegs2.translate(0, -(formerPitch2 * 4));
			piLines2.translate(0, (pitch * 4));
			piDegs2.translate(0, (pitch * 4));
			piLines2.rotate(roll, centerX, centerY);
			piDegs2.rotate(roll, centerX, centerY);
		}
		if (doPitch == true)
		{
			formerPitch2 = pitch;
		}
	} else {
		setItemDisplayed("Heading2-Attitude", false);
	}
}