var theGpsTableView = null;
var theGlonassTableView = null;
var theSbasTableView = null;
var theGalileoTableView = null;
var theQZSSTableView = null;

//Tabs
var myTabs = null;

//GPS OK, GLONASS OK, GALILEO OK, SBAS OK, QZSS OK, GPS NOT OK, GLONASS NOT OK, GALILEO NOT OK, SBAS NOT OK, QZSS NOT OK
var colors = new Array(
    "#00cc00",  //GPS OK
    "#cc0000",  //GLONASS OK
    "#f8971d",  //GALILEO OK
    "#007fff",  //SBAS OK
    "#3333cc",  //QZSS OK
    "#8fcc8f",  //GPS NOT OK
    "#cc8f8f",  //GLONASS NOT OK
    "#f8c381",  //GALILEO NOT OK
    "#8f8fcc",  //SBAS NOT OK
    "#99ccff"   //QZSS OK
    );
    
//Bar Graphs
var theGpsBarGraph=null, theGlonassBarGraph=null, theSbasBarGraph=null, theGalileoBarGraph = null, theQZSSBarGraph = null;

//Constellation sizes
//QZSS Size is set to 5
var consSize = new Array(32,24,30,19,5);

//dBHz Scale
var scaleMaximum = 60;

//barPapers related storage (check status and update)
var barPapers = new Array();
var oldBars = new Array(), dataBars = new Array();
var barUsedPathSet = new Array();
var barToolTipPathSet = new Array(), barToolTipTextSet = new Array();
var rectHover = new Array();
var barColsize = new Array();
var barElementId = new Array();
var formerK = null;
var initFinish = false;

//NEW STUFF
var barRectSet = [];

//Polar view
var theSatellitePolarView = null;
var side, centerx, centery, radiusx, radiusy;
var colgps, colglonass, colsbas, colgalileo, colors;
var statusData;
var paper;
var textSet;
var rectSet;
var legend;
var oldSats = new Object();

var currentStatus = null;

function getGpsStatus()
{
	return (currentStatus != null) ? currentStatus.Gps : [];
}

function getGlonassStatus()
{
	return (currentStatus != null) ? currentStatus.Glonass : [];
}

function getSbasStatus()
{
	return (currentStatus != null) ? currentStatus.Sbas : [];
}

function getGalileoStatus()
{
	return (currentStatus != null) ? currentStatus.Galileo : [];
}

function getQZSSStatus()
{
	return (currentStatus != null) ? currentStatus.QZSS : [];
}

function updateStatusSatellite()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusSatellite()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get status
			var status = data.StatusSatellite2;
			if (status == null) 
			{
			alert("toto");
			    return;
			}
			
			//Simulation until Service Layer is OK : START ---------------------------
			/*
			status.Options = "QO";
			status.GalileoEnabled = 1;
			
			status.Galileo =
			[
				{
					"Prn":1,
					"Status":1,
					"Azimuth":Math.round((Math.random() * 360)),
					"Elevation":Math.round((Math.random() * 90)),
					"SnE1":Math.round((Math.random() * 60)),
					"SnE1Smooth":Math.round((Math.random() * 255)),
					"SnE5a":Math.round((Math.random() * 60)),
					"SnE5aSmooth":Math.round((Math.random() * 255))
				},
				{
					"Prn":2,
					"Status":1,
					"Azimuth":Math.round((Math.random() * 360)),
					"Elevation":Math.round((Math.random() * 90)),
					"SnE1":Math.round((Math.random() * 60)),
					"SnE1Smooth":Math.round((Math.random() * 255)),
					"SnE5a":Math.round((Math.random() * 60)),
					"SnE5aSmooth":Math.round((Math.random() * 255))
				}
			];
			
			status.Gps.push({
				"Prn":31,
				"DifferentialStatus":2,
				"Status":1,
				"Azimuth":144.000000,
				"Elevation":15.000000,
				"SnL1C":32,
				"SnL1P":0,
				"SnL2C":0,
				"SnL2P":8,
				"SnL1CSmooth":255,
				"SnL1PSmooth":0,
				"SnL2PSmooth":0,
				"SnL2CSmooth":0
			});
			
			status.Gps.push({
				"Prn":32,
				"DifferentialStatus":2,
				"Status":1,
				"Azimuth":144.000000,
				"Elevation":15.000000,
				"SnL1C":32,
				"SnL1P":0,
				"SnL2C":0,
				"SnL2P":8,
				"SnL1CSmooth":255,
				"SnL1PSmooth":0,
				"SnL2PSmooth":0,
				"SnL2CSmooth":0
			});
			
			for (var i = 0; i < status.Gps.length; i++)
			{
				status.Gps[i].SnL2C = Math.round((Math.random() * 60));
				status.Gps[i].SnL2CSmooth = Math.round((Math.random() * 255));
				status.Gps[i].SnL5Q = Math.round((Math.random() * 60));
				status.Gps[i].SnL5QSmooth = Math.round((Math.random() * 255));
				status.Gps[i].DifferentialStatus = Math.round(Math.random() * 5);
			}
			
			for (var i = 0; i < status.Glonass.length; i++)
			{
				status.Glonass[i].DifferentialStatus = Math.round(Math.random() * 5);
			}
			
			for (var i = 0; i < status.Sbas.length; i++)
			{
				status.Sbas[i].DifferentialStatus = Math.round(Math.random() * 5);
			}
			
			for (var i = 0; i < status.Galileo.length; i++)
			{
				status.Galileo[i].DifferentialStatus = Math.round(Math.random() * 5);
			}
			*/
			//Simulation until Service Layer is OK : END ---------------------------
			
			//Options
			optionsGlobal = status.Options;
			
			// Update values
			var value;

			// -- GPS enabled --
			switch (status.GpsEnabled)
			{
				case 0: value = getResource('Satellite-Resource-Off'); break;
				case 1: value = getResource('Satellite-Resource-On'); break;
				default: value = status.GpsEnabled;
			}	
			setItemText('Satellite-GpsEnabled', value);

			// -- GLONASS enabled --
			switch (status.GlonassEnabled)
			{
				case 0: value = getResource('Satellite-Resource-Off'); break;
				case 1: value = getResource('Satellite-Resource-On'); break;
				default: value = status.GlonassEnabled;
			}	
			setItemText('Satellite-GlonassEnabled', value);
			
			// -- GALILEO enabled --
			switch (status.GalileoEnabled)
			{
				case 0: value = getResource('Satellite-Resource-Off'); break;
				case 1: value = getResource('Satellite-Resource-On'); break;
				default: value = status.GalileoEnabled;
			}	
			setItemText('Satellite-GalileoEnabled', value);
			
			//Galileo Management
			setItemDisplayed('Label-GALILEO',(optionsGlobal.indexOf("O") != -1));
			setItemDisplayed('Satellite-GalileoEnabled', (optionsGlobal.indexOf("O") != -1));
			YAHOO.util.Dom.setStyle(document.getElementById('LI-Galileo'), "display", (optionsGlobal.indexOf("O") != -1) ? "" : "none");
			//setItemDisplayed('LI-Galileo', (optionsGlobal.indexOf("O") != -1));
			setItemDisplayed('Satellite-GALILEO-Used', (optionsGlobal.indexOf("O") != -1));
			setItemDisplayed('Satellite-GALILEO-Unused', (optionsGlobal.indexOf("O") != -1));

			// -- SBAS enabled --
			switch (status.SbasEnabled)
			{
				case 0: value = getResource('Satellite-Resource-Off'); break;
				case 1: value = getResource('Satellite-Resource-On'); break;
				default: value = status.SbasEnabled;
			}	
			setItemText('Satellite-SbasEnabled', value);

			// -- QZSS enabled --
			switch (status.QZSSEnabled)
			{
				case 0: value = getResource('Satellite-Resource-Off'); break;
				case 1: value = getResource('Satellite-Resource-On'); break;
				default: value = status.QZSSEnabled;
			}	
			setItemText('Satellite-QZSSEnabled', value);

			//-- Antenna 2 Status --
			switch (status.Antenna2Enabled)
			{
				case 0: value = getResource('Satellite-Resource-Off'); break;
				case 1: value = getResource('Satellite-Resource-On'); break;
				default: value = status.Antenna2Enabled;
			}	
            setItemText('Satellite-Antenna2Enabled', value);


			// -- Update current status --
			currentStatus = status;
			
			// -- Satellite tables --
			if (theGpsTableView == null) {
				theGpsTableView = new SatelliteTableView('GpsTableView', getResource('Satellite-Resource-GPS'), getGpsStatus, getGpsConfig() );
			}
			if (theGlonassTableView == null) {
				theGlonassTableView = new SatelliteTableView('GlonassTableView', getResource('Satellite-Resource-GLONASS'), getGlonassStatus, getGlonassConfig() );
			}
			if (theGalileoTableView == null) {
				theGalileoTableView = new SatelliteTableView('GalileoTableView', getResource('Satellite-Resource-GALILEO'), getGalileoStatus, getGalileoConfig() );
			}
			if (theSbasTableView == null) {
				theSbasTableView = new SatelliteTableView('SbasTableView', getResource('Satellite-Resource-SBAS'), getSbasStatus, getSbasConfig() );
			}
			if (theQZSSTableView == null) {
				theQZSSTableView = new SatelliteTableView('QZSSTableView', getResource('Satellite-Resource-QZSS'), getQZSSStatus, getQZSSConfig() );
			}
			
			//RaphaelJs
			
			//Polar View Initialization
			if (theSatellitePolarView == null)
			{
				//legend = 40;
				legend = 0;
				sidex = 600;
				sidey = 560;
				centerx = sidex / 2 - 20;
				centery = sidex / 2 - 40 + legend;
				marging = 40;
				radiusx = centerx - marging;
				radiusy = centery - marging;
				
				theSatellitePolarView = 'RaphaelSatellitePolarView';
					
				paper = Raphael(document.getElementById(theSatellitePolarView), sidex, sidey);
				
				paper.circle(centerx, centery, radiusx * 1 / 3);
				paper.circle(centerx, centery, radiusx * 2 / 3);
				paper.circle(centerx, centery, radiusx * 3 / 3);

				paper.text(centerx - 10, legend + 10, "0°");
				paper.text(centerx * 2 - 10, centery, "90°");
				paper.text(centerx - 10, centery * 2 - legend - 10, "180°");
				paper.text(10, centery, "270°");

				paper.text(centerx - 10, centery * 1 / 3 - 10, "30°");
				paper.text(centerx - 10, centery * 2 / 3 - 10, "60°");
				paper.text(centerx - 10, centery * 3 / 3 - 10, "90°");
				paper.path("M" + marging + " " + (radiusy + marging) +"L" + (radiusx * 2 + marging) + " " + (radiusy + marging));
				paper.path("M" + (radiusx + marging) + " " + (legend + marging / 2) +"L" + (radiusx + marging) + " " + (radiusy * 2 + marging * 1.5));
				
				paper.text(centerx * 1.75 - 20, centerx * 0.25 + 20 + legend * 0.5, "Az.");
				paper.text(centerx + 10, centery - 10, "El.");
				
				textSet = paper.set();
				rectSet = paper.set();
			}
			
			if ((theGpsBarGraph == null) || (theGlonassBarGraph == null) || (theSbasBarGraph == null))
			{
				sidex = 680;
				sidey = 200;
				xpos = 25;
				ypos = 30;
				width = sidex - xpos * 4;
				height = sidey - ypos * 2;
			}
			
			//Gps Bar Graph
			if (theGpsBarGraph == null) {
				theGpsBarGraph = 'RaphaelGpsBarGraph';
				initBarGraph(theGpsBarGraph, sidex + 40, sidey, xpos, ypos, width, height, 0);
			}
			
			//Glonass Bar Graph
			if (theGlonassBarGraph == null) {
				theGlonassBarGraph = 'RaphaelGlonassBarGraph';
				initBarGraph(theGlonassBarGraph, sidex + 40, sidey, xpos, ypos, width, height, 1);
			}
			
			//Galileo Bar Graph
			if (theGalileoBarGraph == null) {	
				theGalileoBarGraph = 'RaphaelGalileoBarGraph';
				initBarGraph(theGalileoBarGraph, sidex + 40, sidey, xpos, ypos, width, height, 2);
			}
			
			//Sbas Bar Graph
			if (theSbasBarGraph == null) {	
				theSbasBarGraph = 'RaphaelSbasBarGraph';
				initBarGraph(theSbasBarGraph, sidex + 40, sidey, xpos, ypos, width, height, 3);
			}
			
			//QZSS Bar Graph
			if (theQZSSBarGraph == null) {	
				theQZSSBarGraph = 'RaphaelQZSSBarGraph';
				initBarGraph(theQZSSBarGraph, sidex + 40, sidey, xpos, ypos, width, height, 4);
			}
			
			statusData = new Array(status.Gps, status.Glonass, status.Galileo, status.Sbas, status.QZSS);
			updateSatellitePolarView(statusData, centerx, centery, radiusx);
			updateBarGraph(statusData, xpos, ypos, width, height);
			
			//YUI TabView (Tabs)
			if (myTabs == null) {
				myTabs = new YAHOO.widget.TabView("tabs");
			}
			
			// Update every (x / 1000) seconds
			if (initFinish == false) {
				setTimeout("updateStatusSatellite()", 1000);
			} else {
				setTimeout("updateStatusSatellite()", 5000);
				YAHOO.util.Dom.setStyle(document.getElementById('loading_msg'), "display", "none");
				YAHOO.util.Dom.setStyle(document.getElementById('SatelliteTableView'), "display", "block");
			}	
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusSatellite()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getStatusSatellite2URL, callbacks);
}

function polarSat(prn, az, el, status, color, textcolor, dash, constellation) {
    this.Prn = prn;
    this.Azimuth = az;
    this.Elevation = el;
    this.Status = status;
    this.Color = color;
    this.Textcolor = textcolor;
    this.Dash = dash;
    this.Cons = constellation;
}

function barSat(prn, signals, used, status, differentialStatus, color, textcolor, constellation) {
    this.Prn = prn;
    this.Signals = signals;
    this.Used = used;
    this.Status = status;
    this.DifferentialStatus = differentialStatus;
    this.Color = color;
    this.Textcolor = textcolor;
    this.Cons = constellation;
}

function initBarGraph(bargraphid, sidex, sidey, xpos, ypos, width, height, i) {	
	barPaper = Raphael(document.getElementById(bargraphid), sidex, sidey);
	
	//Element access for out of scope position event
	barElementId.push(bargraphid);
	
	//Rectangles per [constellation], per [satellites], per [signals]
	barRectSet.push(new Array());
	
	//Bar Dyna
	barToolTipPathSet.push(null);
	barToolTipTextSet.push(null);
	
	//Fixed drawings	
    //Grid
	barPaper.path("M" + (xpos) + "," + (ypos) + "L" + (xpos) + "," + (ypos + height)).attr("stroke-width", 2);
	
	colsize = Math.floor(width / consSize[i]);
	barColsize.push(colsize);
	width = colsize * consSize[i];
	barPaper.path("M" + (xpos - 1) + "," + (ypos + height) + "L" + (xpos + width + 1) + "," + (ypos + height));
	//Legend
	barPaper.text(xpos - 10, ypos - 10, getResource('Satellite-Resource-dBHz'));
	barPaper.text(xpos + width + 25, ypos + height + 5, getResource('Satellite-Resource-Satellites'));
	
	for (j = 0; j < consSize[i]; j++)
	{
		prn = (i == 3) ? j + 120 : ((i == 4) ? j + 193 : j + 1);
		
		//X Axis
		barPaper.text(xpos + (j) * colsize + colsize / 2 + 2, ypos + height + 10, prn);
		
		barRectSet[i].push([
			{"Channel":"L1C","Rect":null},
			{"Channel":"L1P","Rect":null},
			{"Channel":"L2C","Rect":null},
			{"Channel":"L2P","Rect":null}
		]);
		if (optionsGlobal.indexOf("Q") != -1)
		{
			barRectSet[i][j].push({"Channel":"L5Q","Rect":null});
		}
		if (optionsGlobal.indexOf("O") != -1)
		{
			barRectSet[i][j].push({"Channel":"E1","Rect":null});
			barRectSet[i][j].push({"Channel":"E5a","Rect":null});
		}
	}
	//Draw scale dBHz
	for (j = 0; j < scaleMaximum; j+=10)
	{
		barPaper.text(xpos - 15, Math.round(ypos + height - j / scaleMaximum * height), j);
		barPaper.path("M" + (xpos - 5) + "," + (ypos + height - j / scaleMaximum * (height - 2)) + "L" + (xpos) + "," + (ypos + height - j / scaleMaximum * (height - 2)));
	}
	
	//Raphael Dynamic
	barPapers.push(barPaper);
	
	//OldBars
	oldBars.push(null);
}

function updateBarGraph(data, xpos, ypos, width, height) {
	for (var i in data) {
		if ((myTabs == null) || ((myTabs != null) && (myTabs.get('activeIndex') - 1 == i))) {
			colsize = Math.floor(width / consSize[i]);
			
			dataBars[i] = new Object();
			var nbNow = 0;
			
			for (var j in data[i]) {
				dat = data[i][j];
				//Up-to-date values
				if (dat.Status == 1) {
					used = true;
					color = colors[i];
					textcolor = "#FFFFFF";
				} else {
					used = false;
					color = colors[parseInt(i,10) + 5]; // +1 for QZSS
					textcolor = "#000000";
				}
				
				var signals = [];
				
				signals.push({"Channel":"L1C","Value": (dat.SnL1C != null) ? dat.SnL1C : 0});
				signals.push({"Channel":"L1P","Value":(dat.SnL1P != null) ? dat.SnL1P : 0});
				signals.push({"Channel":"L2C","Value":(dat.SnL2C != null) ? dat.SnL2C : 0});
				signals.push({"Channel":"L2P","Value":(dat.SnL2P != null) ? dat.SnL2P : 0});
				if (optionsGlobal.indexOf("Q") != -1) {
					signals.push({"Channel":"L5Q","Value":(dat.SnL5Q != null) ? dat.SnL5Q : 0});
				}
				if (optionsGlobal.indexOf("O") != -1) {
					signals.push({"Channel":"E1","Value":(dat.SnE1 != null) ? dat.SnE1 : 0});
					signals.push({"Channel":"E5a","Value":(dat.SnE5a != null) ? dat.SnE5a : 0});
				}
				
				dataBars[i][j] = new barSat(dat.Prn, signals, used, dat.Status, dat.DifferentialStatus, color, textcolor, i);
				nbNow++;
			}
			
			//Avoid former satellites to stay on the graph when the satellites count "lowers"
			if (oldBars[i] != null) {
				var nbBefore = 0;
				for (var j in oldBars[i])
					nbBefore++;
					
				if (nbBefore > nbNow) {
					for (var j = nbNow; j < nbBefore; j++) {
						for (var s = 0; s < barRectSet[i][j].length; s++) {
							if (barRectSet[i][j][s].Rect != null) {
								barRectSet[i][j][s].Rect.remove();
								barRectSet[i][j][s].Rect = null;
							}
						}
					}
				}
			}
			
			for (var j in dataBars[i]) {
				info = dataBars[i][j];
				prn = (i == 3) ? info.Prn - 120 : ((i == 4) ? info.Prn - 193 : info.Prn - 1);

//				topleft = (ypos - 1 + height - colheight1);
				var rectChanged = false;
				
				for (var s = 0; s < info.Signals.length; s++) {
					signal = info.Signals[s];
					if (signal.Value > 0) {
						colheight = (signal.Value / scaleMaximum) * (height - 2);
						if (barRectSet[i][j][s].Rect == null)
						{
							barRectSet[i][j][s].Rect = barPapers[i].rect(xpos + (prn) * (colsize) + 5, ypos - 1 + height - colheight, colsize - 6, colheight).attr("fill", info.Color);
							rectChanged = true;
						} else if (info.Prn != oldBars[i][j].Prn) {
							barRectSet[i][j][s].Rect.remove();
							barRectSet[i][j][s].Rect = null;
							barRectSet[i][j][s].Rect = barPapers[i].rect(xpos + (prn) * (colsize) + 5, ypos - 1 + height - colheight, colsize - 6, colheight).attr("fill", info.Color);
							rectChanged = true;
						} else if (signal.Value != oldBars[i][j].Signals[s].Value) {
							barRectSet[i][j][s].Rect.attr("y",(ypos - 1 + height - colheight));
							barRectSet[i][j][s].Rect.attr("height", colheight);
							rectChanged = true;
						}
					} else {
						if ((oldBars[i] != null) && (oldBars[i][j] != null) && (oldBars[i][j].Signals[s].Value > 0)) {
							barRectSet[i][j][s].Rect.remove();
							barRectSet[i][j][s].Rect = null;
						}
					}
					
					//Color update
					if ((barRectSet[i][j][s].Rect != null) && (oldBars[i] != null) && (oldBars[i][j] != null) && (info.Color != oldBars[i][j].Color))	{
						barRectSet[i][j][s].Rect.attr("fill", info.Color);
					}
				}
				
				//If something changed, we probably have to change the z-index of rectangles
				if (rectChanged == true) {
					var rectArray = new Array();
					for (var s = 0; s < barRectSet[i][j].length; s++) {
						if (barRectSet[i][j][s].Rect != null) {
							rectArray.push(barRectSet[i][j][s].Rect);
						}
					}
					
					do {
						var isOrderingFinished = true;
						for (var s = 0; s < rectArray.length - 1; s++) {
							if (rectArray[s].attr("height") > rectArray[s + 1].attr("height")) {
								isOrderingFinished = false;
								var buffer = rectArray[s + 1];
								rectArray[s + 1] = rectArray[s];
								rectArray[s] = buffer;
							}
						}
					} while (isOrderingFinished != true);
					
					for (var s = rectArray.length - 1; s > -1; s--) {
						rectArray[s].toFront();
					}
				}
			}
			
			//ToolTip
			if (barToolTipPathSet[i] == null) {
				rectHover[i] = barPapers[i].rect(xpos, ypos, width, height).attr({ stroke: "none", fill: "yellow", opacity: 0 });
				
			    //Init ToolTip
				basex = 50; 
				basey = 50;
				tipWidth = 120;
				//Add 5 to diag per additional Signal
				diag = 30;
				color = "#FFFFFF";
				//ToolTip Path
				barToolTipPathSet[i] = barPapers[i].path("M" + (basex) + "," + (basey) + "L" + (basex + diag) + "," + (basey - diag) + "L" + (basex + diag + tipWidth) + "," + (basey - diag) + "L" + (basex + diag + tipWidth) + "," + (basey + diag) + "L" + (basex + diag) + "," + (basey + diag) + " z").attr({stroke: color, "stroke-width": 2, fill: "#000000", opacity: 0.75});
				//ToolTip Text
				barToolTipTextSet[i] = barPapers[i].text(basex + diag + tipWidth / 2, basey,"").attr({fill:color, "font-size": 11});
				
				//Hide
				barToolTipPathSet[i].hide();
				barToolTipTextSet[i].hide();
	
				rectHover[i].mousemove(function (event) {
					index = myTabs.get('activeIndex') - 1;
					cols = barColsize[index];
					
					left = event.clientX - YAHOO.util.Dom.getDocumentScrollLeft() - YAHOO.util.Dom.getX(barElementId[index]) - xpos;
					leftpos = Math.round((left + (barColsize[index] - 5) / 2));
					
					//Guess what satellite is hovered
					min = 99999;
					indK = null;
					for (var k in dataBars[index]) {
						info = dataBars[index][k];
						for (s = 0; s < info.Signals.length; s++)
						{
							//We need at least one signal
							if (info.Signals[s].Value > 0) {
								prn = (index == 3) ? info.Prn - 120 : ((index == 4) ? info.Prn - 193 : info.Prn - 1);
								
								kpos = prn * cols + cols * 0.75 + 2;
								val = Math.abs(kpos - leftpos);
								if (val > min) {
									break;
								} else {
									min = val;
									indK = k;
								}
								break;
							}
						}
					}
					
					if (formerK != indK) {
						info = dataBars[index][indK];
						prn = (index == 3) ? info.Prn - 120 : ((index == 4) ? info.Prn - 193 : info.Prn - 1);
						
						//New values
						//X
						newX = xpos + (prn + 1) * (cols);
						
						//Detect if there is enough place at the right side of the column
						var toDrawRight = ((sidex 
								- (xpos + (prn + 1) * (cols)) 
								- tipWidth 
								- diag) > 0) ? true : false;
						
						if (toDrawRight) {
							newX = xpos + (prn + 1) * (cols);
						} else {
							newX = xpos + (prn) * (cols);
						}
						
						//Y
						maxcolheight = 0;
						for (s = 0; s < info.Signals.length; s++)
						{
							if (info.Signals[s].Value > 0) {
								maxcolheight = Math.max(maxcolheight, (info.Signals[s].Value / scaleMaximum) * height);
							}
						}
						newY = Math.round(ypos + height - maxcolheight);
						
						//Former values
						formerPath = barToolTipPathSet[index].attr("path") + "";
						//"M" + x + "," + y + "L" + ...
//						formerX = parseInt(formerPath.substring(1, formerPath.indexOf(",")),10);
						formerY = parseInt(formerPath.substring(formerPath.indexOf(",") + 1, formerPath.indexOf("L")),10);
						moveY = Math.round(newY - formerY);
						
						//Path Tanslation bug in current release using ie8
						//Use path change instead
						//http://groups.google.com/group/raphaeljs/browse_thread/thread/72245b7c61360ae5/f407390c72eca046?lnk=gst&q=+Inconsistency+in+path#f407390c72eca046
						if (toDrawRight)
						{
							barToolTipPathSet[index].attr("path","M" + (newX) + "," + (newY) + "L" + (diag + newX) + "," + (- diag + newY) + "L" + (+ diag + tipWidth + newX) + "," + (- diag + newY) + "L" + (+ diag + tipWidth + newX) + "," + (+ diag + newY) + "L" + (+ diag + newX) + "," + (+ diag + newY) + " z");
							barToolTipTextSet[index].attr("x", diag + tipWidth / 2 + newX);
							barToolTipTextSet[index].attr("y", barToolTipTextSet[index].attr("y") + moveY);
						} else {
							barToolTipPathSet[index].attr("path","M" + (newX) + "," + (newY) + "L" + (-diag + newX) + "," + (- diag + newY) + "L" + (- diag - tipWidth + newX) + "," + (- diag + newY) + "L" + (- diag - tipWidth + newX) + "," + (+ diag + newY) + "L" + (- diag + newX) + "," + (+ diag + newY) + " z");
							barToolTipTextSet[index].attr("x", - diag - tipWidth / 2 + newX);
							barToolTipTextSet[index].attr("y", barToolTipTextSet[index].attr("y") + moveY);
						}
						
						//Text change
						var value = "";
						var resId = "Satellite-Resource-Status-";
						switch(info.Status) {
							case 1:
							case 2:
							case 3:
								value = getResource( resId + 'Used');
								break;
							case 16:
								value = getResource( resId + 'NoEphemeris');
								break;
							case 18:
							case 22:
								value = getResource( resId + 'Unhealthy');
								break;
							case 21:
								value = getResource( resId + 'BadURA');
								break;
						}

						if (value != "")
						switch (info.DifferentialStatus)
						{
							case 2:
								value += " - " + getResource( resId + 'SBAScorr');
								break;
							case 3:
								value += " - " + getResource( resId + 'DGPScorr');
								break;
							case 4:
								value += " - " + getResource( resId + 'L1RTKcorr');
								break;
							case 5:
								value += " - " + getResource( resId + 'L1L2RTKcorr');
								break;
						}
						ttiptext = value;
						
						//Limited to 3 Signals ATM (TSL MODE)
						var nbSignals = 0;
						for (s = 0; (s < info.Signals.length && nbSignals < 3); s++)
						{
							//One line per Signal
							if (info.Signals[s].Value > 0) {
								ttiptext += "\n" + info.Signals[s].Channel + ": " + info.Signals[s].Value;
								nbSignals++;
							}
						}
						
						barToolTipTextSet[index].attr("text",ttiptext);
						
					    //Show
						barToolTipPathSet[index].toFront();
						barToolTipTextSet[index].toFront();
						rectHover[index].toFront();
						barToolTipPathSet[index].show();
						barToolTipTextSet[index].show();
					}
					formerK = indK;
				});
				
				rectHover[i].mouseout(function (event) {
					formerK = null;
					index = myTabs.get('activeIndex') - 1;
					//Hide
					barToolTipPathSet[index].hide();
					barToolTipTextSet[index].hide();
				});
				
			}
			
			//Important: enable events all over the area
			barToolTipPathSet[i].toFront();
			barToolTipTextSet[i].toFront();
			rectHover[i].toFront();
			
			//Backup for next update cycle
			oldBars[i] = dataBars[i];
		}
	}

	initFinish = true;
}
 
function updateSatellitePolarView(data, centerx, centery, radius)
{	
	if ((myTabs == null) || ((myTabs != null) && (myTabs.get('activeIndex') == 5))){
		//New source code (Internet Explorer Performance Optimization)
		var dataSats = new Object();
	
		var indData = new Array();
		var toAddSats = new Object();
		
		var indOld = new Array();
		var toDelSats = new Object();
		
		var ind = 0;
		
		//Out filter "undefined" Satellites
		for (var i in data){
			//Filter out Galileo Satellites is no Option
			if ((optionsGlobal.indexOf("O") != -1) || (i != 2))
			{
				for (var j in data[i]){
					dat = data[i][j];
					//Up-to-date values
					if (dat.Status == 1){
						// Used
						color = colors[i];
						textcolor = "#FFFFFF";
					} else {
						// Unused
						color = colors[parseInt(i,10) + 5]; // +1 for QZSS
						textcolor = "#000000";
					}
					if (dat.Status != 0){
						// Tracked
						dash = "";
					} else {
						// Non-tracked
						dash = "-";
					}
					
					dataSats[ind] = new polarSat(dat.Prn + "", dat.Azimuth, dat.Elevation, dat.Status, color, textcolor, dash, i);
					ind++;
				}
			}
		}
	
		//Check frozen satellites.	
		for (var i in dataSats){
			dat = dataSats[i];
			for (var j in oldSats){
				oldat = oldSats[j];
				if (dat.Prn == oldat.Prn && dat.Azimuth == oldat.Azimuth && dat.Elevation == oldat.Elevation && dat.Color == oldat.Color && dat.Dash == oldat.Dash)
				{
					//Index of frozen Satellite in Data Array
					indData.push(i);
					//Index of frozen Satellite in Old Array
					indOld.push(j);
					
					break;
				}
			}
		}
		
		//Keep new or updated Satellite in Data Array (to draw satellites)
		ind = 0;
		for (var i in dataSats){	
			found = false;
			for (var j in indData)
				if (indData[j] == i)
					found = true;
			
			if (found == false){
				// Test Azimuth and Elevation (Galileo bug)
				if ((dataSats[i].Azimuth >= 0) &&
					(dataSats[i].Azimuth <= 360) &&
					(dataSats[i].Elevation >= 0) &&
					(dataSats[i].Elevation <= 90))
				{
					toAddSats[ind] = dataSats[i];
					ind++;
				}
			}
		}
		
		//Keep former or updated Satellite in Old Array (to remove satellites)
		ind = 0;
		for (var i in oldSats){
			found = false;
			for (var j in indOld)
				if (indOld[j] == i)
					found = true;
			
			if (found == false){
				toDelSats[ind] = oldSats[i];
				ind++;
			}
		}
		
		//Backup for next update cycle
		oldSats = dataSats;
		
		for (var i in toDelSats){
			for (j = 0; j < textSet.items.length; j++){
				tex = textSet.items[j];
				rec = rectSet.items[j];
				if ((tex.attr("text") == toDelSats[i].Prn) && (rec.attr("fill") == toDelSats[i].Color) && (rec.attr("stroke-dasharray") == toDelSats[i].Dash)){
					tex.remove();
					rec.remove();
					
					break;
				}
			}
		}
		
		//Draw	
		for (var i in toAddSats){
			addInfo = toAddSats[i];
			
			evdist = radiusx * ((90 - addInfo.Elevation) / 90);
			radAzimuth = (addInfo.Azimuth * Math.PI) / 180;
			api = radAzimuth + Math.PI / 2;
			ecosapi = evdist * Math.cos(api);
			esinapi = evdist * Math.sin(api);
			
			if (radAzimuth < Math.PI) {
			    if (radAzimuth % 1 < 0.5 * Math.PI) {
			    	xrect = centerx - ecosapi;
			    } else {
			    	xrect = centerx + ecosapi;
			    }
			} else {
			    xrect = centerx - ecosapi;
			}
	
			if (radAzimuth % 1 < 0.5 * Math.PI) {
			    yrect = centery - esinapi;
			} else {
			    yrect = centery + esinapi;
			}
			
			rectSet.push(paper.rect(xrect - 10, yrect - 10, 20, 20).attr("fill", addInfo.Color).attr("stroke-dasharray", addInfo.Dash));
			textSet.push(paper.text(xrect, yrect + 2, addInfo.Prn).attr("fill", addInfo.Textcolor));
		}
	}
}

function SatelliteTableView(id, caption, source, config )
{
	// Columns definition
	var baseColumnDefs = 
	[
		{label:getResource('Satellite-Resource-Prn'), key:"Prn", resizeable:true},
		{label:getResource('Satellite-Resource-Status'), key:"Status", formatter:SatelliteTableView.formatStatus, resizeable:true},
		{label:'', key:"DifferentialStatus", resizeable:true, hidden:true},
		{label:getResource('Satellite-Resource-Azimuth'), key:"Azimuth", resizeable:true},
		{label:getResource('Satellite-Resource-Elevation'), key:"Elevation", resizeable:true},
		{label:getResource('Satellite-Resource-SN'), formatter:SatelliteTableView.formatSn, 
			children: config["SnColumnDefs"]
		},
		{label:getResource('Satellite-Resource-Smooth'), formatter:SatelliteTableView.formatSmooth, 
			children: config["SmoothColumnDefs"]
		}
	];

	// Fields
	var baseFields = ["Prn", "Status", "Azimuth", "Elevation"];
	
	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = baseFields.concat( config["fields"] );

	// Table configs
	var myConfigs = {};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('Satellite-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('Satellite-Resource-Loading');

	// Create table
	var myDataTable = new YAHOO.widget.DataTable(id, baseColumnDefs, myDataSource, myConfigs);
	// Set up polling
	var myCallback =
	{
		success: myDataTable.onDataReturnInitializeTable,
		failure: function()
		{
			YAHOO.log("SatelliteTableView: Polling failure", "error");
		},
		scope: myDataTable
	};
	myDataSource.setInterval(1000, null, myCallback);
}

function getGpsConfig()
{
	var config = new Object();
	config["SnColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1C", resizeable:true},
		{label:"L1P(Y)", key:"SnL1P", resizeable:true},
		{label:"L2CS", key:"SnL2C", resizeable:true},
		{label:"L2P(Y)", key:"SnL2P", resizeable:true}
	];
	config["SmoothColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1CSmooth", resizeable:true},
		{label:"L1P(Y)", key:"SnL1PSmooth", resizeable:true},
		{label:"L2CS", key:"SnL2CSmooth", resizeable:true},
		{label:"L2P(Y)", key:"SnL2PSmooth", resizeable:true}
	];
	config["fields"] = ["SnL1C", "SnL1P", "SnL2P", "SnL1CSmooth", "SnL1PSmooth", "SnL2CSmooth", "SnL2PSmooth"];

	if (optionsGlobal.indexOf("Q") != -1)
	{
		config["SnColumnDefs"].push({label:"L5", key:"SnL5Q", resizeable:true});
		config["SmoothColumnDefs"].push({label:"L5", key:"SnL5QSmooth", resizeable:true});
		config["fields"].push("SnL5Q");
		config["fields"].push("SnL5QSmooth");
	}
	
	return config;
}

function getGlonassConfig()
{
	var config = new Object();
	config["SnColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1C", resizeable:true},	
		{label:"L2C", key:"SnL2C", resizeable:true}
	];
	config["SmoothColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1CSmooth", resizeable:true},
		{label:"L2C", key:"SnL2CSmooth", resizeable:true}
	];
	config["fields"] = ["SnL1C", "SnL2C", "SnL1CSmooth", "SnL2CSmooth"];
	return config;
}

function getSbasConfig()
{
	var config = new Object();
	config["SnColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1C", resizeable:true}
	];
	config["SmoothColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1CSmooth", resizeable:true}
	];
	config["fields"] = ["SnL1C", "SnL1CSmooth"];
	return config;
}

function getGalileoConfig()
{
	var config = new Object();
	config["SnColumnDefs"] = 
	[
		{label:"E1", key:"SnE1", resizeable:true},	
		{label:"E5a", key:"SnE5a", resizeable:true}
	];
	config["SmoothColumnDefs"] = 
	[
		{label:"E1", key:"SnE1Smooth", resizeable:true},
		{label:"E5a", key:"SnE5aSmooth", resizeable:true}
	];
	config["fields"] = ["SnE1", "SnE5a", "SnE1Smooth", "SnE5aSmooth"];
	return config;
}

function getQZSSConfig()
{
	var config = new Object();
	config["SnColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1C", resizeable:true},
		{label:"L2CS", key:"SnL2C", resizeable:true}
	];
	config["SmoothColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1CSmooth", resizeable:true},
		{label:"L2CS", key:"SnL2CSmooth", resizeable:true}
	];
	config["fields"] = ["SnL1C", "SnL2C", "SnL1CSmooth", "SnL2CSmooth"];

	if (optionsGlobal.indexOf("Q") != -1)
	{
		config["SnColumnDefs"].push({label:"L5", key:"SnL5Q", resizeable:true});
		config["SmoothColumnDefs"].push({label:"L5", key:"SnL5QSmooth", resizeable:true});
		config["fields"].push("SnL5Q");
		config["fields"].push("SnL5QSmooth");
	}
	
	return config;
}

SatelliteTableView.formatStatus = function(el, oRecord, oColumn, oData)
{	
	try
	{
		var value = "";
		var resId = "Satellite-Resource-Status-";
		switch(oData)
		{
			case 1:
			case 2:
			case 3:
				value = getResource( resId + 'Used');
				break;
			case 16:
				value = getResource( resId + 'NoEphemeris');
				break;
			case 18:
			case 21:
				value = getResource( resId + 'BadURA');
			case 22:
				value = getResource( resId + 'Unhealthy');
				break;
			case 17:
			case 25:
				value = getResource( resId + 'Tracked');
		}

		if ((value != "") && (oData != 17) && (oData != 25))
		switch (oRecord.getData("DifferentialStatus"))
		{
			case 2:
				value += " - " + getResource( resId + 'SBAScorr');
				break;
			case 3:
				value += " - " + getResource( resId + 'DGPScorr');
				break;
			case 4:
				value += " - " + getResource( resId + 'L1RTKcorr');
				break;
			case 5:
				value += " - " + getResource( resId + 'L1L2RTKcorr');
				break;
		}
		el.innerHTML = value;
	}
	catch (x) {
		YAHOO.log("SatelliteTableView.formatUsage: '" + oData + "' bad format");
	}
};

SatelliteTableView.formatSn = function(el, oRecord, oColumn, oData)
{
	try
	{
		el.innerHTML = oData > 0 ? oData : "";
	}
	catch (x) {
		YAHOO.log("SatelliteTableView.formatSn: '" + oData + "' bad format");	
	}
};

SatelliteTableView.formatSmooth = function(el, oRecord, oColumn, oData)
{
	try
	{
		el.innerHTML = oData > 0 ? oData : "";
		if ( oData > 254 )
		{
			el.innerHTML = ">255";
		}
	}
	catch (x) {
		YAHOO.log("SatelliteTableView.formatSmooth: '" + oData + "' bad format");	
	}
};