var speed = new Array(300,600,1200,2400,4800,9600,19200,38400,57600,115200,230400,460800,921600,1428571,2500000,5000000);
function updateStatusSerialPorts()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusSerialPorts()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get status
			var status = data.StatusSerialPorts;
			if (status == null) return;
			
			// Update values
			var value;
			
            // Port A
            setItemText('SerialPortA-BaudRate', speed[status.SerialPortA.BaudRate]);
            setItemText('SerialPortA-Mode', status.SerialPortA.Mode);
			switch (status.SerialPortA.RtsCts)
			{
			case 0: value = getResource('SerialPorts-Resource-Disabled'); break;
			case 1: value = getResource('SerialPorts-Resource-Enabled'); break;
			default: value = status.SerialPortA.RtsCts;
			}	
            setItemText('SerialPortA-RtsCts', value);
            setItemDisplayed('Label-RTSA', status.SerialPortA.Mode == 232);
            setItemDisplayed('SerialPortA-RtsCts', status.SerialPortA.Mode == 232);

            // Port B
            setItemText('SerialPortB-BaudRate', speed[status.SerialPortB.BaudRate]);
			switch (status.SerialPortB.RtsCts)
			{
			case 0: value = getResource('SerialPorts-Resource-Disabled'); break;
			case 1: value = getResource('SerialPorts-Resource-Enabled'); break;
			default: value = status.SerialPortB.RtsCts;
			}	
            setItemText('SerialPortB-RtsCts', value);
            
            // Port F
            setItemText('SerialPortF-BaudRate', speed[status.SerialPortF.BaudRate]);
			switch (status.SerialPortF.RtsCts)
			{
			case 0: value = getResource('SerialPorts-Resource-Disabled'); break;
			case 1: value = getResource('SerialPorts-Resource-Enabled'); break;
			default: value = status.SerialPortF.RtsCts;
			}	
            setItemText('SerialPortF-RtsCts', value);

            // Power Extented
			switch (status.PowerExtented)
			{
			case 0: value = getResource('SerialPorts-Resource-Off'); break;
			case 1: value = getResource('SerialPorts-Resource-On'); break;
			default: value = status.status.PowerExtented;
			}	
            setItemText('SerialPorts-PowerExtented', value);
                        
			setTimeout("updateStatusSerialPorts()", 1000);
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusSerialPorts()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getStatusSerialPortsURL, callbacks);
}

