function MemorySize(size)
{
	return formatTextAsMemorySize( size );
}

function updateStatusSystem()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusSystem()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get status
			var status = data.StatusSystem;
			if (status == null) return;
			
			// Update values
			var value;

			// -- Power Source --
			switch (status.PowerSource)
			{
			case 0: value = getResource('System-Resource-InternalBattery'); break;
			case 1: value = getResource('System-Resource-ExternalBattery'); break;
			case 2: value = getResource('System-Resource-ExternalDC'); break;
			default: value = status.PowerSource;
			}	
			setItemText('System-PowerSource', value);

			//-- Internal Battery Charge --
            setItemText('System-InternalBatteryCharge', formatString('{0} %', status.InternalBatteryCharge));
            
			//-- Internal Battery Volt --
            setItemText('System-InternalBatteryVolt', formatString('{0} V', status.InternalBatteryVolt));
            
			// -- Charging Status --
			switch (status.ChargingStatus)
			{
			case 0: value = getResource('System-Resource-Charging'); break;
			case 1: value = getResource('System-Resource-Discharging'); break;
			case 2: value = getResource('System-Resource-FullyCharged'); break;
			default: value = status.ChargingStatus;
			}	
			setItemText('System-ChargingStatus', value);

			// -- Extended Ports --
			switch (status.ExtendedPorts)
			{
			case 0: value = getResource('System-Resource-Off'); break;
			case 1: value = getResource('System-Resource-On'); break;
			default: value = status.ExtendedPorts;
			}	
			setItemText('System-ExtendedPorts', value);

			// -- Internal Modem --
			switch (status.ModemStatus)
			{
			case 0: value = getResource('System-Resource-Off'); break;
			case 1: value = getResource('System-Resource-On'); break;
			case 2: value = getResource('System-Resource-Init'); break;
			case 3: value = getResource('System-Resource-Dialing'); break;
			case 4: value = getResource('System-Resource-Online'); break;
			case 5: value = getResource('System-Resource-None'); break;
			default: value = status.ModemStatus;
			}
			setItemText('System-InternalModem', value);

			// -- Internal Modem Network --
			if (status.ModemNetworkType != null && status.ModemNetworkName != null)
			{
				value = status.ModemNetworkType + " " + status.ModemNetworkName;
			} else {
				value = null;
			}
			setItemText('System-InternalModemNetwork', value);

			// -- Internal Radio Type --
			switch (status.InternalRadioType)
			{
			case 0: value = getResource('System-Resource-None'); break;
			case 1: value = getResource('System-Resource-Auto-detection'); break;
			case 2: value = getResource('System-Resource-MagellanU-Link'); break;
			case 4: value = getResource('System-Resource-PDLRXO'); break;
			case 8: value = getResource('System-Resource-ADLFoundation'); break;
			default: value = status.InternalRadioType;
			}	
			setItemText('System-InternalRadioType', value);

			// -- Internal Radio Status --
			switch (status.InternalRadioStatus)
			{
			case 0: value = getResource('System-Resource-Off'); break;
			case 1: value = getResource('System-Resource-On'); break;
			default: value = status.InternalRadioStatus;
			}	
			setItemText('System-InternalRadioStatus', value);

			// -- External Radio Type --
			switch (status.ExternalRadioType)
			{
			case 0: value = getResource('System-Resource-NoneCable'); break;
			case 2: value = getResource('System-Resource-MagellanU-Link'); break;
			case 3: value = getResource('System-Resource-MagellanUHF'); break;
			case 4: value = getResource('System-Resource-PDLHPBLPB'); break;
			case 5: value = getResource('System-Resource-LicenseFreeEurope'); break;
			case 6: value = getResource('System-Resource-LicenseFreeNorthAmerica'); break;
			case 7: 
			    {
			    //value = getResource('System-Resource-ADLVantage'); break;
    			if (status.CommunicationModelID == 2)     
    			    value = "ADL Vantage";
			    else if (status.CommunicationModelID == 3)
			        value = "ADL Vantage Pro";
			    else 
			        value = "ADL Vantage / Vantage Pro";
			    break;
			    }
			case 9: value = "XDL Rover"; break; // No translation needed
			default: value = status.ExternalRadioType;
			}	
			setItemText('System-ExternalRadioType', value);

			// -- Ethernet Status --
			switch (status.EthernetStatus)
			{
			case 0: value = getResource('System-Resource-Off'); break;
			case 1: value = getResource('System-Resource-On'); break;
			default: value = status.EthernetStatus;
			}	
			setItemText('System-EthernetStatus', value);
			
			// -- Ethernet Dhcp Status --
			switch (status.EthernetDhcpStatus)
			{
			case 0: value = getResource('System-Resource-Disabled'); break;
			case 1: value = getResource('System-Resource-Enabled'); break;
			default: value = status.EthernetDhcpStatus;
			}	
			setItemText('System-EthernetDhcpStatus', value);

			// -- Ethernet Tcp Status --
			switch (status.EthernetTcpStatus)
			{
			case 0: value = getResource('System-Resource-Disabled'); break;
			case 1: value = getResource('System-Resource-EnabledWithAuthentication'); break;
			case 2: value = getResource('System-Resource-EnabledWithoutAuthentication'); break;
			default: value = status.EthernetTcpStatus;
			}	
			setItemText('System-EthernetTcpStatus', value);

			//-- Bluetooth Device Name --
            setItemText('System-BlueToothDeviceName',status.BlueToothDeviceName);

			//-- Internal Memory --
			value = "";
			if (status.InternalMemory.PercentFree != null)
			{
				value = formatString(getResource('System-Resource-FreeFormat'), status.InternalMemory.PercentFree + ' %') 
				+ ' - ' + formatString(getResource('System-Resource-UsedFormat'), MemorySize(status.InternalMemory.SizeUsed)) 
				+ ' - ' + formatString(getResource('System-Resource-FreeFormat'), MemorySize(status.InternalMemory.SizeFree))
				+ ' - ' + formatString(getResource('System-Resource-FilesFormat'), status.InternalMemory.FileCount); 
			}
            setItemText('System-InternalMemory', value);

			//-- External Memory --
			value = "";
			if (status.UsbKeyMemory.PercentFree != null)
			{
				value = formatString(getResource('System-Resource-FreeFormat'), status.UsbKeyMemory.PercentFree + ' %') 
				+ ' - ' + formatString(getResource('System-Resource-UsedFormat'), MemorySize(status.UsbKeyMemory.SizeUsed)) 
				+ ' - ' + formatString(getResource('System-Resource-FreeFormat'), MemorySize(status.UsbKeyMemory.SizeFree))
				+ ' - ' + formatString(getResource('System-Resource-FilesFormat'), status.UsbKeyMemory.FileCount);
			}
			setItemText('System-UsbKeyMemory', value);

			// -- Storage Location --
			switch (status.StorageLocation)
			{
			case 0: value = getResource('System-Resource-InternalMemory'); break;
			case 2: value = getResource('System-Resource-UsbKey'); break;
			default: value = status.StorageLocation;
			}	
			setItemText('System-StorageLocation', value);

			// -- Recording Mode --
			switch (status.RecordingMode)
			{
			case 'Y': value = getResource('System-Resource-EnableDataRecording'); break;
			case 'N': value = getResource('System-Resource-DisableDataRecording'); break;
			default: value = status.RecordingMode;
			}	
			setItemText('System-RecordingMode', value);

			//-- Recording Interval --
            setItemText('System-RecordingInterval', formatString( '{0} s', status.RecordingInterval ) );

			//-- Elevation Mask --
            setItemText('System-ElevationMask', formatString( '{0} &deg;', status.ElevationMask ) );

			// Update every 1 seconds
			setTimeout("updateStatusSystem()", 1000);
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusSystem()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getStatusSystemURL, callbacks);
}

