//var speed = new Array(300,600,1200,2400,4800,9600,19200,38400,57600,115200,230400,460800,921600,1428571,2500000,5000000);
function updateStatusTiltmeter()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusTiltmeter()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var status = data.StatusTiltmeter;
			//set data for measurement
			var angle = parseFloat(status.TiltmeterMeasurements.AngularDisplacementNorth).toFixed(3);
			if ( !isNaN( angle ) )
				setItemText( 'Tiltmeter-Measurement-AngularDisplacementNorth', angle );
			
			angle = parseFloat(status.TiltmeterMeasurements.AngularDisplacementEast).toFixed(3);
			if ( !isNaN( angle ) )
				setItemText( 'Tiltmeter-Measurement-AngularDisplacementEast', angle );
			
			setItemText('Tiltmeter-Measurement-Temperature', formatString('{0} &deg;C', status.TiltmeterMeasurements.Temperature));
			
			var value;
			function setPortFields( name, data )
			{
				switch (data.ProcessTiltmeter)
				{
					case 0: value = getResource('Tiltmeter-Resource-Off'); break;
					case 1: value = getResource('Tiltmeter-Resource-On'); break;
					default: value = data.ProcessTiltmeter;
				}
				setItemText( name + '-' + 'ProcessTiltmeter', value );
				
				setItemText( name + '-' + 'BaudRate', portSpeed[ data.BaudRate ] );
				switch (data.RtsCts)
				{
					case 0: value = getResource('Tiltmeter-Resource-Disabled'); break;
					case 1: value = getResource('Tiltmeter-Resource-Enabled'); break;
					default: value = data.RtsCts;
				}
				setItemText( name + '-' + 'RtsCts', value );
				setItemText( name + '-' + 'InitializationString', data.InitializationString );
				setItemText( name + '-' + 'TriggerString', data.TriggerString );
				setItemText( name + '-' + 'Interval', formatString( '{0} s', data.Interval ) );
			}
			
			setPortFields( 'Tiltmeter-PortA', status.PortA );
			//port A supports additional field mode
			setItemText( 'Tiltmeter-PortA-Mode', status.PortA.Mode );
			
			setPortFields( 'Tiltmeter-PortB', status.PortB );
			setPortFields( 'Tiltmeter-PortF', status.PortF );
			
			var text="";
			switch( status.DFileSupport )
			{
				case 0: text = getResource('Tiltmeter-Resource-No'); break;
				case 1: text = getResource('Tiltmeter-Resource-Yes'); break;
			}
			setItemText( 'Tiltmeter-LegacyDFileSupport', text );
			
			setTimeout("updateStatusTiltmeter()", 1000);
		},
		failure : function ( o )
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusTiltmeter()", 1000);
		},
		
		timeout : 10000,
		cache : false
	};
		
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getStatusTiltmeter, callbacks);
}