function updateStatusVersion()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusVersion()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get status
			var status = data.StatusVersion;
			if (status == null) return;
			
            // Serial number			
            setItemText('Version-SerialNumber', status.SerialNumber);
            
            // FW Version
            setItemText('Version-Receiver', status.Receiver);
            
            // Options 
            var enabled = getResource('Version-Resource-Enabled');
            if (status.Options.search('P') >= 0) {
                setItemText('Options-GNSSL2', enabled); 
            }
            if (status.Options.search('F') >= 0) {
                setItemText('Options-FASTOUTPUT', enabled); 
            }
            if (status.Options.search('S') >= 0) {
                setItemText('Options-GLONASS', enabled); 
            }
            if (status.Options.search('Z') >= 0) {
                setItemText('Options-MODEM', enabled); 
            }
            if (status.Options.search('M') >= 0) {
                setItemText('Options-RTK2', enabled); 
            }
            if (status.Options.search('N') >= 0) {
                setItemText('Options-STA', enabled); 
            }
            if (status.Options.search('K') >= 0) {
                setItemText('Options-RTKBASE', enabled); 
            }
            if (status.Options.search('L') >= 0) {
                setItemText('Options-RTK3', enabled); 
            }
            if (status.Options.search('R') >= 0) {
                setItemText('Options-FlyingRTK', enabled); 
            }
            if (status.Options.search('C') >= 0) {
                setItemText('Options-Caster', enabled); 
            }
            if (status.Options.search('Q') >= 0) {
                setItemText('Options-GNSSL5', enabled); 
            }
            if (status.Options.search('O') >= 0) {
                setItemText('Options-Galileo', enabled); 
            }
            
            // detailed versions
            setItemText('Version-Syst', status.Syst);
            setItemText('Version-Gnss', status.Gnss);
            setItemText('Version-Kernel', status.Kernel);
            setItemText('Version-Rescue', status.Rescue);
            setItemText('Version-BootLoader', status.BootLoader);
            setItemText('Version-Pmu', status.Pmu);
            setItemText('Version-Api', status.Api);
            setItemText('Version-Bsp', status.Bsp);
            //setItemText('Version-GnssUploader', status.GnssUploader);
            setItemText('Version-GnssSerialNumber', status.GnssSerialNumber);
            setItemText('Version-GnssOptions', status.GnssOptions);
            setItemText('Version-Rfs', status.Rfs);            
            setItemText('Version-ModemModel', status.ModemModel);
            setItemText('Version-ModemFirmware', status.ModemFirmware);
            //setItemText('Version-GsmUploader', status.GsmUploader);
            setItemText('Version-Imei', status.Imei);
            setItemText('Version-StackIp', status.StackIp);
            setItemText('Version-InternalRadio', status.InternalRadio);
            //setItemText('Version-UlinkUploader', status.UlinkUploader);
            setItemText('Version-CanController', status.CanController);
            //setItemText('Version-CanUploader', status.CanUploader);
            setItemText('Version-WebInterface', status.WebInterface);
            setItemText('Version-NTRIPCaster', status.NTRIPCaster);
            
			setTimeout("updateStatusVersion()", 1000);
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusVersion()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getStatusVersionURL, callbacks);
}

